/* Autogenerated: src/ExtractionOCaml/word_by_word_montgomery --lang Go --cmovznz-by-mul p384 32 '2^384 - 2^128 - 2^96 + 2^32 - 1' mul square add sub opp from_montgomery to_montgomery nonzero selectznz to_bytes from_bytes one msat divstep divstep_precomp */
/* curve description: p384 */
/* machine_wordsize = 32 (from "32") */
/* requested operations: mul, square, add, sub, opp, from_montgomery, to_montgomery, nonzero, selectznz, to_bytes, from_bytes, one, msat, divstep, divstep_precomp */
/* m = 0xfffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffeffffffff0000000000000000ffffffff (from "2^384 - 2^128 - 2^96 + 2^32 - 1") */
/*                                                                    */
/* NOTE: In addition to the bounds specified above each function, all */
/*   functions synthesized for this Montgomery arithmetic require the */
/*   input to be strictly less than the prime modulus (m), and also   */
/*   require the input to be in the unique saturated representation.  */
/*   All functions also ensure that these two properties are true of  */
/*   return values.                                                   */
/*  */
/* Computed values: */
/* eval z = z[0] + (z[1] << 32) + (z[2] << 64) + (z[3] << 96) + (z[4] << 128) + (z[5] << 160) + (z[6] << 192) + (z[7] << 224) + (z[8] << 256) + (z[9] << 0x120) + (z[10] << 0x140) + (z[11] << 0x160) */
/* bytes_eval z = z[0] + (z[1] << 8) + (z[2] << 16) + (z[3] << 24) + (z[4] << 32) + (z[5] << 40) + (z[6] << 48) + (z[7] << 56) + (z[8] << 64) + (z[9] << 72) + (z[10] << 80) + (z[11] << 88) + (z[12] << 96) + (z[13] << 104) + (z[14] << 112) + (z[15] << 120) + (z[16] << 128) + (z[17] << 136) + (z[18] << 144) + (z[19] << 152) + (z[20] << 160) + (z[21] << 168) + (z[22] << 176) + (z[23] << 184) + (z[24] << 192) + (z[25] << 200) + (z[26] << 208) + (z[27] << 216) + (z[28] << 224) + (z[29] << 232) + (z[30] << 240) + (z[31] << 248) + (z[32] << 256) + (z[33] << 0x108) + (z[34] << 0x110) + (z[35] << 0x118) + (z[36] << 0x120) + (z[37] << 0x128) + (z[38] << 0x130) + (z[39] << 0x138) + (z[40] << 0x140) + (z[41] << 0x148) + (z[42] << 0x150) + (z[43] << 0x158) + (z[44] << 0x160) + (z[45] << 0x168) + (z[46] << 0x170) + (z[47] << 0x178) */

package fiat_p384

import "math/bits"
type fiat_p384_uint1 uint8
type fiat_p384_int1 int8

/* The function fiat_p384_addcarryx_u32 is a thin wrapper around bits.Add32 that uses fiat_p384_uint1 rather than uint32 */
func fiat_p384_addcarryx_u32(x uint32, y uint32, carry fiat_p384_uint1) (uint32, fiat_p384_uint1) {
  var sum uint32
  var carryOut uint32
  sum, carryOut = bits.Add32(x, y, uint32(carry))
  return sum, fiat_p384_uint1(carryOut)
}

/* The function fiat_p384_subborrowx_u32 is a thin wrapper around bits.Sub32 that uses fiat_p384_uint1 rather than uint32 */
func fiat_p384_subborrowx_u32(x uint32, y uint32, carry fiat_p384_uint1) (uint32, fiat_p384_uint1) {
  var sum uint32
  var carryOut uint32
  sum, carryOut = bits.Sub32(x, y, uint32(carry))
  return sum, fiat_p384_uint1(carryOut)
}


/*
 * The function fiat_p384_cmovznz_u32 is a single-word conditional move.
 * Postconditions:
 *   out1 = (if arg1 = 0 then arg2 else arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffff]
 *   arg3: [0x0 ~> 0xffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffff]
 */
/*inline*/
func fiat_p384_cmovznz_u32(out1 *uint32, arg1 fiat_p384_uint1, arg2 uint32, arg3 uint32) {
  var x1 uint32 = (uint32(arg1) * 0xffffffff)
  var x2 uint32 = ((x1 & arg3) | ((^x1) & arg2))
  *out1 = x2
}

/*
 * The function fiat_p384_mul multiplies two field elements in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   arg2: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
/*inline*/
func fiat_p384_mul(out1 *[12]uint32, arg1 *[12]uint32, arg2 *[12]uint32) {
  var x1 uint32 = (arg1[1])
  var x2 uint32 = (arg1[2])
  var x3 uint32 = (arg1[3])
  var x4 uint32 = (arg1[4])
  var x5 uint32 = (arg1[5])
  var x6 uint32 = (arg1[6])
  var x7 uint32 = (arg1[7])
  var x8 uint32 = (arg1[8])
  var x9 uint32 = (arg1[9])
  var x10 uint32 = (arg1[10])
  var x11 uint32 = (arg1[11])
  var x12 uint32 = (arg1[0])
  var x13 uint32
  var x14 uint32
  x14, x13 = bits.Mul32(x12, (arg2[11]))
  var x15 uint32
  var x16 uint32
  x16, x15 = bits.Mul32(x12, (arg2[10]))
  var x17 uint32
  var x18 uint32
  x18, x17 = bits.Mul32(x12, (arg2[9]))
  var x19 uint32
  var x20 uint32
  x20, x19 = bits.Mul32(x12, (arg2[8]))
  var x21 uint32
  var x22 uint32
  x22, x21 = bits.Mul32(x12, (arg2[7]))
  var x23 uint32
  var x24 uint32
  x24, x23 = bits.Mul32(x12, (arg2[6]))
  var x25 uint32
  var x26 uint32
  x26, x25 = bits.Mul32(x12, (arg2[5]))
  var x27 uint32
  var x28 uint32
  x28, x27 = bits.Mul32(x12, (arg2[4]))
  var x29 uint32
  var x30 uint32
  x30, x29 = bits.Mul32(x12, (arg2[3]))
  var x31 uint32
  var x32 uint32
  x32, x31 = bits.Mul32(x12, (arg2[2]))
  var x33 uint32
  var x34 uint32
  x34, x33 = bits.Mul32(x12, (arg2[1]))
  var x35 uint32
  var x36 uint32
  x36, x35 = bits.Mul32(x12, (arg2[0]))
  var x37 uint32
  var x38 fiat_p384_uint1
  x37, x38 = fiat_p384_addcarryx_u32(x36, x33, 0x0)
  var x39 uint32
  var x40 fiat_p384_uint1
  x39, x40 = fiat_p384_addcarryx_u32(x34, x31, x38)
  var x41 uint32
  var x42 fiat_p384_uint1
  x41, x42 = fiat_p384_addcarryx_u32(x32, x29, x40)
  var x43 uint32
  var x44 fiat_p384_uint1
  x43, x44 = fiat_p384_addcarryx_u32(x30, x27, x42)
  var x45 uint32
  var x46 fiat_p384_uint1
  x45, x46 = fiat_p384_addcarryx_u32(x28, x25, x44)
  var x47 uint32
  var x48 fiat_p384_uint1
  x47, x48 = fiat_p384_addcarryx_u32(x26, x23, x46)
  var x49 uint32
  var x50 fiat_p384_uint1
  x49, x50 = fiat_p384_addcarryx_u32(x24, x21, x48)
  var x51 uint32
  var x52 fiat_p384_uint1
  x51, x52 = fiat_p384_addcarryx_u32(x22, x19, x50)
  var x53 uint32
  var x54 fiat_p384_uint1
  x53, x54 = fiat_p384_addcarryx_u32(x20, x17, x52)
  var x55 uint32
  var x56 fiat_p384_uint1
  x55, x56 = fiat_p384_addcarryx_u32(x18, x15, x54)
  var x57 uint32
  var x58 fiat_p384_uint1
  x57, x58 = fiat_p384_addcarryx_u32(x16, x13, x56)
  var x59 uint32 = (uint32(x58) + x14)
  var x60 uint32
  var x61 uint32
  x61, x60 = bits.Mul32(x35, 0xffffffff)
  var x62 uint32
  var x63 uint32
  x63, x62 = bits.Mul32(x35, 0xffffffff)
  var x64 uint32
  var x65 uint32
  x65, x64 = bits.Mul32(x35, 0xffffffff)
  var x66 uint32
  var x67 uint32
  x67, x66 = bits.Mul32(x35, 0xffffffff)
  var x68 uint32
  var x69 uint32
  x69, x68 = bits.Mul32(x35, 0xffffffff)
  var x70 uint32
  var x71 uint32
  x71, x70 = bits.Mul32(x35, 0xffffffff)
  var x72 uint32
  var x73 uint32
  x73, x72 = bits.Mul32(x35, 0xffffffff)
  var x74 uint32
  var x75 uint32
  x75, x74 = bits.Mul32(x35, 0xfffffffe)
  var x76 uint32
  var x77 uint32
  x77, x76 = bits.Mul32(x35, 0xffffffff)
  var x78 uint32
  var x79 uint32
  x79, x78 = bits.Mul32(x35, 0xffffffff)
  var x80 uint32
  var x81 fiat_p384_uint1
  x80, x81 = fiat_p384_addcarryx_u32(x77, x74, 0x0)
  var x82 uint32
  var x83 fiat_p384_uint1
  x82, x83 = fiat_p384_addcarryx_u32(x75, x72, x81)
  var x84 uint32
  var x85 fiat_p384_uint1
  x84, x85 = fiat_p384_addcarryx_u32(x73, x70, x83)
  var x86 uint32
  var x87 fiat_p384_uint1
  x86, x87 = fiat_p384_addcarryx_u32(x71, x68, x85)
  var x88 uint32
  var x89 fiat_p384_uint1
  x88, x89 = fiat_p384_addcarryx_u32(x69, x66, x87)
  var x90 uint32
  var x91 fiat_p384_uint1
  x90, x91 = fiat_p384_addcarryx_u32(x67, x64, x89)
  var x92 uint32
  var x93 fiat_p384_uint1
  x92, x93 = fiat_p384_addcarryx_u32(x65, x62, x91)
  var x94 uint32
  var x95 fiat_p384_uint1
  x94, x95 = fiat_p384_addcarryx_u32(x63, x60, x93)
  var x96 uint32 = (uint32(x95) + x61)
  var x98 fiat_p384_uint1
  _, x98 = fiat_p384_addcarryx_u32(x35, x78, 0x0)
  var x99 uint32
  var x100 fiat_p384_uint1
  x99, x100 = fiat_p384_addcarryx_u32(x37, x79, x98)
  var x101 uint32
  var x102 fiat_p384_uint1
  x101, x102 = fiat_p384_addcarryx_u32(x39, uint32(0x0), x100)
  var x103 uint32
  var x104 fiat_p384_uint1
  x103, x104 = fiat_p384_addcarryx_u32(x41, x76, x102)
  var x105 uint32
  var x106 fiat_p384_uint1
  x105, x106 = fiat_p384_addcarryx_u32(x43, x80, x104)
  var x107 uint32
  var x108 fiat_p384_uint1
  x107, x108 = fiat_p384_addcarryx_u32(x45, x82, x106)
  var x109 uint32
  var x110 fiat_p384_uint1
  x109, x110 = fiat_p384_addcarryx_u32(x47, x84, x108)
  var x111 uint32
  var x112 fiat_p384_uint1
  x111, x112 = fiat_p384_addcarryx_u32(x49, x86, x110)
  var x113 uint32
  var x114 fiat_p384_uint1
  x113, x114 = fiat_p384_addcarryx_u32(x51, x88, x112)
  var x115 uint32
  var x116 fiat_p384_uint1
  x115, x116 = fiat_p384_addcarryx_u32(x53, x90, x114)
  var x117 uint32
  var x118 fiat_p384_uint1
  x117, x118 = fiat_p384_addcarryx_u32(x55, x92, x116)
  var x119 uint32
  var x120 fiat_p384_uint1
  x119, x120 = fiat_p384_addcarryx_u32(x57, x94, x118)
  var x121 uint32
  var x122 fiat_p384_uint1
  x121, x122 = fiat_p384_addcarryx_u32(x59, x96, x120)
  var x123 uint32
  var x124 uint32
  x124, x123 = bits.Mul32(x1, (arg2[11]))
  var x125 uint32
  var x126 uint32
  x126, x125 = bits.Mul32(x1, (arg2[10]))
  var x127 uint32
  var x128 uint32
  x128, x127 = bits.Mul32(x1, (arg2[9]))
  var x129 uint32
  var x130 uint32
  x130, x129 = bits.Mul32(x1, (arg2[8]))
  var x131 uint32
  var x132 uint32
  x132, x131 = bits.Mul32(x1, (arg2[7]))
  var x133 uint32
  var x134 uint32
  x134, x133 = bits.Mul32(x1, (arg2[6]))
  var x135 uint32
  var x136 uint32
  x136, x135 = bits.Mul32(x1, (arg2[5]))
  var x137 uint32
  var x138 uint32
  x138, x137 = bits.Mul32(x1, (arg2[4]))
  var x139 uint32
  var x140 uint32
  x140, x139 = bits.Mul32(x1, (arg2[3]))
  var x141 uint32
  var x142 uint32
  x142, x141 = bits.Mul32(x1, (arg2[2]))
  var x143 uint32
  var x144 uint32
  x144, x143 = bits.Mul32(x1, (arg2[1]))
  var x145 uint32
  var x146 uint32
  x146, x145 = bits.Mul32(x1, (arg2[0]))
  var x147 uint32
  var x148 fiat_p384_uint1
  x147, x148 = fiat_p384_addcarryx_u32(x146, x143, 0x0)
  var x149 uint32
  var x150 fiat_p384_uint1
  x149, x150 = fiat_p384_addcarryx_u32(x144, x141, x148)
  var x151 uint32
  var x152 fiat_p384_uint1
  x151, x152 = fiat_p384_addcarryx_u32(x142, x139, x150)
  var x153 uint32
  var x154 fiat_p384_uint1
  x153, x154 = fiat_p384_addcarryx_u32(x140, x137, x152)
  var x155 uint32
  var x156 fiat_p384_uint1
  x155, x156 = fiat_p384_addcarryx_u32(x138, x135, x154)
  var x157 uint32
  var x158 fiat_p384_uint1
  x157, x158 = fiat_p384_addcarryx_u32(x136, x133, x156)
  var x159 uint32
  var x160 fiat_p384_uint1
  x159, x160 = fiat_p384_addcarryx_u32(x134, x131, x158)
  var x161 uint32
  var x162 fiat_p384_uint1
  x161, x162 = fiat_p384_addcarryx_u32(x132, x129, x160)
  var x163 uint32
  var x164 fiat_p384_uint1
  x163, x164 = fiat_p384_addcarryx_u32(x130, x127, x162)
  var x165 uint32
  var x166 fiat_p384_uint1
  x165, x166 = fiat_p384_addcarryx_u32(x128, x125, x164)
  var x167 uint32
  var x168 fiat_p384_uint1
  x167, x168 = fiat_p384_addcarryx_u32(x126, x123, x166)
  var x169 uint32 = (uint32(x168) + x124)
  var x170 uint32
  var x171 fiat_p384_uint1
  x170, x171 = fiat_p384_addcarryx_u32(x99, x145, 0x0)
  var x172 uint32
  var x173 fiat_p384_uint1
  x172, x173 = fiat_p384_addcarryx_u32(x101, x147, x171)
  var x174 uint32
  var x175 fiat_p384_uint1
  x174, x175 = fiat_p384_addcarryx_u32(x103, x149, x173)
  var x176 uint32
  var x177 fiat_p384_uint1
  x176, x177 = fiat_p384_addcarryx_u32(x105, x151, x175)
  var x178 uint32
  var x179 fiat_p384_uint1
  x178, x179 = fiat_p384_addcarryx_u32(x107, x153, x177)
  var x180 uint32
  var x181 fiat_p384_uint1
  x180, x181 = fiat_p384_addcarryx_u32(x109, x155, x179)
  var x182 uint32
  var x183 fiat_p384_uint1
  x182, x183 = fiat_p384_addcarryx_u32(x111, x157, x181)
  var x184 uint32
  var x185 fiat_p384_uint1
  x184, x185 = fiat_p384_addcarryx_u32(x113, x159, x183)
  var x186 uint32
  var x187 fiat_p384_uint1
  x186, x187 = fiat_p384_addcarryx_u32(x115, x161, x185)
  var x188 uint32
  var x189 fiat_p384_uint1
  x188, x189 = fiat_p384_addcarryx_u32(x117, x163, x187)
  var x190 uint32
  var x191 fiat_p384_uint1
  x190, x191 = fiat_p384_addcarryx_u32(x119, x165, x189)
  var x192 uint32
  var x193 fiat_p384_uint1
  x192, x193 = fiat_p384_addcarryx_u32(x121, x167, x191)
  var x194 uint32
  var x195 fiat_p384_uint1
  x194, x195 = fiat_p384_addcarryx_u32(uint32(x122), x169, x193)
  var x196 uint32
  var x197 uint32
  x197, x196 = bits.Mul32(x170, 0xffffffff)
  var x198 uint32
  var x199 uint32
  x199, x198 = bits.Mul32(x170, 0xffffffff)
  var x200 uint32
  var x201 uint32
  x201, x200 = bits.Mul32(x170, 0xffffffff)
  var x202 uint32
  var x203 uint32
  x203, x202 = bits.Mul32(x170, 0xffffffff)
  var x204 uint32
  var x205 uint32
  x205, x204 = bits.Mul32(x170, 0xffffffff)
  var x206 uint32
  var x207 uint32
  x207, x206 = bits.Mul32(x170, 0xffffffff)
  var x208 uint32
  var x209 uint32
  x209, x208 = bits.Mul32(x170, 0xffffffff)
  var x210 uint32
  var x211 uint32
  x211, x210 = bits.Mul32(x170, 0xfffffffe)
  var x212 uint32
  var x213 uint32
  x213, x212 = bits.Mul32(x170, 0xffffffff)
  var x214 uint32
  var x215 uint32
  x215, x214 = bits.Mul32(x170, 0xffffffff)
  var x216 uint32
  var x217 fiat_p384_uint1
  x216, x217 = fiat_p384_addcarryx_u32(x213, x210, 0x0)
  var x218 uint32
  var x219 fiat_p384_uint1
  x218, x219 = fiat_p384_addcarryx_u32(x211, x208, x217)
  var x220 uint32
  var x221 fiat_p384_uint1
  x220, x221 = fiat_p384_addcarryx_u32(x209, x206, x219)
  var x222 uint32
  var x223 fiat_p384_uint1
  x222, x223 = fiat_p384_addcarryx_u32(x207, x204, x221)
  var x224 uint32
  var x225 fiat_p384_uint1
  x224, x225 = fiat_p384_addcarryx_u32(x205, x202, x223)
  var x226 uint32
  var x227 fiat_p384_uint1
  x226, x227 = fiat_p384_addcarryx_u32(x203, x200, x225)
  var x228 uint32
  var x229 fiat_p384_uint1
  x228, x229 = fiat_p384_addcarryx_u32(x201, x198, x227)
  var x230 uint32
  var x231 fiat_p384_uint1
  x230, x231 = fiat_p384_addcarryx_u32(x199, x196, x229)
  var x232 uint32 = (uint32(x231) + x197)
  var x234 fiat_p384_uint1
  _, x234 = fiat_p384_addcarryx_u32(x170, x214, 0x0)
  var x235 uint32
  var x236 fiat_p384_uint1
  x235, x236 = fiat_p384_addcarryx_u32(x172, x215, x234)
  var x237 uint32
  var x238 fiat_p384_uint1
  x237, x238 = fiat_p384_addcarryx_u32(x174, uint32(0x0), x236)
  var x239 uint32
  var x240 fiat_p384_uint1
  x239, x240 = fiat_p384_addcarryx_u32(x176, x212, x238)
  var x241 uint32
  var x242 fiat_p384_uint1
  x241, x242 = fiat_p384_addcarryx_u32(x178, x216, x240)
  var x243 uint32
  var x244 fiat_p384_uint1
  x243, x244 = fiat_p384_addcarryx_u32(x180, x218, x242)
  var x245 uint32
  var x246 fiat_p384_uint1
  x245, x246 = fiat_p384_addcarryx_u32(x182, x220, x244)
  var x247 uint32
  var x248 fiat_p384_uint1
  x247, x248 = fiat_p384_addcarryx_u32(x184, x222, x246)
  var x249 uint32
  var x250 fiat_p384_uint1
  x249, x250 = fiat_p384_addcarryx_u32(x186, x224, x248)
  var x251 uint32
  var x252 fiat_p384_uint1
  x251, x252 = fiat_p384_addcarryx_u32(x188, x226, x250)
  var x253 uint32
  var x254 fiat_p384_uint1
  x253, x254 = fiat_p384_addcarryx_u32(x190, x228, x252)
  var x255 uint32
  var x256 fiat_p384_uint1
  x255, x256 = fiat_p384_addcarryx_u32(x192, x230, x254)
  var x257 uint32
  var x258 fiat_p384_uint1
  x257, x258 = fiat_p384_addcarryx_u32(x194, x232, x256)
  var x259 uint32 = (uint32(x258) + uint32(x195))
  var x260 uint32
  var x261 uint32
  x261, x260 = bits.Mul32(x2, (arg2[11]))
  var x262 uint32
  var x263 uint32
  x263, x262 = bits.Mul32(x2, (arg2[10]))
  var x264 uint32
  var x265 uint32
  x265, x264 = bits.Mul32(x2, (arg2[9]))
  var x266 uint32
  var x267 uint32
  x267, x266 = bits.Mul32(x2, (arg2[8]))
  var x268 uint32
  var x269 uint32
  x269, x268 = bits.Mul32(x2, (arg2[7]))
  var x270 uint32
  var x271 uint32
  x271, x270 = bits.Mul32(x2, (arg2[6]))
  var x272 uint32
  var x273 uint32
  x273, x272 = bits.Mul32(x2, (arg2[5]))
  var x274 uint32
  var x275 uint32
  x275, x274 = bits.Mul32(x2, (arg2[4]))
  var x276 uint32
  var x277 uint32
  x277, x276 = bits.Mul32(x2, (arg2[3]))
  var x278 uint32
  var x279 uint32
  x279, x278 = bits.Mul32(x2, (arg2[2]))
  var x280 uint32
  var x281 uint32
  x281, x280 = bits.Mul32(x2, (arg2[1]))
  var x282 uint32
  var x283 uint32
  x283, x282 = bits.Mul32(x2, (arg2[0]))
  var x284 uint32
  var x285 fiat_p384_uint1
  x284, x285 = fiat_p384_addcarryx_u32(x283, x280, 0x0)
  var x286 uint32
  var x287 fiat_p384_uint1
  x286, x287 = fiat_p384_addcarryx_u32(x281, x278, x285)
  var x288 uint32
  var x289 fiat_p384_uint1
  x288, x289 = fiat_p384_addcarryx_u32(x279, x276, x287)
  var x290 uint32
  var x291 fiat_p384_uint1
  x290, x291 = fiat_p384_addcarryx_u32(x277, x274, x289)
  var x292 uint32
  var x293 fiat_p384_uint1
  x292, x293 = fiat_p384_addcarryx_u32(x275, x272, x291)
  var x294 uint32
  var x295 fiat_p384_uint1
  x294, x295 = fiat_p384_addcarryx_u32(x273, x270, x293)
  var x296 uint32
  var x297 fiat_p384_uint1
  x296, x297 = fiat_p384_addcarryx_u32(x271, x268, x295)
  var x298 uint32
  var x299 fiat_p384_uint1
  x298, x299 = fiat_p384_addcarryx_u32(x269, x266, x297)
  var x300 uint32
  var x301 fiat_p384_uint1
  x300, x301 = fiat_p384_addcarryx_u32(x267, x264, x299)
  var x302 uint32
  var x303 fiat_p384_uint1
  x302, x303 = fiat_p384_addcarryx_u32(x265, x262, x301)
  var x304 uint32
  var x305 fiat_p384_uint1
  x304, x305 = fiat_p384_addcarryx_u32(x263, x260, x303)
  var x306 uint32 = (uint32(x305) + x261)
  var x307 uint32
  var x308 fiat_p384_uint1
  x307, x308 = fiat_p384_addcarryx_u32(x235, x282, 0x0)
  var x309 uint32
  var x310 fiat_p384_uint1
  x309, x310 = fiat_p384_addcarryx_u32(x237, x284, x308)
  var x311 uint32
  var x312 fiat_p384_uint1
  x311, x312 = fiat_p384_addcarryx_u32(x239, x286, x310)
  var x313 uint32
  var x314 fiat_p384_uint1
  x313, x314 = fiat_p384_addcarryx_u32(x241, x288, x312)
  var x315 uint32
  var x316 fiat_p384_uint1
  x315, x316 = fiat_p384_addcarryx_u32(x243, x290, x314)
  var x317 uint32
  var x318 fiat_p384_uint1
  x317, x318 = fiat_p384_addcarryx_u32(x245, x292, x316)
  var x319 uint32
  var x320 fiat_p384_uint1
  x319, x320 = fiat_p384_addcarryx_u32(x247, x294, x318)
  var x321 uint32
  var x322 fiat_p384_uint1
  x321, x322 = fiat_p384_addcarryx_u32(x249, x296, x320)
  var x323 uint32
  var x324 fiat_p384_uint1
  x323, x324 = fiat_p384_addcarryx_u32(x251, x298, x322)
  var x325 uint32
  var x326 fiat_p384_uint1
  x325, x326 = fiat_p384_addcarryx_u32(x253, x300, x324)
  var x327 uint32
  var x328 fiat_p384_uint1
  x327, x328 = fiat_p384_addcarryx_u32(x255, x302, x326)
  var x329 uint32
  var x330 fiat_p384_uint1
  x329, x330 = fiat_p384_addcarryx_u32(x257, x304, x328)
  var x331 uint32
  var x332 fiat_p384_uint1
  x331, x332 = fiat_p384_addcarryx_u32(x259, x306, x330)
  var x333 uint32
  var x334 uint32
  x334, x333 = bits.Mul32(x307, 0xffffffff)
  var x335 uint32
  var x336 uint32
  x336, x335 = bits.Mul32(x307, 0xffffffff)
  var x337 uint32
  var x338 uint32
  x338, x337 = bits.Mul32(x307, 0xffffffff)
  var x339 uint32
  var x340 uint32
  x340, x339 = bits.Mul32(x307, 0xffffffff)
  var x341 uint32
  var x342 uint32
  x342, x341 = bits.Mul32(x307, 0xffffffff)
  var x343 uint32
  var x344 uint32
  x344, x343 = bits.Mul32(x307, 0xffffffff)
  var x345 uint32
  var x346 uint32
  x346, x345 = bits.Mul32(x307, 0xffffffff)
  var x347 uint32
  var x348 uint32
  x348, x347 = bits.Mul32(x307, 0xfffffffe)
  var x349 uint32
  var x350 uint32
  x350, x349 = bits.Mul32(x307, 0xffffffff)
  var x351 uint32
  var x352 uint32
  x352, x351 = bits.Mul32(x307, 0xffffffff)
  var x353 uint32
  var x354 fiat_p384_uint1
  x353, x354 = fiat_p384_addcarryx_u32(x350, x347, 0x0)
  var x355 uint32
  var x356 fiat_p384_uint1
  x355, x356 = fiat_p384_addcarryx_u32(x348, x345, x354)
  var x357 uint32
  var x358 fiat_p384_uint1
  x357, x358 = fiat_p384_addcarryx_u32(x346, x343, x356)
  var x359 uint32
  var x360 fiat_p384_uint1
  x359, x360 = fiat_p384_addcarryx_u32(x344, x341, x358)
  var x361 uint32
  var x362 fiat_p384_uint1
  x361, x362 = fiat_p384_addcarryx_u32(x342, x339, x360)
  var x363 uint32
  var x364 fiat_p384_uint1
  x363, x364 = fiat_p384_addcarryx_u32(x340, x337, x362)
  var x365 uint32
  var x366 fiat_p384_uint1
  x365, x366 = fiat_p384_addcarryx_u32(x338, x335, x364)
  var x367 uint32
  var x368 fiat_p384_uint1
  x367, x368 = fiat_p384_addcarryx_u32(x336, x333, x366)
  var x369 uint32 = (uint32(x368) + x334)
  var x371 fiat_p384_uint1
  _, x371 = fiat_p384_addcarryx_u32(x307, x351, 0x0)
  var x372 uint32
  var x373 fiat_p384_uint1
  x372, x373 = fiat_p384_addcarryx_u32(x309, x352, x371)
  var x374 uint32
  var x375 fiat_p384_uint1
  x374, x375 = fiat_p384_addcarryx_u32(x311, uint32(0x0), x373)
  var x376 uint32
  var x377 fiat_p384_uint1
  x376, x377 = fiat_p384_addcarryx_u32(x313, x349, x375)
  var x378 uint32
  var x379 fiat_p384_uint1
  x378, x379 = fiat_p384_addcarryx_u32(x315, x353, x377)
  var x380 uint32
  var x381 fiat_p384_uint1
  x380, x381 = fiat_p384_addcarryx_u32(x317, x355, x379)
  var x382 uint32
  var x383 fiat_p384_uint1
  x382, x383 = fiat_p384_addcarryx_u32(x319, x357, x381)
  var x384 uint32
  var x385 fiat_p384_uint1
  x384, x385 = fiat_p384_addcarryx_u32(x321, x359, x383)
  var x386 uint32
  var x387 fiat_p384_uint1
  x386, x387 = fiat_p384_addcarryx_u32(x323, x361, x385)
  var x388 uint32
  var x389 fiat_p384_uint1
  x388, x389 = fiat_p384_addcarryx_u32(x325, x363, x387)
  var x390 uint32
  var x391 fiat_p384_uint1
  x390, x391 = fiat_p384_addcarryx_u32(x327, x365, x389)
  var x392 uint32
  var x393 fiat_p384_uint1
  x392, x393 = fiat_p384_addcarryx_u32(x329, x367, x391)
  var x394 uint32
  var x395 fiat_p384_uint1
  x394, x395 = fiat_p384_addcarryx_u32(x331, x369, x393)
  var x396 uint32 = (uint32(x395) + uint32(x332))
  var x397 uint32
  var x398 uint32
  x398, x397 = bits.Mul32(x3, (arg2[11]))
  var x399 uint32
  var x400 uint32
  x400, x399 = bits.Mul32(x3, (arg2[10]))
  var x401 uint32
  var x402 uint32
  x402, x401 = bits.Mul32(x3, (arg2[9]))
  var x403 uint32
  var x404 uint32
  x404, x403 = bits.Mul32(x3, (arg2[8]))
  var x405 uint32
  var x406 uint32
  x406, x405 = bits.Mul32(x3, (arg2[7]))
  var x407 uint32
  var x408 uint32
  x408, x407 = bits.Mul32(x3, (arg2[6]))
  var x409 uint32
  var x410 uint32
  x410, x409 = bits.Mul32(x3, (arg2[5]))
  var x411 uint32
  var x412 uint32
  x412, x411 = bits.Mul32(x3, (arg2[4]))
  var x413 uint32
  var x414 uint32
  x414, x413 = bits.Mul32(x3, (arg2[3]))
  var x415 uint32
  var x416 uint32
  x416, x415 = bits.Mul32(x3, (arg2[2]))
  var x417 uint32
  var x418 uint32
  x418, x417 = bits.Mul32(x3, (arg2[1]))
  var x419 uint32
  var x420 uint32
  x420, x419 = bits.Mul32(x3, (arg2[0]))
  var x421 uint32
  var x422 fiat_p384_uint1
  x421, x422 = fiat_p384_addcarryx_u32(x420, x417, 0x0)
  var x423 uint32
  var x424 fiat_p384_uint1
  x423, x424 = fiat_p384_addcarryx_u32(x418, x415, x422)
  var x425 uint32
  var x426 fiat_p384_uint1
  x425, x426 = fiat_p384_addcarryx_u32(x416, x413, x424)
  var x427 uint32
  var x428 fiat_p384_uint1
  x427, x428 = fiat_p384_addcarryx_u32(x414, x411, x426)
  var x429 uint32
  var x430 fiat_p384_uint1
  x429, x430 = fiat_p384_addcarryx_u32(x412, x409, x428)
  var x431 uint32
  var x432 fiat_p384_uint1
  x431, x432 = fiat_p384_addcarryx_u32(x410, x407, x430)
  var x433 uint32
  var x434 fiat_p384_uint1
  x433, x434 = fiat_p384_addcarryx_u32(x408, x405, x432)
  var x435 uint32
  var x436 fiat_p384_uint1
  x435, x436 = fiat_p384_addcarryx_u32(x406, x403, x434)
  var x437 uint32
  var x438 fiat_p384_uint1
  x437, x438 = fiat_p384_addcarryx_u32(x404, x401, x436)
  var x439 uint32
  var x440 fiat_p384_uint1
  x439, x440 = fiat_p384_addcarryx_u32(x402, x399, x438)
  var x441 uint32
  var x442 fiat_p384_uint1
  x441, x442 = fiat_p384_addcarryx_u32(x400, x397, x440)
  var x443 uint32 = (uint32(x442) + x398)
  var x444 uint32
  var x445 fiat_p384_uint1
  x444, x445 = fiat_p384_addcarryx_u32(x372, x419, 0x0)
  var x446 uint32
  var x447 fiat_p384_uint1
  x446, x447 = fiat_p384_addcarryx_u32(x374, x421, x445)
  var x448 uint32
  var x449 fiat_p384_uint1
  x448, x449 = fiat_p384_addcarryx_u32(x376, x423, x447)
  var x450 uint32
  var x451 fiat_p384_uint1
  x450, x451 = fiat_p384_addcarryx_u32(x378, x425, x449)
  var x452 uint32
  var x453 fiat_p384_uint1
  x452, x453 = fiat_p384_addcarryx_u32(x380, x427, x451)
  var x454 uint32
  var x455 fiat_p384_uint1
  x454, x455 = fiat_p384_addcarryx_u32(x382, x429, x453)
  var x456 uint32
  var x457 fiat_p384_uint1
  x456, x457 = fiat_p384_addcarryx_u32(x384, x431, x455)
  var x458 uint32
  var x459 fiat_p384_uint1
  x458, x459 = fiat_p384_addcarryx_u32(x386, x433, x457)
  var x460 uint32
  var x461 fiat_p384_uint1
  x460, x461 = fiat_p384_addcarryx_u32(x388, x435, x459)
  var x462 uint32
  var x463 fiat_p384_uint1
  x462, x463 = fiat_p384_addcarryx_u32(x390, x437, x461)
  var x464 uint32
  var x465 fiat_p384_uint1
  x464, x465 = fiat_p384_addcarryx_u32(x392, x439, x463)
  var x466 uint32
  var x467 fiat_p384_uint1
  x466, x467 = fiat_p384_addcarryx_u32(x394, x441, x465)
  var x468 uint32
  var x469 fiat_p384_uint1
  x468, x469 = fiat_p384_addcarryx_u32(x396, x443, x467)
  var x470 uint32
  var x471 uint32
  x471, x470 = bits.Mul32(x444, 0xffffffff)
  var x472 uint32
  var x473 uint32
  x473, x472 = bits.Mul32(x444, 0xffffffff)
  var x474 uint32
  var x475 uint32
  x475, x474 = bits.Mul32(x444, 0xffffffff)
  var x476 uint32
  var x477 uint32
  x477, x476 = bits.Mul32(x444, 0xffffffff)
  var x478 uint32
  var x479 uint32
  x479, x478 = bits.Mul32(x444, 0xffffffff)
  var x480 uint32
  var x481 uint32
  x481, x480 = bits.Mul32(x444, 0xffffffff)
  var x482 uint32
  var x483 uint32
  x483, x482 = bits.Mul32(x444, 0xffffffff)
  var x484 uint32
  var x485 uint32
  x485, x484 = bits.Mul32(x444, 0xfffffffe)
  var x486 uint32
  var x487 uint32
  x487, x486 = bits.Mul32(x444, 0xffffffff)
  var x488 uint32
  var x489 uint32
  x489, x488 = bits.Mul32(x444, 0xffffffff)
  var x490 uint32
  var x491 fiat_p384_uint1
  x490, x491 = fiat_p384_addcarryx_u32(x487, x484, 0x0)
  var x492 uint32
  var x493 fiat_p384_uint1
  x492, x493 = fiat_p384_addcarryx_u32(x485, x482, x491)
  var x494 uint32
  var x495 fiat_p384_uint1
  x494, x495 = fiat_p384_addcarryx_u32(x483, x480, x493)
  var x496 uint32
  var x497 fiat_p384_uint1
  x496, x497 = fiat_p384_addcarryx_u32(x481, x478, x495)
  var x498 uint32
  var x499 fiat_p384_uint1
  x498, x499 = fiat_p384_addcarryx_u32(x479, x476, x497)
  var x500 uint32
  var x501 fiat_p384_uint1
  x500, x501 = fiat_p384_addcarryx_u32(x477, x474, x499)
  var x502 uint32
  var x503 fiat_p384_uint1
  x502, x503 = fiat_p384_addcarryx_u32(x475, x472, x501)
  var x504 uint32
  var x505 fiat_p384_uint1
  x504, x505 = fiat_p384_addcarryx_u32(x473, x470, x503)
  var x506 uint32 = (uint32(x505) + x471)
  var x508 fiat_p384_uint1
  _, x508 = fiat_p384_addcarryx_u32(x444, x488, 0x0)
  var x509 uint32
  var x510 fiat_p384_uint1
  x509, x510 = fiat_p384_addcarryx_u32(x446, x489, x508)
  var x511 uint32
  var x512 fiat_p384_uint1
  x511, x512 = fiat_p384_addcarryx_u32(x448, uint32(0x0), x510)
  var x513 uint32
  var x514 fiat_p384_uint1
  x513, x514 = fiat_p384_addcarryx_u32(x450, x486, x512)
  var x515 uint32
  var x516 fiat_p384_uint1
  x515, x516 = fiat_p384_addcarryx_u32(x452, x490, x514)
  var x517 uint32
  var x518 fiat_p384_uint1
  x517, x518 = fiat_p384_addcarryx_u32(x454, x492, x516)
  var x519 uint32
  var x520 fiat_p384_uint1
  x519, x520 = fiat_p384_addcarryx_u32(x456, x494, x518)
  var x521 uint32
  var x522 fiat_p384_uint1
  x521, x522 = fiat_p384_addcarryx_u32(x458, x496, x520)
  var x523 uint32
  var x524 fiat_p384_uint1
  x523, x524 = fiat_p384_addcarryx_u32(x460, x498, x522)
  var x525 uint32
  var x526 fiat_p384_uint1
  x525, x526 = fiat_p384_addcarryx_u32(x462, x500, x524)
  var x527 uint32
  var x528 fiat_p384_uint1
  x527, x528 = fiat_p384_addcarryx_u32(x464, x502, x526)
  var x529 uint32
  var x530 fiat_p384_uint1
  x529, x530 = fiat_p384_addcarryx_u32(x466, x504, x528)
  var x531 uint32
  var x532 fiat_p384_uint1
  x531, x532 = fiat_p384_addcarryx_u32(x468, x506, x530)
  var x533 uint32 = (uint32(x532) + uint32(x469))
  var x534 uint32
  var x535 uint32
  x535, x534 = bits.Mul32(x4, (arg2[11]))
  var x536 uint32
  var x537 uint32
  x537, x536 = bits.Mul32(x4, (arg2[10]))
  var x538 uint32
  var x539 uint32
  x539, x538 = bits.Mul32(x4, (arg2[9]))
  var x540 uint32
  var x541 uint32
  x541, x540 = bits.Mul32(x4, (arg2[8]))
  var x542 uint32
  var x543 uint32
  x543, x542 = bits.Mul32(x4, (arg2[7]))
  var x544 uint32
  var x545 uint32
  x545, x544 = bits.Mul32(x4, (arg2[6]))
  var x546 uint32
  var x547 uint32
  x547, x546 = bits.Mul32(x4, (arg2[5]))
  var x548 uint32
  var x549 uint32
  x549, x548 = bits.Mul32(x4, (arg2[4]))
  var x550 uint32
  var x551 uint32
  x551, x550 = bits.Mul32(x4, (arg2[3]))
  var x552 uint32
  var x553 uint32
  x553, x552 = bits.Mul32(x4, (arg2[2]))
  var x554 uint32
  var x555 uint32
  x555, x554 = bits.Mul32(x4, (arg2[1]))
  var x556 uint32
  var x557 uint32
  x557, x556 = bits.Mul32(x4, (arg2[0]))
  var x558 uint32
  var x559 fiat_p384_uint1
  x558, x559 = fiat_p384_addcarryx_u32(x557, x554, 0x0)
  var x560 uint32
  var x561 fiat_p384_uint1
  x560, x561 = fiat_p384_addcarryx_u32(x555, x552, x559)
  var x562 uint32
  var x563 fiat_p384_uint1
  x562, x563 = fiat_p384_addcarryx_u32(x553, x550, x561)
  var x564 uint32
  var x565 fiat_p384_uint1
  x564, x565 = fiat_p384_addcarryx_u32(x551, x548, x563)
  var x566 uint32
  var x567 fiat_p384_uint1
  x566, x567 = fiat_p384_addcarryx_u32(x549, x546, x565)
  var x568 uint32
  var x569 fiat_p384_uint1
  x568, x569 = fiat_p384_addcarryx_u32(x547, x544, x567)
  var x570 uint32
  var x571 fiat_p384_uint1
  x570, x571 = fiat_p384_addcarryx_u32(x545, x542, x569)
  var x572 uint32
  var x573 fiat_p384_uint1
  x572, x573 = fiat_p384_addcarryx_u32(x543, x540, x571)
  var x574 uint32
  var x575 fiat_p384_uint1
  x574, x575 = fiat_p384_addcarryx_u32(x541, x538, x573)
  var x576 uint32
  var x577 fiat_p384_uint1
  x576, x577 = fiat_p384_addcarryx_u32(x539, x536, x575)
  var x578 uint32
  var x579 fiat_p384_uint1
  x578, x579 = fiat_p384_addcarryx_u32(x537, x534, x577)
  var x580 uint32 = (uint32(x579) + x535)
  var x581 uint32
  var x582 fiat_p384_uint1
  x581, x582 = fiat_p384_addcarryx_u32(x509, x556, 0x0)
  var x583 uint32
  var x584 fiat_p384_uint1
  x583, x584 = fiat_p384_addcarryx_u32(x511, x558, x582)
  var x585 uint32
  var x586 fiat_p384_uint1
  x585, x586 = fiat_p384_addcarryx_u32(x513, x560, x584)
  var x587 uint32
  var x588 fiat_p384_uint1
  x587, x588 = fiat_p384_addcarryx_u32(x515, x562, x586)
  var x589 uint32
  var x590 fiat_p384_uint1
  x589, x590 = fiat_p384_addcarryx_u32(x517, x564, x588)
  var x591 uint32
  var x592 fiat_p384_uint1
  x591, x592 = fiat_p384_addcarryx_u32(x519, x566, x590)
  var x593 uint32
  var x594 fiat_p384_uint1
  x593, x594 = fiat_p384_addcarryx_u32(x521, x568, x592)
  var x595 uint32
  var x596 fiat_p384_uint1
  x595, x596 = fiat_p384_addcarryx_u32(x523, x570, x594)
  var x597 uint32
  var x598 fiat_p384_uint1
  x597, x598 = fiat_p384_addcarryx_u32(x525, x572, x596)
  var x599 uint32
  var x600 fiat_p384_uint1
  x599, x600 = fiat_p384_addcarryx_u32(x527, x574, x598)
  var x601 uint32
  var x602 fiat_p384_uint1
  x601, x602 = fiat_p384_addcarryx_u32(x529, x576, x600)
  var x603 uint32
  var x604 fiat_p384_uint1
  x603, x604 = fiat_p384_addcarryx_u32(x531, x578, x602)
  var x605 uint32
  var x606 fiat_p384_uint1
  x605, x606 = fiat_p384_addcarryx_u32(x533, x580, x604)
  var x607 uint32
  var x608 uint32
  x608, x607 = bits.Mul32(x581, 0xffffffff)
  var x609 uint32
  var x610 uint32
  x610, x609 = bits.Mul32(x581, 0xffffffff)
  var x611 uint32
  var x612 uint32
  x612, x611 = bits.Mul32(x581, 0xffffffff)
  var x613 uint32
  var x614 uint32
  x614, x613 = bits.Mul32(x581, 0xffffffff)
  var x615 uint32
  var x616 uint32
  x616, x615 = bits.Mul32(x581, 0xffffffff)
  var x617 uint32
  var x618 uint32
  x618, x617 = bits.Mul32(x581, 0xffffffff)
  var x619 uint32
  var x620 uint32
  x620, x619 = bits.Mul32(x581, 0xffffffff)
  var x621 uint32
  var x622 uint32
  x622, x621 = bits.Mul32(x581, 0xfffffffe)
  var x623 uint32
  var x624 uint32
  x624, x623 = bits.Mul32(x581, 0xffffffff)
  var x625 uint32
  var x626 uint32
  x626, x625 = bits.Mul32(x581, 0xffffffff)
  var x627 uint32
  var x628 fiat_p384_uint1
  x627, x628 = fiat_p384_addcarryx_u32(x624, x621, 0x0)
  var x629 uint32
  var x630 fiat_p384_uint1
  x629, x630 = fiat_p384_addcarryx_u32(x622, x619, x628)
  var x631 uint32
  var x632 fiat_p384_uint1
  x631, x632 = fiat_p384_addcarryx_u32(x620, x617, x630)
  var x633 uint32
  var x634 fiat_p384_uint1
  x633, x634 = fiat_p384_addcarryx_u32(x618, x615, x632)
  var x635 uint32
  var x636 fiat_p384_uint1
  x635, x636 = fiat_p384_addcarryx_u32(x616, x613, x634)
  var x637 uint32
  var x638 fiat_p384_uint1
  x637, x638 = fiat_p384_addcarryx_u32(x614, x611, x636)
  var x639 uint32
  var x640 fiat_p384_uint1
  x639, x640 = fiat_p384_addcarryx_u32(x612, x609, x638)
  var x641 uint32
  var x642 fiat_p384_uint1
  x641, x642 = fiat_p384_addcarryx_u32(x610, x607, x640)
  var x643 uint32 = (uint32(x642) + x608)
  var x645 fiat_p384_uint1
  _, x645 = fiat_p384_addcarryx_u32(x581, x625, 0x0)
  var x646 uint32
  var x647 fiat_p384_uint1
  x646, x647 = fiat_p384_addcarryx_u32(x583, x626, x645)
  var x648 uint32
  var x649 fiat_p384_uint1
  x648, x649 = fiat_p384_addcarryx_u32(x585, uint32(0x0), x647)
  var x650 uint32
  var x651 fiat_p384_uint1
  x650, x651 = fiat_p384_addcarryx_u32(x587, x623, x649)
  var x652 uint32
  var x653 fiat_p384_uint1
  x652, x653 = fiat_p384_addcarryx_u32(x589, x627, x651)
  var x654 uint32
  var x655 fiat_p384_uint1
  x654, x655 = fiat_p384_addcarryx_u32(x591, x629, x653)
  var x656 uint32
  var x657 fiat_p384_uint1
  x656, x657 = fiat_p384_addcarryx_u32(x593, x631, x655)
  var x658 uint32
  var x659 fiat_p384_uint1
  x658, x659 = fiat_p384_addcarryx_u32(x595, x633, x657)
  var x660 uint32
  var x661 fiat_p384_uint1
  x660, x661 = fiat_p384_addcarryx_u32(x597, x635, x659)
  var x662 uint32
  var x663 fiat_p384_uint1
  x662, x663 = fiat_p384_addcarryx_u32(x599, x637, x661)
  var x664 uint32
  var x665 fiat_p384_uint1
  x664, x665 = fiat_p384_addcarryx_u32(x601, x639, x663)
  var x666 uint32
  var x667 fiat_p384_uint1
  x666, x667 = fiat_p384_addcarryx_u32(x603, x641, x665)
  var x668 uint32
  var x669 fiat_p384_uint1
  x668, x669 = fiat_p384_addcarryx_u32(x605, x643, x667)
  var x670 uint32 = (uint32(x669) + uint32(x606))
  var x671 uint32
  var x672 uint32
  x672, x671 = bits.Mul32(x5, (arg2[11]))
  var x673 uint32
  var x674 uint32
  x674, x673 = bits.Mul32(x5, (arg2[10]))
  var x675 uint32
  var x676 uint32
  x676, x675 = bits.Mul32(x5, (arg2[9]))
  var x677 uint32
  var x678 uint32
  x678, x677 = bits.Mul32(x5, (arg2[8]))
  var x679 uint32
  var x680 uint32
  x680, x679 = bits.Mul32(x5, (arg2[7]))
  var x681 uint32
  var x682 uint32
  x682, x681 = bits.Mul32(x5, (arg2[6]))
  var x683 uint32
  var x684 uint32
  x684, x683 = bits.Mul32(x5, (arg2[5]))
  var x685 uint32
  var x686 uint32
  x686, x685 = bits.Mul32(x5, (arg2[4]))
  var x687 uint32
  var x688 uint32
  x688, x687 = bits.Mul32(x5, (arg2[3]))
  var x689 uint32
  var x690 uint32
  x690, x689 = bits.Mul32(x5, (arg2[2]))
  var x691 uint32
  var x692 uint32
  x692, x691 = bits.Mul32(x5, (arg2[1]))
  var x693 uint32
  var x694 uint32
  x694, x693 = bits.Mul32(x5, (arg2[0]))
  var x695 uint32
  var x696 fiat_p384_uint1
  x695, x696 = fiat_p384_addcarryx_u32(x694, x691, 0x0)
  var x697 uint32
  var x698 fiat_p384_uint1
  x697, x698 = fiat_p384_addcarryx_u32(x692, x689, x696)
  var x699 uint32
  var x700 fiat_p384_uint1
  x699, x700 = fiat_p384_addcarryx_u32(x690, x687, x698)
  var x701 uint32
  var x702 fiat_p384_uint1
  x701, x702 = fiat_p384_addcarryx_u32(x688, x685, x700)
  var x703 uint32
  var x704 fiat_p384_uint1
  x703, x704 = fiat_p384_addcarryx_u32(x686, x683, x702)
  var x705 uint32
  var x706 fiat_p384_uint1
  x705, x706 = fiat_p384_addcarryx_u32(x684, x681, x704)
  var x707 uint32
  var x708 fiat_p384_uint1
  x707, x708 = fiat_p384_addcarryx_u32(x682, x679, x706)
  var x709 uint32
  var x710 fiat_p384_uint1
  x709, x710 = fiat_p384_addcarryx_u32(x680, x677, x708)
  var x711 uint32
  var x712 fiat_p384_uint1
  x711, x712 = fiat_p384_addcarryx_u32(x678, x675, x710)
  var x713 uint32
  var x714 fiat_p384_uint1
  x713, x714 = fiat_p384_addcarryx_u32(x676, x673, x712)
  var x715 uint32
  var x716 fiat_p384_uint1
  x715, x716 = fiat_p384_addcarryx_u32(x674, x671, x714)
  var x717 uint32 = (uint32(x716) + x672)
  var x718 uint32
  var x719 fiat_p384_uint1
  x718, x719 = fiat_p384_addcarryx_u32(x646, x693, 0x0)
  var x720 uint32
  var x721 fiat_p384_uint1
  x720, x721 = fiat_p384_addcarryx_u32(x648, x695, x719)
  var x722 uint32
  var x723 fiat_p384_uint1
  x722, x723 = fiat_p384_addcarryx_u32(x650, x697, x721)
  var x724 uint32
  var x725 fiat_p384_uint1
  x724, x725 = fiat_p384_addcarryx_u32(x652, x699, x723)
  var x726 uint32
  var x727 fiat_p384_uint1
  x726, x727 = fiat_p384_addcarryx_u32(x654, x701, x725)
  var x728 uint32
  var x729 fiat_p384_uint1
  x728, x729 = fiat_p384_addcarryx_u32(x656, x703, x727)
  var x730 uint32
  var x731 fiat_p384_uint1
  x730, x731 = fiat_p384_addcarryx_u32(x658, x705, x729)
  var x732 uint32
  var x733 fiat_p384_uint1
  x732, x733 = fiat_p384_addcarryx_u32(x660, x707, x731)
  var x734 uint32
  var x735 fiat_p384_uint1
  x734, x735 = fiat_p384_addcarryx_u32(x662, x709, x733)
  var x736 uint32
  var x737 fiat_p384_uint1
  x736, x737 = fiat_p384_addcarryx_u32(x664, x711, x735)
  var x738 uint32
  var x739 fiat_p384_uint1
  x738, x739 = fiat_p384_addcarryx_u32(x666, x713, x737)
  var x740 uint32
  var x741 fiat_p384_uint1
  x740, x741 = fiat_p384_addcarryx_u32(x668, x715, x739)
  var x742 uint32
  var x743 fiat_p384_uint1
  x742, x743 = fiat_p384_addcarryx_u32(x670, x717, x741)
  var x744 uint32
  var x745 uint32
  x745, x744 = bits.Mul32(x718, 0xffffffff)
  var x746 uint32
  var x747 uint32
  x747, x746 = bits.Mul32(x718, 0xffffffff)
  var x748 uint32
  var x749 uint32
  x749, x748 = bits.Mul32(x718, 0xffffffff)
  var x750 uint32
  var x751 uint32
  x751, x750 = bits.Mul32(x718, 0xffffffff)
  var x752 uint32
  var x753 uint32
  x753, x752 = bits.Mul32(x718, 0xffffffff)
  var x754 uint32
  var x755 uint32
  x755, x754 = bits.Mul32(x718, 0xffffffff)
  var x756 uint32
  var x757 uint32
  x757, x756 = bits.Mul32(x718, 0xffffffff)
  var x758 uint32
  var x759 uint32
  x759, x758 = bits.Mul32(x718, 0xfffffffe)
  var x760 uint32
  var x761 uint32
  x761, x760 = bits.Mul32(x718, 0xffffffff)
  var x762 uint32
  var x763 uint32
  x763, x762 = bits.Mul32(x718, 0xffffffff)
  var x764 uint32
  var x765 fiat_p384_uint1
  x764, x765 = fiat_p384_addcarryx_u32(x761, x758, 0x0)
  var x766 uint32
  var x767 fiat_p384_uint1
  x766, x767 = fiat_p384_addcarryx_u32(x759, x756, x765)
  var x768 uint32
  var x769 fiat_p384_uint1
  x768, x769 = fiat_p384_addcarryx_u32(x757, x754, x767)
  var x770 uint32
  var x771 fiat_p384_uint1
  x770, x771 = fiat_p384_addcarryx_u32(x755, x752, x769)
  var x772 uint32
  var x773 fiat_p384_uint1
  x772, x773 = fiat_p384_addcarryx_u32(x753, x750, x771)
  var x774 uint32
  var x775 fiat_p384_uint1
  x774, x775 = fiat_p384_addcarryx_u32(x751, x748, x773)
  var x776 uint32
  var x777 fiat_p384_uint1
  x776, x777 = fiat_p384_addcarryx_u32(x749, x746, x775)
  var x778 uint32
  var x779 fiat_p384_uint1
  x778, x779 = fiat_p384_addcarryx_u32(x747, x744, x777)
  var x780 uint32 = (uint32(x779) + x745)
  var x782 fiat_p384_uint1
  _, x782 = fiat_p384_addcarryx_u32(x718, x762, 0x0)
  var x783 uint32
  var x784 fiat_p384_uint1
  x783, x784 = fiat_p384_addcarryx_u32(x720, x763, x782)
  var x785 uint32
  var x786 fiat_p384_uint1
  x785, x786 = fiat_p384_addcarryx_u32(x722, uint32(0x0), x784)
  var x787 uint32
  var x788 fiat_p384_uint1
  x787, x788 = fiat_p384_addcarryx_u32(x724, x760, x786)
  var x789 uint32
  var x790 fiat_p384_uint1
  x789, x790 = fiat_p384_addcarryx_u32(x726, x764, x788)
  var x791 uint32
  var x792 fiat_p384_uint1
  x791, x792 = fiat_p384_addcarryx_u32(x728, x766, x790)
  var x793 uint32
  var x794 fiat_p384_uint1
  x793, x794 = fiat_p384_addcarryx_u32(x730, x768, x792)
  var x795 uint32
  var x796 fiat_p384_uint1
  x795, x796 = fiat_p384_addcarryx_u32(x732, x770, x794)
  var x797 uint32
  var x798 fiat_p384_uint1
  x797, x798 = fiat_p384_addcarryx_u32(x734, x772, x796)
  var x799 uint32
  var x800 fiat_p384_uint1
  x799, x800 = fiat_p384_addcarryx_u32(x736, x774, x798)
  var x801 uint32
  var x802 fiat_p384_uint1
  x801, x802 = fiat_p384_addcarryx_u32(x738, x776, x800)
  var x803 uint32
  var x804 fiat_p384_uint1
  x803, x804 = fiat_p384_addcarryx_u32(x740, x778, x802)
  var x805 uint32
  var x806 fiat_p384_uint1
  x805, x806 = fiat_p384_addcarryx_u32(x742, x780, x804)
  var x807 uint32 = (uint32(x806) + uint32(x743))
  var x808 uint32
  var x809 uint32
  x809, x808 = bits.Mul32(x6, (arg2[11]))
  var x810 uint32
  var x811 uint32
  x811, x810 = bits.Mul32(x6, (arg2[10]))
  var x812 uint32
  var x813 uint32
  x813, x812 = bits.Mul32(x6, (arg2[9]))
  var x814 uint32
  var x815 uint32
  x815, x814 = bits.Mul32(x6, (arg2[8]))
  var x816 uint32
  var x817 uint32
  x817, x816 = bits.Mul32(x6, (arg2[7]))
  var x818 uint32
  var x819 uint32
  x819, x818 = bits.Mul32(x6, (arg2[6]))
  var x820 uint32
  var x821 uint32
  x821, x820 = bits.Mul32(x6, (arg2[5]))
  var x822 uint32
  var x823 uint32
  x823, x822 = bits.Mul32(x6, (arg2[4]))
  var x824 uint32
  var x825 uint32
  x825, x824 = bits.Mul32(x6, (arg2[3]))
  var x826 uint32
  var x827 uint32
  x827, x826 = bits.Mul32(x6, (arg2[2]))
  var x828 uint32
  var x829 uint32
  x829, x828 = bits.Mul32(x6, (arg2[1]))
  var x830 uint32
  var x831 uint32
  x831, x830 = bits.Mul32(x6, (arg2[0]))
  var x832 uint32
  var x833 fiat_p384_uint1
  x832, x833 = fiat_p384_addcarryx_u32(x831, x828, 0x0)
  var x834 uint32
  var x835 fiat_p384_uint1
  x834, x835 = fiat_p384_addcarryx_u32(x829, x826, x833)
  var x836 uint32
  var x837 fiat_p384_uint1
  x836, x837 = fiat_p384_addcarryx_u32(x827, x824, x835)
  var x838 uint32
  var x839 fiat_p384_uint1
  x838, x839 = fiat_p384_addcarryx_u32(x825, x822, x837)
  var x840 uint32
  var x841 fiat_p384_uint1
  x840, x841 = fiat_p384_addcarryx_u32(x823, x820, x839)
  var x842 uint32
  var x843 fiat_p384_uint1
  x842, x843 = fiat_p384_addcarryx_u32(x821, x818, x841)
  var x844 uint32
  var x845 fiat_p384_uint1
  x844, x845 = fiat_p384_addcarryx_u32(x819, x816, x843)
  var x846 uint32
  var x847 fiat_p384_uint1
  x846, x847 = fiat_p384_addcarryx_u32(x817, x814, x845)
  var x848 uint32
  var x849 fiat_p384_uint1
  x848, x849 = fiat_p384_addcarryx_u32(x815, x812, x847)
  var x850 uint32
  var x851 fiat_p384_uint1
  x850, x851 = fiat_p384_addcarryx_u32(x813, x810, x849)
  var x852 uint32
  var x853 fiat_p384_uint1
  x852, x853 = fiat_p384_addcarryx_u32(x811, x808, x851)
  var x854 uint32 = (uint32(x853) + x809)
  var x855 uint32
  var x856 fiat_p384_uint1
  x855, x856 = fiat_p384_addcarryx_u32(x783, x830, 0x0)
  var x857 uint32
  var x858 fiat_p384_uint1
  x857, x858 = fiat_p384_addcarryx_u32(x785, x832, x856)
  var x859 uint32
  var x860 fiat_p384_uint1
  x859, x860 = fiat_p384_addcarryx_u32(x787, x834, x858)
  var x861 uint32
  var x862 fiat_p384_uint1
  x861, x862 = fiat_p384_addcarryx_u32(x789, x836, x860)
  var x863 uint32
  var x864 fiat_p384_uint1
  x863, x864 = fiat_p384_addcarryx_u32(x791, x838, x862)
  var x865 uint32
  var x866 fiat_p384_uint1
  x865, x866 = fiat_p384_addcarryx_u32(x793, x840, x864)
  var x867 uint32
  var x868 fiat_p384_uint1
  x867, x868 = fiat_p384_addcarryx_u32(x795, x842, x866)
  var x869 uint32
  var x870 fiat_p384_uint1
  x869, x870 = fiat_p384_addcarryx_u32(x797, x844, x868)
  var x871 uint32
  var x872 fiat_p384_uint1
  x871, x872 = fiat_p384_addcarryx_u32(x799, x846, x870)
  var x873 uint32
  var x874 fiat_p384_uint1
  x873, x874 = fiat_p384_addcarryx_u32(x801, x848, x872)
  var x875 uint32
  var x876 fiat_p384_uint1
  x875, x876 = fiat_p384_addcarryx_u32(x803, x850, x874)
  var x877 uint32
  var x878 fiat_p384_uint1
  x877, x878 = fiat_p384_addcarryx_u32(x805, x852, x876)
  var x879 uint32
  var x880 fiat_p384_uint1
  x879, x880 = fiat_p384_addcarryx_u32(x807, x854, x878)
  var x881 uint32
  var x882 uint32
  x882, x881 = bits.Mul32(x855, 0xffffffff)
  var x883 uint32
  var x884 uint32
  x884, x883 = bits.Mul32(x855, 0xffffffff)
  var x885 uint32
  var x886 uint32
  x886, x885 = bits.Mul32(x855, 0xffffffff)
  var x887 uint32
  var x888 uint32
  x888, x887 = bits.Mul32(x855, 0xffffffff)
  var x889 uint32
  var x890 uint32
  x890, x889 = bits.Mul32(x855, 0xffffffff)
  var x891 uint32
  var x892 uint32
  x892, x891 = bits.Mul32(x855, 0xffffffff)
  var x893 uint32
  var x894 uint32
  x894, x893 = bits.Mul32(x855, 0xffffffff)
  var x895 uint32
  var x896 uint32
  x896, x895 = bits.Mul32(x855, 0xfffffffe)
  var x897 uint32
  var x898 uint32
  x898, x897 = bits.Mul32(x855, 0xffffffff)
  var x899 uint32
  var x900 uint32
  x900, x899 = bits.Mul32(x855, 0xffffffff)
  var x901 uint32
  var x902 fiat_p384_uint1
  x901, x902 = fiat_p384_addcarryx_u32(x898, x895, 0x0)
  var x903 uint32
  var x904 fiat_p384_uint1
  x903, x904 = fiat_p384_addcarryx_u32(x896, x893, x902)
  var x905 uint32
  var x906 fiat_p384_uint1
  x905, x906 = fiat_p384_addcarryx_u32(x894, x891, x904)
  var x907 uint32
  var x908 fiat_p384_uint1
  x907, x908 = fiat_p384_addcarryx_u32(x892, x889, x906)
  var x909 uint32
  var x910 fiat_p384_uint1
  x909, x910 = fiat_p384_addcarryx_u32(x890, x887, x908)
  var x911 uint32
  var x912 fiat_p384_uint1
  x911, x912 = fiat_p384_addcarryx_u32(x888, x885, x910)
  var x913 uint32
  var x914 fiat_p384_uint1
  x913, x914 = fiat_p384_addcarryx_u32(x886, x883, x912)
  var x915 uint32
  var x916 fiat_p384_uint1
  x915, x916 = fiat_p384_addcarryx_u32(x884, x881, x914)
  var x917 uint32 = (uint32(x916) + x882)
  var x919 fiat_p384_uint1
  _, x919 = fiat_p384_addcarryx_u32(x855, x899, 0x0)
  var x920 uint32
  var x921 fiat_p384_uint1
  x920, x921 = fiat_p384_addcarryx_u32(x857, x900, x919)
  var x922 uint32
  var x923 fiat_p384_uint1
  x922, x923 = fiat_p384_addcarryx_u32(x859, uint32(0x0), x921)
  var x924 uint32
  var x925 fiat_p384_uint1
  x924, x925 = fiat_p384_addcarryx_u32(x861, x897, x923)
  var x926 uint32
  var x927 fiat_p384_uint1
  x926, x927 = fiat_p384_addcarryx_u32(x863, x901, x925)
  var x928 uint32
  var x929 fiat_p384_uint1
  x928, x929 = fiat_p384_addcarryx_u32(x865, x903, x927)
  var x930 uint32
  var x931 fiat_p384_uint1
  x930, x931 = fiat_p384_addcarryx_u32(x867, x905, x929)
  var x932 uint32
  var x933 fiat_p384_uint1
  x932, x933 = fiat_p384_addcarryx_u32(x869, x907, x931)
  var x934 uint32
  var x935 fiat_p384_uint1
  x934, x935 = fiat_p384_addcarryx_u32(x871, x909, x933)
  var x936 uint32
  var x937 fiat_p384_uint1
  x936, x937 = fiat_p384_addcarryx_u32(x873, x911, x935)
  var x938 uint32
  var x939 fiat_p384_uint1
  x938, x939 = fiat_p384_addcarryx_u32(x875, x913, x937)
  var x940 uint32
  var x941 fiat_p384_uint1
  x940, x941 = fiat_p384_addcarryx_u32(x877, x915, x939)
  var x942 uint32
  var x943 fiat_p384_uint1
  x942, x943 = fiat_p384_addcarryx_u32(x879, x917, x941)
  var x944 uint32 = (uint32(x943) + uint32(x880))
  var x945 uint32
  var x946 uint32
  x946, x945 = bits.Mul32(x7, (arg2[11]))
  var x947 uint32
  var x948 uint32
  x948, x947 = bits.Mul32(x7, (arg2[10]))
  var x949 uint32
  var x950 uint32
  x950, x949 = bits.Mul32(x7, (arg2[9]))
  var x951 uint32
  var x952 uint32
  x952, x951 = bits.Mul32(x7, (arg2[8]))
  var x953 uint32
  var x954 uint32
  x954, x953 = bits.Mul32(x7, (arg2[7]))
  var x955 uint32
  var x956 uint32
  x956, x955 = bits.Mul32(x7, (arg2[6]))
  var x957 uint32
  var x958 uint32
  x958, x957 = bits.Mul32(x7, (arg2[5]))
  var x959 uint32
  var x960 uint32
  x960, x959 = bits.Mul32(x7, (arg2[4]))
  var x961 uint32
  var x962 uint32
  x962, x961 = bits.Mul32(x7, (arg2[3]))
  var x963 uint32
  var x964 uint32
  x964, x963 = bits.Mul32(x7, (arg2[2]))
  var x965 uint32
  var x966 uint32
  x966, x965 = bits.Mul32(x7, (arg2[1]))
  var x967 uint32
  var x968 uint32
  x968, x967 = bits.Mul32(x7, (arg2[0]))
  var x969 uint32
  var x970 fiat_p384_uint1
  x969, x970 = fiat_p384_addcarryx_u32(x968, x965, 0x0)
  var x971 uint32
  var x972 fiat_p384_uint1
  x971, x972 = fiat_p384_addcarryx_u32(x966, x963, x970)
  var x973 uint32
  var x974 fiat_p384_uint1
  x973, x974 = fiat_p384_addcarryx_u32(x964, x961, x972)
  var x975 uint32
  var x976 fiat_p384_uint1
  x975, x976 = fiat_p384_addcarryx_u32(x962, x959, x974)
  var x977 uint32
  var x978 fiat_p384_uint1
  x977, x978 = fiat_p384_addcarryx_u32(x960, x957, x976)
  var x979 uint32
  var x980 fiat_p384_uint1
  x979, x980 = fiat_p384_addcarryx_u32(x958, x955, x978)
  var x981 uint32
  var x982 fiat_p384_uint1
  x981, x982 = fiat_p384_addcarryx_u32(x956, x953, x980)
  var x983 uint32
  var x984 fiat_p384_uint1
  x983, x984 = fiat_p384_addcarryx_u32(x954, x951, x982)
  var x985 uint32
  var x986 fiat_p384_uint1
  x985, x986 = fiat_p384_addcarryx_u32(x952, x949, x984)
  var x987 uint32
  var x988 fiat_p384_uint1
  x987, x988 = fiat_p384_addcarryx_u32(x950, x947, x986)
  var x989 uint32
  var x990 fiat_p384_uint1
  x989, x990 = fiat_p384_addcarryx_u32(x948, x945, x988)
  var x991 uint32 = (uint32(x990) + x946)
  var x992 uint32
  var x993 fiat_p384_uint1
  x992, x993 = fiat_p384_addcarryx_u32(x920, x967, 0x0)
  var x994 uint32
  var x995 fiat_p384_uint1
  x994, x995 = fiat_p384_addcarryx_u32(x922, x969, x993)
  var x996 uint32
  var x997 fiat_p384_uint1
  x996, x997 = fiat_p384_addcarryx_u32(x924, x971, x995)
  var x998 uint32
  var x999 fiat_p384_uint1
  x998, x999 = fiat_p384_addcarryx_u32(x926, x973, x997)
  var x1000 uint32
  var x1001 fiat_p384_uint1
  x1000, x1001 = fiat_p384_addcarryx_u32(x928, x975, x999)
  var x1002 uint32
  var x1003 fiat_p384_uint1
  x1002, x1003 = fiat_p384_addcarryx_u32(x930, x977, x1001)
  var x1004 uint32
  var x1005 fiat_p384_uint1
  x1004, x1005 = fiat_p384_addcarryx_u32(x932, x979, x1003)
  var x1006 uint32
  var x1007 fiat_p384_uint1
  x1006, x1007 = fiat_p384_addcarryx_u32(x934, x981, x1005)
  var x1008 uint32
  var x1009 fiat_p384_uint1
  x1008, x1009 = fiat_p384_addcarryx_u32(x936, x983, x1007)
  var x1010 uint32
  var x1011 fiat_p384_uint1
  x1010, x1011 = fiat_p384_addcarryx_u32(x938, x985, x1009)
  var x1012 uint32
  var x1013 fiat_p384_uint1
  x1012, x1013 = fiat_p384_addcarryx_u32(x940, x987, x1011)
  var x1014 uint32
  var x1015 fiat_p384_uint1
  x1014, x1015 = fiat_p384_addcarryx_u32(x942, x989, x1013)
  var x1016 uint32
  var x1017 fiat_p384_uint1
  x1016, x1017 = fiat_p384_addcarryx_u32(x944, x991, x1015)
  var x1018 uint32
  var x1019 uint32
  x1019, x1018 = bits.Mul32(x992, 0xffffffff)
  var x1020 uint32
  var x1021 uint32
  x1021, x1020 = bits.Mul32(x992, 0xffffffff)
  var x1022 uint32
  var x1023 uint32
  x1023, x1022 = bits.Mul32(x992, 0xffffffff)
  var x1024 uint32
  var x1025 uint32
  x1025, x1024 = bits.Mul32(x992, 0xffffffff)
  var x1026 uint32
  var x1027 uint32
  x1027, x1026 = bits.Mul32(x992, 0xffffffff)
  var x1028 uint32
  var x1029 uint32
  x1029, x1028 = bits.Mul32(x992, 0xffffffff)
  var x1030 uint32
  var x1031 uint32
  x1031, x1030 = bits.Mul32(x992, 0xffffffff)
  var x1032 uint32
  var x1033 uint32
  x1033, x1032 = bits.Mul32(x992, 0xfffffffe)
  var x1034 uint32
  var x1035 uint32
  x1035, x1034 = bits.Mul32(x992, 0xffffffff)
  var x1036 uint32
  var x1037 uint32
  x1037, x1036 = bits.Mul32(x992, 0xffffffff)
  var x1038 uint32
  var x1039 fiat_p384_uint1
  x1038, x1039 = fiat_p384_addcarryx_u32(x1035, x1032, 0x0)
  var x1040 uint32
  var x1041 fiat_p384_uint1
  x1040, x1041 = fiat_p384_addcarryx_u32(x1033, x1030, x1039)
  var x1042 uint32
  var x1043 fiat_p384_uint1
  x1042, x1043 = fiat_p384_addcarryx_u32(x1031, x1028, x1041)
  var x1044 uint32
  var x1045 fiat_p384_uint1
  x1044, x1045 = fiat_p384_addcarryx_u32(x1029, x1026, x1043)
  var x1046 uint32
  var x1047 fiat_p384_uint1
  x1046, x1047 = fiat_p384_addcarryx_u32(x1027, x1024, x1045)
  var x1048 uint32
  var x1049 fiat_p384_uint1
  x1048, x1049 = fiat_p384_addcarryx_u32(x1025, x1022, x1047)
  var x1050 uint32
  var x1051 fiat_p384_uint1
  x1050, x1051 = fiat_p384_addcarryx_u32(x1023, x1020, x1049)
  var x1052 uint32
  var x1053 fiat_p384_uint1
  x1052, x1053 = fiat_p384_addcarryx_u32(x1021, x1018, x1051)
  var x1054 uint32 = (uint32(x1053) + x1019)
  var x1056 fiat_p384_uint1
  _, x1056 = fiat_p384_addcarryx_u32(x992, x1036, 0x0)
  var x1057 uint32
  var x1058 fiat_p384_uint1
  x1057, x1058 = fiat_p384_addcarryx_u32(x994, x1037, x1056)
  var x1059 uint32
  var x1060 fiat_p384_uint1
  x1059, x1060 = fiat_p384_addcarryx_u32(x996, uint32(0x0), x1058)
  var x1061 uint32
  var x1062 fiat_p384_uint1
  x1061, x1062 = fiat_p384_addcarryx_u32(x998, x1034, x1060)
  var x1063 uint32
  var x1064 fiat_p384_uint1
  x1063, x1064 = fiat_p384_addcarryx_u32(x1000, x1038, x1062)
  var x1065 uint32
  var x1066 fiat_p384_uint1
  x1065, x1066 = fiat_p384_addcarryx_u32(x1002, x1040, x1064)
  var x1067 uint32
  var x1068 fiat_p384_uint1
  x1067, x1068 = fiat_p384_addcarryx_u32(x1004, x1042, x1066)
  var x1069 uint32
  var x1070 fiat_p384_uint1
  x1069, x1070 = fiat_p384_addcarryx_u32(x1006, x1044, x1068)
  var x1071 uint32
  var x1072 fiat_p384_uint1
  x1071, x1072 = fiat_p384_addcarryx_u32(x1008, x1046, x1070)
  var x1073 uint32
  var x1074 fiat_p384_uint1
  x1073, x1074 = fiat_p384_addcarryx_u32(x1010, x1048, x1072)
  var x1075 uint32
  var x1076 fiat_p384_uint1
  x1075, x1076 = fiat_p384_addcarryx_u32(x1012, x1050, x1074)
  var x1077 uint32
  var x1078 fiat_p384_uint1
  x1077, x1078 = fiat_p384_addcarryx_u32(x1014, x1052, x1076)
  var x1079 uint32
  var x1080 fiat_p384_uint1
  x1079, x1080 = fiat_p384_addcarryx_u32(x1016, x1054, x1078)
  var x1081 uint32 = (uint32(x1080) + uint32(x1017))
  var x1082 uint32
  var x1083 uint32
  x1083, x1082 = bits.Mul32(x8, (arg2[11]))
  var x1084 uint32
  var x1085 uint32
  x1085, x1084 = bits.Mul32(x8, (arg2[10]))
  var x1086 uint32
  var x1087 uint32
  x1087, x1086 = bits.Mul32(x8, (arg2[9]))
  var x1088 uint32
  var x1089 uint32
  x1089, x1088 = bits.Mul32(x8, (arg2[8]))
  var x1090 uint32
  var x1091 uint32
  x1091, x1090 = bits.Mul32(x8, (arg2[7]))
  var x1092 uint32
  var x1093 uint32
  x1093, x1092 = bits.Mul32(x8, (arg2[6]))
  var x1094 uint32
  var x1095 uint32
  x1095, x1094 = bits.Mul32(x8, (arg2[5]))
  var x1096 uint32
  var x1097 uint32
  x1097, x1096 = bits.Mul32(x8, (arg2[4]))
  var x1098 uint32
  var x1099 uint32
  x1099, x1098 = bits.Mul32(x8, (arg2[3]))
  var x1100 uint32
  var x1101 uint32
  x1101, x1100 = bits.Mul32(x8, (arg2[2]))
  var x1102 uint32
  var x1103 uint32
  x1103, x1102 = bits.Mul32(x8, (arg2[1]))
  var x1104 uint32
  var x1105 uint32
  x1105, x1104 = bits.Mul32(x8, (arg2[0]))
  var x1106 uint32
  var x1107 fiat_p384_uint1
  x1106, x1107 = fiat_p384_addcarryx_u32(x1105, x1102, 0x0)
  var x1108 uint32
  var x1109 fiat_p384_uint1
  x1108, x1109 = fiat_p384_addcarryx_u32(x1103, x1100, x1107)
  var x1110 uint32
  var x1111 fiat_p384_uint1
  x1110, x1111 = fiat_p384_addcarryx_u32(x1101, x1098, x1109)
  var x1112 uint32
  var x1113 fiat_p384_uint1
  x1112, x1113 = fiat_p384_addcarryx_u32(x1099, x1096, x1111)
  var x1114 uint32
  var x1115 fiat_p384_uint1
  x1114, x1115 = fiat_p384_addcarryx_u32(x1097, x1094, x1113)
  var x1116 uint32
  var x1117 fiat_p384_uint1
  x1116, x1117 = fiat_p384_addcarryx_u32(x1095, x1092, x1115)
  var x1118 uint32
  var x1119 fiat_p384_uint1
  x1118, x1119 = fiat_p384_addcarryx_u32(x1093, x1090, x1117)
  var x1120 uint32
  var x1121 fiat_p384_uint1
  x1120, x1121 = fiat_p384_addcarryx_u32(x1091, x1088, x1119)
  var x1122 uint32
  var x1123 fiat_p384_uint1
  x1122, x1123 = fiat_p384_addcarryx_u32(x1089, x1086, x1121)
  var x1124 uint32
  var x1125 fiat_p384_uint1
  x1124, x1125 = fiat_p384_addcarryx_u32(x1087, x1084, x1123)
  var x1126 uint32
  var x1127 fiat_p384_uint1
  x1126, x1127 = fiat_p384_addcarryx_u32(x1085, x1082, x1125)
  var x1128 uint32 = (uint32(x1127) + x1083)
  var x1129 uint32
  var x1130 fiat_p384_uint1
  x1129, x1130 = fiat_p384_addcarryx_u32(x1057, x1104, 0x0)
  var x1131 uint32
  var x1132 fiat_p384_uint1
  x1131, x1132 = fiat_p384_addcarryx_u32(x1059, x1106, x1130)
  var x1133 uint32
  var x1134 fiat_p384_uint1
  x1133, x1134 = fiat_p384_addcarryx_u32(x1061, x1108, x1132)
  var x1135 uint32
  var x1136 fiat_p384_uint1
  x1135, x1136 = fiat_p384_addcarryx_u32(x1063, x1110, x1134)
  var x1137 uint32
  var x1138 fiat_p384_uint1
  x1137, x1138 = fiat_p384_addcarryx_u32(x1065, x1112, x1136)
  var x1139 uint32
  var x1140 fiat_p384_uint1
  x1139, x1140 = fiat_p384_addcarryx_u32(x1067, x1114, x1138)
  var x1141 uint32
  var x1142 fiat_p384_uint1
  x1141, x1142 = fiat_p384_addcarryx_u32(x1069, x1116, x1140)
  var x1143 uint32
  var x1144 fiat_p384_uint1
  x1143, x1144 = fiat_p384_addcarryx_u32(x1071, x1118, x1142)
  var x1145 uint32
  var x1146 fiat_p384_uint1
  x1145, x1146 = fiat_p384_addcarryx_u32(x1073, x1120, x1144)
  var x1147 uint32
  var x1148 fiat_p384_uint1
  x1147, x1148 = fiat_p384_addcarryx_u32(x1075, x1122, x1146)
  var x1149 uint32
  var x1150 fiat_p384_uint1
  x1149, x1150 = fiat_p384_addcarryx_u32(x1077, x1124, x1148)
  var x1151 uint32
  var x1152 fiat_p384_uint1
  x1151, x1152 = fiat_p384_addcarryx_u32(x1079, x1126, x1150)
  var x1153 uint32
  var x1154 fiat_p384_uint1
  x1153, x1154 = fiat_p384_addcarryx_u32(x1081, x1128, x1152)
  var x1155 uint32
  var x1156 uint32
  x1156, x1155 = bits.Mul32(x1129, 0xffffffff)
  var x1157 uint32
  var x1158 uint32
  x1158, x1157 = bits.Mul32(x1129, 0xffffffff)
  var x1159 uint32
  var x1160 uint32
  x1160, x1159 = bits.Mul32(x1129, 0xffffffff)
  var x1161 uint32
  var x1162 uint32
  x1162, x1161 = bits.Mul32(x1129, 0xffffffff)
  var x1163 uint32
  var x1164 uint32
  x1164, x1163 = bits.Mul32(x1129, 0xffffffff)
  var x1165 uint32
  var x1166 uint32
  x1166, x1165 = bits.Mul32(x1129, 0xffffffff)
  var x1167 uint32
  var x1168 uint32
  x1168, x1167 = bits.Mul32(x1129, 0xffffffff)
  var x1169 uint32
  var x1170 uint32
  x1170, x1169 = bits.Mul32(x1129, 0xfffffffe)
  var x1171 uint32
  var x1172 uint32
  x1172, x1171 = bits.Mul32(x1129, 0xffffffff)
  var x1173 uint32
  var x1174 uint32
  x1174, x1173 = bits.Mul32(x1129, 0xffffffff)
  var x1175 uint32
  var x1176 fiat_p384_uint1
  x1175, x1176 = fiat_p384_addcarryx_u32(x1172, x1169, 0x0)
  var x1177 uint32
  var x1178 fiat_p384_uint1
  x1177, x1178 = fiat_p384_addcarryx_u32(x1170, x1167, x1176)
  var x1179 uint32
  var x1180 fiat_p384_uint1
  x1179, x1180 = fiat_p384_addcarryx_u32(x1168, x1165, x1178)
  var x1181 uint32
  var x1182 fiat_p384_uint1
  x1181, x1182 = fiat_p384_addcarryx_u32(x1166, x1163, x1180)
  var x1183 uint32
  var x1184 fiat_p384_uint1
  x1183, x1184 = fiat_p384_addcarryx_u32(x1164, x1161, x1182)
  var x1185 uint32
  var x1186 fiat_p384_uint1
  x1185, x1186 = fiat_p384_addcarryx_u32(x1162, x1159, x1184)
  var x1187 uint32
  var x1188 fiat_p384_uint1
  x1187, x1188 = fiat_p384_addcarryx_u32(x1160, x1157, x1186)
  var x1189 uint32
  var x1190 fiat_p384_uint1
  x1189, x1190 = fiat_p384_addcarryx_u32(x1158, x1155, x1188)
  var x1191 uint32 = (uint32(x1190) + x1156)
  var x1193 fiat_p384_uint1
  _, x1193 = fiat_p384_addcarryx_u32(x1129, x1173, 0x0)
  var x1194 uint32
  var x1195 fiat_p384_uint1
  x1194, x1195 = fiat_p384_addcarryx_u32(x1131, x1174, x1193)
  var x1196 uint32
  var x1197 fiat_p384_uint1
  x1196, x1197 = fiat_p384_addcarryx_u32(x1133, uint32(0x0), x1195)
  var x1198 uint32
  var x1199 fiat_p384_uint1
  x1198, x1199 = fiat_p384_addcarryx_u32(x1135, x1171, x1197)
  var x1200 uint32
  var x1201 fiat_p384_uint1
  x1200, x1201 = fiat_p384_addcarryx_u32(x1137, x1175, x1199)
  var x1202 uint32
  var x1203 fiat_p384_uint1
  x1202, x1203 = fiat_p384_addcarryx_u32(x1139, x1177, x1201)
  var x1204 uint32
  var x1205 fiat_p384_uint1
  x1204, x1205 = fiat_p384_addcarryx_u32(x1141, x1179, x1203)
  var x1206 uint32
  var x1207 fiat_p384_uint1
  x1206, x1207 = fiat_p384_addcarryx_u32(x1143, x1181, x1205)
  var x1208 uint32
  var x1209 fiat_p384_uint1
  x1208, x1209 = fiat_p384_addcarryx_u32(x1145, x1183, x1207)
  var x1210 uint32
  var x1211 fiat_p384_uint1
  x1210, x1211 = fiat_p384_addcarryx_u32(x1147, x1185, x1209)
  var x1212 uint32
  var x1213 fiat_p384_uint1
  x1212, x1213 = fiat_p384_addcarryx_u32(x1149, x1187, x1211)
  var x1214 uint32
  var x1215 fiat_p384_uint1
  x1214, x1215 = fiat_p384_addcarryx_u32(x1151, x1189, x1213)
  var x1216 uint32
  var x1217 fiat_p384_uint1
  x1216, x1217 = fiat_p384_addcarryx_u32(x1153, x1191, x1215)
  var x1218 uint32 = (uint32(x1217) + uint32(x1154))
  var x1219 uint32
  var x1220 uint32
  x1220, x1219 = bits.Mul32(x9, (arg2[11]))
  var x1221 uint32
  var x1222 uint32
  x1222, x1221 = bits.Mul32(x9, (arg2[10]))
  var x1223 uint32
  var x1224 uint32
  x1224, x1223 = bits.Mul32(x9, (arg2[9]))
  var x1225 uint32
  var x1226 uint32
  x1226, x1225 = bits.Mul32(x9, (arg2[8]))
  var x1227 uint32
  var x1228 uint32
  x1228, x1227 = bits.Mul32(x9, (arg2[7]))
  var x1229 uint32
  var x1230 uint32
  x1230, x1229 = bits.Mul32(x9, (arg2[6]))
  var x1231 uint32
  var x1232 uint32
  x1232, x1231 = bits.Mul32(x9, (arg2[5]))
  var x1233 uint32
  var x1234 uint32
  x1234, x1233 = bits.Mul32(x9, (arg2[4]))
  var x1235 uint32
  var x1236 uint32
  x1236, x1235 = bits.Mul32(x9, (arg2[3]))
  var x1237 uint32
  var x1238 uint32
  x1238, x1237 = bits.Mul32(x9, (arg2[2]))
  var x1239 uint32
  var x1240 uint32
  x1240, x1239 = bits.Mul32(x9, (arg2[1]))
  var x1241 uint32
  var x1242 uint32
  x1242, x1241 = bits.Mul32(x9, (arg2[0]))
  var x1243 uint32
  var x1244 fiat_p384_uint1
  x1243, x1244 = fiat_p384_addcarryx_u32(x1242, x1239, 0x0)
  var x1245 uint32
  var x1246 fiat_p384_uint1
  x1245, x1246 = fiat_p384_addcarryx_u32(x1240, x1237, x1244)
  var x1247 uint32
  var x1248 fiat_p384_uint1
  x1247, x1248 = fiat_p384_addcarryx_u32(x1238, x1235, x1246)
  var x1249 uint32
  var x1250 fiat_p384_uint1
  x1249, x1250 = fiat_p384_addcarryx_u32(x1236, x1233, x1248)
  var x1251 uint32
  var x1252 fiat_p384_uint1
  x1251, x1252 = fiat_p384_addcarryx_u32(x1234, x1231, x1250)
  var x1253 uint32
  var x1254 fiat_p384_uint1
  x1253, x1254 = fiat_p384_addcarryx_u32(x1232, x1229, x1252)
  var x1255 uint32
  var x1256 fiat_p384_uint1
  x1255, x1256 = fiat_p384_addcarryx_u32(x1230, x1227, x1254)
  var x1257 uint32
  var x1258 fiat_p384_uint1
  x1257, x1258 = fiat_p384_addcarryx_u32(x1228, x1225, x1256)
  var x1259 uint32
  var x1260 fiat_p384_uint1
  x1259, x1260 = fiat_p384_addcarryx_u32(x1226, x1223, x1258)
  var x1261 uint32
  var x1262 fiat_p384_uint1
  x1261, x1262 = fiat_p384_addcarryx_u32(x1224, x1221, x1260)
  var x1263 uint32
  var x1264 fiat_p384_uint1
  x1263, x1264 = fiat_p384_addcarryx_u32(x1222, x1219, x1262)
  var x1265 uint32 = (uint32(x1264) + x1220)
  var x1266 uint32
  var x1267 fiat_p384_uint1
  x1266, x1267 = fiat_p384_addcarryx_u32(x1194, x1241, 0x0)
  var x1268 uint32
  var x1269 fiat_p384_uint1
  x1268, x1269 = fiat_p384_addcarryx_u32(x1196, x1243, x1267)
  var x1270 uint32
  var x1271 fiat_p384_uint1
  x1270, x1271 = fiat_p384_addcarryx_u32(x1198, x1245, x1269)
  var x1272 uint32
  var x1273 fiat_p384_uint1
  x1272, x1273 = fiat_p384_addcarryx_u32(x1200, x1247, x1271)
  var x1274 uint32
  var x1275 fiat_p384_uint1
  x1274, x1275 = fiat_p384_addcarryx_u32(x1202, x1249, x1273)
  var x1276 uint32
  var x1277 fiat_p384_uint1
  x1276, x1277 = fiat_p384_addcarryx_u32(x1204, x1251, x1275)
  var x1278 uint32
  var x1279 fiat_p384_uint1
  x1278, x1279 = fiat_p384_addcarryx_u32(x1206, x1253, x1277)
  var x1280 uint32
  var x1281 fiat_p384_uint1
  x1280, x1281 = fiat_p384_addcarryx_u32(x1208, x1255, x1279)
  var x1282 uint32
  var x1283 fiat_p384_uint1
  x1282, x1283 = fiat_p384_addcarryx_u32(x1210, x1257, x1281)
  var x1284 uint32
  var x1285 fiat_p384_uint1
  x1284, x1285 = fiat_p384_addcarryx_u32(x1212, x1259, x1283)
  var x1286 uint32
  var x1287 fiat_p384_uint1
  x1286, x1287 = fiat_p384_addcarryx_u32(x1214, x1261, x1285)
  var x1288 uint32
  var x1289 fiat_p384_uint1
  x1288, x1289 = fiat_p384_addcarryx_u32(x1216, x1263, x1287)
  var x1290 uint32
  var x1291 fiat_p384_uint1
  x1290, x1291 = fiat_p384_addcarryx_u32(x1218, x1265, x1289)
  var x1292 uint32
  var x1293 uint32
  x1293, x1292 = bits.Mul32(x1266, 0xffffffff)
  var x1294 uint32
  var x1295 uint32
  x1295, x1294 = bits.Mul32(x1266, 0xffffffff)
  var x1296 uint32
  var x1297 uint32
  x1297, x1296 = bits.Mul32(x1266, 0xffffffff)
  var x1298 uint32
  var x1299 uint32
  x1299, x1298 = bits.Mul32(x1266, 0xffffffff)
  var x1300 uint32
  var x1301 uint32
  x1301, x1300 = bits.Mul32(x1266, 0xffffffff)
  var x1302 uint32
  var x1303 uint32
  x1303, x1302 = bits.Mul32(x1266, 0xffffffff)
  var x1304 uint32
  var x1305 uint32
  x1305, x1304 = bits.Mul32(x1266, 0xffffffff)
  var x1306 uint32
  var x1307 uint32
  x1307, x1306 = bits.Mul32(x1266, 0xfffffffe)
  var x1308 uint32
  var x1309 uint32
  x1309, x1308 = bits.Mul32(x1266, 0xffffffff)
  var x1310 uint32
  var x1311 uint32
  x1311, x1310 = bits.Mul32(x1266, 0xffffffff)
  var x1312 uint32
  var x1313 fiat_p384_uint1
  x1312, x1313 = fiat_p384_addcarryx_u32(x1309, x1306, 0x0)
  var x1314 uint32
  var x1315 fiat_p384_uint1
  x1314, x1315 = fiat_p384_addcarryx_u32(x1307, x1304, x1313)
  var x1316 uint32
  var x1317 fiat_p384_uint1
  x1316, x1317 = fiat_p384_addcarryx_u32(x1305, x1302, x1315)
  var x1318 uint32
  var x1319 fiat_p384_uint1
  x1318, x1319 = fiat_p384_addcarryx_u32(x1303, x1300, x1317)
  var x1320 uint32
  var x1321 fiat_p384_uint1
  x1320, x1321 = fiat_p384_addcarryx_u32(x1301, x1298, x1319)
  var x1322 uint32
  var x1323 fiat_p384_uint1
  x1322, x1323 = fiat_p384_addcarryx_u32(x1299, x1296, x1321)
  var x1324 uint32
  var x1325 fiat_p384_uint1
  x1324, x1325 = fiat_p384_addcarryx_u32(x1297, x1294, x1323)
  var x1326 uint32
  var x1327 fiat_p384_uint1
  x1326, x1327 = fiat_p384_addcarryx_u32(x1295, x1292, x1325)
  var x1328 uint32 = (uint32(x1327) + x1293)
  var x1330 fiat_p384_uint1
  _, x1330 = fiat_p384_addcarryx_u32(x1266, x1310, 0x0)
  var x1331 uint32
  var x1332 fiat_p384_uint1
  x1331, x1332 = fiat_p384_addcarryx_u32(x1268, x1311, x1330)
  var x1333 uint32
  var x1334 fiat_p384_uint1
  x1333, x1334 = fiat_p384_addcarryx_u32(x1270, uint32(0x0), x1332)
  var x1335 uint32
  var x1336 fiat_p384_uint1
  x1335, x1336 = fiat_p384_addcarryx_u32(x1272, x1308, x1334)
  var x1337 uint32
  var x1338 fiat_p384_uint1
  x1337, x1338 = fiat_p384_addcarryx_u32(x1274, x1312, x1336)
  var x1339 uint32
  var x1340 fiat_p384_uint1
  x1339, x1340 = fiat_p384_addcarryx_u32(x1276, x1314, x1338)
  var x1341 uint32
  var x1342 fiat_p384_uint1
  x1341, x1342 = fiat_p384_addcarryx_u32(x1278, x1316, x1340)
  var x1343 uint32
  var x1344 fiat_p384_uint1
  x1343, x1344 = fiat_p384_addcarryx_u32(x1280, x1318, x1342)
  var x1345 uint32
  var x1346 fiat_p384_uint1
  x1345, x1346 = fiat_p384_addcarryx_u32(x1282, x1320, x1344)
  var x1347 uint32
  var x1348 fiat_p384_uint1
  x1347, x1348 = fiat_p384_addcarryx_u32(x1284, x1322, x1346)
  var x1349 uint32
  var x1350 fiat_p384_uint1
  x1349, x1350 = fiat_p384_addcarryx_u32(x1286, x1324, x1348)
  var x1351 uint32
  var x1352 fiat_p384_uint1
  x1351, x1352 = fiat_p384_addcarryx_u32(x1288, x1326, x1350)
  var x1353 uint32
  var x1354 fiat_p384_uint1
  x1353, x1354 = fiat_p384_addcarryx_u32(x1290, x1328, x1352)
  var x1355 uint32 = (uint32(x1354) + uint32(x1291))
  var x1356 uint32
  var x1357 uint32
  x1357, x1356 = bits.Mul32(x10, (arg2[11]))
  var x1358 uint32
  var x1359 uint32
  x1359, x1358 = bits.Mul32(x10, (arg2[10]))
  var x1360 uint32
  var x1361 uint32
  x1361, x1360 = bits.Mul32(x10, (arg2[9]))
  var x1362 uint32
  var x1363 uint32
  x1363, x1362 = bits.Mul32(x10, (arg2[8]))
  var x1364 uint32
  var x1365 uint32
  x1365, x1364 = bits.Mul32(x10, (arg2[7]))
  var x1366 uint32
  var x1367 uint32
  x1367, x1366 = bits.Mul32(x10, (arg2[6]))
  var x1368 uint32
  var x1369 uint32
  x1369, x1368 = bits.Mul32(x10, (arg2[5]))
  var x1370 uint32
  var x1371 uint32
  x1371, x1370 = bits.Mul32(x10, (arg2[4]))
  var x1372 uint32
  var x1373 uint32
  x1373, x1372 = bits.Mul32(x10, (arg2[3]))
  var x1374 uint32
  var x1375 uint32
  x1375, x1374 = bits.Mul32(x10, (arg2[2]))
  var x1376 uint32
  var x1377 uint32
  x1377, x1376 = bits.Mul32(x10, (arg2[1]))
  var x1378 uint32
  var x1379 uint32
  x1379, x1378 = bits.Mul32(x10, (arg2[0]))
  var x1380 uint32
  var x1381 fiat_p384_uint1
  x1380, x1381 = fiat_p384_addcarryx_u32(x1379, x1376, 0x0)
  var x1382 uint32
  var x1383 fiat_p384_uint1
  x1382, x1383 = fiat_p384_addcarryx_u32(x1377, x1374, x1381)
  var x1384 uint32
  var x1385 fiat_p384_uint1
  x1384, x1385 = fiat_p384_addcarryx_u32(x1375, x1372, x1383)
  var x1386 uint32
  var x1387 fiat_p384_uint1
  x1386, x1387 = fiat_p384_addcarryx_u32(x1373, x1370, x1385)
  var x1388 uint32
  var x1389 fiat_p384_uint1
  x1388, x1389 = fiat_p384_addcarryx_u32(x1371, x1368, x1387)
  var x1390 uint32
  var x1391 fiat_p384_uint1
  x1390, x1391 = fiat_p384_addcarryx_u32(x1369, x1366, x1389)
  var x1392 uint32
  var x1393 fiat_p384_uint1
  x1392, x1393 = fiat_p384_addcarryx_u32(x1367, x1364, x1391)
  var x1394 uint32
  var x1395 fiat_p384_uint1
  x1394, x1395 = fiat_p384_addcarryx_u32(x1365, x1362, x1393)
  var x1396 uint32
  var x1397 fiat_p384_uint1
  x1396, x1397 = fiat_p384_addcarryx_u32(x1363, x1360, x1395)
  var x1398 uint32
  var x1399 fiat_p384_uint1
  x1398, x1399 = fiat_p384_addcarryx_u32(x1361, x1358, x1397)
  var x1400 uint32
  var x1401 fiat_p384_uint1
  x1400, x1401 = fiat_p384_addcarryx_u32(x1359, x1356, x1399)
  var x1402 uint32 = (uint32(x1401) + x1357)
  var x1403 uint32
  var x1404 fiat_p384_uint1
  x1403, x1404 = fiat_p384_addcarryx_u32(x1331, x1378, 0x0)
  var x1405 uint32
  var x1406 fiat_p384_uint1
  x1405, x1406 = fiat_p384_addcarryx_u32(x1333, x1380, x1404)
  var x1407 uint32
  var x1408 fiat_p384_uint1
  x1407, x1408 = fiat_p384_addcarryx_u32(x1335, x1382, x1406)
  var x1409 uint32
  var x1410 fiat_p384_uint1
  x1409, x1410 = fiat_p384_addcarryx_u32(x1337, x1384, x1408)
  var x1411 uint32
  var x1412 fiat_p384_uint1
  x1411, x1412 = fiat_p384_addcarryx_u32(x1339, x1386, x1410)
  var x1413 uint32
  var x1414 fiat_p384_uint1
  x1413, x1414 = fiat_p384_addcarryx_u32(x1341, x1388, x1412)
  var x1415 uint32
  var x1416 fiat_p384_uint1
  x1415, x1416 = fiat_p384_addcarryx_u32(x1343, x1390, x1414)
  var x1417 uint32
  var x1418 fiat_p384_uint1
  x1417, x1418 = fiat_p384_addcarryx_u32(x1345, x1392, x1416)
  var x1419 uint32
  var x1420 fiat_p384_uint1
  x1419, x1420 = fiat_p384_addcarryx_u32(x1347, x1394, x1418)
  var x1421 uint32
  var x1422 fiat_p384_uint1
  x1421, x1422 = fiat_p384_addcarryx_u32(x1349, x1396, x1420)
  var x1423 uint32
  var x1424 fiat_p384_uint1
  x1423, x1424 = fiat_p384_addcarryx_u32(x1351, x1398, x1422)
  var x1425 uint32
  var x1426 fiat_p384_uint1
  x1425, x1426 = fiat_p384_addcarryx_u32(x1353, x1400, x1424)
  var x1427 uint32
  var x1428 fiat_p384_uint1
  x1427, x1428 = fiat_p384_addcarryx_u32(x1355, x1402, x1426)
  var x1429 uint32
  var x1430 uint32
  x1430, x1429 = bits.Mul32(x1403, 0xffffffff)
  var x1431 uint32
  var x1432 uint32
  x1432, x1431 = bits.Mul32(x1403, 0xffffffff)
  var x1433 uint32
  var x1434 uint32
  x1434, x1433 = bits.Mul32(x1403, 0xffffffff)
  var x1435 uint32
  var x1436 uint32
  x1436, x1435 = bits.Mul32(x1403, 0xffffffff)
  var x1437 uint32
  var x1438 uint32
  x1438, x1437 = bits.Mul32(x1403, 0xffffffff)
  var x1439 uint32
  var x1440 uint32
  x1440, x1439 = bits.Mul32(x1403, 0xffffffff)
  var x1441 uint32
  var x1442 uint32
  x1442, x1441 = bits.Mul32(x1403, 0xffffffff)
  var x1443 uint32
  var x1444 uint32
  x1444, x1443 = bits.Mul32(x1403, 0xfffffffe)
  var x1445 uint32
  var x1446 uint32
  x1446, x1445 = bits.Mul32(x1403, 0xffffffff)
  var x1447 uint32
  var x1448 uint32
  x1448, x1447 = bits.Mul32(x1403, 0xffffffff)
  var x1449 uint32
  var x1450 fiat_p384_uint1
  x1449, x1450 = fiat_p384_addcarryx_u32(x1446, x1443, 0x0)
  var x1451 uint32
  var x1452 fiat_p384_uint1
  x1451, x1452 = fiat_p384_addcarryx_u32(x1444, x1441, x1450)
  var x1453 uint32
  var x1454 fiat_p384_uint1
  x1453, x1454 = fiat_p384_addcarryx_u32(x1442, x1439, x1452)
  var x1455 uint32
  var x1456 fiat_p384_uint1
  x1455, x1456 = fiat_p384_addcarryx_u32(x1440, x1437, x1454)
  var x1457 uint32
  var x1458 fiat_p384_uint1
  x1457, x1458 = fiat_p384_addcarryx_u32(x1438, x1435, x1456)
  var x1459 uint32
  var x1460 fiat_p384_uint1
  x1459, x1460 = fiat_p384_addcarryx_u32(x1436, x1433, x1458)
  var x1461 uint32
  var x1462 fiat_p384_uint1
  x1461, x1462 = fiat_p384_addcarryx_u32(x1434, x1431, x1460)
  var x1463 uint32
  var x1464 fiat_p384_uint1
  x1463, x1464 = fiat_p384_addcarryx_u32(x1432, x1429, x1462)
  var x1465 uint32 = (uint32(x1464) + x1430)
  var x1467 fiat_p384_uint1
  _, x1467 = fiat_p384_addcarryx_u32(x1403, x1447, 0x0)
  var x1468 uint32
  var x1469 fiat_p384_uint1
  x1468, x1469 = fiat_p384_addcarryx_u32(x1405, x1448, x1467)
  var x1470 uint32
  var x1471 fiat_p384_uint1
  x1470, x1471 = fiat_p384_addcarryx_u32(x1407, uint32(0x0), x1469)
  var x1472 uint32
  var x1473 fiat_p384_uint1
  x1472, x1473 = fiat_p384_addcarryx_u32(x1409, x1445, x1471)
  var x1474 uint32
  var x1475 fiat_p384_uint1
  x1474, x1475 = fiat_p384_addcarryx_u32(x1411, x1449, x1473)
  var x1476 uint32
  var x1477 fiat_p384_uint1
  x1476, x1477 = fiat_p384_addcarryx_u32(x1413, x1451, x1475)
  var x1478 uint32
  var x1479 fiat_p384_uint1
  x1478, x1479 = fiat_p384_addcarryx_u32(x1415, x1453, x1477)
  var x1480 uint32
  var x1481 fiat_p384_uint1
  x1480, x1481 = fiat_p384_addcarryx_u32(x1417, x1455, x1479)
  var x1482 uint32
  var x1483 fiat_p384_uint1
  x1482, x1483 = fiat_p384_addcarryx_u32(x1419, x1457, x1481)
  var x1484 uint32
  var x1485 fiat_p384_uint1
  x1484, x1485 = fiat_p384_addcarryx_u32(x1421, x1459, x1483)
  var x1486 uint32
  var x1487 fiat_p384_uint1
  x1486, x1487 = fiat_p384_addcarryx_u32(x1423, x1461, x1485)
  var x1488 uint32
  var x1489 fiat_p384_uint1
  x1488, x1489 = fiat_p384_addcarryx_u32(x1425, x1463, x1487)
  var x1490 uint32
  var x1491 fiat_p384_uint1
  x1490, x1491 = fiat_p384_addcarryx_u32(x1427, x1465, x1489)
  var x1492 uint32 = (uint32(x1491) + uint32(x1428))
  var x1493 uint32
  var x1494 uint32
  x1494, x1493 = bits.Mul32(x11, (arg2[11]))
  var x1495 uint32
  var x1496 uint32
  x1496, x1495 = bits.Mul32(x11, (arg2[10]))
  var x1497 uint32
  var x1498 uint32
  x1498, x1497 = bits.Mul32(x11, (arg2[9]))
  var x1499 uint32
  var x1500 uint32
  x1500, x1499 = bits.Mul32(x11, (arg2[8]))
  var x1501 uint32
  var x1502 uint32
  x1502, x1501 = bits.Mul32(x11, (arg2[7]))
  var x1503 uint32
  var x1504 uint32
  x1504, x1503 = bits.Mul32(x11, (arg2[6]))
  var x1505 uint32
  var x1506 uint32
  x1506, x1505 = bits.Mul32(x11, (arg2[5]))
  var x1507 uint32
  var x1508 uint32
  x1508, x1507 = bits.Mul32(x11, (arg2[4]))
  var x1509 uint32
  var x1510 uint32
  x1510, x1509 = bits.Mul32(x11, (arg2[3]))
  var x1511 uint32
  var x1512 uint32
  x1512, x1511 = bits.Mul32(x11, (arg2[2]))
  var x1513 uint32
  var x1514 uint32
  x1514, x1513 = bits.Mul32(x11, (arg2[1]))
  var x1515 uint32
  var x1516 uint32
  x1516, x1515 = bits.Mul32(x11, (arg2[0]))
  var x1517 uint32
  var x1518 fiat_p384_uint1
  x1517, x1518 = fiat_p384_addcarryx_u32(x1516, x1513, 0x0)
  var x1519 uint32
  var x1520 fiat_p384_uint1
  x1519, x1520 = fiat_p384_addcarryx_u32(x1514, x1511, x1518)
  var x1521 uint32
  var x1522 fiat_p384_uint1
  x1521, x1522 = fiat_p384_addcarryx_u32(x1512, x1509, x1520)
  var x1523 uint32
  var x1524 fiat_p384_uint1
  x1523, x1524 = fiat_p384_addcarryx_u32(x1510, x1507, x1522)
  var x1525 uint32
  var x1526 fiat_p384_uint1
  x1525, x1526 = fiat_p384_addcarryx_u32(x1508, x1505, x1524)
  var x1527 uint32
  var x1528 fiat_p384_uint1
  x1527, x1528 = fiat_p384_addcarryx_u32(x1506, x1503, x1526)
  var x1529 uint32
  var x1530 fiat_p384_uint1
  x1529, x1530 = fiat_p384_addcarryx_u32(x1504, x1501, x1528)
  var x1531 uint32
  var x1532 fiat_p384_uint1
  x1531, x1532 = fiat_p384_addcarryx_u32(x1502, x1499, x1530)
  var x1533 uint32
  var x1534 fiat_p384_uint1
  x1533, x1534 = fiat_p384_addcarryx_u32(x1500, x1497, x1532)
  var x1535 uint32
  var x1536 fiat_p384_uint1
  x1535, x1536 = fiat_p384_addcarryx_u32(x1498, x1495, x1534)
  var x1537 uint32
  var x1538 fiat_p384_uint1
  x1537, x1538 = fiat_p384_addcarryx_u32(x1496, x1493, x1536)
  var x1539 uint32 = (uint32(x1538) + x1494)
  var x1540 uint32
  var x1541 fiat_p384_uint1
  x1540, x1541 = fiat_p384_addcarryx_u32(x1468, x1515, 0x0)
  var x1542 uint32
  var x1543 fiat_p384_uint1
  x1542, x1543 = fiat_p384_addcarryx_u32(x1470, x1517, x1541)
  var x1544 uint32
  var x1545 fiat_p384_uint1
  x1544, x1545 = fiat_p384_addcarryx_u32(x1472, x1519, x1543)
  var x1546 uint32
  var x1547 fiat_p384_uint1
  x1546, x1547 = fiat_p384_addcarryx_u32(x1474, x1521, x1545)
  var x1548 uint32
  var x1549 fiat_p384_uint1
  x1548, x1549 = fiat_p384_addcarryx_u32(x1476, x1523, x1547)
  var x1550 uint32
  var x1551 fiat_p384_uint1
  x1550, x1551 = fiat_p384_addcarryx_u32(x1478, x1525, x1549)
  var x1552 uint32
  var x1553 fiat_p384_uint1
  x1552, x1553 = fiat_p384_addcarryx_u32(x1480, x1527, x1551)
  var x1554 uint32
  var x1555 fiat_p384_uint1
  x1554, x1555 = fiat_p384_addcarryx_u32(x1482, x1529, x1553)
  var x1556 uint32
  var x1557 fiat_p384_uint1
  x1556, x1557 = fiat_p384_addcarryx_u32(x1484, x1531, x1555)
  var x1558 uint32
  var x1559 fiat_p384_uint1
  x1558, x1559 = fiat_p384_addcarryx_u32(x1486, x1533, x1557)
  var x1560 uint32
  var x1561 fiat_p384_uint1
  x1560, x1561 = fiat_p384_addcarryx_u32(x1488, x1535, x1559)
  var x1562 uint32
  var x1563 fiat_p384_uint1
  x1562, x1563 = fiat_p384_addcarryx_u32(x1490, x1537, x1561)
  var x1564 uint32
  var x1565 fiat_p384_uint1
  x1564, x1565 = fiat_p384_addcarryx_u32(x1492, x1539, x1563)
  var x1566 uint32
  var x1567 uint32
  x1567, x1566 = bits.Mul32(x1540, 0xffffffff)
  var x1568 uint32
  var x1569 uint32
  x1569, x1568 = bits.Mul32(x1540, 0xffffffff)
  var x1570 uint32
  var x1571 uint32
  x1571, x1570 = bits.Mul32(x1540, 0xffffffff)
  var x1572 uint32
  var x1573 uint32
  x1573, x1572 = bits.Mul32(x1540, 0xffffffff)
  var x1574 uint32
  var x1575 uint32
  x1575, x1574 = bits.Mul32(x1540, 0xffffffff)
  var x1576 uint32
  var x1577 uint32
  x1577, x1576 = bits.Mul32(x1540, 0xffffffff)
  var x1578 uint32
  var x1579 uint32
  x1579, x1578 = bits.Mul32(x1540, 0xffffffff)
  var x1580 uint32
  var x1581 uint32
  x1581, x1580 = bits.Mul32(x1540, 0xfffffffe)
  var x1582 uint32
  var x1583 uint32
  x1583, x1582 = bits.Mul32(x1540, 0xffffffff)
  var x1584 uint32
  var x1585 uint32
  x1585, x1584 = bits.Mul32(x1540, 0xffffffff)
  var x1586 uint32
  var x1587 fiat_p384_uint1
  x1586, x1587 = fiat_p384_addcarryx_u32(x1583, x1580, 0x0)
  var x1588 uint32
  var x1589 fiat_p384_uint1
  x1588, x1589 = fiat_p384_addcarryx_u32(x1581, x1578, x1587)
  var x1590 uint32
  var x1591 fiat_p384_uint1
  x1590, x1591 = fiat_p384_addcarryx_u32(x1579, x1576, x1589)
  var x1592 uint32
  var x1593 fiat_p384_uint1
  x1592, x1593 = fiat_p384_addcarryx_u32(x1577, x1574, x1591)
  var x1594 uint32
  var x1595 fiat_p384_uint1
  x1594, x1595 = fiat_p384_addcarryx_u32(x1575, x1572, x1593)
  var x1596 uint32
  var x1597 fiat_p384_uint1
  x1596, x1597 = fiat_p384_addcarryx_u32(x1573, x1570, x1595)
  var x1598 uint32
  var x1599 fiat_p384_uint1
  x1598, x1599 = fiat_p384_addcarryx_u32(x1571, x1568, x1597)
  var x1600 uint32
  var x1601 fiat_p384_uint1
  x1600, x1601 = fiat_p384_addcarryx_u32(x1569, x1566, x1599)
  var x1602 uint32 = (uint32(x1601) + x1567)
  var x1604 fiat_p384_uint1
  _, x1604 = fiat_p384_addcarryx_u32(x1540, x1584, 0x0)
  var x1605 uint32
  var x1606 fiat_p384_uint1
  x1605, x1606 = fiat_p384_addcarryx_u32(x1542, x1585, x1604)
  var x1607 uint32
  var x1608 fiat_p384_uint1
  x1607, x1608 = fiat_p384_addcarryx_u32(x1544, uint32(0x0), x1606)
  var x1609 uint32
  var x1610 fiat_p384_uint1
  x1609, x1610 = fiat_p384_addcarryx_u32(x1546, x1582, x1608)
  var x1611 uint32
  var x1612 fiat_p384_uint1
  x1611, x1612 = fiat_p384_addcarryx_u32(x1548, x1586, x1610)
  var x1613 uint32
  var x1614 fiat_p384_uint1
  x1613, x1614 = fiat_p384_addcarryx_u32(x1550, x1588, x1612)
  var x1615 uint32
  var x1616 fiat_p384_uint1
  x1615, x1616 = fiat_p384_addcarryx_u32(x1552, x1590, x1614)
  var x1617 uint32
  var x1618 fiat_p384_uint1
  x1617, x1618 = fiat_p384_addcarryx_u32(x1554, x1592, x1616)
  var x1619 uint32
  var x1620 fiat_p384_uint1
  x1619, x1620 = fiat_p384_addcarryx_u32(x1556, x1594, x1618)
  var x1621 uint32
  var x1622 fiat_p384_uint1
  x1621, x1622 = fiat_p384_addcarryx_u32(x1558, x1596, x1620)
  var x1623 uint32
  var x1624 fiat_p384_uint1
  x1623, x1624 = fiat_p384_addcarryx_u32(x1560, x1598, x1622)
  var x1625 uint32
  var x1626 fiat_p384_uint1
  x1625, x1626 = fiat_p384_addcarryx_u32(x1562, x1600, x1624)
  var x1627 uint32
  var x1628 fiat_p384_uint1
  x1627, x1628 = fiat_p384_addcarryx_u32(x1564, x1602, x1626)
  var x1629 uint32 = (uint32(x1628) + uint32(x1565))
  var x1630 uint32
  var x1631 fiat_p384_uint1
  x1630, x1631 = fiat_p384_subborrowx_u32(x1605, 0xffffffff, 0x0)
  var x1632 uint32
  var x1633 fiat_p384_uint1
  x1632, x1633 = fiat_p384_subborrowx_u32(x1607, uint32(0x0), x1631)
  var x1634 uint32
  var x1635 fiat_p384_uint1
  x1634, x1635 = fiat_p384_subborrowx_u32(x1609, uint32(0x0), x1633)
  var x1636 uint32
  var x1637 fiat_p384_uint1
  x1636, x1637 = fiat_p384_subborrowx_u32(x1611, 0xffffffff, x1635)
  var x1638 uint32
  var x1639 fiat_p384_uint1
  x1638, x1639 = fiat_p384_subborrowx_u32(x1613, 0xfffffffe, x1637)
  var x1640 uint32
  var x1641 fiat_p384_uint1
  x1640, x1641 = fiat_p384_subborrowx_u32(x1615, 0xffffffff, x1639)
  var x1642 uint32
  var x1643 fiat_p384_uint1
  x1642, x1643 = fiat_p384_subborrowx_u32(x1617, 0xffffffff, x1641)
  var x1644 uint32
  var x1645 fiat_p384_uint1
  x1644, x1645 = fiat_p384_subborrowx_u32(x1619, 0xffffffff, x1643)
  var x1646 uint32
  var x1647 fiat_p384_uint1
  x1646, x1647 = fiat_p384_subborrowx_u32(x1621, 0xffffffff, x1645)
  var x1648 uint32
  var x1649 fiat_p384_uint1
  x1648, x1649 = fiat_p384_subborrowx_u32(x1623, 0xffffffff, x1647)
  var x1650 uint32
  var x1651 fiat_p384_uint1
  x1650, x1651 = fiat_p384_subborrowx_u32(x1625, 0xffffffff, x1649)
  var x1652 uint32
  var x1653 fiat_p384_uint1
  x1652, x1653 = fiat_p384_subborrowx_u32(x1627, 0xffffffff, x1651)
  var x1655 fiat_p384_uint1
  _, x1655 = fiat_p384_subborrowx_u32(x1629, uint32(0x0), x1653)
  var x1656 uint32
  fiat_p384_cmovznz_u32(&x1656, x1655, x1630, x1605)
  var x1657 uint32
  fiat_p384_cmovznz_u32(&x1657, x1655, x1632, x1607)
  var x1658 uint32
  fiat_p384_cmovznz_u32(&x1658, x1655, x1634, x1609)
  var x1659 uint32
  fiat_p384_cmovznz_u32(&x1659, x1655, x1636, x1611)
  var x1660 uint32
  fiat_p384_cmovznz_u32(&x1660, x1655, x1638, x1613)
  var x1661 uint32
  fiat_p384_cmovznz_u32(&x1661, x1655, x1640, x1615)
  var x1662 uint32
  fiat_p384_cmovznz_u32(&x1662, x1655, x1642, x1617)
  var x1663 uint32
  fiat_p384_cmovznz_u32(&x1663, x1655, x1644, x1619)
  var x1664 uint32
  fiat_p384_cmovznz_u32(&x1664, x1655, x1646, x1621)
  var x1665 uint32
  fiat_p384_cmovznz_u32(&x1665, x1655, x1648, x1623)
  var x1666 uint32
  fiat_p384_cmovznz_u32(&x1666, x1655, x1650, x1625)
  var x1667 uint32
  fiat_p384_cmovznz_u32(&x1667, x1655, x1652, x1627)
  out1[0] = x1656
  out1[1] = x1657
  out1[2] = x1658
  out1[3] = x1659
  out1[4] = x1660
  out1[5] = x1661
  out1[6] = x1662
  out1[7] = x1663
  out1[8] = x1664
  out1[9] = x1665
  out1[10] = x1666
  out1[11] = x1667
}

/*
 * The function fiat_p384_square squares a field element in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg1)) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
/*inline*/
func fiat_p384_square(out1 *[12]uint32, arg1 *[12]uint32) {
  var x1 uint32 = (arg1[1])
  var x2 uint32 = (arg1[2])
  var x3 uint32 = (arg1[3])
  var x4 uint32 = (arg1[4])
  var x5 uint32 = (arg1[5])
  var x6 uint32 = (arg1[6])
  var x7 uint32 = (arg1[7])
  var x8 uint32 = (arg1[8])
  var x9 uint32 = (arg1[9])
  var x10 uint32 = (arg1[10])
  var x11 uint32 = (arg1[11])
  var x12 uint32 = (arg1[0])
  var x13 uint32
  var x14 uint32
  x14, x13 = bits.Mul32(x12, (arg1[11]))
  var x15 uint32
  var x16 uint32
  x16, x15 = bits.Mul32(x12, (arg1[10]))
  var x17 uint32
  var x18 uint32
  x18, x17 = bits.Mul32(x12, (arg1[9]))
  var x19 uint32
  var x20 uint32
  x20, x19 = bits.Mul32(x12, (arg1[8]))
  var x21 uint32
  var x22 uint32
  x22, x21 = bits.Mul32(x12, (arg1[7]))
  var x23 uint32
  var x24 uint32
  x24, x23 = bits.Mul32(x12, (arg1[6]))
  var x25 uint32
  var x26 uint32
  x26, x25 = bits.Mul32(x12, (arg1[5]))
  var x27 uint32
  var x28 uint32
  x28, x27 = bits.Mul32(x12, (arg1[4]))
  var x29 uint32
  var x30 uint32
  x30, x29 = bits.Mul32(x12, (arg1[3]))
  var x31 uint32
  var x32 uint32
  x32, x31 = bits.Mul32(x12, (arg1[2]))
  var x33 uint32
  var x34 uint32
  x34, x33 = bits.Mul32(x12, (arg1[1]))
  var x35 uint32
  var x36 uint32
  x36, x35 = bits.Mul32(x12, (arg1[0]))
  var x37 uint32
  var x38 fiat_p384_uint1
  x37, x38 = fiat_p384_addcarryx_u32(x36, x33, 0x0)
  var x39 uint32
  var x40 fiat_p384_uint1
  x39, x40 = fiat_p384_addcarryx_u32(x34, x31, x38)
  var x41 uint32
  var x42 fiat_p384_uint1
  x41, x42 = fiat_p384_addcarryx_u32(x32, x29, x40)
  var x43 uint32
  var x44 fiat_p384_uint1
  x43, x44 = fiat_p384_addcarryx_u32(x30, x27, x42)
  var x45 uint32
  var x46 fiat_p384_uint1
  x45, x46 = fiat_p384_addcarryx_u32(x28, x25, x44)
  var x47 uint32
  var x48 fiat_p384_uint1
  x47, x48 = fiat_p384_addcarryx_u32(x26, x23, x46)
  var x49 uint32
  var x50 fiat_p384_uint1
  x49, x50 = fiat_p384_addcarryx_u32(x24, x21, x48)
  var x51 uint32
  var x52 fiat_p384_uint1
  x51, x52 = fiat_p384_addcarryx_u32(x22, x19, x50)
  var x53 uint32
  var x54 fiat_p384_uint1
  x53, x54 = fiat_p384_addcarryx_u32(x20, x17, x52)
  var x55 uint32
  var x56 fiat_p384_uint1
  x55, x56 = fiat_p384_addcarryx_u32(x18, x15, x54)
  var x57 uint32
  var x58 fiat_p384_uint1
  x57, x58 = fiat_p384_addcarryx_u32(x16, x13, x56)
  var x59 uint32 = (uint32(x58) + x14)
  var x60 uint32
  var x61 uint32
  x61, x60 = bits.Mul32(x35, 0xffffffff)
  var x62 uint32
  var x63 uint32
  x63, x62 = bits.Mul32(x35, 0xffffffff)
  var x64 uint32
  var x65 uint32
  x65, x64 = bits.Mul32(x35, 0xffffffff)
  var x66 uint32
  var x67 uint32
  x67, x66 = bits.Mul32(x35, 0xffffffff)
  var x68 uint32
  var x69 uint32
  x69, x68 = bits.Mul32(x35, 0xffffffff)
  var x70 uint32
  var x71 uint32
  x71, x70 = bits.Mul32(x35, 0xffffffff)
  var x72 uint32
  var x73 uint32
  x73, x72 = bits.Mul32(x35, 0xffffffff)
  var x74 uint32
  var x75 uint32
  x75, x74 = bits.Mul32(x35, 0xfffffffe)
  var x76 uint32
  var x77 uint32
  x77, x76 = bits.Mul32(x35, 0xffffffff)
  var x78 uint32
  var x79 uint32
  x79, x78 = bits.Mul32(x35, 0xffffffff)
  var x80 uint32
  var x81 fiat_p384_uint1
  x80, x81 = fiat_p384_addcarryx_u32(x77, x74, 0x0)
  var x82 uint32
  var x83 fiat_p384_uint1
  x82, x83 = fiat_p384_addcarryx_u32(x75, x72, x81)
  var x84 uint32
  var x85 fiat_p384_uint1
  x84, x85 = fiat_p384_addcarryx_u32(x73, x70, x83)
  var x86 uint32
  var x87 fiat_p384_uint1
  x86, x87 = fiat_p384_addcarryx_u32(x71, x68, x85)
  var x88 uint32
  var x89 fiat_p384_uint1
  x88, x89 = fiat_p384_addcarryx_u32(x69, x66, x87)
  var x90 uint32
  var x91 fiat_p384_uint1
  x90, x91 = fiat_p384_addcarryx_u32(x67, x64, x89)
  var x92 uint32
  var x93 fiat_p384_uint1
  x92, x93 = fiat_p384_addcarryx_u32(x65, x62, x91)
  var x94 uint32
  var x95 fiat_p384_uint1
  x94, x95 = fiat_p384_addcarryx_u32(x63, x60, x93)
  var x96 uint32 = (uint32(x95) + x61)
  var x98 fiat_p384_uint1
  _, x98 = fiat_p384_addcarryx_u32(x35, x78, 0x0)
  var x99 uint32
  var x100 fiat_p384_uint1
  x99, x100 = fiat_p384_addcarryx_u32(x37, x79, x98)
  var x101 uint32
  var x102 fiat_p384_uint1
  x101, x102 = fiat_p384_addcarryx_u32(x39, uint32(0x0), x100)
  var x103 uint32
  var x104 fiat_p384_uint1
  x103, x104 = fiat_p384_addcarryx_u32(x41, x76, x102)
  var x105 uint32
  var x106 fiat_p384_uint1
  x105, x106 = fiat_p384_addcarryx_u32(x43, x80, x104)
  var x107 uint32
  var x108 fiat_p384_uint1
  x107, x108 = fiat_p384_addcarryx_u32(x45, x82, x106)
  var x109 uint32
  var x110 fiat_p384_uint1
  x109, x110 = fiat_p384_addcarryx_u32(x47, x84, x108)
  var x111 uint32
  var x112 fiat_p384_uint1
  x111, x112 = fiat_p384_addcarryx_u32(x49, x86, x110)
  var x113 uint32
  var x114 fiat_p384_uint1
  x113, x114 = fiat_p384_addcarryx_u32(x51, x88, x112)
  var x115 uint32
  var x116 fiat_p384_uint1
  x115, x116 = fiat_p384_addcarryx_u32(x53, x90, x114)
  var x117 uint32
  var x118 fiat_p384_uint1
  x117, x118 = fiat_p384_addcarryx_u32(x55, x92, x116)
  var x119 uint32
  var x120 fiat_p384_uint1
  x119, x120 = fiat_p384_addcarryx_u32(x57, x94, x118)
  var x121 uint32
  var x122 fiat_p384_uint1
  x121, x122 = fiat_p384_addcarryx_u32(x59, x96, x120)
  var x123 uint32
  var x124 uint32
  x124, x123 = bits.Mul32(x1, (arg1[11]))
  var x125 uint32
  var x126 uint32
  x126, x125 = bits.Mul32(x1, (arg1[10]))
  var x127 uint32
  var x128 uint32
  x128, x127 = bits.Mul32(x1, (arg1[9]))
  var x129 uint32
  var x130 uint32
  x130, x129 = bits.Mul32(x1, (arg1[8]))
  var x131 uint32
  var x132 uint32
  x132, x131 = bits.Mul32(x1, (arg1[7]))
  var x133 uint32
  var x134 uint32
  x134, x133 = bits.Mul32(x1, (arg1[6]))
  var x135 uint32
  var x136 uint32
  x136, x135 = bits.Mul32(x1, (arg1[5]))
  var x137 uint32
  var x138 uint32
  x138, x137 = bits.Mul32(x1, (arg1[4]))
  var x139 uint32
  var x140 uint32
  x140, x139 = bits.Mul32(x1, (arg1[3]))
  var x141 uint32
  var x142 uint32
  x142, x141 = bits.Mul32(x1, (arg1[2]))
  var x143 uint32
  var x144 uint32
  x144, x143 = bits.Mul32(x1, (arg1[1]))
  var x145 uint32
  var x146 uint32
  x146, x145 = bits.Mul32(x1, (arg1[0]))
  var x147 uint32
  var x148 fiat_p384_uint1
  x147, x148 = fiat_p384_addcarryx_u32(x146, x143, 0x0)
  var x149 uint32
  var x150 fiat_p384_uint1
  x149, x150 = fiat_p384_addcarryx_u32(x144, x141, x148)
  var x151 uint32
  var x152 fiat_p384_uint1
  x151, x152 = fiat_p384_addcarryx_u32(x142, x139, x150)
  var x153 uint32
  var x154 fiat_p384_uint1
  x153, x154 = fiat_p384_addcarryx_u32(x140, x137, x152)
  var x155 uint32
  var x156 fiat_p384_uint1
  x155, x156 = fiat_p384_addcarryx_u32(x138, x135, x154)
  var x157 uint32
  var x158 fiat_p384_uint1
  x157, x158 = fiat_p384_addcarryx_u32(x136, x133, x156)
  var x159 uint32
  var x160 fiat_p384_uint1
  x159, x160 = fiat_p384_addcarryx_u32(x134, x131, x158)
  var x161 uint32
  var x162 fiat_p384_uint1
  x161, x162 = fiat_p384_addcarryx_u32(x132, x129, x160)
  var x163 uint32
  var x164 fiat_p384_uint1
  x163, x164 = fiat_p384_addcarryx_u32(x130, x127, x162)
  var x165 uint32
  var x166 fiat_p384_uint1
  x165, x166 = fiat_p384_addcarryx_u32(x128, x125, x164)
  var x167 uint32
  var x168 fiat_p384_uint1
  x167, x168 = fiat_p384_addcarryx_u32(x126, x123, x166)
  var x169 uint32 = (uint32(x168) + x124)
  var x170 uint32
  var x171 fiat_p384_uint1
  x170, x171 = fiat_p384_addcarryx_u32(x99, x145, 0x0)
  var x172 uint32
  var x173 fiat_p384_uint1
  x172, x173 = fiat_p384_addcarryx_u32(x101, x147, x171)
  var x174 uint32
  var x175 fiat_p384_uint1
  x174, x175 = fiat_p384_addcarryx_u32(x103, x149, x173)
  var x176 uint32
  var x177 fiat_p384_uint1
  x176, x177 = fiat_p384_addcarryx_u32(x105, x151, x175)
  var x178 uint32
  var x179 fiat_p384_uint1
  x178, x179 = fiat_p384_addcarryx_u32(x107, x153, x177)
  var x180 uint32
  var x181 fiat_p384_uint1
  x180, x181 = fiat_p384_addcarryx_u32(x109, x155, x179)
  var x182 uint32
  var x183 fiat_p384_uint1
  x182, x183 = fiat_p384_addcarryx_u32(x111, x157, x181)
  var x184 uint32
  var x185 fiat_p384_uint1
  x184, x185 = fiat_p384_addcarryx_u32(x113, x159, x183)
  var x186 uint32
  var x187 fiat_p384_uint1
  x186, x187 = fiat_p384_addcarryx_u32(x115, x161, x185)
  var x188 uint32
  var x189 fiat_p384_uint1
  x188, x189 = fiat_p384_addcarryx_u32(x117, x163, x187)
  var x190 uint32
  var x191 fiat_p384_uint1
  x190, x191 = fiat_p384_addcarryx_u32(x119, x165, x189)
  var x192 uint32
  var x193 fiat_p384_uint1
  x192, x193 = fiat_p384_addcarryx_u32(x121, x167, x191)
  var x194 uint32
  var x195 fiat_p384_uint1
  x194, x195 = fiat_p384_addcarryx_u32(uint32(x122), x169, x193)
  var x196 uint32
  var x197 uint32
  x197, x196 = bits.Mul32(x170, 0xffffffff)
  var x198 uint32
  var x199 uint32
  x199, x198 = bits.Mul32(x170, 0xffffffff)
  var x200 uint32
  var x201 uint32
  x201, x200 = bits.Mul32(x170, 0xffffffff)
  var x202 uint32
  var x203 uint32
  x203, x202 = bits.Mul32(x170, 0xffffffff)
  var x204 uint32
  var x205 uint32
  x205, x204 = bits.Mul32(x170, 0xffffffff)
  var x206 uint32
  var x207 uint32
  x207, x206 = bits.Mul32(x170, 0xffffffff)
  var x208 uint32
  var x209 uint32
  x209, x208 = bits.Mul32(x170, 0xffffffff)
  var x210 uint32
  var x211 uint32
  x211, x210 = bits.Mul32(x170, 0xfffffffe)
  var x212 uint32
  var x213 uint32
  x213, x212 = bits.Mul32(x170, 0xffffffff)
  var x214 uint32
  var x215 uint32
  x215, x214 = bits.Mul32(x170, 0xffffffff)
  var x216 uint32
  var x217 fiat_p384_uint1
  x216, x217 = fiat_p384_addcarryx_u32(x213, x210, 0x0)
  var x218 uint32
  var x219 fiat_p384_uint1
  x218, x219 = fiat_p384_addcarryx_u32(x211, x208, x217)
  var x220 uint32
  var x221 fiat_p384_uint1
  x220, x221 = fiat_p384_addcarryx_u32(x209, x206, x219)
  var x222 uint32
  var x223 fiat_p384_uint1
  x222, x223 = fiat_p384_addcarryx_u32(x207, x204, x221)
  var x224 uint32
  var x225 fiat_p384_uint1
  x224, x225 = fiat_p384_addcarryx_u32(x205, x202, x223)
  var x226 uint32
  var x227 fiat_p384_uint1
  x226, x227 = fiat_p384_addcarryx_u32(x203, x200, x225)
  var x228 uint32
  var x229 fiat_p384_uint1
  x228, x229 = fiat_p384_addcarryx_u32(x201, x198, x227)
  var x230 uint32
  var x231 fiat_p384_uint1
  x230, x231 = fiat_p384_addcarryx_u32(x199, x196, x229)
  var x232 uint32 = (uint32(x231) + x197)
  var x234 fiat_p384_uint1
  _, x234 = fiat_p384_addcarryx_u32(x170, x214, 0x0)
  var x235 uint32
  var x236 fiat_p384_uint1
  x235, x236 = fiat_p384_addcarryx_u32(x172, x215, x234)
  var x237 uint32
  var x238 fiat_p384_uint1
  x237, x238 = fiat_p384_addcarryx_u32(x174, uint32(0x0), x236)
  var x239 uint32
  var x240 fiat_p384_uint1
  x239, x240 = fiat_p384_addcarryx_u32(x176, x212, x238)
  var x241 uint32
  var x242 fiat_p384_uint1
  x241, x242 = fiat_p384_addcarryx_u32(x178, x216, x240)
  var x243 uint32
  var x244 fiat_p384_uint1
  x243, x244 = fiat_p384_addcarryx_u32(x180, x218, x242)
  var x245 uint32
  var x246 fiat_p384_uint1
  x245, x246 = fiat_p384_addcarryx_u32(x182, x220, x244)
  var x247 uint32
  var x248 fiat_p384_uint1
  x247, x248 = fiat_p384_addcarryx_u32(x184, x222, x246)
  var x249 uint32
  var x250 fiat_p384_uint1
  x249, x250 = fiat_p384_addcarryx_u32(x186, x224, x248)
  var x251 uint32
  var x252 fiat_p384_uint1
  x251, x252 = fiat_p384_addcarryx_u32(x188, x226, x250)
  var x253 uint32
  var x254 fiat_p384_uint1
  x253, x254 = fiat_p384_addcarryx_u32(x190, x228, x252)
  var x255 uint32
  var x256 fiat_p384_uint1
  x255, x256 = fiat_p384_addcarryx_u32(x192, x230, x254)
  var x257 uint32
  var x258 fiat_p384_uint1
  x257, x258 = fiat_p384_addcarryx_u32(x194, x232, x256)
  var x259 uint32 = (uint32(x258) + uint32(x195))
  var x260 uint32
  var x261 uint32
  x261, x260 = bits.Mul32(x2, (arg1[11]))
  var x262 uint32
  var x263 uint32
  x263, x262 = bits.Mul32(x2, (arg1[10]))
  var x264 uint32
  var x265 uint32
  x265, x264 = bits.Mul32(x2, (arg1[9]))
  var x266 uint32
  var x267 uint32
  x267, x266 = bits.Mul32(x2, (arg1[8]))
  var x268 uint32
  var x269 uint32
  x269, x268 = bits.Mul32(x2, (arg1[7]))
  var x270 uint32
  var x271 uint32
  x271, x270 = bits.Mul32(x2, (arg1[6]))
  var x272 uint32
  var x273 uint32
  x273, x272 = bits.Mul32(x2, (arg1[5]))
  var x274 uint32
  var x275 uint32
  x275, x274 = bits.Mul32(x2, (arg1[4]))
  var x276 uint32
  var x277 uint32
  x277, x276 = bits.Mul32(x2, (arg1[3]))
  var x278 uint32
  var x279 uint32
  x279, x278 = bits.Mul32(x2, (arg1[2]))
  var x280 uint32
  var x281 uint32
  x281, x280 = bits.Mul32(x2, (arg1[1]))
  var x282 uint32
  var x283 uint32
  x283, x282 = bits.Mul32(x2, (arg1[0]))
  var x284 uint32
  var x285 fiat_p384_uint1
  x284, x285 = fiat_p384_addcarryx_u32(x283, x280, 0x0)
  var x286 uint32
  var x287 fiat_p384_uint1
  x286, x287 = fiat_p384_addcarryx_u32(x281, x278, x285)
  var x288 uint32
  var x289 fiat_p384_uint1
  x288, x289 = fiat_p384_addcarryx_u32(x279, x276, x287)
  var x290 uint32
  var x291 fiat_p384_uint1
  x290, x291 = fiat_p384_addcarryx_u32(x277, x274, x289)
  var x292 uint32
  var x293 fiat_p384_uint1
  x292, x293 = fiat_p384_addcarryx_u32(x275, x272, x291)
  var x294 uint32
  var x295 fiat_p384_uint1
  x294, x295 = fiat_p384_addcarryx_u32(x273, x270, x293)
  var x296 uint32
  var x297 fiat_p384_uint1
  x296, x297 = fiat_p384_addcarryx_u32(x271, x268, x295)
  var x298 uint32
  var x299 fiat_p384_uint1
  x298, x299 = fiat_p384_addcarryx_u32(x269, x266, x297)
  var x300 uint32
  var x301 fiat_p384_uint1
  x300, x301 = fiat_p384_addcarryx_u32(x267, x264, x299)
  var x302 uint32
  var x303 fiat_p384_uint1
  x302, x303 = fiat_p384_addcarryx_u32(x265, x262, x301)
  var x304 uint32
  var x305 fiat_p384_uint1
  x304, x305 = fiat_p384_addcarryx_u32(x263, x260, x303)
  var x306 uint32 = (uint32(x305) + x261)
  var x307 uint32
  var x308 fiat_p384_uint1
  x307, x308 = fiat_p384_addcarryx_u32(x235, x282, 0x0)
  var x309 uint32
  var x310 fiat_p384_uint1
  x309, x310 = fiat_p384_addcarryx_u32(x237, x284, x308)
  var x311 uint32
  var x312 fiat_p384_uint1
  x311, x312 = fiat_p384_addcarryx_u32(x239, x286, x310)
  var x313 uint32
  var x314 fiat_p384_uint1
  x313, x314 = fiat_p384_addcarryx_u32(x241, x288, x312)
  var x315 uint32
  var x316 fiat_p384_uint1
  x315, x316 = fiat_p384_addcarryx_u32(x243, x290, x314)
  var x317 uint32
  var x318 fiat_p384_uint1
  x317, x318 = fiat_p384_addcarryx_u32(x245, x292, x316)
  var x319 uint32
  var x320 fiat_p384_uint1
  x319, x320 = fiat_p384_addcarryx_u32(x247, x294, x318)
  var x321 uint32
  var x322 fiat_p384_uint1
  x321, x322 = fiat_p384_addcarryx_u32(x249, x296, x320)
  var x323 uint32
  var x324 fiat_p384_uint1
  x323, x324 = fiat_p384_addcarryx_u32(x251, x298, x322)
  var x325 uint32
  var x326 fiat_p384_uint1
  x325, x326 = fiat_p384_addcarryx_u32(x253, x300, x324)
  var x327 uint32
  var x328 fiat_p384_uint1
  x327, x328 = fiat_p384_addcarryx_u32(x255, x302, x326)
  var x329 uint32
  var x330 fiat_p384_uint1
  x329, x330 = fiat_p384_addcarryx_u32(x257, x304, x328)
  var x331 uint32
  var x332 fiat_p384_uint1
  x331, x332 = fiat_p384_addcarryx_u32(x259, x306, x330)
  var x333 uint32
  var x334 uint32
  x334, x333 = bits.Mul32(x307, 0xffffffff)
  var x335 uint32
  var x336 uint32
  x336, x335 = bits.Mul32(x307, 0xffffffff)
  var x337 uint32
  var x338 uint32
  x338, x337 = bits.Mul32(x307, 0xffffffff)
  var x339 uint32
  var x340 uint32
  x340, x339 = bits.Mul32(x307, 0xffffffff)
  var x341 uint32
  var x342 uint32
  x342, x341 = bits.Mul32(x307, 0xffffffff)
  var x343 uint32
  var x344 uint32
  x344, x343 = bits.Mul32(x307, 0xffffffff)
  var x345 uint32
  var x346 uint32
  x346, x345 = bits.Mul32(x307, 0xffffffff)
  var x347 uint32
  var x348 uint32
  x348, x347 = bits.Mul32(x307, 0xfffffffe)
  var x349 uint32
  var x350 uint32
  x350, x349 = bits.Mul32(x307, 0xffffffff)
  var x351 uint32
  var x352 uint32
  x352, x351 = bits.Mul32(x307, 0xffffffff)
  var x353 uint32
  var x354 fiat_p384_uint1
  x353, x354 = fiat_p384_addcarryx_u32(x350, x347, 0x0)
  var x355 uint32
  var x356 fiat_p384_uint1
  x355, x356 = fiat_p384_addcarryx_u32(x348, x345, x354)
  var x357 uint32
  var x358 fiat_p384_uint1
  x357, x358 = fiat_p384_addcarryx_u32(x346, x343, x356)
  var x359 uint32
  var x360 fiat_p384_uint1
  x359, x360 = fiat_p384_addcarryx_u32(x344, x341, x358)
  var x361 uint32
  var x362 fiat_p384_uint1
  x361, x362 = fiat_p384_addcarryx_u32(x342, x339, x360)
  var x363 uint32
  var x364 fiat_p384_uint1
  x363, x364 = fiat_p384_addcarryx_u32(x340, x337, x362)
  var x365 uint32
  var x366 fiat_p384_uint1
  x365, x366 = fiat_p384_addcarryx_u32(x338, x335, x364)
  var x367 uint32
  var x368 fiat_p384_uint1
  x367, x368 = fiat_p384_addcarryx_u32(x336, x333, x366)
  var x369 uint32 = (uint32(x368) + x334)
  var x371 fiat_p384_uint1
  _, x371 = fiat_p384_addcarryx_u32(x307, x351, 0x0)
  var x372 uint32
  var x373 fiat_p384_uint1
  x372, x373 = fiat_p384_addcarryx_u32(x309, x352, x371)
  var x374 uint32
  var x375 fiat_p384_uint1
  x374, x375 = fiat_p384_addcarryx_u32(x311, uint32(0x0), x373)
  var x376 uint32
  var x377 fiat_p384_uint1
  x376, x377 = fiat_p384_addcarryx_u32(x313, x349, x375)
  var x378 uint32
  var x379 fiat_p384_uint1
  x378, x379 = fiat_p384_addcarryx_u32(x315, x353, x377)
  var x380 uint32
  var x381 fiat_p384_uint1
  x380, x381 = fiat_p384_addcarryx_u32(x317, x355, x379)
  var x382 uint32
  var x383 fiat_p384_uint1
  x382, x383 = fiat_p384_addcarryx_u32(x319, x357, x381)
  var x384 uint32
  var x385 fiat_p384_uint1
  x384, x385 = fiat_p384_addcarryx_u32(x321, x359, x383)
  var x386 uint32
  var x387 fiat_p384_uint1
  x386, x387 = fiat_p384_addcarryx_u32(x323, x361, x385)
  var x388 uint32
  var x389 fiat_p384_uint1
  x388, x389 = fiat_p384_addcarryx_u32(x325, x363, x387)
  var x390 uint32
  var x391 fiat_p384_uint1
  x390, x391 = fiat_p384_addcarryx_u32(x327, x365, x389)
  var x392 uint32
  var x393 fiat_p384_uint1
  x392, x393 = fiat_p384_addcarryx_u32(x329, x367, x391)
  var x394 uint32
  var x395 fiat_p384_uint1
  x394, x395 = fiat_p384_addcarryx_u32(x331, x369, x393)
  var x396 uint32 = (uint32(x395) + uint32(x332))
  var x397 uint32
  var x398 uint32
  x398, x397 = bits.Mul32(x3, (arg1[11]))
  var x399 uint32
  var x400 uint32
  x400, x399 = bits.Mul32(x3, (arg1[10]))
  var x401 uint32
  var x402 uint32
  x402, x401 = bits.Mul32(x3, (arg1[9]))
  var x403 uint32
  var x404 uint32
  x404, x403 = bits.Mul32(x3, (arg1[8]))
  var x405 uint32
  var x406 uint32
  x406, x405 = bits.Mul32(x3, (arg1[7]))
  var x407 uint32
  var x408 uint32
  x408, x407 = bits.Mul32(x3, (arg1[6]))
  var x409 uint32
  var x410 uint32
  x410, x409 = bits.Mul32(x3, (arg1[5]))
  var x411 uint32
  var x412 uint32
  x412, x411 = bits.Mul32(x3, (arg1[4]))
  var x413 uint32
  var x414 uint32
  x414, x413 = bits.Mul32(x3, (arg1[3]))
  var x415 uint32
  var x416 uint32
  x416, x415 = bits.Mul32(x3, (arg1[2]))
  var x417 uint32
  var x418 uint32
  x418, x417 = bits.Mul32(x3, (arg1[1]))
  var x419 uint32
  var x420 uint32
  x420, x419 = bits.Mul32(x3, (arg1[0]))
  var x421 uint32
  var x422 fiat_p384_uint1
  x421, x422 = fiat_p384_addcarryx_u32(x420, x417, 0x0)
  var x423 uint32
  var x424 fiat_p384_uint1
  x423, x424 = fiat_p384_addcarryx_u32(x418, x415, x422)
  var x425 uint32
  var x426 fiat_p384_uint1
  x425, x426 = fiat_p384_addcarryx_u32(x416, x413, x424)
  var x427 uint32
  var x428 fiat_p384_uint1
  x427, x428 = fiat_p384_addcarryx_u32(x414, x411, x426)
  var x429 uint32
  var x430 fiat_p384_uint1
  x429, x430 = fiat_p384_addcarryx_u32(x412, x409, x428)
  var x431 uint32
  var x432 fiat_p384_uint1
  x431, x432 = fiat_p384_addcarryx_u32(x410, x407, x430)
  var x433 uint32
  var x434 fiat_p384_uint1
  x433, x434 = fiat_p384_addcarryx_u32(x408, x405, x432)
  var x435 uint32
  var x436 fiat_p384_uint1
  x435, x436 = fiat_p384_addcarryx_u32(x406, x403, x434)
  var x437 uint32
  var x438 fiat_p384_uint1
  x437, x438 = fiat_p384_addcarryx_u32(x404, x401, x436)
  var x439 uint32
  var x440 fiat_p384_uint1
  x439, x440 = fiat_p384_addcarryx_u32(x402, x399, x438)
  var x441 uint32
  var x442 fiat_p384_uint1
  x441, x442 = fiat_p384_addcarryx_u32(x400, x397, x440)
  var x443 uint32 = (uint32(x442) + x398)
  var x444 uint32
  var x445 fiat_p384_uint1
  x444, x445 = fiat_p384_addcarryx_u32(x372, x419, 0x0)
  var x446 uint32
  var x447 fiat_p384_uint1
  x446, x447 = fiat_p384_addcarryx_u32(x374, x421, x445)
  var x448 uint32
  var x449 fiat_p384_uint1
  x448, x449 = fiat_p384_addcarryx_u32(x376, x423, x447)
  var x450 uint32
  var x451 fiat_p384_uint1
  x450, x451 = fiat_p384_addcarryx_u32(x378, x425, x449)
  var x452 uint32
  var x453 fiat_p384_uint1
  x452, x453 = fiat_p384_addcarryx_u32(x380, x427, x451)
  var x454 uint32
  var x455 fiat_p384_uint1
  x454, x455 = fiat_p384_addcarryx_u32(x382, x429, x453)
  var x456 uint32
  var x457 fiat_p384_uint1
  x456, x457 = fiat_p384_addcarryx_u32(x384, x431, x455)
  var x458 uint32
  var x459 fiat_p384_uint1
  x458, x459 = fiat_p384_addcarryx_u32(x386, x433, x457)
  var x460 uint32
  var x461 fiat_p384_uint1
  x460, x461 = fiat_p384_addcarryx_u32(x388, x435, x459)
  var x462 uint32
  var x463 fiat_p384_uint1
  x462, x463 = fiat_p384_addcarryx_u32(x390, x437, x461)
  var x464 uint32
  var x465 fiat_p384_uint1
  x464, x465 = fiat_p384_addcarryx_u32(x392, x439, x463)
  var x466 uint32
  var x467 fiat_p384_uint1
  x466, x467 = fiat_p384_addcarryx_u32(x394, x441, x465)
  var x468 uint32
  var x469 fiat_p384_uint1
  x468, x469 = fiat_p384_addcarryx_u32(x396, x443, x467)
  var x470 uint32
  var x471 uint32
  x471, x470 = bits.Mul32(x444, 0xffffffff)
  var x472 uint32
  var x473 uint32
  x473, x472 = bits.Mul32(x444, 0xffffffff)
  var x474 uint32
  var x475 uint32
  x475, x474 = bits.Mul32(x444, 0xffffffff)
  var x476 uint32
  var x477 uint32
  x477, x476 = bits.Mul32(x444, 0xffffffff)
  var x478 uint32
  var x479 uint32
  x479, x478 = bits.Mul32(x444, 0xffffffff)
  var x480 uint32
  var x481 uint32
  x481, x480 = bits.Mul32(x444, 0xffffffff)
  var x482 uint32
  var x483 uint32
  x483, x482 = bits.Mul32(x444, 0xffffffff)
  var x484 uint32
  var x485 uint32
  x485, x484 = bits.Mul32(x444, 0xfffffffe)
  var x486 uint32
  var x487 uint32
  x487, x486 = bits.Mul32(x444, 0xffffffff)
  var x488 uint32
  var x489 uint32
  x489, x488 = bits.Mul32(x444, 0xffffffff)
  var x490 uint32
  var x491 fiat_p384_uint1
  x490, x491 = fiat_p384_addcarryx_u32(x487, x484, 0x0)
  var x492 uint32
  var x493 fiat_p384_uint1
  x492, x493 = fiat_p384_addcarryx_u32(x485, x482, x491)
  var x494 uint32
  var x495 fiat_p384_uint1
  x494, x495 = fiat_p384_addcarryx_u32(x483, x480, x493)
  var x496 uint32
  var x497 fiat_p384_uint1
  x496, x497 = fiat_p384_addcarryx_u32(x481, x478, x495)
  var x498 uint32
  var x499 fiat_p384_uint1
  x498, x499 = fiat_p384_addcarryx_u32(x479, x476, x497)
  var x500 uint32
  var x501 fiat_p384_uint1
  x500, x501 = fiat_p384_addcarryx_u32(x477, x474, x499)
  var x502 uint32
  var x503 fiat_p384_uint1
  x502, x503 = fiat_p384_addcarryx_u32(x475, x472, x501)
  var x504 uint32
  var x505 fiat_p384_uint1
  x504, x505 = fiat_p384_addcarryx_u32(x473, x470, x503)
  var x506 uint32 = (uint32(x505) + x471)
  var x508 fiat_p384_uint1
  _, x508 = fiat_p384_addcarryx_u32(x444, x488, 0x0)
  var x509 uint32
  var x510 fiat_p384_uint1
  x509, x510 = fiat_p384_addcarryx_u32(x446, x489, x508)
  var x511 uint32
  var x512 fiat_p384_uint1
  x511, x512 = fiat_p384_addcarryx_u32(x448, uint32(0x0), x510)
  var x513 uint32
  var x514 fiat_p384_uint1
  x513, x514 = fiat_p384_addcarryx_u32(x450, x486, x512)
  var x515 uint32
  var x516 fiat_p384_uint1
  x515, x516 = fiat_p384_addcarryx_u32(x452, x490, x514)
  var x517 uint32
  var x518 fiat_p384_uint1
  x517, x518 = fiat_p384_addcarryx_u32(x454, x492, x516)
  var x519 uint32
  var x520 fiat_p384_uint1
  x519, x520 = fiat_p384_addcarryx_u32(x456, x494, x518)
  var x521 uint32
  var x522 fiat_p384_uint1
  x521, x522 = fiat_p384_addcarryx_u32(x458, x496, x520)
  var x523 uint32
  var x524 fiat_p384_uint1
  x523, x524 = fiat_p384_addcarryx_u32(x460, x498, x522)
  var x525 uint32
  var x526 fiat_p384_uint1
  x525, x526 = fiat_p384_addcarryx_u32(x462, x500, x524)
  var x527 uint32
  var x528 fiat_p384_uint1
  x527, x528 = fiat_p384_addcarryx_u32(x464, x502, x526)
  var x529 uint32
  var x530 fiat_p384_uint1
  x529, x530 = fiat_p384_addcarryx_u32(x466, x504, x528)
  var x531 uint32
  var x532 fiat_p384_uint1
  x531, x532 = fiat_p384_addcarryx_u32(x468, x506, x530)
  var x533 uint32 = (uint32(x532) + uint32(x469))
  var x534 uint32
  var x535 uint32
  x535, x534 = bits.Mul32(x4, (arg1[11]))
  var x536 uint32
  var x537 uint32
  x537, x536 = bits.Mul32(x4, (arg1[10]))
  var x538 uint32
  var x539 uint32
  x539, x538 = bits.Mul32(x4, (arg1[9]))
  var x540 uint32
  var x541 uint32
  x541, x540 = bits.Mul32(x4, (arg1[8]))
  var x542 uint32
  var x543 uint32
  x543, x542 = bits.Mul32(x4, (arg1[7]))
  var x544 uint32
  var x545 uint32
  x545, x544 = bits.Mul32(x4, (arg1[6]))
  var x546 uint32
  var x547 uint32
  x547, x546 = bits.Mul32(x4, (arg1[5]))
  var x548 uint32
  var x549 uint32
  x549, x548 = bits.Mul32(x4, (arg1[4]))
  var x550 uint32
  var x551 uint32
  x551, x550 = bits.Mul32(x4, (arg1[3]))
  var x552 uint32
  var x553 uint32
  x553, x552 = bits.Mul32(x4, (arg1[2]))
  var x554 uint32
  var x555 uint32
  x555, x554 = bits.Mul32(x4, (arg1[1]))
  var x556 uint32
  var x557 uint32
  x557, x556 = bits.Mul32(x4, (arg1[0]))
  var x558 uint32
  var x559 fiat_p384_uint1
  x558, x559 = fiat_p384_addcarryx_u32(x557, x554, 0x0)
  var x560 uint32
  var x561 fiat_p384_uint1
  x560, x561 = fiat_p384_addcarryx_u32(x555, x552, x559)
  var x562 uint32
  var x563 fiat_p384_uint1
  x562, x563 = fiat_p384_addcarryx_u32(x553, x550, x561)
  var x564 uint32
  var x565 fiat_p384_uint1
  x564, x565 = fiat_p384_addcarryx_u32(x551, x548, x563)
  var x566 uint32
  var x567 fiat_p384_uint1
  x566, x567 = fiat_p384_addcarryx_u32(x549, x546, x565)
  var x568 uint32
  var x569 fiat_p384_uint1
  x568, x569 = fiat_p384_addcarryx_u32(x547, x544, x567)
  var x570 uint32
  var x571 fiat_p384_uint1
  x570, x571 = fiat_p384_addcarryx_u32(x545, x542, x569)
  var x572 uint32
  var x573 fiat_p384_uint1
  x572, x573 = fiat_p384_addcarryx_u32(x543, x540, x571)
  var x574 uint32
  var x575 fiat_p384_uint1
  x574, x575 = fiat_p384_addcarryx_u32(x541, x538, x573)
  var x576 uint32
  var x577 fiat_p384_uint1
  x576, x577 = fiat_p384_addcarryx_u32(x539, x536, x575)
  var x578 uint32
  var x579 fiat_p384_uint1
  x578, x579 = fiat_p384_addcarryx_u32(x537, x534, x577)
  var x580 uint32 = (uint32(x579) + x535)
  var x581 uint32
  var x582 fiat_p384_uint1
  x581, x582 = fiat_p384_addcarryx_u32(x509, x556, 0x0)
  var x583 uint32
  var x584 fiat_p384_uint1
  x583, x584 = fiat_p384_addcarryx_u32(x511, x558, x582)
  var x585 uint32
  var x586 fiat_p384_uint1
  x585, x586 = fiat_p384_addcarryx_u32(x513, x560, x584)
  var x587 uint32
  var x588 fiat_p384_uint1
  x587, x588 = fiat_p384_addcarryx_u32(x515, x562, x586)
  var x589 uint32
  var x590 fiat_p384_uint1
  x589, x590 = fiat_p384_addcarryx_u32(x517, x564, x588)
  var x591 uint32
  var x592 fiat_p384_uint1
  x591, x592 = fiat_p384_addcarryx_u32(x519, x566, x590)
  var x593 uint32
  var x594 fiat_p384_uint1
  x593, x594 = fiat_p384_addcarryx_u32(x521, x568, x592)
  var x595 uint32
  var x596 fiat_p384_uint1
  x595, x596 = fiat_p384_addcarryx_u32(x523, x570, x594)
  var x597 uint32
  var x598 fiat_p384_uint1
  x597, x598 = fiat_p384_addcarryx_u32(x525, x572, x596)
  var x599 uint32
  var x600 fiat_p384_uint1
  x599, x600 = fiat_p384_addcarryx_u32(x527, x574, x598)
  var x601 uint32
  var x602 fiat_p384_uint1
  x601, x602 = fiat_p384_addcarryx_u32(x529, x576, x600)
  var x603 uint32
  var x604 fiat_p384_uint1
  x603, x604 = fiat_p384_addcarryx_u32(x531, x578, x602)
  var x605 uint32
  var x606 fiat_p384_uint1
  x605, x606 = fiat_p384_addcarryx_u32(x533, x580, x604)
  var x607 uint32
  var x608 uint32
  x608, x607 = bits.Mul32(x581, 0xffffffff)
  var x609 uint32
  var x610 uint32
  x610, x609 = bits.Mul32(x581, 0xffffffff)
  var x611 uint32
  var x612 uint32
  x612, x611 = bits.Mul32(x581, 0xffffffff)
  var x613 uint32
  var x614 uint32
  x614, x613 = bits.Mul32(x581, 0xffffffff)
  var x615 uint32
  var x616 uint32
  x616, x615 = bits.Mul32(x581, 0xffffffff)
  var x617 uint32
  var x618 uint32
  x618, x617 = bits.Mul32(x581, 0xffffffff)
  var x619 uint32
  var x620 uint32
  x620, x619 = bits.Mul32(x581, 0xffffffff)
  var x621 uint32
  var x622 uint32
  x622, x621 = bits.Mul32(x581, 0xfffffffe)
  var x623 uint32
  var x624 uint32
  x624, x623 = bits.Mul32(x581, 0xffffffff)
  var x625 uint32
  var x626 uint32
  x626, x625 = bits.Mul32(x581, 0xffffffff)
  var x627 uint32
  var x628 fiat_p384_uint1
  x627, x628 = fiat_p384_addcarryx_u32(x624, x621, 0x0)
  var x629 uint32
  var x630 fiat_p384_uint1
  x629, x630 = fiat_p384_addcarryx_u32(x622, x619, x628)
  var x631 uint32
  var x632 fiat_p384_uint1
  x631, x632 = fiat_p384_addcarryx_u32(x620, x617, x630)
  var x633 uint32
  var x634 fiat_p384_uint1
  x633, x634 = fiat_p384_addcarryx_u32(x618, x615, x632)
  var x635 uint32
  var x636 fiat_p384_uint1
  x635, x636 = fiat_p384_addcarryx_u32(x616, x613, x634)
  var x637 uint32
  var x638 fiat_p384_uint1
  x637, x638 = fiat_p384_addcarryx_u32(x614, x611, x636)
  var x639 uint32
  var x640 fiat_p384_uint1
  x639, x640 = fiat_p384_addcarryx_u32(x612, x609, x638)
  var x641 uint32
  var x642 fiat_p384_uint1
  x641, x642 = fiat_p384_addcarryx_u32(x610, x607, x640)
  var x643 uint32 = (uint32(x642) + x608)
  var x645 fiat_p384_uint1
  _, x645 = fiat_p384_addcarryx_u32(x581, x625, 0x0)
  var x646 uint32
  var x647 fiat_p384_uint1
  x646, x647 = fiat_p384_addcarryx_u32(x583, x626, x645)
  var x648 uint32
  var x649 fiat_p384_uint1
  x648, x649 = fiat_p384_addcarryx_u32(x585, uint32(0x0), x647)
  var x650 uint32
  var x651 fiat_p384_uint1
  x650, x651 = fiat_p384_addcarryx_u32(x587, x623, x649)
  var x652 uint32
  var x653 fiat_p384_uint1
  x652, x653 = fiat_p384_addcarryx_u32(x589, x627, x651)
  var x654 uint32
  var x655 fiat_p384_uint1
  x654, x655 = fiat_p384_addcarryx_u32(x591, x629, x653)
  var x656 uint32
  var x657 fiat_p384_uint1
  x656, x657 = fiat_p384_addcarryx_u32(x593, x631, x655)
  var x658 uint32
  var x659 fiat_p384_uint1
  x658, x659 = fiat_p384_addcarryx_u32(x595, x633, x657)
  var x660 uint32
  var x661 fiat_p384_uint1
  x660, x661 = fiat_p384_addcarryx_u32(x597, x635, x659)
  var x662 uint32
  var x663 fiat_p384_uint1
  x662, x663 = fiat_p384_addcarryx_u32(x599, x637, x661)
  var x664 uint32
  var x665 fiat_p384_uint1
  x664, x665 = fiat_p384_addcarryx_u32(x601, x639, x663)
  var x666 uint32
  var x667 fiat_p384_uint1
  x666, x667 = fiat_p384_addcarryx_u32(x603, x641, x665)
  var x668 uint32
  var x669 fiat_p384_uint1
  x668, x669 = fiat_p384_addcarryx_u32(x605, x643, x667)
  var x670 uint32 = (uint32(x669) + uint32(x606))
  var x671 uint32
  var x672 uint32
  x672, x671 = bits.Mul32(x5, (arg1[11]))
  var x673 uint32
  var x674 uint32
  x674, x673 = bits.Mul32(x5, (arg1[10]))
  var x675 uint32
  var x676 uint32
  x676, x675 = bits.Mul32(x5, (arg1[9]))
  var x677 uint32
  var x678 uint32
  x678, x677 = bits.Mul32(x5, (arg1[8]))
  var x679 uint32
  var x680 uint32
  x680, x679 = bits.Mul32(x5, (arg1[7]))
  var x681 uint32
  var x682 uint32
  x682, x681 = bits.Mul32(x5, (arg1[6]))
  var x683 uint32
  var x684 uint32
  x684, x683 = bits.Mul32(x5, (arg1[5]))
  var x685 uint32
  var x686 uint32
  x686, x685 = bits.Mul32(x5, (arg1[4]))
  var x687 uint32
  var x688 uint32
  x688, x687 = bits.Mul32(x5, (arg1[3]))
  var x689 uint32
  var x690 uint32
  x690, x689 = bits.Mul32(x5, (arg1[2]))
  var x691 uint32
  var x692 uint32
  x692, x691 = bits.Mul32(x5, (arg1[1]))
  var x693 uint32
  var x694 uint32
  x694, x693 = bits.Mul32(x5, (arg1[0]))
  var x695 uint32
  var x696 fiat_p384_uint1
  x695, x696 = fiat_p384_addcarryx_u32(x694, x691, 0x0)
  var x697 uint32
  var x698 fiat_p384_uint1
  x697, x698 = fiat_p384_addcarryx_u32(x692, x689, x696)
  var x699 uint32
  var x700 fiat_p384_uint1
  x699, x700 = fiat_p384_addcarryx_u32(x690, x687, x698)
  var x701 uint32
  var x702 fiat_p384_uint1
  x701, x702 = fiat_p384_addcarryx_u32(x688, x685, x700)
  var x703 uint32
  var x704 fiat_p384_uint1
  x703, x704 = fiat_p384_addcarryx_u32(x686, x683, x702)
  var x705 uint32
  var x706 fiat_p384_uint1
  x705, x706 = fiat_p384_addcarryx_u32(x684, x681, x704)
  var x707 uint32
  var x708 fiat_p384_uint1
  x707, x708 = fiat_p384_addcarryx_u32(x682, x679, x706)
  var x709 uint32
  var x710 fiat_p384_uint1
  x709, x710 = fiat_p384_addcarryx_u32(x680, x677, x708)
  var x711 uint32
  var x712 fiat_p384_uint1
  x711, x712 = fiat_p384_addcarryx_u32(x678, x675, x710)
  var x713 uint32
  var x714 fiat_p384_uint1
  x713, x714 = fiat_p384_addcarryx_u32(x676, x673, x712)
  var x715 uint32
  var x716 fiat_p384_uint1
  x715, x716 = fiat_p384_addcarryx_u32(x674, x671, x714)
  var x717 uint32 = (uint32(x716) + x672)
  var x718 uint32
  var x719 fiat_p384_uint1
  x718, x719 = fiat_p384_addcarryx_u32(x646, x693, 0x0)
  var x720 uint32
  var x721 fiat_p384_uint1
  x720, x721 = fiat_p384_addcarryx_u32(x648, x695, x719)
  var x722 uint32
  var x723 fiat_p384_uint1
  x722, x723 = fiat_p384_addcarryx_u32(x650, x697, x721)
  var x724 uint32
  var x725 fiat_p384_uint1
  x724, x725 = fiat_p384_addcarryx_u32(x652, x699, x723)
  var x726 uint32
  var x727 fiat_p384_uint1
  x726, x727 = fiat_p384_addcarryx_u32(x654, x701, x725)
  var x728 uint32
  var x729 fiat_p384_uint1
  x728, x729 = fiat_p384_addcarryx_u32(x656, x703, x727)
  var x730 uint32
  var x731 fiat_p384_uint1
  x730, x731 = fiat_p384_addcarryx_u32(x658, x705, x729)
  var x732 uint32
  var x733 fiat_p384_uint1
  x732, x733 = fiat_p384_addcarryx_u32(x660, x707, x731)
  var x734 uint32
  var x735 fiat_p384_uint1
  x734, x735 = fiat_p384_addcarryx_u32(x662, x709, x733)
  var x736 uint32
  var x737 fiat_p384_uint1
  x736, x737 = fiat_p384_addcarryx_u32(x664, x711, x735)
  var x738 uint32
  var x739 fiat_p384_uint1
  x738, x739 = fiat_p384_addcarryx_u32(x666, x713, x737)
  var x740 uint32
  var x741 fiat_p384_uint1
  x740, x741 = fiat_p384_addcarryx_u32(x668, x715, x739)
  var x742 uint32
  var x743 fiat_p384_uint1
  x742, x743 = fiat_p384_addcarryx_u32(x670, x717, x741)
  var x744 uint32
  var x745 uint32
  x745, x744 = bits.Mul32(x718, 0xffffffff)
  var x746 uint32
  var x747 uint32
  x747, x746 = bits.Mul32(x718, 0xffffffff)
  var x748 uint32
  var x749 uint32
  x749, x748 = bits.Mul32(x718, 0xffffffff)
  var x750 uint32
  var x751 uint32
  x751, x750 = bits.Mul32(x718, 0xffffffff)
  var x752 uint32
  var x753 uint32
  x753, x752 = bits.Mul32(x718, 0xffffffff)
  var x754 uint32
  var x755 uint32
  x755, x754 = bits.Mul32(x718, 0xffffffff)
  var x756 uint32
  var x757 uint32
  x757, x756 = bits.Mul32(x718, 0xffffffff)
  var x758 uint32
  var x759 uint32
  x759, x758 = bits.Mul32(x718, 0xfffffffe)
  var x760 uint32
  var x761 uint32
  x761, x760 = bits.Mul32(x718, 0xffffffff)
  var x762 uint32
  var x763 uint32
  x763, x762 = bits.Mul32(x718, 0xffffffff)
  var x764 uint32
  var x765 fiat_p384_uint1
  x764, x765 = fiat_p384_addcarryx_u32(x761, x758, 0x0)
  var x766 uint32
  var x767 fiat_p384_uint1
  x766, x767 = fiat_p384_addcarryx_u32(x759, x756, x765)
  var x768 uint32
  var x769 fiat_p384_uint1
  x768, x769 = fiat_p384_addcarryx_u32(x757, x754, x767)
  var x770 uint32
  var x771 fiat_p384_uint1
  x770, x771 = fiat_p384_addcarryx_u32(x755, x752, x769)
  var x772 uint32
  var x773 fiat_p384_uint1
  x772, x773 = fiat_p384_addcarryx_u32(x753, x750, x771)
  var x774 uint32
  var x775 fiat_p384_uint1
  x774, x775 = fiat_p384_addcarryx_u32(x751, x748, x773)
  var x776 uint32
  var x777 fiat_p384_uint1
  x776, x777 = fiat_p384_addcarryx_u32(x749, x746, x775)
  var x778 uint32
  var x779 fiat_p384_uint1
  x778, x779 = fiat_p384_addcarryx_u32(x747, x744, x777)
  var x780 uint32 = (uint32(x779) + x745)
  var x782 fiat_p384_uint1
  _, x782 = fiat_p384_addcarryx_u32(x718, x762, 0x0)
  var x783 uint32
  var x784 fiat_p384_uint1
  x783, x784 = fiat_p384_addcarryx_u32(x720, x763, x782)
  var x785 uint32
  var x786 fiat_p384_uint1
  x785, x786 = fiat_p384_addcarryx_u32(x722, uint32(0x0), x784)
  var x787 uint32
  var x788 fiat_p384_uint1
  x787, x788 = fiat_p384_addcarryx_u32(x724, x760, x786)
  var x789 uint32
  var x790 fiat_p384_uint1
  x789, x790 = fiat_p384_addcarryx_u32(x726, x764, x788)
  var x791 uint32
  var x792 fiat_p384_uint1
  x791, x792 = fiat_p384_addcarryx_u32(x728, x766, x790)
  var x793 uint32
  var x794 fiat_p384_uint1
  x793, x794 = fiat_p384_addcarryx_u32(x730, x768, x792)
  var x795 uint32
  var x796 fiat_p384_uint1
  x795, x796 = fiat_p384_addcarryx_u32(x732, x770, x794)
  var x797 uint32
  var x798 fiat_p384_uint1
  x797, x798 = fiat_p384_addcarryx_u32(x734, x772, x796)
  var x799 uint32
  var x800 fiat_p384_uint1
  x799, x800 = fiat_p384_addcarryx_u32(x736, x774, x798)
  var x801 uint32
  var x802 fiat_p384_uint1
  x801, x802 = fiat_p384_addcarryx_u32(x738, x776, x800)
  var x803 uint32
  var x804 fiat_p384_uint1
  x803, x804 = fiat_p384_addcarryx_u32(x740, x778, x802)
  var x805 uint32
  var x806 fiat_p384_uint1
  x805, x806 = fiat_p384_addcarryx_u32(x742, x780, x804)
  var x807 uint32 = (uint32(x806) + uint32(x743))
  var x808 uint32
  var x809 uint32
  x809, x808 = bits.Mul32(x6, (arg1[11]))
  var x810 uint32
  var x811 uint32
  x811, x810 = bits.Mul32(x6, (arg1[10]))
  var x812 uint32
  var x813 uint32
  x813, x812 = bits.Mul32(x6, (arg1[9]))
  var x814 uint32
  var x815 uint32
  x815, x814 = bits.Mul32(x6, (arg1[8]))
  var x816 uint32
  var x817 uint32
  x817, x816 = bits.Mul32(x6, (arg1[7]))
  var x818 uint32
  var x819 uint32
  x819, x818 = bits.Mul32(x6, (arg1[6]))
  var x820 uint32
  var x821 uint32
  x821, x820 = bits.Mul32(x6, (arg1[5]))
  var x822 uint32
  var x823 uint32
  x823, x822 = bits.Mul32(x6, (arg1[4]))
  var x824 uint32
  var x825 uint32
  x825, x824 = bits.Mul32(x6, (arg1[3]))
  var x826 uint32
  var x827 uint32
  x827, x826 = bits.Mul32(x6, (arg1[2]))
  var x828 uint32
  var x829 uint32
  x829, x828 = bits.Mul32(x6, (arg1[1]))
  var x830 uint32
  var x831 uint32
  x831, x830 = bits.Mul32(x6, (arg1[0]))
  var x832 uint32
  var x833 fiat_p384_uint1
  x832, x833 = fiat_p384_addcarryx_u32(x831, x828, 0x0)
  var x834 uint32
  var x835 fiat_p384_uint1
  x834, x835 = fiat_p384_addcarryx_u32(x829, x826, x833)
  var x836 uint32
  var x837 fiat_p384_uint1
  x836, x837 = fiat_p384_addcarryx_u32(x827, x824, x835)
  var x838 uint32
  var x839 fiat_p384_uint1
  x838, x839 = fiat_p384_addcarryx_u32(x825, x822, x837)
  var x840 uint32
  var x841 fiat_p384_uint1
  x840, x841 = fiat_p384_addcarryx_u32(x823, x820, x839)
  var x842 uint32
  var x843 fiat_p384_uint1
  x842, x843 = fiat_p384_addcarryx_u32(x821, x818, x841)
  var x844 uint32
  var x845 fiat_p384_uint1
  x844, x845 = fiat_p384_addcarryx_u32(x819, x816, x843)
  var x846 uint32
  var x847 fiat_p384_uint1
  x846, x847 = fiat_p384_addcarryx_u32(x817, x814, x845)
  var x848 uint32
  var x849 fiat_p384_uint1
  x848, x849 = fiat_p384_addcarryx_u32(x815, x812, x847)
  var x850 uint32
  var x851 fiat_p384_uint1
  x850, x851 = fiat_p384_addcarryx_u32(x813, x810, x849)
  var x852 uint32
  var x853 fiat_p384_uint1
  x852, x853 = fiat_p384_addcarryx_u32(x811, x808, x851)
  var x854 uint32 = (uint32(x853) + x809)
  var x855 uint32
  var x856 fiat_p384_uint1
  x855, x856 = fiat_p384_addcarryx_u32(x783, x830, 0x0)
  var x857 uint32
  var x858 fiat_p384_uint1
  x857, x858 = fiat_p384_addcarryx_u32(x785, x832, x856)
  var x859 uint32
  var x860 fiat_p384_uint1
  x859, x860 = fiat_p384_addcarryx_u32(x787, x834, x858)
  var x861 uint32
  var x862 fiat_p384_uint1
  x861, x862 = fiat_p384_addcarryx_u32(x789, x836, x860)
  var x863 uint32
  var x864 fiat_p384_uint1
  x863, x864 = fiat_p384_addcarryx_u32(x791, x838, x862)
  var x865 uint32
  var x866 fiat_p384_uint1
  x865, x866 = fiat_p384_addcarryx_u32(x793, x840, x864)
  var x867 uint32
  var x868 fiat_p384_uint1
  x867, x868 = fiat_p384_addcarryx_u32(x795, x842, x866)
  var x869 uint32
  var x870 fiat_p384_uint1
  x869, x870 = fiat_p384_addcarryx_u32(x797, x844, x868)
  var x871 uint32
  var x872 fiat_p384_uint1
  x871, x872 = fiat_p384_addcarryx_u32(x799, x846, x870)
  var x873 uint32
  var x874 fiat_p384_uint1
  x873, x874 = fiat_p384_addcarryx_u32(x801, x848, x872)
  var x875 uint32
  var x876 fiat_p384_uint1
  x875, x876 = fiat_p384_addcarryx_u32(x803, x850, x874)
  var x877 uint32
  var x878 fiat_p384_uint1
  x877, x878 = fiat_p384_addcarryx_u32(x805, x852, x876)
  var x879 uint32
  var x880 fiat_p384_uint1
  x879, x880 = fiat_p384_addcarryx_u32(x807, x854, x878)
  var x881 uint32
  var x882 uint32
  x882, x881 = bits.Mul32(x855, 0xffffffff)
  var x883 uint32
  var x884 uint32
  x884, x883 = bits.Mul32(x855, 0xffffffff)
  var x885 uint32
  var x886 uint32
  x886, x885 = bits.Mul32(x855, 0xffffffff)
  var x887 uint32
  var x888 uint32
  x888, x887 = bits.Mul32(x855, 0xffffffff)
  var x889 uint32
  var x890 uint32
  x890, x889 = bits.Mul32(x855, 0xffffffff)
  var x891 uint32
  var x892 uint32
  x892, x891 = bits.Mul32(x855, 0xffffffff)
  var x893 uint32
  var x894 uint32
  x894, x893 = bits.Mul32(x855, 0xffffffff)
  var x895 uint32
  var x896 uint32
  x896, x895 = bits.Mul32(x855, 0xfffffffe)
  var x897 uint32
  var x898 uint32
  x898, x897 = bits.Mul32(x855, 0xffffffff)
  var x899 uint32
  var x900 uint32
  x900, x899 = bits.Mul32(x855, 0xffffffff)
  var x901 uint32
  var x902 fiat_p384_uint1
  x901, x902 = fiat_p384_addcarryx_u32(x898, x895, 0x0)
  var x903 uint32
  var x904 fiat_p384_uint1
  x903, x904 = fiat_p384_addcarryx_u32(x896, x893, x902)
  var x905 uint32
  var x906 fiat_p384_uint1
  x905, x906 = fiat_p384_addcarryx_u32(x894, x891, x904)
  var x907 uint32
  var x908 fiat_p384_uint1
  x907, x908 = fiat_p384_addcarryx_u32(x892, x889, x906)
  var x909 uint32
  var x910 fiat_p384_uint1
  x909, x910 = fiat_p384_addcarryx_u32(x890, x887, x908)
  var x911 uint32
  var x912 fiat_p384_uint1
  x911, x912 = fiat_p384_addcarryx_u32(x888, x885, x910)
  var x913 uint32
  var x914 fiat_p384_uint1
  x913, x914 = fiat_p384_addcarryx_u32(x886, x883, x912)
  var x915 uint32
  var x916 fiat_p384_uint1
  x915, x916 = fiat_p384_addcarryx_u32(x884, x881, x914)
  var x917 uint32 = (uint32(x916) + x882)
  var x919 fiat_p384_uint1
  _, x919 = fiat_p384_addcarryx_u32(x855, x899, 0x0)
  var x920 uint32
  var x921 fiat_p384_uint1
  x920, x921 = fiat_p384_addcarryx_u32(x857, x900, x919)
  var x922 uint32
  var x923 fiat_p384_uint1
  x922, x923 = fiat_p384_addcarryx_u32(x859, uint32(0x0), x921)
  var x924 uint32
  var x925 fiat_p384_uint1
  x924, x925 = fiat_p384_addcarryx_u32(x861, x897, x923)
  var x926 uint32
  var x927 fiat_p384_uint1
  x926, x927 = fiat_p384_addcarryx_u32(x863, x901, x925)
  var x928 uint32
  var x929 fiat_p384_uint1
  x928, x929 = fiat_p384_addcarryx_u32(x865, x903, x927)
  var x930 uint32
  var x931 fiat_p384_uint1
  x930, x931 = fiat_p384_addcarryx_u32(x867, x905, x929)
  var x932 uint32
  var x933 fiat_p384_uint1
  x932, x933 = fiat_p384_addcarryx_u32(x869, x907, x931)
  var x934 uint32
  var x935 fiat_p384_uint1
  x934, x935 = fiat_p384_addcarryx_u32(x871, x909, x933)
  var x936 uint32
  var x937 fiat_p384_uint1
  x936, x937 = fiat_p384_addcarryx_u32(x873, x911, x935)
  var x938 uint32
  var x939 fiat_p384_uint1
  x938, x939 = fiat_p384_addcarryx_u32(x875, x913, x937)
  var x940 uint32
  var x941 fiat_p384_uint1
  x940, x941 = fiat_p384_addcarryx_u32(x877, x915, x939)
  var x942 uint32
  var x943 fiat_p384_uint1
  x942, x943 = fiat_p384_addcarryx_u32(x879, x917, x941)
  var x944 uint32 = (uint32(x943) + uint32(x880))
  var x945 uint32
  var x946 uint32
  x946, x945 = bits.Mul32(x7, (arg1[11]))
  var x947 uint32
  var x948 uint32
  x948, x947 = bits.Mul32(x7, (arg1[10]))
  var x949 uint32
  var x950 uint32
  x950, x949 = bits.Mul32(x7, (arg1[9]))
  var x951 uint32
  var x952 uint32
  x952, x951 = bits.Mul32(x7, (arg1[8]))
  var x953 uint32
  var x954 uint32
  x954, x953 = bits.Mul32(x7, (arg1[7]))
  var x955 uint32
  var x956 uint32
  x956, x955 = bits.Mul32(x7, (arg1[6]))
  var x957 uint32
  var x958 uint32
  x958, x957 = bits.Mul32(x7, (arg1[5]))
  var x959 uint32
  var x960 uint32
  x960, x959 = bits.Mul32(x7, (arg1[4]))
  var x961 uint32
  var x962 uint32
  x962, x961 = bits.Mul32(x7, (arg1[3]))
  var x963 uint32
  var x964 uint32
  x964, x963 = bits.Mul32(x7, (arg1[2]))
  var x965 uint32
  var x966 uint32
  x966, x965 = bits.Mul32(x7, (arg1[1]))
  var x967 uint32
  var x968 uint32
  x968, x967 = bits.Mul32(x7, (arg1[0]))
  var x969 uint32
  var x970 fiat_p384_uint1
  x969, x970 = fiat_p384_addcarryx_u32(x968, x965, 0x0)
  var x971 uint32
  var x972 fiat_p384_uint1
  x971, x972 = fiat_p384_addcarryx_u32(x966, x963, x970)
  var x973 uint32
  var x974 fiat_p384_uint1
  x973, x974 = fiat_p384_addcarryx_u32(x964, x961, x972)
  var x975 uint32
  var x976 fiat_p384_uint1
  x975, x976 = fiat_p384_addcarryx_u32(x962, x959, x974)
  var x977 uint32
  var x978 fiat_p384_uint1
  x977, x978 = fiat_p384_addcarryx_u32(x960, x957, x976)
  var x979 uint32
  var x980 fiat_p384_uint1
  x979, x980 = fiat_p384_addcarryx_u32(x958, x955, x978)
  var x981 uint32
  var x982 fiat_p384_uint1
  x981, x982 = fiat_p384_addcarryx_u32(x956, x953, x980)
  var x983 uint32
  var x984 fiat_p384_uint1
  x983, x984 = fiat_p384_addcarryx_u32(x954, x951, x982)
  var x985 uint32
  var x986 fiat_p384_uint1
  x985, x986 = fiat_p384_addcarryx_u32(x952, x949, x984)
  var x987 uint32
  var x988 fiat_p384_uint1
  x987, x988 = fiat_p384_addcarryx_u32(x950, x947, x986)
  var x989 uint32
  var x990 fiat_p384_uint1
  x989, x990 = fiat_p384_addcarryx_u32(x948, x945, x988)
  var x991 uint32 = (uint32(x990) + x946)
  var x992 uint32
  var x993 fiat_p384_uint1
  x992, x993 = fiat_p384_addcarryx_u32(x920, x967, 0x0)
  var x994 uint32
  var x995 fiat_p384_uint1
  x994, x995 = fiat_p384_addcarryx_u32(x922, x969, x993)
  var x996 uint32
  var x997 fiat_p384_uint1
  x996, x997 = fiat_p384_addcarryx_u32(x924, x971, x995)
  var x998 uint32
  var x999 fiat_p384_uint1
  x998, x999 = fiat_p384_addcarryx_u32(x926, x973, x997)
  var x1000 uint32
  var x1001 fiat_p384_uint1
  x1000, x1001 = fiat_p384_addcarryx_u32(x928, x975, x999)
  var x1002 uint32
  var x1003 fiat_p384_uint1
  x1002, x1003 = fiat_p384_addcarryx_u32(x930, x977, x1001)
  var x1004 uint32
  var x1005 fiat_p384_uint1
  x1004, x1005 = fiat_p384_addcarryx_u32(x932, x979, x1003)
  var x1006 uint32
  var x1007 fiat_p384_uint1
  x1006, x1007 = fiat_p384_addcarryx_u32(x934, x981, x1005)
  var x1008 uint32
  var x1009 fiat_p384_uint1
  x1008, x1009 = fiat_p384_addcarryx_u32(x936, x983, x1007)
  var x1010 uint32
  var x1011 fiat_p384_uint1
  x1010, x1011 = fiat_p384_addcarryx_u32(x938, x985, x1009)
  var x1012 uint32
  var x1013 fiat_p384_uint1
  x1012, x1013 = fiat_p384_addcarryx_u32(x940, x987, x1011)
  var x1014 uint32
  var x1015 fiat_p384_uint1
  x1014, x1015 = fiat_p384_addcarryx_u32(x942, x989, x1013)
  var x1016 uint32
  var x1017 fiat_p384_uint1
  x1016, x1017 = fiat_p384_addcarryx_u32(x944, x991, x1015)
  var x1018 uint32
  var x1019 uint32
  x1019, x1018 = bits.Mul32(x992, 0xffffffff)
  var x1020 uint32
  var x1021 uint32
  x1021, x1020 = bits.Mul32(x992, 0xffffffff)
  var x1022 uint32
  var x1023 uint32
  x1023, x1022 = bits.Mul32(x992, 0xffffffff)
  var x1024 uint32
  var x1025 uint32
  x1025, x1024 = bits.Mul32(x992, 0xffffffff)
  var x1026 uint32
  var x1027 uint32
  x1027, x1026 = bits.Mul32(x992, 0xffffffff)
  var x1028 uint32
  var x1029 uint32
  x1029, x1028 = bits.Mul32(x992, 0xffffffff)
  var x1030 uint32
  var x1031 uint32
  x1031, x1030 = bits.Mul32(x992, 0xffffffff)
  var x1032 uint32
  var x1033 uint32
  x1033, x1032 = bits.Mul32(x992, 0xfffffffe)
  var x1034 uint32
  var x1035 uint32
  x1035, x1034 = bits.Mul32(x992, 0xffffffff)
  var x1036 uint32
  var x1037 uint32
  x1037, x1036 = bits.Mul32(x992, 0xffffffff)
  var x1038 uint32
  var x1039 fiat_p384_uint1
  x1038, x1039 = fiat_p384_addcarryx_u32(x1035, x1032, 0x0)
  var x1040 uint32
  var x1041 fiat_p384_uint1
  x1040, x1041 = fiat_p384_addcarryx_u32(x1033, x1030, x1039)
  var x1042 uint32
  var x1043 fiat_p384_uint1
  x1042, x1043 = fiat_p384_addcarryx_u32(x1031, x1028, x1041)
  var x1044 uint32
  var x1045 fiat_p384_uint1
  x1044, x1045 = fiat_p384_addcarryx_u32(x1029, x1026, x1043)
  var x1046 uint32
  var x1047 fiat_p384_uint1
  x1046, x1047 = fiat_p384_addcarryx_u32(x1027, x1024, x1045)
  var x1048 uint32
  var x1049 fiat_p384_uint1
  x1048, x1049 = fiat_p384_addcarryx_u32(x1025, x1022, x1047)
  var x1050 uint32
  var x1051 fiat_p384_uint1
  x1050, x1051 = fiat_p384_addcarryx_u32(x1023, x1020, x1049)
  var x1052 uint32
  var x1053 fiat_p384_uint1
  x1052, x1053 = fiat_p384_addcarryx_u32(x1021, x1018, x1051)
  var x1054 uint32 = (uint32(x1053) + x1019)
  var x1056 fiat_p384_uint1
  _, x1056 = fiat_p384_addcarryx_u32(x992, x1036, 0x0)
  var x1057 uint32
  var x1058 fiat_p384_uint1
  x1057, x1058 = fiat_p384_addcarryx_u32(x994, x1037, x1056)
  var x1059 uint32
  var x1060 fiat_p384_uint1
  x1059, x1060 = fiat_p384_addcarryx_u32(x996, uint32(0x0), x1058)
  var x1061 uint32
  var x1062 fiat_p384_uint1
  x1061, x1062 = fiat_p384_addcarryx_u32(x998, x1034, x1060)
  var x1063 uint32
  var x1064 fiat_p384_uint1
  x1063, x1064 = fiat_p384_addcarryx_u32(x1000, x1038, x1062)
  var x1065 uint32
  var x1066 fiat_p384_uint1
  x1065, x1066 = fiat_p384_addcarryx_u32(x1002, x1040, x1064)
  var x1067 uint32
  var x1068 fiat_p384_uint1
  x1067, x1068 = fiat_p384_addcarryx_u32(x1004, x1042, x1066)
  var x1069 uint32
  var x1070 fiat_p384_uint1
  x1069, x1070 = fiat_p384_addcarryx_u32(x1006, x1044, x1068)
  var x1071 uint32
  var x1072 fiat_p384_uint1
  x1071, x1072 = fiat_p384_addcarryx_u32(x1008, x1046, x1070)
  var x1073 uint32
  var x1074 fiat_p384_uint1
  x1073, x1074 = fiat_p384_addcarryx_u32(x1010, x1048, x1072)
  var x1075 uint32
  var x1076 fiat_p384_uint1
  x1075, x1076 = fiat_p384_addcarryx_u32(x1012, x1050, x1074)
  var x1077 uint32
  var x1078 fiat_p384_uint1
  x1077, x1078 = fiat_p384_addcarryx_u32(x1014, x1052, x1076)
  var x1079 uint32
  var x1080 fiat_p384_uint1
  x1079, x1080 = fiat_p384_addcarryx_u32(x1016, x1054, x1078)
  var x1081 uint32 = (uint32(x1080) + uint32(x1017))
  var x1082 uint32
  var x1083 uint32
  x1083, x1082 = bits.Mul32(x8, (arg1[11]))
  var x1084 uint32
  var x1085 uint32
  x1085, x1084 = bits.Mul32(x8, (arg1[10]))
  var x1086 uint32
  var x1087 uint32
  x1087, x1086 = bits.Mul32(x8, (arg1[9]))
  var x1088 uint32
  var x1089 uint32
  x1089, x1088 = bits.Mul32(x8, (arg1[8]))
  var x1090 uint32
  var x1091 uint32
  x1091, x1090 = bits.Mul32(x8, (arg1[7]))
  var x1092 uint32
  var x1093 uint32
  x1093, x1092 = bits.Mul32(x8, (arg1[6]))
  var x1094 uint32
  var x1095 uint32
  x1095, x1094 = bits.Mul32(x8, (arg1[5]))
  var x1096 uint32
  var x1097 uint32
  x1097, x1096 = bits.Mul32(x8, (arg1[4]))
  var x1098 uint32
  var x1099 uint32
  x1099, x1098 = bits.Mul32(x8, (arg1[3]))
  var x1100 uint32
  var x1101 uint32
  x1101, x1100 = bits.Mul32(x8, (arg1[2]))
  var x1102 uint32
  var x1103 uint32
  x1103, x1102 = bits.Mul32(x8, (arg1[1]))
  var x1104 uint32
  var x1105 uint32
  x1105, x1104 = bits.Mul32(x8, (arg1[0]))
  var x1106 uint32
  var x1107 fiat_p384_uint1
  x1106, x1107 = fiat_p384_addcarryx_u32(x1105, x1102, 0x0)
  var x1108 uint32
  var x1109 fiat_p384_uint1
  x1108, x1109 = fiat_p384_addcarryx_u32(x1103, x1100, x1107)
  var x1110 uint32
  var x1111 fiat_p384_uint1
  x1110, x1111 = fiat_p384_addcarryx_u32(x1101, x1098, x1109)
  var x1112 uint32
  var x1113 fiat_p384_uint1
  x1112, x1113 = fiat_p384_addcarryx_u32(x1099, x1096, x1111)
  var x1114 uint32
  var x1115 fiat_p384_uint1
  x1114, x1115 = fiat_p384_addcarryx_u32(x1097, x1094, x1113)
  var x1116 uint32
  var x1117 fiat_p384_uint1
  x1116, x1117 = fiat_p384_addcarryx_u32(x1095, x1092, x1115)
  var x1118 uint32
  var x1119 fiat_p384_uint1
  x1118, x1119 = fiat_p384_addcarryx_u32(x1093, x1090, x1117)
  var x1120 uint32
  var x1121 fiat_p384_uint1
  x1120, x1121 = fiat_p384_addcarryx_u32(x1091, x1088, x1119)
  var x1122 uint32
  var x1123 fiat_p384_uint1
  x1122, x1123 = fiat_p384_addcarryx_u32(x1089, x1086, x1121)
  var x1124 uint32
  var x1125 fiat_p384_uint1
  x1124, x1125 = fiat_p384_addcarryx_u32(x1087, x1084, x1123)
  var x1126 uint32
  var x1127 fiat_p384_uint1
  x1126, x1127 = fiat_p384_addcarryx_u32(x1085, x1082, x1125)
  var x1128 uint32 = (uint32(x1127) + x1083)
  var x1129 uint32
  var x1130 fiat_p384_uint1
  x1129, x1130 = fiat_p384_addcarryx_u32(x1057, x1104, 0x0)
  var x1131 uint32
  var x1132 fiat_p384_uint1
  x1131, x1132 = fiat_p384_addcarryx_u32(x1059, x1106, x1130)
  var x1133 uint32
  var x1134 fiat_p384_uint1
  x1133, x1134 = fiat_p384_addcarryx_u32(x1061, x1108, x1132)
  var x1135 uint32
  var x1136 fiat_p384_uint1
  x1135, x1136 = fiat_p384_addcarryx_u32(x1063, x1110, x1134)
  var x1137 uint32
  var x1138 fiat_p384_uint1
  x1137, x1138 = fiat_p384_addcarryx_u32(x1065, x1112, x1136)
  var x1139 uint32
  var x1140 fiat_p384_uint1
  x1139, x1140 = fiat_p384_addcarryx_u32(x1067, x1114, x1138)
  var x1141 uint32
  var x1142 fiat_p384_uint1
  x1141, x1142 = fiat_p384_addcarryx_u32(x1069, x1116, x1140)
  var x1143 uint32
  var x1144 fiat_p384_uint1
  x1143, x1144 = fiat_p384_addcarryx_u32(x1071, x1118, x1142)
  var x1145 uint32
  var x1146 fiat_p384_uint1
  x1145, x1146 = fiat_p384_addcarryx_u32(x1073, x1120, x1144)
  var x1147 uint32
  var x1148 fiat_p384_uint1
  x1147, x1148 = fiat_p384_addcarryx_u32(x1075, x1122, x1146)
  var x1149 uint32
  var x1150 fiat_p384_uint1
  x1149, x1150 = fiat_p384_addcarryx_u32(x1077, x1124, x1148)
  var x1151 uint32
  var x1152 fiat_p384_uint1
  x1151, x1152 = fiat_p384_addcarryx_u32(x1079, x1126, x1150)
  var x1153 uint32
  var x1154 fiat_p384_uint1
  x1153, x1154 = fiat_p384_addcarryx_u32(x1081, x1128, x1152)
  var x1155 uint32
  var x1156 uint32
  x1156, x1155 = bits.Mul32(x1129, 0xffffffff)
  var x1157 uint32
  var x1158 uint32
  x1158, x1157 = bits.Mul32(x1129, 0xffffffff)
  var x1159 uint32
  var x1160 uint32
  x1160, x1159 = bits.Mul32(x1129, 0xffffffff)
  var x1161 uint32
  var x1162 uint32
  x1162, x1161 = bits.Mul32(x1129, 0xffffffff)
  var x1163 uint32
  var x1164 uint32
  x1164, x1163 = bits.Mul32(x1129, 0xffffffff)
  var x1165 uint32
  var x1166 uint32
  x1166, x1165 = bits.Mul32(x1129, 0xffffffff)
  var x1167 uint32
  var x1168 uint32
  x1168, x1167 = bits.Mul32(x1129, 0xffffffff)
  var x1169 uint32
  var x1170 uint32
  x1170, x1169 = bits.Mul32(x1129, 0xfffffffe)
  var x1171 uint32
  var x1172 uint32
  x1172, x1171 = bits.Mul32(x1129, 0xffffffff)
  var x1173 uint32
  var x1174 uint32
  x1174, x1173 = bits.Mul32(x1129, 0xffffffff)
  var x1175 uint32
  var x1176 fiat_p384_uint1
  x1175, x1176 = fiat_p384_addcarryx_u32(x1172, x1169, 0x0)
  var x1177 uint32
  var x1178 fiat_p384_uint1
  x1177, x1178 = fiat_p384_addcarryx_u32(x1170, x1167, x1176)
  var x1179 uint32
  var x1180 fiat_p384_uint1
  x1179, x1180 = fiat_p384_addcarryx_u32(x1168, x1165, x1178)
  var x1181 uint32
  var x1182 fiat_p384_uint1
  x1181, x1182 = fiat_p384_addcarryx_u32(x1166, x1163, x1180)
  var x1183 uint32
  var x1184 fiat_p384_uint1
  x1183, x1184 = fiat_p384_addcarryx_u32(x1164, x1161, x1182)
  var x1185 uint32
  var x1186 fiat_p384_uint1
  x1185, x1186 = fiat_p384_addcarryx_u32(x1162, x1159, x1184)
  var x1187 uint32
  var x1188 fiat_p384_uint1
  x1187, x1188 = fiat_p384_addcarryx_u32(x1160, x1157, x1186)
  var x1189 uint32
  var x1190 fiat_p384_uint1
  x1189, x1190 = fiat_p384_addcarryx_u32(x1158, x1155, x1188)
  var x1191 uint32 = (uint32(x1190) + x1156)
  var x1193 fiat_p384_uint1
  _, x1193 = fiat_p384_addcarryx_u32(x1129, x1173, 0x0)
  var x1194 uint32
  var x1195 fiat_p384_uint1
  x1194, x1195 = fiat_p384_addcarryx_u32(x1131, x1174, x1193)
  var x1196 uint32
  var x1197 fiat_p384_uint1
  x1196, x1197 = fiat_p384_addcarryx_u32(x1133, uint32(0x0), x1195)
  var x1198 uint32
  var x1199 fiat_p384_uint1
  x1198, x1199 = fiat_p384_addcarryx_u32(x1135, x1171, x1197)
  var x1200 uint32
  var x1201 fiat_p384_uint1
  x1200, x1201 = fiat_p384_addcarryx_u32(x1137, x1175, x1199)
  var x1202 uint32
  var x1203 fiat_p384_uint1
  x1202, x1203 = fiat_p384_addcarryx_u32(x1139, x1177, x1201)
  var x1204 uint32
  var x1205 fiat_p384_uint1
  x1204, x1205 = fiat_p384_addcarryx_u32(x1141, x1179, x1203)
  var x1206 uint32
  var x1207 fiat_p384_uint1
  x1206, x1207 = fiat_p384_addcarryx_u32(x1143, x1181, x1205)
  var x1208 uint32
  var x1209 fiat_p384_uint1
  x1208, x1209 = fiat_p384_addcarryx_u32(x1145, x1183, x1207)
  var x1210 uint32
  var x1211 fiat_p384_uint1
  x1210, x1211 = fiat_p384_addcarryx_u32(x1147, x1185, x1209)
  var x1212 uint32
  var x1213 fiat_p384_uint1
  x1212, x1213 = fiat_p384_addcarryx_u32(x1149, x1187, x1211)
  var x1214 uint32
  var x1215 fiat_p384_uint1
  x1214, x1215 = fiat_p384_addcarryx_u32(x1151, x1189, x1213)
  var x1216 uint32
  var x1217 fiat_p384_uint1
  x1216, x1217 = fiat_p384_addcarryx_u32(x1153, x1191, x1215)
  var x1218 uint32 = (uint32(x1217) + uint32(x1154))
  var x1219 uint32
  var x1220 uint32
  x1220, x1219 = bits.Mul32(x9, (arg1[11]))
  var x1221 uint32
  var x1222 uint32
  x1222, x1221 = bits.Mul32(x9, (arg1[10]))
  var x1223 uint32
  var x1224 uint32
  x1224, x1223 = bits.Mul32(x9, (arg1[9]))
  var x1225 uint32
  var x1226 uint32
  x1226, x1225 = bits.Mul32(x9, (arg1[8]))
  var x1227 uint32
  var x1228 uint32
  x1228, x1227 = bits.Mul32(x9, (arg1[7]))
  var x1229 uint32
  var x1230 uint32
  x1230, x1229 = bits.Mul32(x9, (arg1[6]))
  var x1231 uint32
  var x1232 uint32
  x1232, x1231 = bits.Mul32(x9, (arg1[5]))
  var x1233 uint32
  var x1234 uint32
  x1234, x1233 = bits.Mul32(x9, (arg1[4]))
  var x1235 uint32
  var x1236 uint32
  x1236, x1235 = bits.Mul32(x9, (arg1[3]))
  var x1237 uint32
  var x1238 uint32
  x1238, x1237 = bits.Mul32(x9, (arg1[2]))
  var x1239 uint32
  var x1240 uint32
  x1240, x1239 = bits.Mul32(x9, (arg1[1]))
  var x1241 uint32
  var x1242 uint32
  x1242, x1241 = bits.Mul32(x9, (arg1[0]))
  var x1243 uint32
  var x1244 fiat_p384_uint1
  x1243, x1244 = fiat_p384_addcarryx_u32(x1242, x1239, 0x0)
  var x1245 uint32
  var x1246 fiat_p384_uint1
  x1245, x1246 = fiat_p384_addcarryx_u32(x1240, x1237, x1244)
  var x1247 uint32
  var x1248 fiat_p384_uint1
  x1247, x1248 = fiat_p384_addcarryx_u32(x1238, x1235, x1246)
  var x1249 uint32
  var x1250 fiat_p384_uint1
  x1249, x1250 = fiat_p384_addcarryx_u32(x1236, x1233, x1248)
  var x1251 uint32
  var x1252 fiat_p384_uint1
  x1251, x1252 = fiat_p384_addcarryx_u32(x1234, x1231, x1250)
  var x1253 uint32
  var x1254 fiat_p384_uint1
  x1253, x1254 = fiat_p384_addcarryx_u32(x1232, x1229, x1252)
  var x1255 uint32
  var x1256 fiat_p384_uint1
  x1255, x1256 = fiat_p384_addcarryx_u32(x1230, x1227, x1254)
  var x1257 uint32
  var x1258 fiat_p384_uint1
  x1257, x1258 = fiat_p384_addcarryx_u32(x1228, x1225, x1256)
  var x1259 uint32
  var x1260 fiat_p384_uint1
  x1259, x1260 = fiat_p384_addcarryx_u32(x1226, x1223, x1258)
  var x1261 uint32
  var x1262 fiat_p384_uint1
  x1261, x1262 = fiat_p384_addcarryx_u32(x1224, x1221, x1260)
  var x1263 uint32
  var x1264 fiat_p384_uint1
  x1263, x1264 = fiat_p384_addcarryx_u32(x1222, x1219, x1262)
  var x1265 uint32 = (uint32(x1264) + x1220)
  var x1266 uint32
  var x1267 fiat_p384_uint1
  x1266, x1267 = fiat_p384_addcarryx_u32(x1194, x1241, 0x0)
  var x1268 uint32
  var x1269 fiat_p384_uint1
  x1268, x1269 = fiat_p384_addcarryx_u32(x1196, x1243, x1267)
  var x1270 uint32
  var x1271 fiat_p384_uint1
  x1270, x1271 = fiat_p384_addcarryx_u32(x1198, x1245, x1269)
  var x1272 uint32
  var x1273 fiat_p384_uint1
  x1272, x1273 = fiat_p384_addcarryx_u32(x1200, x1247, x1271)
  var x1274 uint32
  var x1275 fiat_p384_uint1
  x1274, x1275 = fiat_p384_addcarryx_u32(x1202, x1249, x1273)
  var x1276 uint32
  var x1277 fiat_p384_uint1
  x1276, x1277 = fiat_p384_addcarryx_u32(x1204, x1251, x1275)
  var x1278 uint32
  var x1279 fiat_p384_uint1
  x1278, x1279 = fiat_p384_addcarryx_u32(x1206, x1253, x1277)
  var x1280 uint32
  var x1281 fiat_p384_uint1
  x1280, x1281 = fiat_p384_addcarryx_u32(x1208, x1255, x1279)
  var x1282 uint32
  var x1283 fiat_p384_uint1
  x1282, x1283 = fiat_p384_addcarryx_u32(x1210, x1257, x1281)
  var x1284 uint32
  var x1285 fiat_p384_uint1
  x1284, x1285 = fiat_p384_addcarryx_u32(x1212, x1259, x1283)
  var x1286 uint32
  var x1287 fiat_p384_uint1
  x1286, x1287 = fiat_p384_addcarryx_u32(x1214, x1261, x1285)
  var x1288 uint32
  var x1289 fiat_p384_uint1
  x1288, x1289 = fiat_p384_addcarryx_u32(x1216, x1263, x1287)
  var x1290 uint32
  var x1291 fiat_p384_uint1
  x1290, x1291 = fiat_p384_addcarryx_u32(x1218, x1265, x1289)
  var x1292 uint32
  var x1293 uint32
  x1293, x1292 = bits.Mul32(x1266, 0xffffffff)
  var x1294 uint32
  var x1295 uint32
  x1295, x1294 = bits.Mul32(x1266, 0xffffffff)
  var x1296 uint32
  var x1297 uint32
  x1297, x1296 = bits.Mul32(x1266, 0xffffffff)
  var x1298 uint32
  var x1299 uint32
  x1299, x1298 = bits.Mul32(x1266, 0xffffffff)
  var x1300 uint32
  var x1301 uint32
  x1301, x1300 = bits.Mul32(x1266, 0xffffffff)
  var x1302 uint32
  var x1303 uint32
  x1303, x1302 = bits.Mul32(x1266, 0xffffffff)
  var x1304 uint32
  var x1305 uint32
  x1305, x1304 = bits.Mul32(x1266, 0xffffffff)
  var x1306 uint32
  var x1307 uint32
  x1307, x1306 = bits.Mul32(x1266, 0xfffffffe)
  var x1308 uint32
  var x1309 uint32
  x1309, x1308 = bits.Mul32(x1266, 0xffffffff)
  var x1310 uint32
  var x1311 uint32
  x1311, x1310 = bits.Mul32(x1266, 0xffffffff)
  var x1312 uint32
  var x1313 fiat_p384_uint1
  x1312, x1313 = fiat_p384_addcarryx_u32(x1309, x1306, 0x0)
  var x1314 uint32
  var x1315 fiat_p384_uint1
  x1314, x1315 = fiat_p384_addcarryx_u32(x1307, x1304, x1313)
  var x1316 uint32
  var x1317 fiat_p384_uint1
  x1316, x1317 = fiat_p384_addcarryx_u32(x1305, x1302, x1315)
  var x1318 uint32
  var x1319 fiat_p384_uint1
  x1318, x1319 = fiat_p384_addcarryx_u32(x1303, x1300, x1317)
  var x1320 uint32
  var x1321 fiat_p384_uint1
  x1320, x1321 = fiat_p384_addcarryx_u32(x1301, x1298, x1319)
  var x1322 uint32
  var x1323 fiat_p384_uint1
  x1322, x1323 = fiat_p384_addcarryx_u32(x1299, x1296, x1321)
  var x1324 uint32
  var x1325 fiat_p384_uint1
  x1324, x1325 = fiat_p384_addcarryx_u32(x1297, x1294, x1323)
  var x1326 uint32
  var x1327 fiat_p384_uint1
  x1326, x1327 = fiat_p384_addcarryx_u32(x1295, x1292, x1325)
  var x1328 uint32 = (uint32(x1327) + x1293)
  var x1330 fiat_p384_uint1
  _, x1330 = fiat_p384_addcarryx_u32(x1266, x1310, 0x0)
  var x1331 uint32
  var x1332 fiat_p384_uint1
  x1331, x1332 = fiat_p384_addcarryx_u32(x1268, x1311, x1330)
  var x1333 uint32
  var x1334 fiat_p384_uint1
  x1333, x1334 = fiat_p384_addcarryx_u32(x1270, uint32(0x0), x1332)
  var x1335 uint32
  var x1336 fiat_p384_uint1
  x1335, x1336 = fiat_p384_addcarryx_u32(x1272, x1308, x1334)
  var x1337 uint32
  var x1338 fiat_p384_uint1
  x1337, x1338 = fiat_p384_addcarryx_u32(x1274, x1312, x1336)
  var x1339 uint32
  var x1340 fiat_p384_uint1
  x1339, x1340 = fiat_p384_addcarryx_u32(x1276, x1314, x1338)
  var x1341 uint32
  var x1342 fiat_p384_uint1
  x1341, x1342 = fiat_p384_addcarryx_u32(x1278, x1316, x1340)
  var x1343 uint32
  var x1344 fiat_p384_uint1
  x1343, x1344 = fiat_p384_addcarryx_u32(x1280, x1318, x1342)
  var x1345 uint32
  var x1346 fiat_p384_uint1
  x1345, x1346 = fiat_p384_addcarryx_u32(x1282, x1320, x1344)
  var x1347 uint32
  var x1348 fiat_p384_uint1
  x1347, x1348 = fiat_p384_addcarryx_u32(x1284, x1322, x1346)
  var x1349 uint32
  var x1350 fiat_p384_uint1
  x1349, x1350 = fiat_p384_addcarryx_u32(x1286, x1324, x1348)
  var x1351 uint32
  var x1352 fiat_p384_uint1
  x1351, x1352 = fiat_p384_addcarryx_u32(x1288, x1326, x1350)
  var x1353 uint32
  var x1354 fiat_p384_uint1
  x1353, x1354 = fiat_p384_addcarryx_u32(x1290, x1328, x1352)
  var x1355 uint32 = (uint32(x1354) + uint32(x1291))
  var x1356 uint32
  var x1357 uint32
  x1357, x1356 = bits.Mul32(x10, (arg1[11]))
  var x1358 uint32
  var x1359 uint32
  x1359, x1358 = bits.Mul32(x10, (arg1[10]))
  var x1360 uint32
  var x1361 uint32
  x1361, x1360 = bits.Mul32(x10, (arg1[9]))
  var x1362 uint32
  var x1363 uint32
  x1363, x1362 = bits.Mul32(x10, (arg1[8]))
  var x1364 uint32
  var x1365 uint32
  x1365, x1364 = bits.Mul32(x10, (arg1[7]))
  var x1366 uint32
  var x1367 uint32
  x1367, x1366 = bits.Mul32(x10, (arg1[6]))
  var x1368 uint32
  var x1369 uint32
  x1369, x1368 = bits.Mul32(x10, (arg1[5]))
  var x1370 uint32
  var x1371 uint32
  x1371, x1370 = bits.Mul32(x10, (arg1[4]))
  var x1372 uint32
  var x1373 uint32
  x1373, x1372 = bits.Mul32(x10, (arg1[3]))
  var x1374 uint32
  var x1375 uint32
  x1375, x1374 = bits.Mul32(x10, (arg1[2]))
  var x1376 uint32
  var x1377 uint32
  x1377, x1376 = bits.Mul32(x10, (arg1[1]))
  var x1378 uint32
  var x1379 uint32
  x1379, x1378 = bits.Mul32(x10, (arg1[0]))
  var x1380 uint32
  var x1381 fiat_p384_uint1
  x1380, x1381 = fiat_p384_addcarryx_u32(x1379, x1376, 0x0)
  var x1382 uint32
  var x1383 fiat_p384_uint1
  x1382, x1383 = fiat_p384_addcarryx_u32(x1377, x1374, x1381)
  var x1384 uint32
  var x1385 fiat_p384_uint1
  x1384, x1385 = fiat_p384_addcarryx_u32(x1375, x1372, x1383)
  var x1386 uint32
  var x1387 fiat_p384_uint1
  x1386, x1387 = fiat_p384_addcarryx_u32(x1373, x1370, x1385)
  var x1388 uint32
  var x1389 fiat_p384_uint1
  x1388, x1389 = fiat_p384_addcarryx_u32(x1371, x1368, x1387)
  var x1390 uint32
  var x1391 fiat_p384_uint1
  x1390, x1391 = fiat_p384_addcarryx_u32(x1369, x1366, x1389)
  var x1392 uint32
  var x1393 fiat_p384_uint1
  x1392, x1393 = fiat_p384_addcarryx_u32(x1367, x1364, x1391)
  var x1394 uint32
  var x1395 fiat_p384_uint1
  x1394, x1395 = fiat_p384_addcarryx_u32(x1365, x1362, x1393)
  var x1396 uint32
  var x1397 fiat_p384_uint1
  x1396, x1397 = fiat_p384_addcarryx_u32(x1363, x1360, x1395)
  var x1398 uint32
  var x1399 fiat_p384_uint1
  x1398, x1399 = fiat_p384_addcarryx_u32(x1361, x1358, x1397)
  var x1400 uint32
  var x1401 fiat_p384_uint1
  x1400, x1401 = fiat_p384_addcarryx_u32(x1359, x1356, x1399)
  var x1402 uint32 = (uint32(x1401) + x1357)
  var x1403 uint32
  var x1404 fiat_p384_uint1
  x1403, x1404 = fiat_p384_addcarryx_u32(x1331, x1378, 0x0)
  var x1405 uint32
  var x1406 fiat_p384_uint1
  x1405, x1406 = fiat_p384_addcarryx_u32(x1333, x1380, x1404)
  var x1407 uint32
  var x1408 fiat_p384_uint1
  x1407, x1408 = fiat_p384_addcarryx_u32(x1335, x1382, x1406)
  var x1409 uint32
  var x1410 fiat_p384_uint1
  x1409, x1410 = fiat_p384_addcarryx_u32(x1337, x1384, x1408)
  var x1411 uint32
  var x1412 fiat_p384_uint1
  x1411, x1412 = fiat_p384_addcarryx_u32(x1339, x1386, x1410)
  var x1413 uint32
  var x1414 fiat_p384_uint1
  x1413, x1414 = fiat_p384_addcarryx_u32(x1341, x1388, x1412)
  var x1415 uint32
  var x1416 fiat_p384_uint1
  x1415, x1416 = fiat_p384_addcarryx_u32(x1343, x1390, x1414)
  var x1417 uint32
  var x1418 fiat_p384_uint1
  x1417, x1418 = fiat_p384_addcarryx_u32(x1345, x1392, x1416)
  var x1419 uint32
  var x1420 fiat_p384_uint1
  x1419, x1420 = fiat_p384_addcarryx_u32(x1347, x1394, x1418)
  var x1421 uint32
  var x1422 fiat_p384_uint1
  x1421, x1422 = fiat_p384_addcarryx_u32(x1349, x1396, x1420)
  var x1423 uint32
  var x1424 fiat_p384_uint1
  x1423, x1424 = fiat_p384_addcarryx_u32(x1351, x1398, x1422)
  var x1425 uint32
  var x1426 fiat_p384_uint1
  x1425, x1426 = fiat_p384_addcarryx_u32(x1353, x1400, x1424)
  var x1427 uint32
  var x1428 fiat_p384_uint1
  x1427, x1428 = fiat_p384_addcarryx_u32(x1355, x1402, x1426)
  var x1429 uint32
  var x1430 uint32
  x1430, x1429 = bits.Mul32(x1403, 0xffffffff)
  var x1431 uint32
  var x1432 uint32
  x1432, x1431 = bits.Mul32(x1403, 0xffffffff)
  var x1433 uint32
  var x1434 uint32
  x1434, x1433 = bits.Mul32(x1403, 0xffffffff)
  var x1435 uint32
  var x1436 uint32
  x1436, x1435 = bits.Mul32(x1403, 0xffffffff)
  var x1437 uint32
  var x1438 uint32
  x1438, x1437 = bits.Mul32(x1403, 0xffffffff)
  var x1439 uint32
  var x1440 uint32
  x1440, x1439 = bits.Mul32(x1403, 0xffffffff)
  var x1441 uint32
  var x1442 uint32
  x1442, x1441 = bits.Mul32(x1403, 0xffffffff)
  var x1443 uint32
  var x1444 uint32
  x1444, x1443 = bits.Mul32(x1403, 0xfffffffe)
  var x1445 uint32
  var x1446 uint32
  x1446, x1445 = bits.Mul32(x1403, 0xffffffff)
  var x1447 uint32
  var x1448 uint32
  x1448, x1447 = bits.Mul32(x1403, 0xffffffff)
  var x1449 uint32
  var x1450 fiat_p384_uint1
  x1449, x1450 = fiat_p384_addcarryx_u32(x1446, x1443, 0x0)
  var x1451 uint32
  var x1452 fiat_p384_uint1
  x1451, x1452 = fiat_p384_addcarryx_u32(x1444, x1441, x1450)
  var x1453 uint32
  var x1454 fiat_p384_uint1
  x1453, x1454 = fiat_p384_addcarryx_u32(x1442, x1439, x1452)
  var x1455 uint32
  var x1456 fiat_p384_uint1
  x1455, x1456 = fiat_p384_addcarryx_u32(x1440, x1437, x1454)
  var x1457 uint32
  var x1458 fiat_p384_uint1
  x1457, x1458 = fiat_p384_addcarryx_u32(x1438, x1435, x1456)
  var x1459 uint32
  var x1460 fiat_p384_uint1
  x1459, x1460 = fiat_p384_addcarryx_u32(x1436, x1433, x1458)
  var x1461 uint32
  var x1462 fiat_p384_uint1
  x1461, x1462 = fiat_p384_addcarryx_u32(x1434, x1431, x1460)
  var x1463 uint32
  var x1464 fiat_p384_uint1
  x1463, x1464 = fiat_p384_addcarryx_u32(x1432, x1429, x1462)
  var x1465 uint32 = (uint32(x1464) + x1430)
  var x1467 fiat_p384_uint1
  _, x1467 = fiat_p384_addcarryx_u32(x1403, x1447, 0x0)
  var x1468 uint32
  var x1469 fiat_p384_uint1
  x1468, x1469 = fiat_p384_addcarryx_u32(x1405, x1448, x1467)
  var x1470 uint32
  var x1471 fiat_p384_uint1
  x1470, x1471 = fiat_p384_addcarryx_u32(x1407, uint32(0x0), x1469)
  var x1472 uint32
  var x1473 fiat_p384_uint1
  x1472, x1473 = fiat_p384_addcarryx_u32(x1409, x1445, x1471)
  var x1474 uint32
  var x1475 fiat_p384_uint1
  x1474, x1475 = fiat_p384_addcarryx_u32(x1411, x1449, x1473)
  var x1476 uint32
  var x1477 fiat_p384_uint1
  x1476, x1477 = fiat_p384_addcarryx_u32(x1413, x1451, x1475)
  var x1478 uint32
  var x1479 fiat_p384_uint1
  x1478, x1479 = fiat_p384_addcarryx_u32(x1415, x1453, x1477)
  var x1480 uint32
  var x1481 fiat_p384_uint1
  x1480, x1481 = fiat_p384_addcarryx_u32(x1417, x1455, x1479)
  var x1482 uint32
  var x1483 fiat_p384_uint1
  x1482, x1483 = fiat_p384_addcarryx_u32(x1419, x1457, x1481)
  var x1484 uint32
  var x1485 fiat_p384_uint1
  x1484, x1485 = fiat_p384_addcarryx_u32(x1421, x1459, x1483)
  var x1486 uint32
  var x1487 fiat_p384_uint1
  x1486, x1487 = fiat_p384_addcarryx_u32(x1423, x1461, x1485)
  var x1488 uint32
  var x1489 fiat_p384_uint1
  x1488, x1489 = fiat_p384_addcarryx_u32(x1425, x1463, x1487)
  var x1490 uint32
  var x1491 fiat_p384_uint1
  x1490, x1491 = fiat_p384_addcarryx_u32(x1427, x1465, x1489)
  var x1492 uint32 = (uint32(x1491) + uint32(x1428))
  var x1493 uint32
  var x1494 uint32
  x1494, x1493 = bits.Mul32(x11, (arg1[11]))
  var x1495 uint32
  var x1496 uint32
  x1496, x1495 = bits.Mul32(x11, (arg1[10]))
  var x1497 uint32
  var x1498 uint32
  x1498, x1497 = bits.Mul32(x11, (arg1[9]))
  var x1499 uint32
  var x1500 uint32
  x1500, x1499 = bits.Mul32(x11, (arg1[8]))
  var x1501 uint32
  var x1502 uint32
  x1502, x1501 = bits.Mul32(x11, (arg1[7]))
  var x1503 uint32
  var x1504 uint32
  x1504, x1503 = bits.Mul32(x11, (arg1[6]))
  var x1505 uint32
  var x1506 uint32
  x1506, x1505 = bits.Mul32(x11, (arg1[5]))
  var x1507 uint32
  var x1508 uint32
  x1508, x1507 = bits.Mul32(x11, (arg1[4]))
  var x1509 uint32
  var x1510 uint32
  x1510, x1509 = bits.Mul32(x11, (arg1[3]))
  var x1511 uint32
  var x1512 uint32
  x1512, x1511 = bits.Mul32(x11, (arg1[2]))
  var x1513 uint32
  var x1514 uint32
  x1514, x1513 = bits.Mul32(x11, (arg1[1]))
  var x1515 uint32
  var x1516 uint32
  x1516, x1515 = bits.Mul32(x11, (arg1[0]))
  var x1517 uint32
  var x1518 fiat_p384_uint1
  x1517, x1518 = fiat_p384_addcarryx_u32(x1516, x1513, 0x0)
  var x1519 uint32
  var x1520 fiat_p384_uint1
  x1519, x1520 = fiat_p384_addcarryx_u32(x1514, x1511, x1518)
  var x1521 uint32
  var x1522 fiat_p384_uint1
  x1521, x1522 = fiat_p384_addcarryx_u32(x1512, x1509, x1520)
  var x1523 uint32
  var x1524 fiat_p384_uint1
  x1523, x1524 = fiat_p384_addcarryx_u32(x1510, x1507, x1522)
  var x1525 uint32
  var x1526 fiat_p384_uint1
  x1525, x1526 = fiat_p384_addcarryx_u32(x1508, x1505, x1524)
  var x1527 uint32
  var x1528 fiat_p384_uint1
  x1527, x1528 = fiat_p384_addcarryx_u32(x1506, x1503, x1526)
  var x1529 uint32
  var x1530 fiat_p384_uint1
  x1529, x1530 = fiat_p384_addcarryx_u32(x1504, x1501, x1528)
  var x1531 uint32
  var x1532 fiat_p384_uint1
  x1531, x1532 = fiat_p384_addcarryx_u32(x1502, x1499, x1530)
  var x1533 uint32
  var x1534 fiat_p384_uint1
  x1533, x1534 = fiat_p384_addcarryx_u32(x1500, x1497, x1532)
  var x1535 uint32
  var x1536 fiat_p384_uint1
  x1535, x1536 = fiat_p384_addcarryx_u32(x1498, x1495, x1534)
  var x1537 uint32
  var x1538 fiat_p384_uint1
  x1537, x1538 = fiat_p384_addcarryx_u32(x1496, x1493, x1536)
  var x1539 uint32 = (uint32(x1538) + x1494)
  var x1540 uint32
  var x1541 fiat_p384_uint1
  x1540, x1541 = fiat_p384_addcarryx_u32(x1468, x1515, 0x0)
  var x1542 uint32
  var x1543 fiat_p384_uint1
  x1542, x1543 = fiat_p384_addcarryx_u32(x1470, x1517, x1541)
  var x1544 uint32
  var x1545 fiat_p384_uint1
  x1544, x1545 = fiat_p384_addcarryx_u32(x1472, x1519, x1543)
  var x1546 uint32
  var x1547 fiat_p384_uint1
  x1546, x1547 = fiat_p384_addcarryx_u32(x1474, x1521, x1545)
  var x1548 uint32
  var x1549 fiat_p384_uint1
  x1548, x1549 = fiat_p384_addcarryx_u32(x1476, x1523, x1547)
  var x1550 uint32
  var x1551 fiat_p384_uint1
  x1550, x1551 = fiat_p384_addcarryx_u32(x1478, x1525, x1549)
  var x1552 uint32
  var x1553 fiat_p384_uint1
  x1552, x1553 = fiat_p384_addcarryx_u32(x1480, x1527, x1551)
  var x1554 uint32
  var x1555 fiat_p384_uint1
  x1554, x1555 = fiat_p384_addcarryx_u32(x1482, x1529, x1553)
  var x1556 uint32
  var x1557 fiat_p384_uint1
  x1556, x1557 = fiat_p384_addcarryx_u32(x1484, x1531, x1555)
  var x1558 uint32
  var x1559 fiat_p384_uint1
  x1558, x1559 = fiat_p384_addcarryx_u32(x1486, x1533, x1557)
  var x1560 uint32
  var x1561 fiat_p384_uint1
  x1560, x1561 = fiat_p384_addcarryx_u32(x1488, x1535, x1559)
  var x1562 uint32
  var x1563 fiat_p384_uint1
  x1562, x1563 = fiat_p384_addcarryx_u32(x1490, x1537, x1561)
  var x1564 uint32
  var x1565 fiat_p384_uint1
  x1564, x1565 = fiat_p384_addcarryx_u32(x1492, x1539, x1563)
  var x1566 uint32
  var x1567 uint32
  x1567, x1566 = bits.Mul32(x1540, 0xffffffff)
  var x1568 uint32
  var x1569 uint32
  x1569, x1568 = bits.Mul32(x1540, 0xffffffff)
  var x1570 uint32
  var x1571 uint32
  x1571, x1570 = bits.Mul32(x1540, 0xffffffff)
  var x1572 uint32
  var x1573 uint32
  x1573, x1572 = bits.Mul32(x1540, 0xffffffff)
  var x1574 uint32
  var x1575 uint32
  x1575, x1574 = bits.Mul32(x1540, 0xffffffff)
  var x1576 uint32
  var x1577 uint32
  x1577, x1576 = bits.Mul32(x1540, 0xffffffff)
  var x1578 uint32
  var x1579 uint32
  x1579, x1578 = bits.Mul32(x1540, 0xffffffff)
  var x1580 uint32
  var x1581 uint32
  x1581, x1580 = bits.Mul32(x1540, 0xfffffffe)
  var x1582 uint32
  var x1583 uint32
  x1583, x1582 = bits.Mul32(x1540, 0xffffffff)
  var x1584 uint32
  var x1585 uint32
  x1585, x1584 = bits.Mul32(x1540, 0xffffffff)
  var x1586 uint32
  var x1587 fiat_p384_uint1
  x1586, x1587 = fiat_p384_addcarryx_u32(x1583, x1580, 0x0)
  var x1588 uint32
  var x1589 fiat_p384_uint1
  x1588, x1589 = fiat_p384_addcarryx_u32(x1581, x1578, x1587)
  var x1590 uint32
  var x1591 fiat_p384_uint1
  x1590, x1591 = fiat_p384_addcarryx_u32(x1579, x1576, x1589)
  var x1592 uint32
  var x1593 fiat_p384_uint1
  x1592, x1593 = fiat_p384_addcarryx_u32(x1577, x1574, x1591)
  var x1594 uint32
  var x1595 fiat_p384_uint1
  x1594, x1595 = fiat_p384_addcarryx_u32(x1575, x1572, x1593)
  var x1596 uint32
  var x1597 fiat_p384_uint1
  x1596, x1597 = fiat_p384_addcarryx_u32(x1573, x1570, x1595)
  var x1598 uint32
  var x1599 fiat_p384_uint1
  x1598, x1599 = fiat_p384_addcarryx_u32(x1571, x1568, x1597)
  var x1600 uint32
  var x1601 fiat_p384_uint1
  x1600, x1601 = fiat_p384_addcarryx_u32(x1569, x1566, x1599)
  var x1602 uint32 = (uint32(x1601) + x1567)
  var x1604 fiat_p384_uint1
  _, x1604 = fiat_p384_addcarryx_u32(x1540, x1584, 0x0)
  var x1605 uint32
  var x1606 fiat_p384_uint1
  x1605, x1606 = fiat_p384_addcarryx_u32(x1542, x1585, x1604)
  var x1607 uint32
  var x1608 fiat_p384_uint1
  x1607, x1608 = fiat_p384_addcarryx_u32(x1544, uint32(0x0), x1606)
  var x1609 uint32
  var x1610 fiat_p384_uint1
  x1609, x1610 = fiat_p384_addcarryx_u32(x1546, x1582, x1608)
  var x1611 uint32
  var x1612 fiat_p384_uint1
  x1611, x1612 = fiat_p384_addcarryx_u32(x1548, x1586, x1610)
  var x1613 uint32
  var x1614 fiat_p384_uint1
  x1613, x1614 = fiat_p384_addcarryx_u32(x1550, x1588, x1612)
  var x1615 uint32
  var x1616 fiat_p384_uint1
  x1615, x1616 = fiat_p384_addcarryx_u32(x1552, x1590, x1614)
  var x1617 uint32
  var x1618 fiat_p384_uint1
  x1617, x1618 = fiat_p384_addcarryx_u32(x1554, x1592, x1616)
  var x1619 uint32
  var x1620 fiat_p384_uint1
  x1619, x1620 = fiat_p384_addcarryx_u32(x1556, x1594, x1618)
  var x1621 uint32
  var x1622 fiat_p384_uint1
  x1621, x1622 = fiat_p384_addcarryx_u32(x1558, x1596, x1620)
  var x1623 uint32
  var x1624 fiat_p384_uint1
  x1623, x1624 = fiat_p384_addcarryx_u32(x1560, x1598, x1622)
  var x1625 uint32
  var x1626 fiat_p384_uint1
  x1625, x1626 = fiat_p384_addcarryx_u32(x1562, x1600, x1624)
  var x1627 uint32
  var x1628 fiat_p384_uint1
  x1627, x1628 = fiat_p384_addcarryx_u32(x1564, x1602, x1626)
  var x1629 uint32 = (uint32(x1628) + uint32(x1565))
  var x1630 uint32
  var x1631 fiat_p384_uint1
  x1630, x1631 = fiat_p384_subborrowx_u32(x1605, 0xffffffff, 0x0)
  var x1632 uint32
  var x1633 fiat_p384_uint1
  x1632, x1633 = fiat_p384_subborrowx_u32(x1607, uint32(0x0), x1631)
  var x1634 uint32
  var x1635 fiat_p384_uint1
  x1634, x1635 = fiat_p384_subborrowx_u32(x1609, uint32(0x0), x1633)
  var x1636 uint32
  var x1637 fiat_p384_uint1
  x1636, x1637 = fiat_p384_subborrowx_u32(x1611, 0xffffffff, x1635)
  var x1638 uint32
  var x1639 fiat_p384_uint1
  x1638, x1639 = fiat_p384_subborrowx_u32(x1613, 0xfffffffe, x1637)
  var x1640 uint32
  var x1641 fiat_p384_uint1
  x1640, x1641 = fiat_p384_subborrowx_u32(x1615, 0xffffffff, x1639)
  var x1642 uint32
  var x1643 fiat_p384_uint1
  x1642, x1643 = fiat_p384_subborrowx_u32(x1617, 0xffffffff, x1641)
  var x1644 uint32
  var x1645 fiat_p384_uint1
  x1644, x1645 = fiat_p384_subborrowx_u32(x1619, 0xffffffff, x1643)
  var x1646 uint32
  var x1647 fiat_p384_uint1
  x1646, x1647 = fiat_p384_subborrowx_u32(x1621, 0xffffffff, x1645)
  var x1648 uint32
  var x1649 fiat_p384_uint1
  x1648, x1649 = fiat_p384_subborrowx_u32(x1623, 0xffffffff, x1647)
  var x1650 uint32
  var x1651 fiat_p384_uint1
  x1650, x1651 = fiat_p384_subborrowx_u32(x1625, 0xffffffff, x1649)
  var x1652 uint32
  var x1653 fiat_p384_uint1
  x1652, x1653 = fiat_p384_subborrowx_u32(x1627, 0xffffffff, x1651)
  var x1655 fiat_p384_uint1
  _, x1655 = fiat_p384_subborrowx_u32(x1629, uint32(0x0), x1653)
  var x1656 uint32
  fiat_p384_cmovznz_u32(&x1656, x1655, x1630, x1605)
  var x1657 uint32
  fiat_p384_cmovznz_u32(&x1657, x1655, x1632, x1607)
  var x1658 uint32
  fiat_p384_cmovznz_u32(&x1658, x1655, x1634, x1609)
  var x1659 uint32
  fiat_p384_cmovznz_u32(&x1659, x1655, x1636, x1611)
  var x1660 uint32
  fiat_p384_cmovznz_u32(&x1660, x1655, x1638, x1613)
  var x1661 uint32
  fiat_p384_cmovznz_u32(&x1661, x1655, x1640, x1615)
  var x1662 uint32
  fiat_p384_cmovznz_u32(&x1662, x1655, x1642, x1617)
  var x1663 uint32
  fiat_p384_cmovznz_u32(&x1663, x1655, x1644, x1619)
  var x1664 uint32
  fiat_p384_cmovznz_u32(&x1664, x1655, x1646, x1621)
  var x1665 uint32
  fiat_p384_cmovznz_u32(&x1665, x1655, x1648, x1623)
  var x1666 uint32
  fiat_p384_cmovznz_u32(&x1666, x1655, x1650, x1625)
  var x1667 uint32
  fiat_p384_cmovznz_u32(&x1667, x1655, x1652, x1627)
  out1[0] = x1656
  out1[1] = x1657
  out1[2] = x1658
  out1[3] = x1659
  out1[4] = x1660
  out1[5] = x1661
  out1[6] = x1662
  out1[7] = x1663
  out1[8] = x1664
  out1[9] = x1665
  out1[10] = x1666
  out1[11] = x1667
}

/*
 * The function fiat_p384_add adds two field elements in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) + eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   arg2: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
/*inline*/
func fiat_p384_add(out1 *[12]uint32, arg1 *[12]uint32, arg2 *[12]uint32) {
  var x1 uint32
  var x2 fiat_p384_uint1
  x1, x2 = fiat_p384_addcarryx_u32((arg1[0]), (arg2[0]), 0x0)
  var x3 uint32
  var x4 fiat_p384_uint1
  x3, x4 = fiat_p384_addcarryx_u32((arg1[1]), (arg2[1]), x2)
  var x5 uint32
  var x6 fiat_p384_uint1
  x5, x6 = fiat_p384_addcarryx_u32((arg1[2]), (arg2[2]), x4)
  var x7 uint32
  var x8 fiat_p384_uint1
  x7, x8 = fiat_p384_addcarryx_u32((arg1[3]), (arg2[3]), x6)
  var x9 uint32
  var x10 fiat_p384_uint1
  x9, x10 = fiat_p384_addcarryx_u32((arg1[4]), (arg2[4]), x8)
  var x11 uint32
  var x12 fiat_p384_uint1
  x11, x12 = fiat_p384_addcarryx_u32((arg1[5]), (arg2[5]), x10)
  var x13 uint32
  var x14 fiat_p384_uint1
  x13, x14 = fiat_p384_addcarryx_u32((arg1[6]), (arg2[6]), x12)
  var x15 uint32
  var x16 fiat_p384_uint1
  x15, x16 = fiat_p384_addcarryx_u32((arg1[7]), (arg2[7]), x14)
  var x17 uint32
  var x18 fiat_p384_uint1
  x17, x18 = fiat_p384_addcarryx_u32((arg1[8]), (arg2[8]), x16)
  var x19 uint32
  var x20 fiat_p384_uint1
  x19, x20 = fiat_p384_addcarryx_u32((arg1[9]), (arg2[9]), x18)
  var x21 uint32
  var x22 fiat_p384_uint1
  x21, x22 = fiat_p384_addcarryx_u32((arg1[10]), (arg2[10]), x20)
  var x23 uint32
  var x24 fiat_p384_uint1
  x23, x24 = fiat_p384_addcarryx_u32((arg1[11]), (arg2[11]), x22)
  var x25 uint32
  var x26 fiat_p384_uint1
  x25, x26 = fiat_p384_subborrowx_u32(x1, 0xffffffff, 0x0)
  var x27 uint32
  var x28 fiat_p384_uint1
  x27, x28 = fiat_p384_subborrowx_u32(x3, uint32(0x0), x26)
  var x29 uint32
  var x30 fiat_p384_uint1
  x29, x30 = fiat_p384_subborrowx_u32(x5, uint32(0x0), x28)
  var x31 uint32
  var x32 fiat_p384_uint1
  x31, x32 = fiat_p384_subborrowx_u32(x7, 0xffffffff, x30)
  var x33 uint32
  var x34 fiat_p384_uint1
  x33, x34 = fiat_p384_subborrowx_u32(x9, 0xfffffffe, x32)
  var x35 uint32
  var x36 fiat_p384_uint1
  x35, x36 = fiat_p384_subborrowx_u32(x11, 0xffffffff, x34)
  var x37 uint32
  var x38 fiat_p384_uint1
  x37, x38 = fiat_p384_subborrowx_u32(x13, 0xffffffff, x36)
  var x39 uint32
  var x40 fiat_p384_uint1
  x39, x40 = fiat_p384_subborrowx_u32(x15, 0xffffffff, x38)
  var x41 uint32
  var x42 fiat_p384_uint1
  x41, x42 = fiat_p384_subborrowx_u32(x17, 0xffffffff, x40)
  var x43 uint32
  var x44 fiat_p384_uint1
  x43, x44 = fiat_p384_subborrowx_u32(x19, 0xffffffff, x42)
  var x45 uint32
  var x46 fiat_p384_uint1
  x45, x46 = fiat_p384_subborrowx_u32(x21, 0xffffffff, x44)
  var x47 uint32
  var x48 fiat_p384_uint1
  x47, x48 = fiat_p384_subborrowx_u32(x23, 0xffffffff, x46)
  var x50 fiat_p384_uint1
  _, x50 = fiat_p384_subborrowx_u32(uint32(x24), uint32(0x0), x48)
  var x51 uint32
  fiat_p384_cmovznz_u32(&x51, x50, x25, x1)
  var x52 uint32
  fiat_p384_cmovznz_u32(&x52, x50, x27, x3)
  var x53 uint32
  fiat_p384_cmovznz_u32(&x53, x50, x29, x5)
  var x54 uint32
  fiat_p384_cmovznz_u32(&x54, x50, x31, x7)
  var x55 uint32
  fiat_p384_cmovznz_u32(&x55, x50, x33, x9)
  var x56 uint32
  fiat_p384_cmovznz_u32(&x56, x50, x35, x11)
  var x57 uint32
  fiat_p384_cmovznz_u32(&x57, x50, x37, x13)
  var x58 uint32
  fiat_p384_cmovznz_u32(&x58, x50, x39, x15)
  var x59 uint32
  fiat_p384_cmovznz_u32(&x59, x50, x41, x17)
  var x60 uint32
  fiat_p384_cmovznz_u32(&x60, x50, x43, x19)
  var x61 uint32
  fiat_p384_cmovznz_u32(&x61, x50, x45, x21)
  var x62 uint32
  fiat_p384_cmovznz_u32(&x62, x50, x47, x23)
  out1[0] = x51
  out1[1] = x52
  out1[2] = x53
  out1[3] = x54
  out1[4] = x55
  out1[5] = x56
  out1[6] = x57
  out1[7] = x58
  out1[8] = x59
  out1[9] = x60
  out1[10] = x61
  out1[11] = x62
}

/*
 * The function fiat_p384_sub subtracts two field elements in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) - eval (from_montgomery arg2)) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   arg2: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
/*inline*/
func fiat_p384_sub(out1 *[12]uint32, arg1 *[12]uint32, arg2 *[12]uint32) {
  var x1 uint32
  var x2 fiat_p384_uint1
  x1, x2 = fiat_p384_subborrowx_u32((arg1[0]), (arg2[0]), 0x0)
  var x3 uint32
  var x4 fiat_p384_uint1
  x3, x4 = fiat_p384_subborrowx_u32((arg1[1]), (arg2[1]), x2)
  var x5 uint32
  var x6 fiat_p384_uint1
  x5, x6 = fiat_p384_subborrowx_u32((arg1[2]), (arg2[2]), x4)
  var x7 uint32
  var x8 fiat_p384_uint1
  x7, x8 = fiat_p384_subborrowx_u32((arg1[3]), (arg2[3]), x6)
  var x9 uint32
  var x10 fiat_p384_uint1
  x9, x10 = fiat_p384_subborrowx_u32((arg1[4]), (arg2[4]), x8)
  var x11 uint32
  var x12 fiat_p384_uint1
  x11, x12 = fiat_p384_subborrowx_u32((arg1[5]), (arg2[5]), x10)
  var x13 uint32
  var x14 fiat_p384_uint1
  x13, x14 = fiat_p384_subborrowx_u32((arg1[6]), (arg2[6]), x12)
  var x15 uint32
  var x16 fiat_p384_uint1
  x15, x16 = fiat_p384_subborrowx_u32((arg1[7]), (arg2[7]), x14)
  var x17 uint32
  var x18 fiat_p384_uint1
  x17, x18 = fiat_p384_subborrowx_u32((arg1[8]), (arg2[8]), x16)
  var x19 uint32
  var x20 fiat_p384_uint1
  x19, x20 = fiat_p384_subborrowx_u32((arg1[9]), (arg2[9]), x18)
  var x21 uint32
  var x22 fiat_p384_uint1
  x21, x22 = fiat_p384_subborrowx_u32((arg1[10]), (arg2[10]), x20)
  var x23 uint32
  var x24 fiat_p384_uint1
  x23, x24 = fiat_p384_subborrowx_u32((arg1[11]), (arg2[11]), x22)
  var x25 uint32
  fiat_p384_cmovznz_u32(&x25, x24, uint32(0x0), 0xffffffff)
  var x26 uint32
  var x27 fiat_p384_uint1
  x26, x27 = fiat_p384_addcarryx_u32(x1, x25, 0x0)
  var x28 uint32
  var x29 fiat_p384_uint1
  x28, x29 = fiat_p384_addcarryx_u32(x3, uint32(0x0), x27)
  var x30 uint32
  var x31 fiat_p384_uint1
  x30, x31 = fiat_p384_addcarryx_u32(x5, uint32(0x0), x29)
  var x32 uint32
  var x33 fiat_p384_uint1
  x32, x33 = fiat_p384_addcarryx_u32(x7, x25, x31)
  var x34 uint32
  var x35 fiat_p384_uint1
  x34, x35 = fiat_p384_addcarryx_u32(x9, (x25 & 0xfffffffe), x33)
  var x36 uint32
  var x37 fiat_p384_uint1
  x36, x37 = fiat_p384_addcarryx_u32(x11, x25, x35)
  var x38 uint32
  var x39 fiat_p384_uint1
  x38, x39 = fiat_p384_addcarryx_u32(x13, x25, x37)
  var x40 uint32
  var x41 fiat_p384_uint1
  x40, x41 = fiat_p384_addcarryx_u32(x15, x25, x39)
  var x42 uint32
  var x43 fiat_p384_uint1
  x42, x43 = fiat_p384_addcarryx_u32(x17, x25, x41)
  var x44 uint32
  var x45 fiat_p384_uint1
  x44, x45 = fiat_p384_addcarryx_u32(x19, x25, x43)
  var x46 uint32
  var x47 fiat_p384_uint1
  x46, x47 = fiat_p384_addcarryx_u32(x21, x25, x45)
  var x48 uint32
  x48, _ = fiat_p384_addcarryx_u32(x23, x25, x47)
  out1[0] = x26
  out1[1] = x28
  out1[2] = x30
  out1[3] = x32
  out1[4] = x34
  out1[5] = x36
  out1[6] = x38
  out1[7] = x40
  out1[8] = x42
  out1[9] = x44
  out1[10] = x46
  out1[11] = x48
}

/*
 * The function fiat_p384_opp negates a field element in the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = -eval (from_montgomery arg1) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
/*inline*/
func fiat_p384_opp(out1 *[12]uint32, arg1 *[12]uint32) {
  var x1 uint32
  var x2 fiat_p384_uint1
  x1, x2 = fiat_p384_subborrowx_u32(uint32(0x0), (arg1[0]), 0x0)
  var x3 uint32
  var x4 fiat_p384_uint1
  x3, x4 = fiat_p384_subborrowx_u32(uint32(0x0), (arg1[1]), x2)
  var x5 uint32
  var x6 fiat_p384_uint1
  x5, x6 = fiat_p384_subborrowx_u32(uint32(0x0), (arg1[2]), x4)
  var x7 uint32
  var x8 fiat_p384_uint1
  x7, x8 = fiat_p384_subborrowx_u32(uint32(0x0), (arg1[3]), x6)
  var x9 uint32
  var x10 fiat_p384_uint1
  x9, x10 = fiat_p384_subborrowx_u32(uint32(0x0), (arg1[4]), x8)
  var x11 uint32
  var x12 fiat_p384_uint1
  x11, x12 = fiat_p384_subborrowx_u32(uint32(0x0), (arg1[5]), x10)
  var x13 uint32
  var x14 fiat_p384_uint1
  x13, x14 = fiat_p384_subborrowx_u32(uint32(0x0), (arg1[6]), x12)
  var x15 uint32
  var x16 fiat_p384_uint1
  x15, x16 = fiat_p384_subborrowx_u32(uint32(0x0), (arg1[7]), x14)
  var x17 uint32
  var x18 fiat_p384_uint1
  x17, x18 = fiat_p384_subborrowx_u32(uint32(0x0), (arg1[8]), x16)
  var x19 uint32
  var x20 fiat_p384_uint1
  x19, x20 = fiat_p384_subborrowx_u32(uint32(0x0), (arg1[9]), x18)
  var x21 uint32
  var x22 fiat_p384_uint1
  x21, x22 = fiat_p384_subborrowx_u32(uint32(0x0), (arg1[10]), x20)
  var x23 uint32
  var x24 fiat_p384_uint1
  x23, x24 = fiat_p384_subborrowx_u32(uint32(0x0), (arg1[11]), x22)
  var x25 uint32
  fiat_p384_cmovznz_u32(&x25, x24, uint32(0x0), 0xffffffff)
  var x26 uint32
  var x27 fiat_p384_uint1
  x26, x27 = fiat_p384_addcarryx_u32(x1, x25, 0x0)
  var x28 uint32
  var x29 fiat_p384_uint1
  x28, x29 = fiat_p384_addcarryx_u32(x3, uint32(0x0), x27)
  var x30 uint32
  var x31 fiat_p384_uint1
  x30, x31 = fiat_p384_addcarryx_u32(x5, uint32(0x0), x29)
  var x32 uint32
  var x33 fiat_p384_uint1
  x32, x33 = fiat_p384_addcarryx_u32(x7, x25, x31)
  var x34 uint32
  var x35 fiat_p384_uint1
  x34, x35 = fiat_p384_addcarryx_u32(x9, (x25 & 0xfffffffe), x33)
  var x36 uint32
  var x37 fiat_p384_uint1
  x36, x37 = fiat_p384_addcarryx_u32(x11, x25, x35)
  var x38 uint32
  var x39 fiat_p384_uint1
  x38, x39 = fiat_p384_addcarryx_u32(x13, x25, x37)
  var x40 uint32
  var x41 fiat_p384_uint1
  x40, x41 = fiat_p384_addcarryx_u32(x15, x25, x39)
  var x42 uint32
  var x43 fiat_p384_uint1
  x42, x43 = fiat_p384_addcarryx_u32(x17, x25, x41)
  var x44 uint32
  var x45 fiat_p384_uint1
  x44, x45 = fiat_p384_addcarryx_u32(x19, x25, x43)
  var x46 uint32
  var x47 fiat_p384_uint1
  x46, x47 = fiat_p384_addcarryx_u32(x21, x25, x45)
  var x48 uint32
  x48, _ = fiat_p384_addcarryx_u32(x23, x25, x47)
  out1[0] = x26
  out1[1] = x28
  out1[2] = x30
  out1[3] = x32
  out1[4] = x34
  out1[5] = x36
  out1[6] = x38
  out1[7] = x40
  out1[8] = x42
  out1[9] = x44
  out1[10] = x46
  out1[11] = x48
}

/*
 * The function fiat_p384_from_montgomery translates a field element out of the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval out1 mod m = (eval arg1 * ((2^32)⁻¹ mod m)^12) mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
/*inline*/
func fiat_p384_from_montgomery(out1 *[12]uint32, arg1 *[12]uint32) {
  var x1 uint32 = (arg1[0])
  var x2 uint32
  var x3 uint32
  x3, x2 = bits.Mul32(x1, 0xffffffff)
  var x4 uint32
  var x5 uint32
  x5, x4 = bits.Mul32(x1, 0xffffffff)
  var x6 uint32
  var x7 uint32
  x7, x6 = bits.Mul32(x1, 0xffffffff)
  var x8 uint32
  var x9 uint32
  x9, x8 = bits.Mul32(x1, 0xffffffff)
  var x10 uint32
  var x11 uint32
  x11, x10 = bits.Mul32(x1, 0xffffffff)
  var x12 uint32
  var x13 uint32
  x13, x12 = bits.Mul32(x1, 0xffffffff)
  var x14 uint32
  var x15 uint32
  x15, x14 = bits.Mul32(x1, 0xffffffff)
  var x16 uint32
  var x17 uint32
  x17, x16 = bits.Mul32(x1, 0xfffffffe)
  var x18 uint32
  var x19 uint32
  x19, x18 = bits.Mul32(x1, 0xffffffff)
  var x20 uint32
  var x21 uint32
  x21, x20 = bits.Mul32(x1, 0xffffffff)
  var x22 uint32
  var x23 fiat_p384_uint1
  x22, x23 = fiat_p384_addcarryx_u32(x19, x16, 0x0)
  var x24 uint32
  var x25 fiat_p384_uint1
  x24, x25 = fiat_p384_addcarryx_u32(x17, x14, x23)
  var x26 uint32
  var x27 fiat_p384_uint1
  x26, x27 = fiat_p384_addcarryx_u32(x15, x12, x25)
  var x28 uint32
  var x29 fiat_p384_uint1
  x28, x29 = fiat_p384_addcarryx_u32(x13, x10, x27)
  var x30 uint32
  var x31 fiat_p384_uint1
  x30, x31 = fiat_p384_addcarryx_u32(x11, x8, x29)
  var x32 uint32
  var x33 fiat_p384_uint1
  x32, x33 = fiat_p384_addcarryx_u32(x9, x6, x31)
  var x34 uint32
  var x35 fiat_p384_uint1
  x34, x35 = fiat_p384_addcarryx_u32(x7, x4, x33)
  var x36 uint32
  var x37 fiat_p384_uint1
  x36, x37 = fiat_p384_addcarryx_u32(x5, x2, x35)
  var x39 fiat_p384_uint1
  _, x39 = fiat_p384_addcarryx_u32(x1, x20, 0x0)
  var x40 uint32
  var x41 fiat_p384_uint1
  x40, x41 = fiat_p384_addcarryx_u32((uint32(x39) + x21), (arg1[1]), 0x0)
  var x42 uint32
  var x43 uint32
  x43, x42 = bits.Mul32(x40, 0xffffffff)
  var x44 uint32
  var x45 uint32
  x45, x44 = bits.Mul32(x40, 0xffffffff)
  var x46 uint32
  var x47 uint32
  x47, x46 = bits.Mul32(x40, 0xffffffff)
  var x48 uint32
  var x49 uint32
  x49, x48 = bits.Mul32(x40, 0xffffffff)
  var x50 uint32
  var x51 uint32
  x51, x50 = bits.Mul32(x40, 0xffffffff)
  var x52 uint32
  var x53 uint32
  x53, x52 = bits.Mul32(x40, 0xffffffff)
  var x54 uint32
  var x55 uint32
  x55, x54 = bits.Mul32(x40, 0xffffffff)
  var x56 uint32
  var x57 uint32
  x57, x56 = bits.Mul32(x40, 0xfffffffe)
  var x58 uint32
  var x59 uint32
  x59, x58 = bits.Mul32(x40, 0xffffffff)
  var x60 uint32
  var x61 uint32
  x61, x60 = bits.Mul32(x40, 0xffffffff)
  var x62 uint32
  var x63 fiat_p384_uint1
  x62, x63 = fiat_p384_addcarryx_u32(x59, x56, 0x0)
  var x64 uint32
  var x65 fiat_p384_uint1
  x64, x65 = fiat_p384_addcarryx_u32(x57, x54, x63)
  var x66 uint32
  var x67 fiat_p384_uint1
  x66, x67 = fiat_p384_addcarryx_u32(x55, x52, x65)
  var x68 uint32
  var x69 fiat_p384_uint1
  x68, x69 = fiat_p384_addcarryx_u32(x53, x50, x67)
  var x70 uint32
  var x71 fiat_p384_uint1
  x70, x71 = fiat_p384_addcarryx_u32(x51, x48, x69)
  var x72 uint32
  var x73 fiat_p384_uint1
  x72, x73 = fiat_p384_addcarryx_u32(x49, x46, x71)
  var x74 uint32
  var x75 fiat_p384_uint1
  x74, x75 = fiat_p384_addcarryx_u32(x47, x44, x73)
  var x76 uint32
  var x77 fiat_p384_uint1
  x76, x77 = fiat_p384_addcarryx_u32(x45, x42, x75)
  var x79 fiat_p384_uint1
  _, x79 = fiat_p384_addcarryx_u32(x40, x60, 0x0)
  var x80 uint32
  var x81 fiat_p384_uint1
  x80, x81 = fiat_p384_addcarryx_u32(uint32(x41), x61, x79)
  var x82 uint32
  var x83 fiat_p384_uint1
  x82, x83 = fiat_p384_addcarryx_u32(x18, uint32(0x0), x81)
  var x84 uint32
  var x85 fiat_p384_uint1
  x84, x85 = fiat_p384_addcarryx_u32(x22, x58, x83)
  var x86 uint32
  var x87 fiat_p384_uint1
  x86, x87 = fiat_p384_addcarryx_u32(x24, x62, x85)
  var x88 uint32
  var x89 fiat_p384_uint1
  x88, x89 = fiat_p384_addcarryx_u32(x26, x64, x87)
  var x90 uint32
  var x91 fiat_p384_uint1
  x90, x91 = fiat_p384_addcarryx_u32(x28, x66, x89)
  var x92 uint32
  var x93 fiat_p384_uint1
  x92, x93 = fiat_p384_addcarryx_u32(x30, x68, x91)
  var x94 uint32
  var x95 fiat_p384_uint1
  x94, x95 = fiat_p384_addcarryx_u32(x32, x70, x93)
  var x96 uint32
  var x97 fiat_p384_uint1
  x96, x97 = fiat_p384_addcarryx_u32(x34, x72, x95)
  var x98 uint32
  var x99 fiat_p384_uint1
  x98, x99 = fiat_p384_addcarryx_u32(x36, x74, x97)
  var x100 uint32
  var x101 fiat_p384_uint1
  x100, x101 = fiat_p384_addcarryx_u32((uint32(x37) + x3), x76, x99)
  var x102 uint32
  var x103 fiat_p384_uint1
  x102, x103 = fiat_p384_addcarryx_u32(uint32(0x0), (uint32(x77) + x43), x101)
  var x104 uint32
  var x105 fiat_p384_uint1
  x104, x105 = fiat_p384_addcarryx_u32(x80, (arg1[2]), 0x0)
  var x106 uint32
  var x107 fiat_p384_uint1
  x106, x107 = fiat_p384_addcarryx_u32(x82, uint32(0x0), x105)
  var x108 uint32
  var x109 fiat_p384_uint1
  x108, x109 = fiat_p384_addcarryx_u32(x84, uint32(0x0), x107)
  var x110 uint32
  var x111 fiat_p384_uint1
  x110, x111 = fiat_p384_addcarryx_u32(x86, uint32(0x0), x109)
  var x112 uint32
  var x113 fiat_p384_uint1
  x112, x113 = fiat_p384_addcarryx_u32(x88, uint32(0x0), x111)
  var x114 uint32
  var x115 fiat_p384_uint1
  x114, x115 = fiat_p384_addcarryx_u32(x90, uint32(0x0), x113)
  var x116 uint32
  var x117 fiat_p384_uint1
  x116, x117 = fiat_p384_addcarryx_u32(x92, uint32(0x0), x115)
  var x118 uint32
  var x119 fiat_p384_uint1
  x118, x119 = fiat_p384_addcarryx_u32(x94, uint32(0x0), x117)
  var x120 uint32
  var x121 fiat_p384_uint1
  x120, x121 = fiat_p384_addcarryx_u32(x96, uint32(0x0), x119)
  var x122 uint32
  var x123 fiat_p384_uint1
  x122, x123 = fiat_p384_addcarryx_u32(x98, uint32(0x0), x121)
  var x124 uint32
  var x125 fiat_p384_uint1
  x124, x125 = fiat_p384_addcarryx_u32(x100, uint32(0x0), x123)
  var x126 uint32
  var x127 fiat_p384_uint1
  x126, x127 = fiat_p384_addcarryx_u32(x102, uint32(0x0), x125)
  var x128 uint32
  var x129 uint32
  x129, x128 = bits.Mul32(x104, 0xffffffff)
  var x130 uint32
  var x131 uint32
  x131, x130 = bits.Mul32(x104, 0xffffffff)
  var x132 uint32
  var x133 uint32
  x133, x132 = bits.Mul32(x104, 0xffffffff)
  var x134 uint32
  var x135 uint32
  x135, x134 = bits.Mul32(x104, 0xffffffff)
  var x136 uint32
  var x137 uint32
  x137, x136 = bits.Mul32(x104, 0xffffffff)
  var x138 uint32
  var x139 uint32
  x139, x138 = bits.Mul32(x104, 0xffffffff)
  var x140 uint32
  var x141 uint32
  x141, x140 = bits.Mul32(x104, 0xffffffff)
  var x142 uint32
  var x143 uint32
  x143, x142 = bits.Mul32(x104, 0xfffffffe)
  var x144 uint32
  var x145 uint32
  x145, x144 = bits.Mul32(x104, 0xffffffff)
  var x146 uint32
  var x147 uint32
  x147, x146 = bits.Mul32(x104, 0xffffffff)
  var x148 uint32
  var x149 fiat_p384_uint1
  x148, x149 = fiat_p384_addcarryx_u32(x145, x142, 0x0)
  var x150 uint32
  var x151 fiat_p384_uint1
  x150, x151 = fiat_p384_addcarryx_u32(x143, x140, x149)
  var x152 uint32
  var x153 fiat_p384_uint1
  x152, x153 = fiat_p384_addcarryx_u32(x141, x138, x151)
  var x154 uint32
  var x155 fiat_p384_uint1
  x154, x155 = fiat_p384_addcarryx_u32(x139, x136, x153)
  var x156 uint32
  var x157 fiat_p384_uint1
  x156, x157 = fiat_p384_addcarryx_u32(x137, x134, x155)
  var x158 uint32
  var x159 fiat_p384_uint1
  x158, x159 = fiat_p384_addcarryx_u32(x135, x132, x157)
  var x160 uint32
  var x161 fiat_p384_uint1
  x160, x161 = fiat_p384_addcarryx_u32(x133, x130, x159)
  var x162 uint32
  var x163 fiat_p384_uint1
  x162, x163 = fiat_p384_addcarryx_u32(x131, x128, x161)
  var x165 fiat_p384_uint1
  _, x165 = fiat_p384_addcarryx_u32(x104, x146, 0x0)
  var x166 uint32
  var x167 fiat_p384_uint1
  x166, x167 = fiat_p384_addcarryx_u32(x106, x147, x165)
  var x168 uint32
  var x169 fiat_p384_uint1
  x168, x169 = fiat_p384_addcarryx_u32(x108, uint32(0x0), x167)
  var x170 uint32
  var x171 fiat_p384_uint1
  x170, x171 = fiat_p384_addcarryx_u32(x110, x144, x169)
  var x172 uint32
  var x173 fiat_p384_uint1
  x172, x173 = fiat_p384_addcarryx_u32(x112, x148, x171)
  var x174 uint32
  var x175 fiat_p384_uint1
  x174, x175 = fiat_p384_addcarryx_u32(x114, x150, x173)
  var x176 uint32
  var x177 fiat_p384_uint1
  x176, x177 = fiat_p384_addcarryx_u32(x116, x152, x175)
  var x178 uint32
  var x179 fiat_p384_uint1
  x178, x179 = fiat_p384_addcarryx_u32(x118, x154, x177)
  var x180 uint32
  var x181 fiat_p384_uint1
  x180, x181 = fiat_p384_addcarryx_u32(x120, x156, x179)
  var x182 uint32
  var x183 fiat_p384_uint1
  x182, x183 = fiat_p384_addcarryx_u32(x122, x158, x181)
  var x184 uint32
  var x185 fiat_p384_uint1
  x184, x185 = fiat_p384_addcarryx_u32(x124, x160, x183)
  var x186 uint32
  var x187 fiat_p384_uint1
  x186, x187 = fiat_p384_addcarryx_u32(x126, x162, x185)
  var x188 uint32
  var x189 fiat_p384_uint1
  x188, x189 = fiat_p384_addcarryx_u32((uint32(x127) + uint32(x103)), (uint32(x163) + x129), x187)
  var x190 uint32
  var x191 fiat_p384_uint1
  x190, x191 = fiat_p384_addcarryx_u32(x166, (arg1[3]), 0x0)
  var x192 uint32
  var x193 fiat_p384_uint1
  x192, x193 = fiat_p384_addcarryx_u32(x168, uint32(0x0), x191)
  var x194 uint32
  var x195 fiat_p384_uint1
  x194, x195 = fiat_p384_addcarryx_u32(x170, uint32(0x0), x193)
  var x196 uint32
  var x197 fiat_p384_uint1
  x196, x197 = fiat_p384_addcarryx_u32(x172, uint32(0x0), x195)
  var x198 uint32
  var x199 fiat_p384_uint1
  x198, x199 = fiat_p384_addcarryx_u32(x174, uint32(0x0), x197)
  var x200 uint32
  var x201 fiat_p384_uint1
  x200, x201 = fiat_p384_addcarryx_u32(x176, uint32(0x0), x199)
  var x202 uint32
  var x203 fiat_p384_uint1
  x202, x203 = fiat_p384_addcarryx_u32(x178, uint32(0x0), x201)
  var x204 uint32
  var x205 fiat_p384_uint1
  x204, x205 = fiat_p384_addcarryx_u32(x180, uint32(0x0), x203)
  var x206 uint32
  var x207 fiat_p384_uint1
  x206, x207 = fiat_p384_addcarryx_u32(x182, uint32(0x0), x205)
  var x208 uint32
  var x209 fiat_p384_uint1
  x208, x209 = fiat_p384_addcarryx_u32(x184, uint32(0x0), x207)
  var x210 uint32
  var x211 fiat_p384_uint1
  x210, x211 = fiat_p384_addcarryx_u32(x186, uint32(0x0), x209)
  var x212 uint32
  var x213 fiat_p384_uint1
  x212, x213 = fiat_p384_addcarryx_u32(x188, uint32(0x0), x211)
  var x214 uint32
  var x215 uint32
  x215, x214 = bits.Mul32(x190, 0xffffffff)
  var x216 uint32
  var x217 uint32
  x217, x216 = bits.Mul32(x190, 0xffffffff)
  var x218 uint32
  var x219 uint32
  x219, x218 = bits.Mul32(x190, 0xffffffff)
  var x220 uint32
  var x221 uint32
  x221, x220 = bits.Mul32(x190, 0xffffffff)
  var x222 uint32
  var x223 uint32
  x223, x222 = bits.Mul32(x190, 0xffffffff)
  var x224 uint32
  var x225 uint32
  x225, x224 = bits.Mul32(x190, 0xffffffff)
  var x226 uint32
  var x227 uint32
  x227, x226 = bits.Mul32(x190, 0xffffffff)
  var x228 uint32
  var x229 uint32
  x229, x228 = bits.Mul32(x190, 0xfffffffe)
  var x230 uint32
  var x231 uint32
  x231, x230 = bits.Mul32(x190, 0xffffffff)
  var x232 uint32
  var x233 uint32
  x233, x232 = bits.Mul32(x190, 0xffffffff)
  var x234 uint32
  var x235 fiat_p384_uint1
  x234, x235 = fiat_p384_addcarryx_u32(x231, x228, 0x0)
  var x236 uint32
  var x237 fiat_p384_uint1
  x236, x237 = fiat_p384_addcarryx_u32(x229, x226, x235)
  var x238 uint32
  var x239 fiat_p384_uint1
  x238, x239 = fiat_p384_addcarryx_u32(x227, x224, x237)
  var x240 uint32
  var x241 fiat_p384_uint1
  x240, x241 = fiat_p384_addcarryx_u32(x225, x222, x239)
  var x242 uint32
  var x243 fiat_p384_uint1
  x242, x243 = fiat_p384_addcarryx_u32(x223, x220, x241)
  var x244 uint32
  var x245 fiat_p384_uint1
  x244, x245 = fiat_p384_addcarryx_u32(x221, x218, x243)
  var x246 uint32
  var x247 fiat_p384_uint1
  x246, x247 = fiat_p384_addcarryx_u32(x219, x216, x245)
  var x248 uint32
  var x249 fiat_p384_uint1
  x248, x249 = fiat_p384_addcarryx_u32(x217, x214, x247)
  var x251 fiat_p384_uint1
  _, x251 = fiat_p384_addcarryx_u32(x190, x232, 0x0)
  var x252 uint32
  var x253 fiat_p384_uint1
  x252, x253 = fiat_p384_addcarryx_u32(x192, x233, x251)
  var x254 uint32
  var x255 fiat_p384_uint1
  x254, x255 = fiat_p384_addcarryx_u32(x194, uint32(0x0), x253)
  var x256 uint32
  var x257 fiat_p384_uint1
  x256, x257 = fiat_p384_addcarryx_u32(x196, x230, x255)
  var x258 uint32
  var x259 fiat_p384_uint1
  x258, x259 = fiat_p384_addcarryx_u32(x198, x234, x257)
  var x260 uint32
  var x261 fiat_p384_uint1
  x260, x261 = fiat_p384_addcarryx_u32(x200, x236, x259)
  var x262 uint32
  var x263 fiat_p384_uint1
  x262, x263 = fiat_p384_addcarryx_u32(x202, x238, x261)
  var x264 uint32
  var x265 fiat_p384_uint1
  x264, x265 = fiat_p384_addcarryx_u32(x204, x240, x263)
  var x266 uint32
  var x267 fiat_p384_uint1
  x266, x267 = fiat_p384_addcarryx_u32(x206, x242, x265)
  var x268 uint32
  var x269 fiat_p384_uint1
  x268, x269 = fiat_p384_addcarryx_u32(x208, x244, x267)
  var x270 uint32
  var x271 fiat_p384_uint1
  x270, x271 = fiat_p384_addcarryx_u32(x210, x246, x269)
  var x272 uint32
  var x273 fiat_p384_uint1
  x272, x273 = fiat_p384_addcarryx_u32(x212, x248, x271)
  var x274 uint32
  var x275 fiat_p384_uint1
  x274, x275 = fiat_p384_addcarryx_u32((uint32(x213) + uint32(x189)), (uint32(x249) + x215), x273)
  var x276 uint32
  var x277 fiat_p384_uint1
  x276, x277 = fiat_p384_addcarryx_u32(x252, (arg1[4]), 0x0)
  var x278 uint32
  var x279 fiat_p384_uint1
  x278, x279 = fiat_p384_addcarryx_u32(x254, uint32(0x0), x277)
  var x280 uint32
  var x281 fiat_p384_uint1
  x280, x281 = fiat_p384_addcarryx_u32(x256, uint32(0x0), x279)
  var x282 uint32
  var x283 fiat_p384_uint1
  x282, x283 = fiat_p384_addcarryx_u32(x258, uint32(0x0), x281)
  var x284 uint32
  var x285 fiat_p384_uint1
  x284, x285 = fiat_p384_addcarryx_u32(x260, uint32(0x0), x283)
  var x286 uint32
  var x287 fiat_p384_uint1
  x286, x287 = fiat_p384_addcarryx_u32(x262, uint32(0x0), x285)
  var x288 uint32
  var x289 fiat_p384_uint1
  x288, x289 = fiat_p384_addcarryx_u32(x264, uint32(0x0), x287)
  var x290 uint32
  var x291 fiat_p384_uint1
  x290, x291 = fiat_p384_addcarryx_u32(x266, uint32(0x0), x289)
  var x292 uint32
  var x293 fiat_p384_uint1
  x292, x293 = fiat_p384_addcarryx_u32(x268, uint32(0x0), x291)
  var x294 uint32
  var x295 fiat_p384_uint1
  x294, x295 = fiat_p384_addcarryx_u32(x270, uint32(0x0), x293)
  var x296 uint32
  var x297 fiat_p384_uint1
  x296, x297 = fiat_p384_addcarryx_u32(x272, uint32(0x0), x295)
  var x298 uint32
  var x299 fiat_p384_uint1
  x298, x299 = fiat_p384_addcarryx_u32(x274, uint32(0x0), x297)
  var x300 uint32
  var x301 uint32
  x301, x300 = bits.Mul32(x276, 0xffffffff)
  var x302 uint32
  var x303 uint32
  x303, x302 = bits.Mul32(x276, 0xffffffff)
  var x304 uint32
  var x305 uint32
  x305, x304 = bits.Mul32(x276, 0xffffffff)
  var x306 uint32
  var x307 uint32
  x307, x306 = bits.Mul32(x276, 0xffffffff)
  var x308 uint32
  var x309 uint32
  x309, x308 = bits.Mul32(x276, 0xffffffff)
  var x310 uint32
  var x311 uint32
  x311, x310 = bits.Mul32(x276, 0xffffffff)
  var x312 uint32
  var x313 uint32
  x313, x312 = bits.Mul32(x276, 0xffffffff)
  var x314 uint32
  var x315 uint32
  x315, x314 = bits.Mul32(x276, 0xfffffffe)
  var x316 uint32
  var x317 uint32
  x317, x316 = bits.Mul32(x276, 0xffffffff)
  var x318 uint32
  var x319 uint32
  x319, x318 = bits.Mul32(x276, 0xffffffff)
  var x320 uint32
  var x321 fiat_p384_uint1
  x320, x321 = fiat_p384_addcarryx_u32(x317, x314, 0x0)
  var x322 uint32
  var x323 fiat_p384_uint1
  x322, x323 = fiat_p384_addcarryx_u32(x315, x312, x321)
  var x324 uint32
  var x325 fiat_p384_uint1
  x324, x325 = fiat_p384_addcarryx_u32(x313, x310, x323)
  var x326 uint32
  var x327 fiat_p384_uint1
  x326, x327 = fiat_p384_addcarryx_u32(x311, x308, x325)
  var x328 uint32
  var x329 fiat_p384_uint1
  x328, x329 = fiat_p384_addcarryx_u32(x309, x306, x327)
  var x330 uint32
  var x331 fiat_p384_uint1
  x330, x331 = fiat_p384_addcarryx_u32(x307, x304, x329)
  var x332 uint32
  var x333 fiat_p384_uint1
  x332, x333 = fiat_p384_addcarryx_u32(x305, x302, x331)
  var x334 uint32
  var x335 fiat_p384_uint1
  x334, x335 = fiat_p384_addcarryx_u32(x303, x300, x333)
  var x337 fiat_p384_uint1
  _, x337 = fiat_p384_addcarryx_u32(x276, x318, 0x0)
  var x338 uint32
  var x339 fiat_p384_uint1
  x338, x339 = fiat_p384_addcarryx_u32(x278, x319, x337)
  var x340 uint32
  var x341 fiat_p384_uint1
  x340, x341 = fiat_p384_addcarryx_u32(x280, uint32(0x0), x339)
  var x342 uint32
  var x343 fiat_p384_uint1
  x342, x343 = fiat_p384_addcarryx_u32(x282, x316, x341)
  var x344 uint32
  var x345 fiat_p384_uint1
  x344, x345 = fiat_p384_addcarryx_u32(x284, x320, x343)
  var x346 uint32
  var x347 fiat_p384_uint1
  x346, x347 = fiat_p384_addcarryx_u32(x286, x322, x345)
  var x348 uint32
  var x349 fiat_p384_uint1
  x348, x349 = fiat_p384_addcarryx_u32(x288, x324, x347)
  var x350 uint32
  var x351 fiat_p384_uint1
  x350, x351 = fiat_p384_addcarryx_u32(x290, x326, x349)
  var x352 uint32
  var x353 fiat_p384_uint1
  x352, x353 = fiat_p384_addcarryx_u32(x292, x328, x351)
  var x354 uint32
  var x355 fiat_p384_uint1
  x354, x355 = fiat_p384_addcarryx_u32(x294, x330, x353)
  var x356 uint32
  var x357 fiat_p384_uint1
  x356, x357 = fiat_p384_addcarryx_u32(x296, x332, x355)
  var x358 uint32
  var x359 fiat_p384_uint1
  x358, x359 = fiat_p384_addcarryx_u32(x298, x334, x357)
  var x360 uint32
  var x361 fiat_p384_uint1
  x360, x361 = fiat_p384_addcarryx_u32((uint32(x299) + uint32(x275)), (uint32(x335) + x301), x359)
  var x362 uint32
  var x363 fiat_p384_uint1
  x362, x363 = fiat_p384_addcarryx_u32(x338, (arg1[5]), 0x0)
  var x364 uint32
  var x365 fiat_p384_uint1
  x364, x365 = fiat_p384_addcarryx_u32(x340, uint32(0x0), x363)
  var x366 uint32
  var x367 fiat_p384_uint1
  x366, x367 = fiat_p384_addcarryx_u32(x342, uint32(0x0), x365)
  var x368 uint32
  var x369 fiat_p384_uint1
  x368, x369 = fiat_p384_addcarryx_u32(x344, uint32(0x0), x367)
  var x370 uint32
  var x371 fiat_p384_uint1
  x370, x371 = fiat_p384_addcarryx_u32(x346, uint32(0x0), x369)
  var x372 uint32
  var x373 fiat_p384_uint1
  x372, x373 = fiat_p384_addcarryx_u32(x348, uint32(0x0), x371)
  var x374 uint32
  var x375 fiat_p384_uint1
  x374, x375 = fiat_p384_addcarryx_u32(x350, uint32(0x0), x373)
  var x376 uint32
  var x377 fiat_p384_uint1
  x376, x377 = fiat_p384_addcarryx_u32(x352, uint32(0x0), x375)
  var x378 uint32
  var x379 fiat_p384_uint1
  x378, x379 = fiat_p384_addcarryx_u32(x354, uint32(0x0), x377)
  var x380 uint32
  var x381 fiat_p384_uint1
  x380, x381 = fiat_p384_addcarryx_u32(x356, uint32(0x0), x379)
  var x382 uint32
  var x383 fiat_p384_uint1
  x382, x383 = fiat_p384_addcarryx_u32(x358, uint32(0x0), x381)
  var x384 uint32
  var x385 fiat_p384_uint1
  x384, x385 = fiat_p384_addcarryx_u32(x360, uint32(0x0), x383)
  var x386 uint32
  var x387 uint32
  x387, x386 = bits.Mul32(x362, 0xffffffff)
  var x388 uint32
  var x389 uint32
  x389, x388 = bits.Mul32(x362, 0xffffffff)
  var x390 uint32
  var x391 uint32
  x391, x390 = bits.Mul32(x362, 0xffffffff)
  var x392 uint32
  var x393 uint32
  x393, x392 = bits.Mul32(x362, 0xffffffff)
  var x394 uint32
  var x395 uint32
  x395, x394 = bits.Mul32(x362, 0xffffffff)
  var x396 uint32
  var x397 uint32
  x397, x396 = bits.Mul32(x362, 0xffffffff)
  var x398 uint32
  var x399 uint32
  x399, x398 = bits.Mul32(x362, 0xffffffff)
  var x400 uint32
  var x401 uint32
  x401, x400 = bits.Mul32(x362, 0xfffffffe)
  var x402 uint32
  var x403 uint32
  x403, x402 = bits.Mul32(x362, 0xffffffff)
  var x404 uint32
  var x405 uint32
  x405, x404 = bits.Mul32(x362, 0xffffffff)
  var x406 uint32
  var x407 fiat_p384_uint1
  x406, x407 = fiat_p384_addcarryx_u32(x403, x400, 0x0)
  var x408 uint32
  var x409 fiat_p384_uint1
  x408, x409 = fiat_p384_addcarryx_u32(x401, x398, x407)
  var x410 uint32
  var x411 fiat_p384_uint1
  x410, x411 = fiat_p384_addcarryx_u32(x399, x396, x409)
  var x412 uint32
  var x413 fiat_p384_uint1
  x412, x413 = fiat_p384_addcarryx_u32(x397, x394, x411)
  var x414 uint32
  var x415 fiat_p384_uint1
  x414, x415 = fiat_p384_addcarryx_u32(x395, x392, x413)
  var x416 uint32
  var x417 fiat_p384_uint1
  x416, x417 = fiat_p384_addcarryx_u32(x393, x390, x415)
  var x418 uint32
  var x419 fiat_p384_uint1
  x418, x419 = fiat_p384_addcarryx_u32(x391, x388, x417)
  var x420 uint32
  var x421 fiat_p384_uint1
  x420, x421 = fiat_p384_addcarryx_u32(x389, x386, x419)
  var x423 fiat_p384_uint1
  _, x423 = fiat_p384_addcarryx_u32(x362, x404, 0x0)
  var x424 uint32
  var x425 fiat_p384_uint1
  x424, x425 = fiat_p384_addcarryx_u32(x364, x405, x423)
  var x426 uint32
  var x427 fiat_p384_uint1
  x426, x427 = fiat_p384_addcarryx_u32(x366, uint32(0x0), x425)
  var x428 uint32
  var x429 fiat_p384_uint1
  x428, x429 = fiat_p384_addcarryx_u32(x368, x402, x427)
  var x430 uint32
  var x431 fiat_p384_uint1
  x430, x431 = fiat_p384_addcarryx_u32(x370, x406, x429)
  var x432 uint32
  var x433 fiat_p384_uint1
  x432, x433 = fiat_p384_addcarryx_u32(x372, x408, x431)
  var x434 uint32
  var x435 fiat_p384_uint1
  x434, x435 = fiat_p384_addcarryx_u32(x374, x410, x433)
  var x436 uint32
  var x437 fiat_p384_uint1
  x436, x437 = fiat_p384_addcarryx_u32(x376, x412, x435)
  var x438 uint32
  var x439 fiat_p384_uint1
  x438, x439 = fiat_p384_addcarryx_u32(x378, x414, x437)
  var x440 uint32
  var x441 fiat_p384_uint1
  x440, x441 = fiat_p384_addcarryx_u32(x380, x416, x439)
  var x442 uint32
  var x443 fiat_p384_uint1
  x442, x443 = fiat_p384_addcarryx_u32(x382, x418, x441)
  var x444 uint32
  var x445 fiat_p384_uint1
  x444, x445 = fiat_p384_addcarryx_u32(x384, x420, x443)
  var x446 uint32
  var x447 fiat_p384_uint1
  x446, x447 = fiat_p384_addcarryx_u32((uint32(x385) + uint32(x361)), (uint32(x421) + x387), x445)
  var x448 uint32
  var x449 fiat_p384_uint1
  x448, x449 = fiat_p384_addcarryx_u32(x424, (arg1[6]), 0x0)
  var x450 uint32
  var x451 fiat_p384_uint1
  x450, x451 = fiat_p384_addcarryx_u32(x426, uint32(0x0), x449)
  var x452 uint32
  var x453 fiat_p384_uint1
  x452, x453 = fiat_p384_addcarryx_u32(x428, uint32(0x0), x451)
  var x454 uint32
  var x455 fiat_p384_uint1
  x454, x455 = fiat_p384_addcarryx_u32(x430, uint32(0x0), x453)
  var x456 uint32
  var x457 fiat_p384_uint1
  x456, x457 = fiat_p384_addcarryx_u32(x432, uint32(0x0), x455)
  var x458 uint32
  var x459 fiat_p384_uint1
  x458, x459 = fiat_p384_addcarryx_u32(x434, uint32(0x0), x457)
  var x460 uint32
  var x461 fiat_p384_uint1
  x460, x461 = fiat_p384_addcarryx_u32(x436, uint32(0x0), x459)
  var x462 uint32
  var x463 fiat_p384_uint1
  x462, x463 = fiat_p384_addcarryx_u32(x438, uint32(0x0), x461)
  var x464 uint32
  var x465 fiat_p384_uint1
  x464, x465 = fiat_p384_addcarryx_u32(x440, uint32(0x0), x463)
  var x466 uint32
  var x467 fiat_p384_uint1
  x466, x467 = fiat_p384_addcarryx_u32(x442, uint32(0x0), x465)
  var x468 uint32
  var x469 fiat_p384_uint1
  x468, x469 = fiat_p384_addcarryx_u32(x444, uint32(0x0), x467)
  var x470 uint32
  var x471 fiat_p384_uint1
  x470, x471 = fiat_p384_addcarryx_u32(x446, uint32(0x0), x469)
  var x472 uint32
  var x473 uint32
  x473, x472 = bits.Mul32(x448, 0xffffffff)
  var x474 uint32
  var x475 uint32
  x475, x474 = bits.Mul32(x448, 0xffffffff)
  var x476 uint32
  var x477 uint32
  x477, x476 = bits.Mul32(x448, 0xffffffff)
  var x478 uint32
  var x479 uint32
  x479, x478 = bits.Mul32(x448, 0xffffffff)
  var x480 uint32
  var x481 uint32
  x481, x480 = bits.Mul32(x448, 0xffffffff)
  var x482 uint32
  var x483 uint32
  x483, x482 = bits.Mul32(x448, 0xffffffff)
  var x484 uint32
  var x485 uint32
  x485, x484 = bits.Mul32(x448, 0xffffffff)
  var x486 uint32
  var x487 uint32
  x487, x486 = bits.Mul32(x448, 0xfffffffe)
  var x488 uint32
  var x489 uint32
  x489, x488 = bits.Mul32(x448, 0xffffffff)
  var x490 uint32
  var x491 uint32
  x491, x490 = bits.Mul32(x448, 0xffffffff)
  var x492 uint32
  var x493 fiat_p384_uint1
  x492, x493 = fiat_p384_addcarryx_u32(x489, x486, 0x0)
  var x494 uint32
  var x495 fiat_p384_uint1
  x494, x495 = fiat_p384_addcarryx_u32(x487, x484, x493)
  var x496 uint32
  var x497 fiat_p384_uint1
  x496, x497 = fiat_p384_addcarryx_u32(x485, x482, x495)
  var x498 uint32
  var x499 fiat_p384_uint1
  x498, x499 = fiat_p384_addcarryx_u32(x483, x480, x497)
  var x500 uint32
  var x501 fiat_p384_uint1
  x500, x501 = fiat_p384_addcarryx_u32(x481, x478, x499)
  var x502 uint32
  var x503 fiat_p384_uint1
  x502, x503 = fiat_p384_addcarryx_u32(x479, x476, x501)
  var x504 uint32
  var x505 fiat_p384_uint1
  x504, x505 = fiat_p384_addcarryx_u32(x477, x474, x503)
  var x506 uint32
  var x507 fiat_p384_uint1
  x506, x507 = fiat_p384_addcarryx_u32(x475, x472, x505)
  var x509 fiat_p384_uint1
  _, x509 = fiat_p384_addcarryx_u32(x448, x490, 0x0)
  var x510 uint32
  var x511 fiat_p384_uint1
  x510, x511 = fiat_p384_addcarryx_u32(x450, x491, x509)
  var x512 uint32
  var x513 fiat_p384_uint1
  x512, x513 = fiat_p384_addcarryx_u32(x452, uint32(0x0), x511)
  var x514 uint32
  var x515 fiat_p384_uint1
  x514, x515 = fiat_p384_addcarryx_u32(x454, x488, x513)
  var x516 uint32
  var x517 fiat_p384_uint1
  x516, x517 = fiat_p384_addcarryx_u32(x456, x492, x515)
  var x518 uint32
  var x519 fiat_p384_uint1
  x518, x519 = fiat_p384_addcarryx_u32(x458, x494, x517)
  var x520 uint32
  var x521 fiat_p384_uint1
  x520, x521 = fiat_p384_addcarryx_u32(x460, x496, x519)
  var x522 uint32
  var x523 fiat_p384_uint1
  x522, x523 = fiat_p384_addcarryx_u32(x462, x498, x521)
  var x524 uint32
  var x525 fiat_p384_uint1
  x524, x525 = fiat_p384_addcarryx_u32(x464, x500, x523)
  var x526 uint32
  var x527 fiat_p384_uint1
  x526, x527 = fiat_p384_addcarryx_u32(x466, x502, x525)
  var x528 uint32
  var x529 fiat_p384_uint1
  x528, x529 = fiat_p384_addcarryx_u32(x468, x504, x527)
  var x530 uint32
  var x531 fiat_p384_uint1
  x530, x531 = fiat_p384_addcarryx_u32(x470, x506, x529)
  var x532 uint32
  var x533 fiat_p384_uint1
  x532, x533 = fiat_p384_addcarryx_u32((uint32(x471) + uint32(x447)), (uint32(x507) + x473), x531)
  var x534 uint32
  var x535 fiat_p384_uint1
  x534, x535 = fiat_p384_addcarryx_u32(x510, (arg1[7]), 0x0)
  var x536 uint32
  var x537 fiat_p384_uint1
  x536, x537 = fiat_p384_addcarryx_u32(x512, uint32(0x0), x535)
  var x538 uint32
  var x539 fiat_p384_uint1
  x538, x539 = fiat_p384_addcarryx_u32(x514, uint32(0x0), x537)
  var x540 uint32
  var x541 fiat_p384_uint1
  x540, x541 = fiat_p384_addcarryx_u32(x516, uint32(0x0), x539)
  var x542 uint32
  var x543 fiat_p384_uint1
  x542, x543 = fiat_p384_addcarryx_u32(x518, uint32(0x0), x541)
  var x544 uint32
  var x545 fiat_p384_uint1
  x544, x545 = fiat_p384_addcarryx_u32(x520, uint32(0x0), x543)
  var x546 uint32
  var x547 fiat_p384_uint1
  x546, x547 = fiat_p384_addcarryx_u32(x522, uint32(0x0), x545)
  var x548 uint32
  var x549 fiat_p384_uint1
  x548, x549 = fiat_p384_addcarryx_u32(x524, uint32(0x0), x547)
  var x550 uint32
  var x551 fiat_p384_uint1
  x550, x551 = fiat_p384_addcarryx_u32(x526, uint32(0x0), x549)
  var x552 uint32
  var x553 fiat_p384_uint1
  x552, x553 = fiat_p384_addcarryx_u32(x528, uint32(0x0), x551)
  var x554 uint32
  var x555 fiat_p384_uint1
  x554, x555 = fiat_p384_addcarryx_u32(x530, uint32(0x0), x553)
  var x556 uint32
  var x557 fiat_p384_uint1
  x556, x557 = fiat_p384_addcarryx_u32(x532, uint32(0x0), x555)
  var x558 uint32
  var x559 uint32
  x559, x558 = bits.Mul32(x534, 0xffffffff)
  var x560 uint32
  var x561 uint32
  x561, x560 = bits.Mul32(x534, 0xffffffff)
  var x562 uint32
  var x563 uint32
  x563, x562 = bits.Mul32(x534, 0xffffffff)
  var x564 uint32
  var x565 uint32
  x565, x564 = bits.Mul32(x534, 0xffffffff)
  var x566 uint32
  var x567 uint32
  x567, x566 = bits.Mul32(x534, 0xffffffff)
  var x568 uint32
  var x569 uint32
  x569, x568 = bits.Mul32(x534, 0xffffffff)
  var x570 uint32
  var x571 uint32
  x571, x570 = bits.Mul32(x534, 0xffffffff)
  var x572 uint32
  var x573 uint32
  x573, x572 = bits.Mul32(x534, 0xfffffffe)
  var x574 uint32
  var x575 uint32
  x575, x574 = bits.Mul32(x534, 0xffffffff)
  var x576 uint32
  var x577 uint32
  x577, x576 = bits.Mul32(x534, 0xffffffff)
  var x578 uint32
  var x579 fiat_p384_uint1
  x578, x579 = fiat_p384_addcarryx_u32(x575, x572, 0x0)
  var x580 uint32
  var x581 fiat_p384_uint1
  x580, x581 = fiat_p384_addcarryx_u32(x573, x570, x579)
  var x582 uint32
  var x583 fiat_p384_uint1
  x582, x583 = fiat_p384_addcarryx_u32(x571, x568, x581)
  var x584 uint32
  var x585 fiat_p384_uint1
  x584, x585 = fiat_p384_addcarryx_u32(x569, x566, x583)
  var x586 uint32
  var x587 fiat_p384_uint1
  x586, x587 = fiat_p384_addcarryx_u32(x567, x564, x585)
  var x588 uint32
  var x589 fiat_p384_uint1
  x588, x589 = fiat_p384_addcarryx_u32(x565, x562, x587)
  var x590 uint32
  var x591 fiat_p384_uint1
  x590, x591 = fiat_p384_addcarryx_u32(x563, x560, x589)
  var x592 uint32
  var x593 fiat_p384_uint1
  x592, x593 = fiat_p384_addcarryx_u32(x561, x558, x591)
  var x595 fiat_p384_uint1
  _, x595 = fiat_p384_addcarryx_u32(x534, x576, 0x0)
  var x596 uint32
  var x597 fiat_p384_uint1
  x596, x597 = fiat_p384_addcarryx_u32(x536, x577, x595)
  var x598 uint32
  var x599 fiat_p384_uint1
  x598, x599 = fiat_p384_addcarryx_u32(x538, uint32(0x0), x597)
  var x600 uint32
  var x601 fiat_p384_uint1
  x600, x601 = fiat_p384_addcarryx_u32(x540, x574, x599)
  var x602 uint32
  var x603 fiat_p384_uint1
  x602, x603 = fiat_p384_addcarryx_u32(x542, x578, x601)
  var x604 uint32
  var x605 fiat_p384_uint1
  x604, x605 = fiat_p384_addcarryx_u32(x544, x580, x603)
  var x606 uint32
  var x607 fiat_p384_uint1
  x606, x607 = fiat_p384_addcarryx_u32(x546, x582, x605)
  var x608 uint32
  var x609 fiat_p384_uint1
  x608, x609 = fiat_p384_addcarryx_u32(x548, x584, x607)
  var x610 uint32
  var x611 fiat_p384_uint1
  x610, x611 = fiat_p384_addcarryx_u32(x550, x586, x609)
  var x612 uint32
  var x613 fiat_p384_uint1
  x612, x613 = fiat_p384_addcarryx_u32(x552, x588, x611)
  var x614 uint32
  var x615 fiat_p384_uint1
  x614, x615 = fiat_p384_addcarryx_u32(x554, x590, x613)
  var x616 uint32
  var x617 fiat_p384_uint1
  x616, x617 = fiat_p384_addcarryx_u32(x556, x592, x615)
  var x618 uint32
  var x619 fiat_p384_uint1
  x618, x619 = fiat_p384_addcarryx_u32((uint32(x557) + uint32(x533)), (uint32(x593) + x559), x617)
  var x620 uint32
  var x621 fiat_p384_uint1
  x620, x621 = fiat_p384_addcarryx_u32(x596, (arg1[8]), 0x0)
  var x622 uint32
  var x623 fiat_p384_uint1
  x622, x623 = fiat_p384_addcarryx_u32(x598, uint32(0x0), x621)
  var x624 uint32
  var x625 fiat_p384_uint1
  x624, x625 = fiat_p384_addcarryx_u32(x600, uint32(0x0), x623)
  var x626 uint32
  var x627 fiat_p384_uint1
  x626, x627 = fiat_p384_addcarryx_u32(x602, uint32(0x0), x625)
  var x628 uint32
  var x629 fiat_p384_uint1
  x628, x629 = fiat_p384_addcarryx_u32(x604, uint32(0x0), x627)
  var x630 uint32
  var x631 fiat_p384_uint1
  x630, x631 = fiat_p384_addcarryx_u32(x606, uint32(0x0), x629)
  var x632 uint32
  var x633 fiat_p384_uint1
  x632, x633 = fiat_p384_addcarryx_u32(x608, uint32(0x0), x631)
  var x634 uint32
  var x635 fiat_p384_uint1
  x634, x635 = fiat_p384_addcarryx_u32(x610, uint32(0x0), x633)
  var x636 uint32
  var x637 fiat_p384_uint1
  x636, x637 = fiat_p384_addcarryx_u32(x612, uint32(0x0), x635)
  var x638 uint32
  var x639 fiat_p384_uint1
  x638, x639 = fiat_p384_addcarryx_u32(x614, uint32(0x0), x637)
  var x640 uint32
  var x641 fiat_p384_uint1
  x640, x641 = fiat_p384_addcarryx_u32(x616, uint32(0x0), x639)
  var x642 uint32
  var x643 fiat_p384_uint1
  x642, x643 = fiat_p384_addcarryx_u32(x618, uint32(0x0), x641)
  var x644 uint32
  var x645 uint32
  x645, x644 = bits.Mul32(x620, 0xffffffff)
  var x646 uint32
  var x647 uint32
  x647, x646 = bits.Mul32(x620, 0xffffffff)
  var x648 uint32
  var x649 uint32
  x649, x648 = bits.Mul32(x620, 0xffffffff)
  var x650 uint32
  var x651 uint32
  x651, x650 = bits.Mul32(x620, 0xffffffff)
  var x652 uint32
  var x653 uint32
  x653, x652 = bits.Mul32(x620, 0xffffffff)
  var x654 uint32
  var x655 uint32
  x655, x654 = bits.Mul32(x620, 0xffffffff)
  var x656 uint32
  var x657 uint32
  x657, x656 = bits.Mul32(x620, 0xffffffff)
  var x658 uint32
  var x659 uint32
  x659, x658 = bits.Mul32(x620, 0xfffffffe)
  var x660 uint32
  var x661 uint32
  x661, x660 = bits.Mul32(x620, 0xffffffff)
  var x662 uint32
  var x663 uint32
  x663, x662 = bits.Mul32(x620, 0xffffffff)
  var x664 uint32
  var x665 fiat_p384_uint1
  x664, x665 = fiat_p384_addcarryx_u32(x661, x658, 0x0)
  var x666 uint32
  var x667 fiat_p384_uint1
  x666, x667 = fiat_p384_addcarryx_u32(x659, x656, x665)
  var x668 uint32
  var x669 fiat_p384_uint1
  x668, x669 = fiat_p384_addcarryx_u32(x657, x654, x667)
  var x670 uint32
  var x671 fiat_p384_uint1
  x670, x671 = fiat_p384_addcarryx_u32(x655, x652, x669)
  var x672 uint32
  var x673 fiat_p384_uint1
  x672, x673 = fiat_p384_addcarryx_u32(x653, x650, x671)
  var x674 uint32
  var x675 fiat_p384_uint1
  x674, x675 = fiat_p384_addcarryx_u32(x651, x648, x673)
  var x676 uint32
  var x677 fiat_p384_uint1
  x676, x677 = fiat_p384_addcarryx_u32(x649, x646, x675)
  var x678 uint32
  var x679 fiat_p384_uint1
  x678, x679 = fiat_p384_addcarryx_u32(x647, x644, x677)
  var x681 fiat_p384_uint1
  _, x681 = fiat_p384_addcarryx_u32(x620, x662, 0x0)
  var x682 uint32
  var x683 fiat_p384_uint1
  x682, x683 = fiat_p384_addcarryx_u32(x622, x663, x681)
  var x684 uint32
  var x685 fiat_p384_uint1
  x684, x685 = fiat_p384_addcarryx_u32(x624, uint32(0x0), x683)
  var x686 uint32
  var x687 fiat_p384_uint1
  x686, x687 = fiat_p384_addcarryx_u32(x626, x660, x685)
  var x688 uint32
  var x689 fiat_p384_uint1
  x688, x689 = fiat_p384_addcarryx_u32(x628, x664, x687)
  var x690 uint32
  var x691 fiat_p384_uint1
  x690, x691 = fiat_p384_addcarryx_u32(x630, x666, x689)
  var x692 uint32
  var x693 fiat_p384_uint1
  x692, x693 = fiat_p384_addcarryx_u32(x632, x668, x691)
  var x694 uint32
  var x695 fiat_p384_uint1
  x694, x695 = fiat_p384_addcarryx_u32(x634, x670, x693)
  var x696 uint32
  var x697 fiat_p384_uint1
  x696, x697 = fiat_p384_addcarryx_u32(x636, x672, x695)
  var x698 uint32
  var x699 fiat_p384_uint1
  x698, x699 = fiat_p384_addcarryx_u32(x638, x674, x697)
  var x700 uint32
  var x701 fiat_p384_uint1
  x700, x701 = fiat_p384_addcarryx_u32(x640, x676, x699)
  var x702 uint32
  var x703 fiat_p384_uint1
  x702, x703 = fiat_p384_addcarryx_u32(x642, x678, x701)
  var x704 uint32
  var x705 fiat_p384_uint1
  x704, x705 = fiat_p384_addcarryx_u32((uint32(x643) + uint32(x619)), (uint32(x679) + x645), x703)
  var x706 uint32
  var x707 fiat_p384_uint1
  x706, x707 = fiat_p384_addcarryx_u32(x682, (arg1[9]), 0x0)
  var x708 uint32
  var x709 fiat_p384_uint1
  x708, x709 = fiat_p384_addcarryx_u32(x684, uint32(0x0), x707)
  var x710 uint32
  var x711 fiat_p384_uint1
  x710, x711 = fiat_p384_addcarryx_u32(x686, uint32(0x0), x709)
  var x712 uint32
  var x713 fiat_p384_uint1
  x712, x713 = fiat_p384_addcarryx_u32(x688, uint32(0x0), x711)
  var x714 uint32
  var x715 fiat_p384_uint1
  x714, x715 = fiat_p384_addcarryx_u32(x690, uint32(0x0), x713)
  var x716 uint32
  var x717 fiat_p384_uint1
  x716, x717 = fiat_p384_addcarryx_u32(x692, uint32(0x0), x715)
  var x718 uint32
  var x719 fiat_p384_uint1
  x718, x719 = fiat_p384_addcarryx_u32(x694, uint32(0x0), x717)
  var x720 uint32
  var x721 fiat_p384_uint1
  x720, x721 = fiat_p384_addcarryx_u32(x696, uint32(0x0), x719)
  var x722 uint32
  var x723 fiat_p384_uint1
  x722, x723 = fiat_p384_addcarryx_u32(x698, uint32(0x0), x721)
  var x724 uint32
  var x725 fiat_p384_uint1
  x724, x725 = fiat_p384_addcarryx_u32(x700, uint32(0x0), x723)
  var x726 uint32
  var x727 fiat_p384_uint1
  x726, x727 = fiat_p384_addcarryx_u32(x702, uint32(0x0), x725)
  var x728 uint32
  var x729 fiat_p384_uint1
  x728, x729 = fiat_p384_addcarryx_u32(x704, uint32(0x0), x727)
  var x730 uint32
  var x731 uint32
  x731, x730 = bits.Mul32(x706, 0xffffffff)
  var x732 uint32
  var x733 uint32
  x733, x732 = bits.Mul32(x706, 0xffffffff)
  var x734 uint32
  var x735 uint32
  x735, x734 = bits.Mul32(x706, 0xffffffff)
  var x736 uint32
  var x737 uint32
  x737, x736 = bits.Mul32(x706, 0xffffffff)
  var x738 uint32
  var x739 uint32
  x739, x738 = bits.Mul32(x706, 0xffffffff)
  var x740 uint32
  var x741 uint32
  x741, x740 = bits.Mul32(x706, 0xffffffff)
  var x742 uint32
  var x743 uint32
  x743, x742 = bits.Mul32(x706, 0xffffffff)
  var x744 uint32
  var x745 uint32
  x745, x744 = bits.Mul32(x706, 0xfffffffe)
  var x746 uint32
  var x747 uint32
  x747, x746 = bits.Mul32(x706, 0xffffffff)
  var x748 uint32
  var x749 uint32
  x749, x748 = bits.Mul32(x706, 0xffffffff)
  var x750 uint32
  var x751 fiat_p384_uint1
  x750, x751 = fiat_p384_addcarryx_u32(x747, x744, 0x0)
  var x752 uint32
  var x753 fiat_p384_uint1
  x752, x753 = fiat_p384_addcarryx_u32(x745, x742, x751)
  var x754 uint32
  var x755 fiat_p384_uint1
  x754, x755 = fiat_p384_addcarryx_u32(x743, x740, x753)
  var x756 uint32
  var x757 fiat_p384_uint1
  x756, x757 = fiat_p384_addcarryx_u32(x741, x738, x755)
  var x758 uint32
  var x759 fiat_p384_uint1
  x758, x759 = fiat_p384_addcarryx_u32(x739, x736, x757)
  var x760 uint32
  var x761 fiat_p384_uint1
  x760, x761 = fiat_p384_addcarryx_u32(x737, x734, x759)
  var x762 uint32
  var x763 fiat_p384_uint1
  x762, x763 = fiat_p384_addcarryx_u32(x735, x732, x761)
  var x764 uint32
  var x765 fiat_p384_uint1
  x764, x765 = fiat_p384_addcarryx_u32(x733, x730, x763)
  var x767 fiat_p384_uint1
  _, x767 = fiat_p384_addcarryx_u32(x706, x748, 0x0)
  var x768 uint32
  var x769 fiat_p384_uint1
  x768, x769 = fiat_p384_addcarryx_u32(x708, x749, x767)
  var x770 uint32
  var x771 fiat_p384_uint1
  x770, x771 = fiat_p384_addcarryx_u32(x710, uint32(0x0), x769)
  var x772 uint32
  var x773 fiat_p384_uint1
  x772, x773 = fiat_p384_addcarryx_u32(x712, x746, x771)
  var x774 uint32
  var x775 fiat_p384_uint1
  x774, x775 = fiat_p384_addcarryx_u32(x714, x750, x773)
  var x776 uint32
  var x777 fiat_p384_uint1
  x776, x777 = fiat_p384_addcarryx_u32(x716, x752, x775)
  var x778 uint32
  var x779 fiat_p384_uint1
  x778, x779 = fiat_p384_addcarryx_u32(x718, x754, x777)
  var x780 uint32
  var x781 fiat_p384_uint1
  x780, x781 = fiat_p384_addcarryx_u32(x720, x756, x779)
  var x782 uint32
  var x783 fiat_p384_uint1
  x782, x783 = fiat_p384_addcarryx_u32(x722, x758, x781)
  var x784 uint32
  var x785 fiat_p384_uint1
  x784, x785 = fiat_p384_addcarryx_u32(x724, x760, x783)
  var x786 uint32
  var x787 fiat_p384_uint1
  x786, x787 = fiat_p384_addcarryx_u32(x726, x762, x785)
  var x788 uint32
  var x789 fiat_p384_uint1
  x788, x789 = fiat_p384_addcarryx_u32(x728, x764, x787)
  var x790 uint32
  var x791 fiat_p384_uint1
  x790, x791 = fiat_p384_addcarryx_u32((uint32(x729) + uint32(x705)), (uint32(x765) + x731), x789)
  var x792 uint32
  var x793 fiat_p384_uint1
  x792, x793 = fiat_p384_addcarryx_u32(x768, (arg1[10]), 0x0)
  var x794 uint32
  var x795 fiat_p384_uint1
  x794, x795 = fiat_p384_addcarryx_u32(x770, uint32(0x0), x793)
  var x796 uint32
  var x797 fiat_p384_uint1
  x796, x797 = fiat_p384_addcarryx_u32(x772, uint32(0x0), x795)
  var x798 uint32
  var x799 fiat_p384_uint1
  x798, x799 = fiat_p384_addcarryx_u32(x774, uint32(0x0), x797)
  var x800 uint32
  var x801 fiat_p384_uint1
  x800, x801 = fiat_p384_addcarryx_u32(x776, uint32(0x0), x799)
  var x802 uint32
  var x803 fiat_p384_uint1
  x802, x803 = fiat_p384_addcarryx_u32(x778, uint32(0x0), x801)
  var x804 uint32
  var x805 fiat_p384_uint1
  x804, x805 = fiat_p384_addcarryx_u32(x780, uint32(0x0), x803)
  var x806 uint32
  var x807 fiat_p384_uint1
  x806, x807 = fiat_p384_addcarryx_u32(x782, uint32(0x0), x805)
  var x808 uint32
  var x809 fiat_p384_uint1
  x808, x809 = fiat_p384_addcarryx_u32(x784, uint32(0x0), x807)
  var x810 uint32
  var x811 fiat_p384_uint1
  x810, x811 = fiat_p384_addcarryx_u32(x786, uint32(0x0), x809)
  var x812 uint32
  var x813 fiat_p384_uint1
  x812, x813 = fiat_p384_addcarryx_u32(x788, uint32(0x0), x811)
  var x814 uint32
  var x815 fiat_p384_uint1
  x814, x815 = fiat_p384_addcarryx_u32(x790, uint32(0x0), x813)
  var x816 uint32
  var x817 uint32
  x817, x816 = bits.Mul32(x792, 0xffffffff)
  var x818 uint32
  var x819 uint32
  x819, x818 = bits.Mul32(x792, 0xffffffff)
  var x820 uint32
  var x821 uint32
  x821, x820 = bits.Mul32(x792, 0xffffffff)
  var x822 uint32
  var x823 uint32
  x823, x822 = bits.Mul32(x792, 0xffffffff)
  var x824 uint32
  var x825 uint32
  x825, x824 = bits.Mul32(x792, 0xffffffff)
  var x826 uint32
  var x827 uint32
  x827, x826 = bits.Mul32(x792, 0xffffffff)
  var x828 uint32
  var x829 uint32
  x829, x828 = bits.Mul32(x792, 0xffffffff)
  var x830 uint32
  var x831 uint32
  x831, x830 = bits.Mul32(x792, 0xfffffffe)
  var x832 uint32
  var x833 uint32
  x833, x832 = bits.Mul32(x792, 0xffffffff)
  var x834 uint32
  var x835 uint32
  x835, x834 = bits.Mul32(x792, 0xffffffff)
  var x836 uint32
  var x837 fiat_p384_uint1
  x836, x837 = fiat_p384_addcarryx_u32(x833, x830, 0x0)
  var x838 uint32
  var x839 fiat_p384_uint1
  x838, x839 = fiat_p384_addcarryx_u32(x831, x828, x837)
  var x840 uint32
  var x841 fiat_p384_uint1
  x840, x841 = fiat_p384_addcarryx_u32(x829, x826, x839)
  var x842 uint32
  var x843 fiat_p384_uint1
  x842, x843 = fiat_p384_addcarryx_u32(x827, x824, x841)
  var x844 uint32
  var x845 fiat_p384_uint1
  x844, x845 = fiat_p384_addcarryx_u32(x825, x822, x843)
  var x846 uint32
  var x847 fiat_p384_uint1
  x846, x847 = fiat_p384_addcarryx_u32(x823, x820, x845)
  var x848 uint32
  var x849 fiat_p384_uint1
  x848, x849 = fiat_p384_addcarryx_u32(x821, x818, x847)
  var x850 uint32
  var x851 fiat_p384_uint1
  x850, x851 = fiat_p384_addcarryx_u32(x819, x816, x849)
  var x853 fiat_p384_uint1
  _, x853 = fiat_p384_addcarryx_u32(x792, x834, 0x0)
  var x854 uint32
  var x855 fiat_p384_uint1
  x854, x855 = fiat_p384_addcarryx_u32(x794, x835, x853)
  var x856 uint32
  var x857 fiat_p384_uint1
  x856, x857 = fiat_p384_addcarryx_u32(x796, uint32(0x0), x855)
  var x858 uint32
  var x859 fiat_p384_uint1
  x858, x859 = fiat_p384_addcarryx_u32(x798, x832, x857)
  var x860 uint32
  var x861 fiat_p384_uint1
  x860, x861 = fiat_p384_addcarryx_u32(x800, x836, x859)
  var x862 uint32
  var x863 fiat_p384_uint1
  x862, x863 = fiat_p384_addcarryx_u32(x802, x838, x861)
  var x864 uint32
  var x865 fiat_p384_uint1
  x864, x865 = fiat_p384_addcarryx_u32(x804, x840, x863)
  var x866 uint32
  var x867 fiat_p384_uint1
  x866, x867 = fiat_p384_addcarryx_u32(x806, x842, x865)
  var x868 uint32
  var x869 fiat_p384_uint1
  x868, x869 = fiat_p384_addcarryx_u32(x808, x844, x867)
  var x870 uint32
  var x871 fiat_p384_uint1
  x870, x871 = fiat_p384_addcarryx_u32(x810, x846, x869)
  var x872 uint32
  var x873 fiat_p384_uint1
  x872, x873 = fiat_p384_addcarryx_u32(x812, x848, x871)
  var x874 uint32
  var x875 fiat_p384_uint1
  x874, x875 = fiat_p384_addcarryx_u32(x814, x850, x873)
  var x876 uint32
  var x877 fiat_p384_uint1
  x876, x877 = fiat_p384_addcarryx_u32((uint32(x815) + uint32(x791)), (uint32(x851) + x817), x875)
  var x878 uint32
  var x879 fiat_p384_uint1
  x878, x879 = fiat_p384_addcarryx_u32(x854, (arg1[11]), 0x0)
  var x880 uint32
  var x881 fiat_p384_uint1
  x880, x881 = fiat_p384_addcarryx_u32(x856, uint32(0x0), x879)
  var x882 uint32
  var x883 fiat_p384_uint1
  x882, x883 = fiat_p384_addcarryx_u32(x858, uint32(0x0), x881)
  var x884 uint32
  var x885 fiat_p384_uint1
  x884, x885 = fiat_p384_addcarryx_u32(x860, uint32(0x0), x883)
  var x886 uint32
  var x887 fiat_p384_uint1
  x886, x887 = fiat_p384_addcarryx_u32(x862, uint32(0x0), x885)
  var x888 uint32
  var x889 fiat_p384_uint1
  x888, x889 = fiat_p384_addcarryx_u32(x864, uint32(0x0), x887)
  var x890 uint32
  var x891 fiat_p384_uint1
  x890, x891 = fiat_p384_addcarryx_u32(x866, uint32(0x0), x889)
  var x892 uint32
  var x893 fiat_p384_uint1
  x892, x893 = fiat_p384_addcarryx_u32(x868, uint32(0x0), x891)
  var x894 uint32
  var x895 fiat_p384_uint1
  x894, x895 = fiat_p384_addcarryx_u32(x870, uint32(0x0), x893)
  var x896 uint32
  var x897 fiat_p384_uint1
  x896, x897 = fiat_p384_addcarryx_u32(x872, uint32(0x0), x895)
  var x898 uint32
  var x899 fiat_p384_uint1
  x898, x899 = fiat_p384_addcarryx_u32(x874, uint32(0x0), x897)
  var x900 uint32
  var x901 fiat_p384_uint1
  x900, x901 = fiat_p384_addcarryx_u32(x876, uint32(0x0), x899)
  var x902 uint32
  var x903 uint32
  x903, x902 = bits.Mul32(x878, 0xffffffff)
  var x904 uint32
  var x905 uint32
  x905, x904 = bits.Mul32(x878, 0xffffffff)
  var x906 uint32
  var x907 uint32
  x907, x906 = bits.Mul32(x878, 0xffffffff)
  var x908 uint32
  var x909 uint32
  x909, x908 = bits.Mul32(x878, 0xffffffff)
  var x910 uint32
  var x911 uint32
  x911, x910 = bits.Mul32(x878, 0xffffffff)
  var x912 uint32
  var x913 uint32
  x913, x912 = bits.Mul32(x878, 0xffffffff)
  var x914 uint32
  var x915 uint32
  x915, x914 = bits.Mul32(x878, 0xffffffff)
  var x916 uint32
  var x917 uint32
  x917, x916 = bits.Mul32(x878, 0xfffffffe)
  var x918 uint32
  var x919 uint32
  x919, x918 = bits.Mul32(x878, 0xffffffff)
  var x920 uint32
  var x921 uint32
  x921, x920 = bits.Mul32(x878, 0xffffffff)
  var x922 uint32
  var x923 fiat_p384_uint1
  x922, x923 = fiat_p384_addcarryx_u32(x919, x916, 0x0)
  var x924 uint32
  var x925 fiat_p384_uint1
  x924, x925 = fiat_p384_addcarryx_u32(x917, x914, x923)
  var x926 uint32
  var x927 fiat_p384_uint1
  x926, x927 = fiat_p384_addcarryx_u32(x915, x912, x925)
  var x928 uint32
  var x929 fiat_p384_uint1
  x928, x929 = fiat_p384_addcarryx_u32(x913, x910, x927)
  var x930 uint32
  var x931 fiat_p384_uint1
  x930, x931 = fiat_p384_addcarryx_u32(x911, x908, x929)
  var x932 uint32
  var x933 fiat_p384_uint1
  x932, x933 = fiat_p384_addcarryx_u32(x909, x906, x931)
  var x934 uint32
  var x935 fiat_p384_uint1
  x934, x935 = fiat_p384_addcarryx_u32(x907, x904, x933)
  var x936 uint32
  var x937 fiat_p384_uint1
  x936, x937 = fiat_p384_addcarryx_u32(x905, x902, x935)
  var x939 fiat_p384_uint1
  _, x939 = fiat_p384_addcarryx_u32(x878, x920, 0x0)
  var x940 uint32
  var x941 fiat_p384_uint1
  x940, x941 = fiat_p384_addcarryx_u32(x880, x921, x939)
  var x942 uint32
  var x943 fiat_p384_uint1
  x942, x943 = fiat_p384_addcarryx_u32(x882, uint32(0x0), x941)
  var x944 uint32
  var x945 fiat_p384_uint1
  x944, x945 = fiat_p384_addcarryx_u32(x884, x918, x943)
  var x946 uint32
  var x947 fiat_p384_uint1
  x946, x947 = fiat_p384_addcarryx_u32(x886, x922, x945)
  var x948 uint32
  var x949 fiat_p384_uint1
  x948, x949 = fiat_p384_addcarryx_u32(x888, x924, x947)
  var x950 uint32
  var x951 fiat_p384_uint1
  x950, x951 = fiat_p384_addcarryx_u32(x890, x926, x949)
  var x952 uint32
  var x953 fiat_p384_uint1
  x952, x953 = fiat_p384_addcarryx_u32(x892, x928, x951)
  var x954 uint32
  var x955 fiat_p384_uint1
  x954, x955 = fiat_p384_addcarryx_u32(x894, x930, x953)
  var x956 uint32
  var x957 fiat_p384_uint1
  x956, x957 = fiat_p384_addcarryx_u32(x896, x932, x955)
  var x958 uint32
  var x959 fiat_p384_uint1
  x958, x959 = fiat_p384_addcarryx_u32(x898, x934, x957)
  var x960 uint32
  var x961 fiat_p384_uint1
  x960, x961 = fiat_p384_addcarryx_u32(x900, x936, x959)
  var x962 uint32
  var x963 fiat_p384_uint1
  x962, x963 = fiat_p384_addcarryx_u32((uint32(x901) + uint32(x877)), (uint32(x937) + x903), x961)
  var x964 uint32
  var x965 fiat_p384_uint1
  x964, x965 = fiat_p384_subborrowx_u32(x940, 0xffffffff, 0x0)
  var x966 uint32
  var x967 fiat_p384_uint1
  x966, x967 = fiat_p384_subborrowx_u32(x942, uint32(0x0), x965)
  var x968 uint32
  var x969 fiat_p384_uint1
  x968, x969 = fiat_p384_subborrowx_u32(x944, uint32(0x0), x967)
  var x970 uint32
  var x971 fiat_p384_uint1
  x970, x971 = fiat_p384_subborrowx_u32(x946, 0xffffffff, x969)
  var x972 uint32
  var x973 fiat_p384_uint1
  x972, x973 = fiat_p384_subborrowx_u32(x948, 0xfffffffe, x971)
  var x974 uint32
  var x975 fiat_p384_uint1
  x974, x975 = fiat_p384_subborrowx_u32(x950, 0xffffffff, x973)
  var x976 uint32
  var x977 fiat_p384_uint1
  x976, x977 = fiat_p384_subborrowx_u32(x952, 0xffffffff, x975)
  var x978 uint32
  var x979 fiat_p384_uint1
  x978, x979 = fiat_p384_subborrowx_u32(x954, 0xffffffff, x977)
  var x980 uint32
  var x981 fiat_p384_uint1
  x980, x981 = fiat_p384_subborrowx_u32(x956, 0xffffffff, x979)
  var x982 uint32
  var x983 fiat_p384_uint1
  x982, x983 = fiat_p384_subborrowx_u32(x958, 0xffffffff, x981)
  var x984 uint32
  var x985 fiat_p384_uint1
  x984, x985 = fiat_p384_subborrowx_u32(x960, 0xffffffff, x983)
  var x986 uint32
  var x987 fiat_p384_uint1
  x986, x987 = fiat_p384_subborrowx_u32(x962, 0xffffffff, x985)
  var x989 fiat_p384_uint1
  _, x989 = fiat_p384_subborrowx_u32(uint32(x963), uint32(0x0), x987)
  var x990 uint32
  fiat_p384_cmovznz_u32(&x990, x989, x964, x940)
  var x991 uint32
  fiat_p384_cmovznz_u32(&x991, x989, x966, x942)
  var x992 uint32
  fiat_p384_cmovznz_u32(&x992, x989, x968, x944)
  var x993 uint32
  fiat_p384_cmovznz_u32(&x993, x989, x970, x946)
  var x994 uint32
  fiat_p384_cmovznz_u32(&x994, x989, x972, x948)
  var x995 uint32
  fiat_p384_cmovznz_u32(&x995, x989, x974, x950)
  var x996 uint32
  fiat_p384_cmovznz_u32(&x996, x989, x976, x952)
  var x997 uint32
  fiat_p384_cmovznz_u32(&x997, x989, x978, x954)
  var x998 uint32
  fiat_p384_cmovznz_u32(&x998, x989, x980, x956)
  var x999 uint32
  fiat_p384_cmovznz_u32(&x999, x989, x982, x958)
  var x1000 uint32
  fiat_p384_cmovznz_u32(&x1000, x989, x984, x960)
  var x1001 uint32
  fiat_p384_cmovznz_u32(&x1001, x989, x986, x962)
  out1[0] = x990
  out1[1] = x991
  out1[2] = x992
  out1[3] = x993
  out1[4] = x994
  out1[5] = x995
  out1[6] = x996
  out1[7] = x997
  out1[8] = x998
  out1[9] = x999
  out1[10] = x1000
  out1[11] = x1001
}

/*
 * The function fiat_p384_to_montgomery translates a field element into the Montgomery domain.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = eval arg1 mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
/*inline*/
func fiat_p384_to_montgomery(out1 *[12]uint32, arg1 *[12]uint32) {
  var x1 uint32 = (arg1[1])
  var x2 uint32 = (arg1[2])
  var x3 uint32 = (arg1[3])
  var x4 uint32 = (arg1[4])
  var x5 uint32 = (arg1[5])
  var x6 uint32 = (arg1[6])
  var x7 uint32 = (arg1[7])
  var x8 uint32 = (arg1[8])
  var x9 uint32 = (arg1[9])
  var x10 uint32 = (arg1[10])
  var x11 uint32 = (arg1[11])
  var x12 uint32 = (arg1[0])
  var x13 uint32
  var x14 uint32
  x14, x13 = bits.Mul32(x12, 0x2)
  var x15 uint32
  var x16 uint32
  x16, x15 = bits.Mul32(x12, 0xfffffffe)
  var x17 uint32
  var x18 uint32
  x18, x17 = bits.Mul32(x12, 0x2)
  var x19 uint32
  var x20 uint32
  x20, x19 = bits.Mul32(x12, 0xfffffffe)
  var x21 uint32
  var x22 fiat_p384_uint1
  x21, x22 = fiat_p384_addcarryx_u32(uint32(fiat_p384_uint1(x14)), x12, 0x0)
  var x23 uint32
  var x24 uint32
  x24, x23 = bits.Mul32(x12, 0xffffffff)
  var x25 uint32
  var x26 uint32
  x26, x25 = bits.Mul32(x12, 0xffffffff)
  var x27 uint32
  var x28 uint32
  x28, x27 = bits.Mul32(x12, 0xffffffff)
  var x29 uint32
  var x30 uint32
  x30, x29 = bits.Mul32(x12, 0xffffffff)
  var x31 uint32
  var x32 uint32
  x32, x31 = bits.Mul32(x12, 0xffffffff)
  var x33 uint32
  var x34 uint32
  x34, x33 = bits.Mul32(x12, 0xffffffff)
  var x35 uint32
  var x36 uint32
  x36, x35 = bits.Mul32(x12, 0xffffffff)
  var x37 uint32
  var x38 uint32
  x38, x37 = bits.Mul32(x12, 0xfffffffe)
  var x39 uint32
  var x40 uint32
  x40, x39 = bits.Mul32(x12, 0xffffffff)
  var x41 uint32
  var x42 uint32
  x42, x41 = bits.Mul32(x12, 0xffffffff)
  var x43 uint32
  var x44 fiat_p384_uint1
  x43, x44 = fiat_p384_addcarryx_u32(x40, x37, 0x0)
  var x45 uint32
  var x46 fiat_p384_uint1
  x45, x46 = fiat_p384_addcarryx_u32(x38, x35, x44)
  var x47 uint32
  var x48 fiat_p384_uint1
  x47, x48 = fiat_p384_addcarryx_u32(x36, x33, x46)
  var x49 uint32
  var x50 fiat_p384_uint1
  x49, x50 = fiat_p384_addcarryx_u32(x34, x31, x48)
  var x51 uint32
  var x52 fiat_p384_uint1
  x51, x52 = fiat_p384_addcarryx_u32(x32, x29, x50)
  var x53 uint32
  var x54 fiat_p384_uint1
  x53, x54 = fiat_p384_addcarryx_u32(x30, x27, x52)
  var x55 uint32
  var x56 fiat_p384_uint1
  x55, x56 = fiat_p384_addcarryx_u32(x28, x25, x54)
  var x57 uint32
  var x58 fiat_p384_uint1
  x57, x58 = fiat_p384_addcarryx_u32(x26, x23, x56)
  var x60 fiat_p384_uint1
  _, x60 = fiat_p384_addcarryx_u32(x12, x41, 0x0)
  var x61 uint32
  var x62 fiat_p384_uint1
  x61, x62 = fiat_p384_addcarryx_u32(x19, x42, x60)
  var x63 uint32
  var x64 fiat_p384_uint1
  x63, x64 = fiat_p384_addcarryx_u32(x17, x39, 0x0)
  var x65 uint32
  var x66 fiat_p384_uint1
  x65, x66 = fiat_p384_addcarryx_u32(uint32(fiat_p384_uint1(x18)), x43, x64)
  var x67 uint32
  var x68 fiat_p384_uint1
  x67, x68 = fiat_p384_addcarryx_u32(x15, x45, x66)
  var x69 uint32
  var x70 fiat_p384_uint1
  x69, x70 = fiat_p384_addcarryx_u32(x16, x47, x68)
  var x71 uint32
  var x72 fiat_p384_uint1
  x71, x72 = fiat_p384_addcarryx_u32(x13, x49, x70)
  var x73 uint32
  var x74 fiat_p384_uint1
  x73, x74 = fiat_p384_addcarryx_u32(x21, x51, x72)
  var x75 uint32
  var x76 fiat_p384_uint1
  x75, x76 = fiat_p384_addcarryx_u32(uint32(x22), x53, x74)
  var x77 uint32
  var x78 fiat_p384_uint1
  x77, x78 = fiat_p384_addcarryx_u32(uint32(0x0), x55, x76)
  var x79 uint32
  var x80 fiat_p384_uint1
  x79, x80 = fiat_p384_addcarryx_u32(uint32(0x0), x57, x78)
  var x81 uint32
  var x82 fiat_p384_uint1
  x81, x82 = fiat_p384_addcarryx_u32(uint32(0x0), (uint32(x58) + x24), x80)
  var x83 uint32
  var x84 uint32
  x84, x83 = bits.Mul32(x1, 0x2)
  var x85 uint32
  var x86 uint32
  x86, x85 = bits.Mul32(x1, 0xfffffffe)
  var x87 uint32
  var x88 uint32
  x88, x87 = bits.Mul32(x1, 0x2)
  var x89 uint32
  var x90 uint32
  x90, x89 = bits.Mul32(x1, 0xfffffffe)
  var x91 uint32
  var x92 fiat_p384_uint1
  x91, x92 = fiat_p384_addcarryx_u32(uint32(fiat_p384_uint1(x84)), x1, 0x0)
  var x93 uint32
  var x94 fiat_p384_uint1
  x93, x94 = fiat_p384_addcarryx_u32(x61, x1, 0x0)
  var x95 uint32
  var x96 fiat_p384_uint1
  x95, x96 = fiat_p384_addcarryx_u32((uint32(x62) + x20), x89, x94)
  var x97 uint32
  var x98 fiat_p384_uint1
  x97, x98 = fiat_p384_addcarryx_u32(x63, x90, x96)
  var x99 uint32
  var x100 fiat_p384_uint1
  x99, x100 = fiat_p384_addcarryx_u32(x65, x87, x98)
  var x101 uint32
  var x102 fiat_p384_uint1
  x101, x102 = fiat_p384_addcarryx_u32(x67, uint32(fiat_p384_uint1(x88)), x100)
  var x103 uint32
  var x104 fiat_p384_uint1
  x103, x104 = fiat_p384_addcarryx_u32(x69, x85, x102)
  var x105 uint32
  var x106 fiat_p384_uint1
  x105, x106 = fiat_p384_addcarryx_u32(x71, x86, x104)
  var x107 uint32
  var x108 fiat_p384_uint1
  x107, x108 = fiat_p384_addcarryx_u32(x73, x83, x106)
  var x109 uint32
  var x110 fiat_p384_uint1
  x109, x110 = fiat_p384_addcarryx_u32(x75, x91, x108)
  var x111 uint32
  var x112 fiat_p384_uint1
  x111, x112 = fiat_p384_addcarryx_u32(x77, uint32(x92), x110)
  var x113 uint32
  var x114 fiat_p384_uint1
  x113, x114 = fiat_p384_addcarryx_u32(x79, uint32(0x0), x112)
  var x115 uint32
  var x116 fiat_p384_uint1
  x115, x116 = fiat_p384_addcarryx_u32(x81, uint32(0x0), x114)
  var x117 uint32
  var x118 uint32
  x118, x117 = bits.Mul32(x93, 0xffffffff)
  var x119 uint32
  var x120 uint32
  x120, x119 = bits.Mul32(x93, 0xffffffff)
  var x121 uint32
  var x122 uint32
  x122, x121 = bits.Mul32(x93, 0xffffffff)
  var x123 uint32
  var x124 uint32
  x124, x123 = bits.Mul32(x93, 0xffffffff)
  var x125 uint32
  var x126 uint32
  x126, x125 = bits.Mul32(x93, 0xffffffff)
  var x127 uint32
  var x128 uint32
  x128, x127 = bits.Mul32(x93, 0xffffffff)
  var x129 uint32
  var x130 uint32
  x130, x129 = bits.Mul32(x93, 0xffffffff)
  var x131 uint32
  var x132 uint32
  x132, x131 = bits.Mul32(x93, 0xfffffffe)
  var x133 uint32
  var x134 uint32
  x134, x133 = bits.Mul32(x93, 0xffffffff)
  var x135 uint32
  var x136 uint32
  x136, x135 = bits.Mul32(x93, 0xffffffff)
  var x137 uint32
  var x138 fiat_p384_uint1
  x137, x138 = fiat_p384_addcarryx_u32(x134, x131, 0x0)
  var x139 uint32
  var x140 fiat_p384_uint1
  x139, x140 = fiat_p384_addcarryx_u32(x132, x129, x138)
  var x141 uint32
  var x142 fiat_p384_uint1
  x141, x142 = fiat_p384_addcarryx_u32(x130, x127, x140)
  var x143 uint32
  var x144 fiat_p384_uint1
  x143, x144 = fiat_p384_addcarryx_u32(x128, x125, x142)
  var x145 uint32
  var x146 fiat_p384_uint1
  x145, x146 = fiat_p384_addcarryx_u32(x126, x123, x144)
  var x147 uint32
  var x148 fiat_p384_uint1
  x147, x148 = fiat_p384_addcarryx_u32(x124, x121, x146)
  var x149 uint32
  var x150 fiat_p384_uint1
  x149, x150 = fiat_p384_addcarryx_u32(x122, x119, x148)
  var x151 uint32
  var x152 fiat_p384_uint1
  x151, x152 = fiat_p384_addcarryx_u32(x120, x117, x150)
  var x154 fiat_p384_uint1
  _, x154 = fiat_p384_addcarryx_u32(x93, x135, 0x0)
  var x155 uint32
  var x156 fiat_p384_uint1
  x155, x156 = fiat_p384_addcarryx_u32(x95, x136, x154)
  var x157 uint32
  var x158 fiat_p384_uint1
  x157, x158 = fiat_p384_addcarryx_u32(x97, uint32(0x0), x156)
  var x159 uint32
  var x160 fiat_p384_uint1
  x159, x160 = fiat_p384_addcarryx_u32(x99, x133, x158)
  var x161 uint32
  var x162 fiat_p384_uint1
  x161, x162 = fiat_p384_addcarryx_u32(x101, x137, x160)
  var x163 uint32
  var x164 fiat_p384_uint1
  x163, x164 = fiat_p384_addcarryx_u32(x103, x139, x162)
  var x165 uint32
  var x166 fiat_p384_uint1
  x165, x166 = fiat_p384_addcarryx_u32(x105, x141, x164)
  var x167 uint32
  var x168 fiat_p384_uint1
  x167, x168 = fiat_p384_addcarryx_u32(x107, x143, x166)
  var x169 uint32
  var x170 fiat_p384_uint1
  x169, x170 = fiat_p384_addcarryx_u32(x109, x145, x168)
  var x171 uint32
  var x172 fiat_p384_uint1
  x171, x172 = fiat_p384_addcarryx_u32(x111, x147, x170)
  var x173 uint32
  var x174 fiat_p384_uint1
  x173, x174 = fiat_p384_addcarryx_u32(x113, x149, x172)
  var x175 uint32
  var x176 fiat_p384_uint1
  x175, x176 = fiat_p384_addcarryx_u32(x115, x151, x174)
  var x177 uint32
  var x178 fiat_p384_uint1
  x177, x178 = fiat_p384_addcarryx_u32((uint32(x116) + uint32(x82)), (uint32(x152) + x118), x176)
  var x179 uint32
  var x180 uint32
  x180, x179 = bits.Mul32(x2, 0x2)
  var x181 uint32
  var x182 uint32
  x182, x181 = bits.Mul32(x2, 0xfffffffe)
  var x183 uint32
  var x184 uint32
  x184, x183 = bits.Mul32(x2, 0x2)
  var x185 uint32
  var x186 uint32
  x186, x185 = bits.Mul32(x2, 0xfffffffe)
  var x187 uint32
  var x188 fiat_p384_uint1
  x187, x188 = fiat_p384_addcarryx_u32(uint32(fiat_p384_uint1(x180)), x2, 0x0)
  var x189 uint32
  var x190 fiat_p384_uint1
  x189, x190 = fiat_p384_addcarryx_u32(x155, x2, 0x0)
  var x191 uint32
  var x192 fiat_p384_uint1
  x191, x192 = fiat_p384_addcarryx_u32(x157, x185, x190)
  var x193 uint32
  var x194 fiat_p384_uint1
  x193, x194 = fiat_p384_addcarryx_u32(x159, x186, x192)
  var x195 uint32
  var x196 fiat_p384_uint1
  x195, x196 = fiat_p384_addcarryx_u32(x161, x183, x194)
  var x197 uint32
  var x198 fiat_p384_uint1
  x197, x198 = fiat_p384_addcarryx_u32(x163, uint32(fiat_p384_uint1(x184)), x196)
  var x199 uint32
  var x200 fiat_p384_uint1
  x199, x200 = fiat_p384_addcarryx_u32(x165, x181, x198)
  var x201 uint32
  var x202 fiat_p384_uint1
  x201, x202 = fiat_p384_addcarryx_u32(x167, x182, x200)
  var x203 uint32
  var x204 fiat_p384_uint1
  x203, x204 = fiat_p384_addcarryx_u32(x169, x179, x202)
  var x205 uint32
  var x206 fiat_p384_uint1
  x205, x206 = fiat_p384_addcarryx_u32(x171, x187, x204)
  var x207 uint32
  var x208 fiat_p384_uint1
  x207, x208 = fiat_p384_addcarryx_u32(x173, uint32(x188), x206)
  var x209 uint32
  var x210 fiat_p384_uint1
  x209, x210 = fiat_p384_addcarryx_u32(x175, uint32(0x0), x208)
  var x211 uint32
  var x212 fiat_p384_uint1
  x211, x212 = fiat_p384_addcarryx_u32(x177, uint32(0x0), x210)
  var x213 uint32
  var x214 uint32
  x214, x213 = bits.Mul32(x189, 0xffffffff)
  var x215 uint32
  var x216 uint32
  x216, x215 = bits.Mul32(x189, 0xffffffff)
  var x217 uint32
  var x218 uint32
  x218, x217 = bits.Mul32(x189, 0xffffffff)
  var x219 uint32
  var x220 uint32
  x220, x219 = bits.Mul32(x189, 0xffffffff)
  var x221 uint32
  var x222 uint32
  x222, x221 = bits.Mul32(x189, 0xffffffff)
  var x223 uint32
  var x224 uint32
  x224, x223 = bits.Mul32(x189, 0xffffffff)
  var x225 uint32
  var x226 uint32
  x226, x225 = bits.Mul32(x189, 0xffffffff)
  var x227 uint32
  var x228 uint32
  x228, x227 = bits.Mul32(x189, 0xfffffffe)
  var x229 uint32
  var x230 uint32
  x230, x229 = bits.Mul32(x189, 0xffffffff)
  var x231 uint32
  var x232 uint32
  x232, x231 = bits.Mul32(x189, 0xffffffff)
  var x233 uint32
  var x234 fiat_p384_uint1
  x233, x234 = fiat_p384_addcarryx_u32(x230, x227, 0x0)
  var x235 uint32
  var x236 fiat_p384_uint1
  x235, x236 = fiat_p384_addcarryx_u32(x228, x225, x234)
  var x237 uint32
  var x238 fiat_p384_uint1
  x237, x238 = fiat_p384_addcarryx_u32(x226, x223, x236)
  var x239 uint32
  var x240 fiat_p384_uint1
  x239, x240 = fiat_p384_addcarryx_u32(x224, x221, x238)
  var x241 uint32
  var x242 fiat_p384_uint1
  x241, x242 = fiat_p384_addcarryx_u32(x222, x219, x240)
  var x243 uint32
  var x244 fiat_p384_uint1
  x243, x244 = fiat_p384_addcarryx_u32(x220, x217, x242)
  var x245 uint32
  var x246 fiat_p384_uint1
  x245, x246 = fiat_p384_addcarryx_u32(x218, x215, x244)
  var x247 uint32
  var x248 fiat_p384_uint1
  x247, x248 = fiat_p384_addcarryx_u32(x216, x213, x246)
  var x250 fiat_p384_uint1
  _, x250 = fiat_p384_addcarryx_u32(x189, x231, 0x0)
  var x251 uint32
  var x252 fiat_p384_uint1
  x251, x252 = fiat_p384_addcarryx_u32(x191, x232, x250)
  var x253 uint32
  var x254 fiat_p384_uint1
  x253, x254 = fiat_p384_addcarryx_u32(x193, uint32(0x0), x252)
  var x255 uint32
  var x256 fiat_p384_uint1
  x255, x256 = fiat_p384_addcarryx_u32(x195, x229, x254)
  var x257 uint32
  var x258 fiat_p384_uint1
  x257, x258 = fiat_p384_addcarryx_u32(x197, x233, x256)
  var x259 uint32
  var x260 fiat_p384_uint1
  x259, x260 = fiat_p384_addcarryx_u32(x199, x235, x258)
  var x261 uint32
  var x262 fiat_p384_uint1
  x261, x262 = fiat_p384_addcarryx_u32(x201, x237, x260)
  var x263 uint32
  var x264 fiat_p384_uint1
  x263, x264 = fiat_p384_addcarryx_u32(x203, x239, x262)
  var x265 uint32
  var x266 fiat_p384_uint1
  x265, x266 = fiat_p384_addcarryx_u32(x205, x241, x264)
  var x267 uint32
  var x268 fiat_p384_uint1
  x267, x268 = fiat_p384_addcarryx_u32(x207, x243, x266)
  var x269 uint32
  var x270 fiat_p384_uint1
  x269, x270 = fiat_p384_addcarryx_u32(x209, x245, x268)
  var x271 uint32
  var x272 fiat_p384_uint1
  x271, x272 = fiat_p384_addcarryx_u32(x211, x247, x270)
  var x273 uint32
  var x274 fiat_p384_uint1
  x273, x274 = fiat_p384_addcarryx_u32((uint32(x212) + uint32(x178)), (uint32(x248) + x214), x272)
  var x275 uint32
  var x276 uint32
  x276, x275 = bits.Mul32(x3, 0x2)
  var x277 uint32
  var x278 uint32
  x278, x277 = bits.Mul32(x3, 0xfffffffe)
  var x279 uint32
  var x280 uint32
  x280, x279 = bits.Mul32(x3, 0x2)
  var x281 uint32
  var x282 uint32
  x282, x281 = bits.Mul32(x3, 0xfffffffe)
  var x283 uint32
  var x284 fiat_p384_uint1
  x283, x284 = fiat_p384_addcarryx_u32(uint32(fiat_p384_uint1(x276)), x3, 0x0)
  var x285 uint32
  var x286 fiat_p384_uint1
  x285, x286 = fiat_p384_addcarryx_u32(x251, x3, 0x0)
  var x287 uint32
  var x288 fiat_p384_uint1
  x287, x288 = fiat_p384_addcarryx_u32(x253, x281, x286)
  var x289 uint32
  var x290 fiat_p384_uint1
  x289, x290 = fiat_p384_addcarryx_u32(x255, x282, x288)
  var x291 uint32
  var x292 fiat_p384_uint1
  x291, x292 = fiat_p384_addcarryx_u32(x257, x279, x290)
  var x293 uint32
  var x294 fiat_p384_uint1
  x293, x294 = fiat_p384_addcarryx_u32(x259, uint32(fiat_p384_uint1(x280)), x292)
  var x295 uint32
  var x296 fiat_p384_uint1
  x295, x296 = fiat_p384_addcarryx_u32(x261, x277, x294)
  var x297 uint32
  var x298 fiat_p384_uint1
  x297, x298 = fiat_p384_addcarryx_u32(x263, x278, x296)
  var x299 uint32
  var x300 fiat_p384_uint1
  x299, x300 = fiat_p384_addcarryx_u32(x265, x275, x298)
  var x301 uint32
  var x302 fiat_p384_uint1
  x301, x302 = fiat_p384_addcarryx_u32(x267, x283, x300)
  var x303 uint32
  var x304 fiat_p384_uint1
  x303, x304 = fiat_p384_addcarryx_u32(x269, uint32(x284), x302)
  var x305 uint32
  var x306 fiat_p384_uint1
  x305, x306 = fiat_p384_addcarryx_u32(x271, uint32(0x0), x304)
  var x307 uint32
  var x308 fiat_p384_uint1
  x307, x308 = fiat_p384_addcarryx_u32(x273, uint32(0x0), x306)
  var x309 uint32
  var x310 uint32
  x310, x309 = bits.Mul32(x285, 0xffffffff)
  var x311 uint32
  var x312 uint32
  x312, x311 = bits.Mul32(x285, 0xffffffff)
  var x313 uint32
  var x314 uint32
  x314, x313 = bits.Mul32(x285, 0xffffffff)
  var x315 uint32
  var x316 uint32
  x316, x315 = bits.Mul32(x285, 0xffffffff)
  var x317 uint32
  var x318 uint32
  x318, x317 = bits.Mul32(x285, 0xffffffff)
  var x319 uint32
  var x320 uint32
  x320, x319 = bits.Mul32(x285, 0xffffffff)
  var x321 uint32
  var x322 uint32
  x322, x321 = bits.Mul32(x285, 0xffffffff)
  var x323 uint32
  var x324 uint32
  x324, x323 = bits.Mul32(x285, 0xfffffffe)
  var x325 uint32
  var x326 uint32
  x326, x325 = bits.Mul32(x285, 0xffffffff)
  var x327 uint32
  var x328 uint32
  x328, x327 = bits.Mul32(x285, 0xffffffff)
  var x329 uint32
  var x330 fiat_p384_uint1
  x329, x330 = fiat_p384_addcarryx_u32(x326, x323, 0x0)
  var x331 uint32
  var x332 fiat_p384_uint1
  x331, x332 = fiat_p384_addcarryx_u32(x324, x321, x330)
  var x333 uint32
  var x334 fiat_p384_uint1
  x333, x334 = fiat_p384_addcarryx_u32(x322, x319, x332)
  var x335 uint32
  var x336 fiat_p384_uint1
  x335, x336 = fiat_p384_addcarryx_u32(x320, x317, x334)
  var x337 uint32
  var x338 fiat_p384_uint1
  x337, x338 = fiat_p384_addcarryx_u32(x318, x315, x336)
  var x339 uint32
  var x340 fiat_p384_uint1
  x339, x340 = fiat_p384_addcarryx_u32(x316, x313, x338)
  var x341 uint32
  var x342 fiat_p384_uint1
  x341, x342 = fiat_p384_addcarryx_u32(x314, x311, x340)
  var x343 uint32
  var x344 fiat_p384_uint1
  x343, x344 = fiat_p384_addcarryx_u32(x312, x309, x342)
  var x346 fiat_p384_uint1
  _, x346 = fiat_p384_addcarryx_u32(x285, x327, 0x0)
  var x347 uint32
  var x348 fiat_p384_uint1
  x347, x348 = fiat_p384_addcarryx_u32(x287, x328, x346)
  var x349 uint32
  var x350 fiat_p384_uint1
  x349, x350 = fiat_p384_addcarryx_u32(x289, uint32(0x0), x348)
  var x351 uint32
  var x352 fiat_p384_uint1
  x351, x352 = fiat_p384_addcarryx_u32(x291, x325, x350)
  var x353 uint32
  var x354 fiat_p384_uint1
  x353, x354 = fiat_p384_addcarryx_u32(x293, x329, x352)
  var x355 uint32
  var x356 fiat_p384_uint1
  x355, x356 = fiat_p384_addcarryx_u32(x295, x331, x354)
  var x357 uint32
  var x358 fiat_p384_uint1
  x357, x358 = fiat_p384_addcarryx_u32(x297, x333, x356)
  var x359 uint32
  var x360 fiat_p384_uint1
  x359, x360 = fiat_p384_addcarryx_u32(x299, x335, x358)
  var x361 uint32
  var x362 fiat_p384_uint1
  x361, x362 = fiat_p384_addcarryx_u32(x301, x337, x360)
  var x363 uint32
  var x364 fiat_p384_uint1
  x363, x364 = fiat_p384_addcarryx_u32(x303, x339, x362)
  var x365 uint32
  var x366 fiat_p384_uint1
  x365, x366 = fiat_p384_addcarryx_u32(x305, x341, x364)
  var x367 uint32
  var x368 fiat_p384_uint1
  x367, x368 = fiat_p384_addcarryx_u32(x307, x343, x366)
  var x369 uint32
  var x370 fiat_p384_uint1
  x369, x370 = fiat_p384_addcarryx_u32((uint32(x308) + uint32(x274)), (uint32(x344) + x310), x368)
  var x371 uint32
  var x372 uint32
  x372, x371 = bits.Mul32(x4, 0x2)
  var x373 uint32
  var x374 uint32
  x374, x373 = bits.Mul32(x4, 0xfffffffe)
  var x375 uint32
  var x376 uint32
  x376, x375 = bits.Mul32(x4, 0x2)
  var x377 uint32
  var x378 uint32
  x378, x377 = bits.Mul32(x4, 0xfffffffe)
  var x379 uint32
  var x380 fiat_p384_uint1
  x379, x380 = fiat_p384_addcarryx_u32(uint32(fiat_p384_uint1(x372)), x4, 0x0)
  var x381 uint32
  var x382 fiat_p384_uint1
  x381, x382 = fiat_p384_addcarryx_u32(x347, x4, 0x0)
  var x383 uint32
  var x384 fiat_p384_uint1
  x383, x384 = fiat_p384_addcarryx_u32(x349, x377, x382)
  var x385 uint32
  var x386 fiat_p384_uint1
  x385, x386 = fiat_p384_addcarryx_u32(x351, x378, x384)
  var x387 uint32
  var x388 fiat_p384_uint1
  x387, x388 = fiat_p384_addcarryx_u32(x353, x375, x386)
  var x389 uint32
  var x390 fiat_p384_uint1
  x389, x390 = fiat_p384_addcarryx_u32(x355, uint32(fiat_p384_uint1(x376)), x388)
  var x391 uint32
  var x392 fiat_p384_uint1
  x391, x392 = fiat_p384_addcarryx_u32(x357, x373, x390)
  var x393 uint32
  var x394 fiat_p384_uint1
  x393, x394 = fiat_p384_addcarryx_u32(x359, x374, x392)
  var x395 uint32
  var x396 fiat_p384_uint1
  x395, x396 = fiat_p384_addcarryx_u32(x361, x371, x394)
  var x397 uint32
  var x398 fiat_p384_uint1
  x397, x398 = fiat_p384_addcarryx_u32(x363, x379, x396)
  var x399 uint32
  var x400 fiat_p384_uint1
  x399, x400 = fiat_p384_addcarryx_u32(x365, uint32(x380), x398)
  var x401 uint32
  var x402 fiat_p384_uint1
  x401, x402 = fiat_p384_addcarryx_u32(x367, uint32(0x0), x400)
  var x403 uint32
  var x404 fiat_p384_uint1
  x403, x404 = fiat_p384_addcarryx_u32(x369, uint32(0x0), x402)
  var x405 uint32
  var x406 uint32
  x406, x405 = bits.Mul32(x381, 0xffffffff)
  var x407 uint32
  var x408 uint32
  x408, x407 = bits.Mul32(x381, 0xffffffff)
  var x409 uint32
  var x410 uint32
  x410, x409 = bits.Mul32(x381, 0xffffffff)
  var x411 uint32
  var x412 uint32
  x412, x411 = bits.Mul32(x381, 0xffffffff)
  var x413 uint32
  var x414 uint32
  x414, x413 = bits.Mul32(x381, 0xffffffff)
  var x415 uint32
  var x416 uint32
  x416, x415 = bits.Mul32(x381, 0xffffffff)
  var x417 uint32
  var x418 uint32
  x418, x417 = bits.Mul32(x381, 0xffffffff)
  var x419 uint32
  var x420 uint32
  x420, x419 = bits.Mul32(x381, 0xfffffffe)
  var x421 uint32
  var x422 uint32
  x422, x421 = bits.Mul32(x381, 0xffffffff)
  var x423 uint32
  var x424 uint32
  x424, x423 = bits.Mul32(x381, 0xffffffff)
  var x425 uint32
  var x426 fiat_p384_uint1
  x425, x426 = fiat_p384_addcarryx_u32(x422, x419, 0x0)
  var x427 uint32
  var x428 fiat_p384_uint1
  x427, x428 = fiat_p384_addcarryx_u32(x420, x417, x426)
  var x429 uint32
  var x430 fiat_p384_uint1
  x429, x430 = fiat_p384_addcarryx_u32(x418, x415, x428)
  var x431 uint32
  var x432 fiat_p384_uint1
  x431, x432 = fiat_p384_addcarryx_u32(x416, x413, x430)
  var x433 uint32
  var x434 fiat_p384_uint1
  x433, x434 = fiat_p384_addcarryx_u32(x414, x411, x432)
  var x435 uint32
  var x436 fiat_p384_uint1
  x435, x436 = fiat_p384_addcarryx_u32(x412, x409, x434)
  var x437 uint32
  var x438 fiat_p384_uint1
  x437, x438 = fiat_p384_addcarryx_u32(x410, x407, x436)
  var x439 uint32
  var x440 fiat_p384_uint1
  x439, x440 = fiat_p384_addcarryx_u32(x408, x405, x438)
  var x442 fiat_p384_uint1
  _, x442 = fiat_p384_addcarryx_u32(x381, x423, 0x0)
  var x443 uint32
  var x444 fiat_p384_uint1
  x443, x444 = fiat_p384_addcarryx_u32(x383, x424, x442)
  var x445 uint32
  var x446 fiat_p384_uint1
  x445, x446 = fiat_p384_addcarryx_u32(x385, uint32(0x0), x444)
  var x447 uint32
  var x448 fiat_p384_uint1
  x447, x448 = fiat_p384_addcarryx_u32(x387, x421, x446)
  var x449 uint32
  var x450 fiat_p384_uint1
  x449, x450 = fiat_p384_addcarryx_u32(x389, x425, x448)
  var x451 uint32
  var x452 fiat_p384_uint1
  x451, x452 = fiat_p384_addcarryx_u32(x391, x427, x450)
  var x453 uint32
  var x454 fiat_p384_uint1
  x453, x454 = fiat_p384_addcarryx_u32(x393, x429, x452)
  var x455 uint32
  var x456 fiat_p384_uint1
  x455, x456 = fiat_p384_addcarryx_u32(x395, x431, x454)
  var x457 uint32
  var x458 fiat_p384_uint1
  x457, x458 = fiat_p384_addcarryx_u32(x397, x433, x456)
  var x459 uint32
  var x460 fiat_p384_uint1
  x459, x460 = fiat_p384_addcarryx_u32(x399, x435, x458)
  var x461 uint32
  var x462 fiat_p384_uint1
  x461, x462 = fiat_p384_addcarryx_u32(x401, x437, x460)
  var x463 uint32
  var x464 fiat_p384_uint1
  x463, x464 = fiat_p384_addcarryx_u32(x403, x439, x462)
  var x465 uint32
  var x466 fiat_p384_uint1
  x465, x466 = fiat_p384_addcarryx_u32((uint32(x404) + uint32(x370)), (uint32(x440) + x406), x464)
  var x467 uint32
  var x468 uint32
  x468, x467 = bits.Mul32(x5, 0x2)
  var x469 uint32
  var x470 uint32
  x470, x469 = bits.Mul32(x5, 0xfffffffe)
  var x471 uint32
  var x472 uint32
  x472, x471 = bits.Mul32(x5, 0x2)
  var x473 uint32
  var x474 uint32
  x474, x473 = bits.Mul32(x5, 0xfffffffe)
  var x475 uint32
  var x476 fiat_p384_uint1
  x475, x476 = fiat_p384_addcarryx_u32(uint32(fiat_p384_uint1(x468)), x5, 0x0)
  var x477 uint32
  var x478 fiat_p384_uint1
  x477, x478 = fiat_p384_addcarryx_u32(x443, x5, 0x0)
  var x479 uint32
  var x480 fiat_p384_uint1
  x479, x480 = fiat_p384_addcarryx_u32(x445, x473, x478)
  var x481 uint32
  var x482 fiat_p384_uint1
  x481, x482 = fiat_p384_addcarryx_u32(x447, x474, x480)
  var x483 uint32
  var x484 fiat_p384_uint1
  x483, x484 = fiat_p384_addcarryx_u32(x449, x471, x482)
  var x485 uint32
  var x486 fiat_p384_uint1
  x485, x486 = fiat_p384_addcarryx_u32(x451, uint32(fiat_p384_uint1(x472)), x484)
  var x487 uint32
  var x488 fiat_p384_uint1
  x487, x488 = fiat_p384_addcarryx_u32(x453, x469, x486)
  var x489 uint32
  var x490 fiat_p384_uint1
  x489, x490 = fiat_p384_addcarryx_u32(x455, x470, x488)
  var x491 uint32
  var x492 fiat_p384_uint1
  x491, x492 = fiat_p384_addcarryx_u32(x457, x467, x490)
  var x493 uint32
  var x494 fiat_p384_uint1
  x493, x494 = fiat_p384_addcarryx_u32(x459, x475, x492)
  var x495 uint32
  var x496 fiat_p384_uint1
  x495, x496 = fiat_p384_addcarryx_u32(x461, uint32(x476), x494)
  var x497 uint32
  var x498 fiat_p384_uint1
  x497, x498 = fiat_p384_addcarryx_u32(x463, uint32(0x0), x496)
  var x499 uint32
  var x500 fiat_p384_uint1
  x499, x500 = fiat_p384_addcarryx_u32(x465, uint32(0x0), x498)
  var x501 uint32
  var x502 uint32
  x502, x501 = bits.Mul32(x477, 0xffffffff)
  var x503 uint32
  var x504 uint32
  x504, x503 = bits.Mul32(x477, 0xffffffff)
  var x505 uint32
  var x506 uint32
  x506, x505 = bits.Mul32(x477, 0xffffffff)
  var x507 uint32
  var x508 uint32
  x508, x507 = bits.Mul32(x477, 0xffffffff)
  var x509 uint32
  var x510 uint32
  x510, x509 = bits.Mul32(x477, 0xffffffff)
  var x511 uint32
  var x512 uint32
  x512, x511 = bits.Mul32(x477, 0xffffffff)
  var x513 uint32
  var x514 uint32
  x514, x513 = bits.Mul32(x477, 0xffffffff)
  var x515 uint32
  var x516 uint32
  x516, x515 = bits.Mul32(x477, 0xfffffffe)
  var x517 uint32
  var x518 uint32
  x518, x517 = bits.Mul32(x477, 0xffffffff)
  var x519 uint32
  var x520 uint32
  x520, x519 = bits.Mul32(x477, 0xffffffff)
  var x521 uint32
  var x522 fiat_p384_uint1
  x521, x522 = fiat_p384_addcarryx_u32(x518, x515, 0x0)
  var x523 uint32
  var x524 fiat_p384_uint1
  x523, x524 = fiat_p384_addcarryx_u32(x516, x513, x522)
  var x525 uint32
  var x526 fiat_p384_uint1
  x525, x526 = fiat_p384_addcarryx_u32(x514, x511, x524)
  var x527 uint32
  var x528 fiat_p384_uint1
  x527, x528 = fiat_p384_addcarryx_u32(x512, x509, x526)
  var x529 uint32
  var x530 fiat_p384_uint1
  x529, x530 = fiat_p384_addcarryx_u32(x510, x507, x528)
  var x531 uint32
  var x532 fiat_p384_uint1
  x531, x532 = fiat_p384_addcarryx_u32(x508, x505, x530)
  var x533 uint32
  var x534 fiat_p384_uint1
  x533, x534 = fiat_p384_addcarryx_u32(x506, x503, x532)
  var x535 uint32
  var x536 fiat_p384_uint1
  x535, x536 = fiat_p384_addcarryx_u32(x504, x501, x534)
  var x538 fiat_p384_uint1
  _, x538 = fiat_p384_addcarryx_u32(x477, x519, 0x0)
  var x539 uint32
  var x540 fiat_p384_uint1
  x539, x540 = fiat_p384_addcarryx_u32(x479, x520, x538)
  var x541 uint32
  var x542 fiat_p384_uint1
  x541, x542 = fiat_p384_addcarryx_u32(x481, uint32(0x0), x540)
  var x543 uint32
  var x544 fiat_p384_uint1
  x543, x544 = fiat_p384_addcarryx_u32(x483, x517, x542)
  var x545 uint32
  var x546 fiat_p384_uint1
  x545, x546 = fiat_p384_addcarryx_u32(x485, x521, x544)
  var x547 uint32
  var x548 fiat_p384_uint1
  x547, x548 = fiat_p384_addcarryx_u32(x487, x523, x546)
  var x549 uint32
  var x550 fiat_p384_uint1
  x549, x550 = fiat_p384_addcarryx_u32(x489, x525, x548)
  var x551 uint32
  var x552 fiat_p384_uint1
  x551, x552 = fiat_p384_addcarryx_u32(x491, x527, x550)
  var x553 uint32
  var x554 fiat_p384_uint1
  x553, x554 = fiat_p384_addcarryx_u32(x493, x529, x552)
  var x555 uint32
  var x556 fiat_p384_uint1
  x555, x556 = fiat_p384_addcarryx_u32(x495, x531, x554)
  var x557 uint32
  var x558 fiat_p384_uint1
  x557, x558 = fiat_p384_addcarryx_u32(x497, x533, x556)
  var x559 uint32
  var x560 fiat_p384_uint1
  x559, x560 = fiat_p384_addcarryx_u32(x499, x535, x558)
  var x561 uint32
  var x562 fiat_p384_uint1
  x561, x562 = fiat_p384_addcarryx_u32((uint32(x500) + uint32(x466)), (uint32(x536) + x502), x560)
  var x563 uint32
  var x564 uint32
  x564, x563 = bits.Mul32(x6, 0x2)
  var x565 uint32
  var x566 uint32
  x566, x565 = bits.Mul32(x6, 0xfffffffe)
  var x567 uint32
  var x568 uint32
  x568, x567 = bits.Mul32(x6, 0x2)
  var x569 uint32
  var x570 uint32
  x570, x569 = bits.Mul32(x6, 0xfffffffe)
  var x571 uint32
  var x572 fiat_p384_uint1
  x571, x572 = fiat_p384_addcarryx_u32(uint32(fiat_p384_uint1(x564)), x6, 0x0)
  var x573 uint32
  var x574 fiat_p384_uint1
  x573, x574 = fiat_p384_addcarryx_u32(x539, x6, 0x0)
  var x575 uint32
  var x576 fiat_p384_uint1
  x575, x576 = fiat_p384_addcarryx_u32(x541, x569, x574)
  var x577 uint32
  var x578 fiat_p384_uint1
  x577, x578 = fiat_p384_addcarryx_u32(x543, x570, x576)
  var x579 uint32
  var x580 fiat_p384_uint1
  x579, x580 = fiat_p384_addcarryx_u32(x545, x567, x578)
  var x581 uint32
  var x582 fiat_p384_uint1
  x581, x582 = fiat_p384_addcarryx_u32(x547, uint32(fiat_p384_uint1(x568)), x580)
  var x583 uint32
  var x584 fiat_p384_uint1
  x583, x584 = fiat_p384_addcarryx_u32(x549, x565, x582)
  var x585 uint32
  var x586 fiat_p384_uint1
  x585, x586 = fiat_p384_addcarryx_u32(x551, x566, x584)
  var x587 uint32
  var x588 fiat_p384_uint1
  x587, x588 = fiat_p384_addcarryx_u32(x553, x563, x586)
  var x589 uint32
  var x590 fiat_p384_uint1
  x589, x590 = fiat_p384_addcarryx_u32(x555, x571, x588)
  var x591 uint32
  var x592 fiat_p384_uint1
  x591, x592 = fiat_p384_addcarryx_u32(x557, uint32(x572), x590)
  var x593 uint32
  var x594 fiat_p384_uint1
  x593, x594 = fiat_p384_addcarryx_u32(x559, uint32(0x0), x592)
  var x595 uint32
  var x596 fiat_p384_uint1
  x595, x596 = fiat_p384_addcarryx_u32(x561, uint32(0x0), x594)
  var x597 uint32
  var x598 uint32
  x598, x597 = bits.Mul32(x573, 0xffffffff)
  var x599 uint32
  var x600 uint32
  x600, x599 = bits.Mul32(x573, 0xffffffff)
  var x601 uint32
  var x602 uint32
  x602, x601 = bits.Mul32(x573, 0xffffffff)
  var x603 uint32
  var x604 uint32
  x604, x603 = bits.Mul32(x573, 0xffffffff)
  var x605 uint32
  var x606 uint32
  x606, x605 = bits.Mul32(x573, 0xffffffff)
  var x607 uint32
  var x608 uint32
  x608, x607 = bits.Mul32(x573, 0xffffffff)
  var x609 uint32
  var x610 uint32
  x610, x609 = bits.Mul32(x573, 0xffffffff)
  var x611 uint32
  var x612 uint32
  x612, x611 = bits.Mul32(x573, 0xfffffffe)
  var x613 uint32
  var x614 uint32
  x614, x613 = bits.Mul32(x573, 0xffffffff)
  var x615 uint32
  var x616 uint32
  x616, x615 = bits.Mul32(x573, 0xffffffff)
  var x617 uint32
  var x618 fiat_p384_uint1
  x617, x618 = fiat_p384_addcarryx_u32(x614, x611, 0x0)
  var x619 uint32
  var x620 fiat_p384_uint1
  x619, x620 = fiat_p384_addcarryx_u32(x612, x609, x618)
  var x621 uint32
  var x622 fiat_p384_uint1
  x621, x622 = fiat_p384_addcarryx_u32(x610, x607, x620)
  var x623 uint32
  var x624 fiat_p384_uint1
  x623, x624 = fiat_p384_addcarryx_u32(x608, x605, x622)
  var x625 uint32
  var x626 fiat_p384_uint1
  x625, x626 = fiat_p384_addcarryx_u32(x606, x603, x624)
  var x627 uint32
  var x628 fiat_p384_uint1
  x627, x628 = fiat_p384_addcarryx_u32(x604, x601, x626)
  var x629 uint32
  var x630 fiat_p384_uint1
  x629, x630 = fiat_p384_addcarryx_u32(x602, x599, x628)
  var x631 uint32
  var x632 fiat_p384_uint1
  x631, x632 = fiat_p384_addcarryx_u32(x600, x597, x630)
  var x634 fiat_p384_uint1
  _, x634 = fiat_p384_addcarryx_u32(x573, x615, 0x0)
  var x635 uint32
  var x636 fiat_p384_uint1
  x635, x636 = fiat_p384_addcarryx_u32(x575, x616, x634)
  var x637 uint32
  var x638 fiat_p384_uint1
  x637, x638 = fiat_p384_addcarryx_u32(x577, uint32(0x0), x636)
  var x639 uint32
  var x640 fiat_p384_uint1
  x639, x640 = fiat_p384_addcarryx_u32(x579, x613, x638)
  var x641 uint32
  var x642 fiat_p384_uint1
  x641, x642 = fiat_p384_addcarryx_u32(x581, x617, x640)
  var x643 uint32
  var x644 fiat_p384_uint1
  x643, x644 = fiat_p384_addcarryx_u32(x583, x619, x642)
  var x645 uint32
  var x646 fiat_p384_uint1
  x645, x646 = fiat_p384_addcarryx_u32(x585, x621, x644)
  var x647 uint32
  var x648 fiat_p384_uint1
  x647, x648 = fiat_p384_addcarryx_u32(x587, x623, x646)
  var x649 uint32
  var x650 fiat_p384_uint1
  x649, x650 = fiat_p384_addcarryx_u32(x589, x625, x648)
  var x651 uint32
  var x652 fiat_p384_uint1
  x651, x652 = fiat_p384_addcarryx_u32(x591, x627, x650)
  var x653 uint32
  var x654 fiat_p384_uint1
  x653, x654 = fiat_p384_addcarryx_u32(x593, x629, x652)
  var x655 uint32
  var x656 fiat_p384_uint1
  x655, x656 = fiat_p384_addcarryx_u32(x595, x631, x654)
  var x657 uint32
  var x658 fiat_p384_uint1
  x657, x658 = fiat_p384_addcarryx_u32((uint32(x596) + uint32(x562)), (uint32(x632) + x598), x656)
  var x659 uint32
  var x660 uint32
  x660, x659 = bits.Mul32(x7, 0x2)
  var x661 uint32
  var x662 uint32
  x662, x661 = bits.Mul32(x7, 0xfffffffe)
  var x663 uint32
  var x664 uint32
  x664, x663 = bits.Mul32(x7, 0x2)
  var x665 uint32
  var x666 uint32
  x666, x665 = bits.Mul32(x7, 0xfffffffe)
  var x667 uint32
  var x668 fiat_p384_uint1
  x667, x668 = fiat_p384_addcarryx_u32(uint32(fiat_p384_uint1(x660)), x7, 0x0)
  var x669 uint32
  var x670 fiat_p384_uint1
  x669, x670 = fiat_p384_addcarryx_u32(x635, x7, 0x0)
  var x671 uint32
  var x672 fiat_p384_uint1
  x671, x672 = fiat_p384_addcarryx_u32(x637, x665, x670)
  var x673 uint32
  var x674 fiat_p384_uint1
  x673, x674 = fiat_p384_addcarryx_u32(x639, x666, x672)
  var x675 uint32
  var x676 fiat_p384_uint1
  x675, x676 = fiat_p384_addcarryx_u32(x641, x663, x674)
  var x677 uint32
  var x678 fiat_p384_uint1
  x677, x678 = fiat_p384_addcarryx_u32(x643, uint32(fiat_p384_uint1(x664)), x676)
  var x679 uint32
  var x680 fiat_p384_uint1
  x679, x680 = fiat_p384_addcarryx_u32(x645, x661, x678)
  var x681 uint32
  var x682 fiat_p384_uint1
  x681, x682 = fiat_p384_addcarryx_u32(x647, x662, x680)
  var x683 uint32
  var x684 fiat_p384_uint1
  x683, x684 = fiat_p384_addcarryx_u32(x649, x659, x682)
  var x685 uint32
  var x686 fiat_p384_uint1
  x685, x686 = fiat_p384_addcarryx_u32(x651, x667, x684)
  var x687 uint32
  var x688 fiat_p384_uint1
  x687, x688 = fiat_p384_addcarryx_u32(x653, uint32(x668), x686)
  var x689 uint32
  var x690 fiat_p384_uint1
  x689, x690 = fiat_p384_addcarryx_u32(x655, uint32(0x0), x688)
  var x691 uint32
  var x692 fiat_p384_uint1
  x691, x692 = fiat_p384_addcarryx_u32(x657, uint32(0x0), x690)
  var x693 uint32
  var x694 uint32
  x694, x693 = bits.Mul32(x669, 0xffffffff)
  var x695 uint32
  var x696 uint32
  x696, x695 = bits.Mul32(x669, 0xffffffff)
  var x697 uint32
  var x698 uint32
  x698, x697 = bits.Mul32(x669, 0xffffffff)
  var x699 uint32
  var x700 uint32
  x700, x699 = bits.Mul32(x669, 0xffffffff)
  var x701 uint32
  var x702 uint32
  x702, x701 = bits.Mul32(x669, 0xffffffff)
  var x703 uint32
  var x704 uint32
  x704, x703 = bits.Mul32(x669, 0xffffffff)
  var x705 uint32
  var x706 uint32
  x706, x705 = bits.Mul32(x669, 0xffffffff)
  var x707 uint32
  var x708 uint32
  x708, x707 = bits.Mul32(x669, 0xfffffffe)
  var x709 uint32
  var x710 uint32
  x710, x709 = bits.Mul32(x669, 0xffffffff)
  var x711 uint32
  var x712 uint32
  x712, x711 = bits.Mul32(x669, 0xffffffff)
  var x713 uint32
  var x714 fiat_p384_uint1
  x713, x714 = fiat_p384_addcarryx_u32(x710, x707, 0x0)
  var x715 uint32
  var x716 fiat_p384_uint1
  x715, x716 = fiat_p384_addcarryx_u32(x708, x705, x714)
  var x717 uint32
  var x718 fiat_p384_uint1
  x717, x718 = fiat_p384_addcarryx_u32(x706, x703, x716)
  var x719 uint32
  var x720 fiat_p384_uint1
  x719, x720 = fiat_p384_addcarryx_u32(x704, x701, x718)
  var x721 uint32
  var x722 fiat_p384_uint1
  x721, x722 = fiat_p384_addcarryx_u32(x702, x699, x720)
  var x723 uint32
  var x724 fiat_p384_uint1
  x723, x724 = fiat_p384_addcarryx_u32(x700, x697, x722)
  var x725 uint32
  var x726 fiat_p384_uint1
  x725, x726 = fiat_p384_addcarryx_u32(x698, x695, x724)
  var x727 uint32
  var x728 fiat_p384_uint1
  x727, x728 = fiat_p384_addcarryx_u32(x696, x693, x726)
  var x730 fiat_p384_uint1
  _, x730 = fiat_p384_addcarryx_u32(x669, x711, 0x0)
  var x731 uint32
  var x732 fiat_p384_uint1
  x731, x732 = fiat_p384_addcarryx_u32(x671, x712, x730)
  var x733 uint32
  var x734 fiat_p384_uint1
  x733, x734 = fiat_p384_addcarryx_u32(x673, uint32(0x0), x732)
  var x735 uint32
  var x736 fiat_p384_uint1
  x735, x736 = fiat_p384_addcarryx_u32(x675, x709, x734)
  var x737 uint32
  var x738 fiat_p384_uint1
  x737, x738 = fiat_p384_addcarryx_u32(x677, x713, x736)
  var x739 uint32
  var x740 fiat_p384_uint1
  x739, x740 = fiat_p384_addcarryx_u32(x679, x715, x738)
  var x741 uint32
  var x742 fiat_p384_uint1
  x741, x742 = fiat_p384_addcarryx_u32(x681, x717, x740)
  var x743 uint32
  var x744 fiat_p384_uint1
  x743, x744 = fiat_p384_addcarryx_u32(x683, x719, x742)
  var x745 uint32
  var x746 fiat_p384_uint1
  x745, x746 = fiat_p384_addcarryx_u32(x685, x721, x744)
  var x747 uint32
  var x748 fiat_p384_uint1
  x747, x748 = fiat_p384_addcarryx_u32(x687, x723, x746)
  var x749 uint32
  var x750 fiat_p384_uint1
  x749, x750 = fiat_p384_addcarryx_u32(x689, x725, x748)
  var x751 uint32
  var x752 fiat_p384_uint1
  x751, x752 = fiat_p384_addcarryx_u32(x691, x727, x750)
  var x753 uint32
  var x754 fiat_p384_uint1
  x753, x754 = fiat_p384_addcarryx_u32((uint32(x692) + uint32(x658)), (uint32(x728) + x694), x752)
  var x755 uint32
  var x756 uint32
  x756, x755 = bits.Mul32(x8, 0x2)
  var x757 uint32
  var x758 uint32
  x758, x757 = bits.Mul32(x8, 0xfffffffe)
  var x759 uint32
  var x760 uint32
  x760, x759 = bits.Mul32(x8, 0x2)
  var x761 uint32
  var x762 uint32
  x762, x761 = bits.Mul32(x8, 0xfffffffe)
  var x763 uint32
  var x764 fiat_p384_uint1
  x763, x764 = fiat_p384_addcarryx_u32(uint32(fiat_p384_uint1(x756)), x8, 0x0)
  var x765 uint32
  var x766 fiat_p384_uint1
  x765, x766 = fiat_p384_addcarryx_u32(x731, x8, 0x0)
  var x767 uint32
  var x768 fiat_p384_uint1
  x767, x768 = fiat_p384_addcarryx_u32(x733, x761, x766)
  var x769 uint32
  var x770 fiat_p384_uint1
  x769, x770 = fiat_p384_addcarryx_u32(x735, x762, x768)
  var x771 uint32
  var x772 fiat_p384_uint1
  x771, x772 = fiat_p384_addcarryx_u32(x737, x759, x770)
  var x773 uint32
  var x774 fiat_p384_uint1
  x773, x774 = fiat_p384_addcarryx_u32(x739, uint32(fiat_p384_uint1(x760)), x772)
  var x775 uint32
  var x776 fiat_p384_uint1
  x775, x776 = fiat_p384_addcarryx_u32(x741, x757, x774)
  var x777 uint32
  var x778 fiat_p384_uint1
  x777, x778 = fiat_p384_addcarryx_u32(x743, x758, x776)
  var x779 uint32
  var x780 fiat_p384_uint1
  x779, x780 = fiat_p384_addcarryx_u32(x745, x755, x778)
  var x781 uint32
  var x782 fiat_p384_uint1
  x781, x782 = fiat_p384_addcarryx_u32(x747, x763, x780)
  var x783 uint32
  var x784 fiat_p384_uint1
  x783, x784 = fiat_p384_addcarryx_u32(x749, uint32(x764), x782)
  var x785 uint32
  var x786 fiat_p384_uint1
  x785, x786 = fiat_p384_addcarryx_u32(x751, uint32(0x0), x784)
  var x787 uint32
  var x788 fiat_p384_uint1
  x787, x788 = fiat_p384_addcarryx_u32(x753, uint32(0x0), x786)
  var x789 uint32
  var x790 uint32
  x790, x789 = bits.Mul32(x765, 0xffffffff)
  var x791 uint32
  var x792 uint32
  x792, x791 = bits.Mul32(x765, 0xffffffff)
  var x793 uint32
  var x794 uint32
  x794, x793 = bits.Mul32(x765, 0xffffffff)
  var x795 uint32
  var x796 uint32
  x796, x795 = bits.Mul32(x765, 0xffffffff)
  var x797 uint32
  var x798 uint32
  x798, x797 = bits.Mul32(x765, 0xffffffff)
  var x799 uint32
  var x800 uint32
  x800, x799 = bits.Mul32(x765, 0xffffffff)
  var x801 uint32
  var x802 uint32
  x802, x801 = bits.Mul32(x765, 0xffffffff)
  var x803 uint32
  var x804 uint32
  x804, x803 = bits.Mul32(x765, 0xfffffffe)
  var x805 uint32
  var x806 uint32
  x806, x805 = bits.Mul32(x765, 0xffffffff)
  var x807 uint32
  var x808 uint32
  x808, x807 = bits.Mul32(x765, 0xffffffff)
  var x809 uint32
  var x810 fiat_p384_uint1
  x809, x810 = fiat_p384_addcarryx_u32(x806, x803, 0x0)
  var x811 uint32
  var x812 fiat_p384_uint1
  x811, x812 = fiat_p384_addcarryx_u32(x804, x801, x810)
  var x813 uint32
  var x814 fiat_p384_uint1
  x813, x814 = fiat_p384_addcarryx_u32(x802, x799, x812)
  var x815 uint32
  var x816 fiat_p384_uint1
  x815, x816 = fiat_p384_addcarryx_u32(x800, x797, x814)
  var x817 uint32
  var x818 fiat_p384_uint1
  x817, x818 = fiat_p384_addcarryx_u32(x798, x795, x816)
  var x819 uint32
  var x820 fiat_p384_uint1
  x819, x820 = fiat_p384_addcarryx_u32(x796, x793, x818)
  var x821 uint32
  var x822 fiat_p384_uint1
  x821, x822 = fiat_p384_addcarryx_u32(x794, x791, x820)
  var x823 uint32
  var x824 fiat_p384_uint1
  x823, x824 = fiat_p384_addcarryx_u32(x792, x789, x822)
  var x826 fiat_p384_uint1
  _, x826 = fiat_p384_addcarryx_u32(x765, x807, 0x0)
  var x827 uint32
  var x828 fiat_p384_uint1
  x827, x828 = fiat_p384_addcarryx_u32(x767, x808, x826)
  var x829 uint32
  var x830 fiat_p384_uint1
  x829, x830 = fiat_p384_addcarryx_u32(x769, uint32(0x0), x828)
  var x831 uint32
  var x832 fiat_p384_uint1
  x831, x832 = fiat_p384_addcarryx_u32(x771, x805, x830)
  var x833 uint32
  var x834 fiat_p384_uint1
  x833, x834 = fiat_p384_addcarryx_u32(x773, x809, x832)
  var x835 uint32
  var x836 fiat_p384_uint1
  x835, x836 = fiat_p384_addcarryx_u32(x775, x811, x834)
  var x837 uint32
  var x838 fiat_p384_uint1
  x837, x838 = fiat_p384_addcarryx_u32(x777, x813, x836)
  var x839 uint32
  var x840 fiat_p384_uint1
  x839, x840 = fiat_p384_addcarryx_u32(x779, x815, x838)
  var x841 uint32
  var x842 fiat_p384_uint1
  x841, x842 = fiat_p384_addcarryx_u32(x781, x817, x840)
  var x843 uint32
  var x844 fiat_p384_uint1
  x843, x844 = fiat_p384_addcarryx_u32(x783, x819, x842)
  var x845 uint32
  var x846 fiat_p384_uint1
  x845, x846 = fiat_p384_addcarryx_u32(x785, x821, x844)
  var x847 uint32
  var x848 fiat_p384_uint1
  x847, x848 = fiat_p384_addcarryx_u32(x787, x823, x846)
  var x849 uint32
  var x850 fiat_p384_uint1
  x849, x850 = fiat_p384_addcarryx_u32((uint32(x788) + uint32(x754)), (uint32(x824) + x790), x848)
  var x851 uint32
  var x852 uint32
  x852, x851 = bits.Mul32(x9, 0x2)
  var x853 uint32
  var x854 uint32
  x854, x853 = bits.Mul32(x9, 0xfffffffe)
  var x855 uint32
  var x856 uint32
  x856, x855 = bits.Mul32(x9, 0x2)
  var x857 uint32
  var x858 uint32
  x858, x857 = bits.Mul32(x9, 0xfffffffe)
  var x859 uint32
  var x860 fiat_p384_uint1
  x859, x860 = fiat_p384_addcarryx_u32(uint32(fiat_p384_uint1(x852)), x9, 0x0)
  var x861 uint32
  var x862 fiat_p384_uint1
  x861, x862 = fiat_p384_addcarryx_u32(x827, x9, 0x0)
  var x863 uint32
  var x864 fiat_p384_uint1
  x863, x864 = fiat_p384_addcarryx_u32(x829, x857, x862)
  var x865 uint32
  var x866 fiat_p384_uint1
  x865, x866 = fiat_p384_addcarryx_u32(x831, x858, x864)
  var x867 uint32
  var x868 fiat_p384_uint1
  x867, x868 = fiat_p384_addcarryx_u32(x833, x855, x866)
  var x869 uint32
  var x870 fiat_p384_uint1
  x869, x870 = fiat_p384_addcarryx_u32(x835, uint32(fiat_p384_uint1(x856)), x868)
  var x871 uint32
  var x872 fiat_p384_uint1
  x871, x872 = fiat_p384_addcarryx_u32(x837, x853, x870)
  var x873 uint32
  var x874 fiat_p384_uint1
  x873, x874 = fiat_p384_addcarryx_u32(x839, x854, x872)
  var x875 uint32
  var x876 fiat_p384_uint1
  x875, x876 = fiat_p384_addcarryx_u32(x841, x851, x874)
  var x877 uint32
  var x878 fiat_p384_uint1
  x877, x878 = fiat_p384_addcarryx_u32(x843, x859, x876)
  var x879 uint32
  var x880 fiat_p384_uint1
  x879, x880 = fiat_p384_addcarryx_u32(x845, uint32(x860), x878)
  var x881 uint32
  var x882 fiat_p384_uint1
  x881, x882 = fiat_p384_addcarryx_u32(x847, uint32(0x0), x880)
  var x883 uint32
  var x884 fiat_p384_uint1
  x883, x884 = fiat_p384_addcarryx_u32(x849, uint32(0x0), x882)
  var x885 uint32
  var x886 uint32
  x886, x885 = bits.Mul32(x861, 0xffffffff)
  var x887 uint32
  var x888 uint32
  x888, x887 = bits.Mul32(x861, 0xffffffff)
  var x889 uint32
  var x890 uint32
  x890, x889 = bits.Mul32(x861, 0xffffffff)
  var x891 uint32
  var x892 uint32
  x892, x891 = bits.Mul32(x861, 0xffffffff)
  var x893 uint32
  var x894 uint32
  x894, x893 = bits.Mul32(x861, 0xffffffff)
  var x895 uint32
  var x896 uint32
  x896, x895 = bits.Mul32(x861, 0xffffffff)
  var x897 uint32
  var x898 uint32
  x898, x897 = bits.Mul32(x861, 0xffffffff)
  var x899 uint32
  var x900 uint32
  x900, x899 = bits.Mul32(x861, 0xfffffffe)
  var x901 uint32
  var x902 uint32
  x902, x901 = bits.Mul32(x861, 0xffffffff)
  var x903 uint32
  var x904 uint32
  x904, x903 = bits.Mul32(x861, 0xffffffff)
  var x905 uint32
  var x906 fiat_p384_uint1
  x905, x906 = fiat_p384_addcarryx_u32(x902, x899, 0x0)
  var x907 uint32
  var x908 fiat_p384_uint1
  x907, x908 = fiat_p384_addcarryx_u32(x900, x897, x906)
  var x909 uint32
  var x910 fiat_p384_uint1
  x909, x910 = fiat_p384_addcarryx_u32(x898, x895, x908)
  var x911 uint32
  var x912 fiat_p384_uint1
  x911, x912 = fiat_p384_addcarryx_u32(x896, x893, x910)
  var x913 uint32
  var x914 fiat_p384_uint1
  x913, x914 = fiat_p384_addcarryx_u32(x894, x891, x912)
  var x915 uint32
  var x916 fiat_p384_uint1
  x915, x916 = fiat_p384_addcarryx_u32(x892, x889, x914)
  var x917 uint32
  var x918 fiat_p384_uint1
  x917, x918 = fiat_p384_addcarryx_u32(x890, x887, x916)
  var x919 uint32
  var x920 fiat_p384_uint1
  x919, x920 = fiat_p384_addcarryx_u32(x888, x885, x918)
  var x922 fiat_p384_uint1
  _, x922 = fiat_p384_addcarryx_u32(x861, x903, 0x0)
  var x923 uint32
  var x924 fiat_p384_uint1
  x923, x924 = fiat_p384_addcarryx_u32(x863, x904, x922)
  var x925 uint32
  var x926 fiat_p384_uint1
  x925, x926 = fiat_p384_addcarryx_u32(x865, uint32(0x0), x924)
  var x927 uint32
  var x928 fiat_p384_uint1
  x927, x928 = fiat_p384_addcarryx_u32(x867, x901, x926)
  var x929 uint32
  var x930 fiat_p384_uint1
  x929, x930 = fiat_p384_addcarryx_u32(x869, x905, x928)
  var x931 uint32
  var x932 fiat_p384_uint1
  x931, x932 = fiat_p384_addcarryx_u32(x871, x907, x930)
  var x933 uint32
  var x934 fiat_p384_uint1
  x933, x934 = fiat_p384_addcarryx_u32(x873, x909, x932)
  var x935 uint32
  var x936 fiat_p384_uint1
  x935, x936 = fiat_p384_addcarryx_u32(x875, x911, x934)
  var x937 uint32
  var x938 fiat_p384_uint1
  x937, x938 = fiat_p384_addcarryx_u32(x877, x913, x936)
  var x939 uint32
  var x940 fiat_p384_uint1
  x939, x940 = fiat_p384_addcarryx_u32(x879, x915, x938)
  var x941 uint32
  var x942 fiat_p384_uint1
  x941, x942 = fiat_p384_addcarryx_u32(x881, x917, x940)
  var x943 uint32
  var x944 fiat_p384_uint1
  x943, x944 = fiat_p384_addcarryx_u32(x883, x919, x942)
  var x945 uint32
  var x946 fiat_p384_uint1
  x945, x946 = fiat_p384_addcarryx_u32((uint32(x884) + uint32(x850)), (uint32(x920) + x886), x944)
  var x947 uint32
  var x948 uint32
  x948, x947 = bits.Mul32(x10, 0x2)
  var x949 uint32
  var x950 uint32
  x950, x949 = bits.Mul32(x10, 0xfffffffe)
  var x951 uint32
  var x952 uint32
  x952, x951 = bits.Mul32(x10, 0x2)
  var x953 uint32
  var x954 uint32
  x954, x953 = bits.Mul32(x10, 0xfffffffe)
  var x955 uint32
  var x956 fiat_p384_uint1
  x955, x956 = fiat_p384_addcarryx_u32(uint32(fiat_p384_uint1(x948)), x10, 0x0)
  var x957 uint32
  var x958 fiat_p384_uint1
  x957, x958 = fiat_p384_addcarryx_u32(x923, x10, 0x0)
  var x959 uint32
  var x960 fiat_p384_uint1
  x959, x960 = fiat_p384_addcarryx_u32(x925, x953, x958)
  var x961 uint32
  var x962 fiat_p384_uint1
  x961, x962 = fiat_p384_addcarryx_u32(x927, x954, x960)
  var x963 uint32
  var x964 fiat_p384_uint1
  x963, x964 = fiat_p384_addcarryx_u32(x929, x951, x962)
  var x965 uint32
  var x966 fiat_p384_uint1
  x965, x966 = fiat_p384_addcarryx_u32(x931, uint32(fiat_p384_uint1(x952)), x964)
  var x967 uint32
  var x968 fiat_p384_uint1
  x967, x968 = fiat_p384_addcarryx_u32(x933, x949, x966)
  var x969 uint32
  var x970 fiat_p384_uint1
  x969, x970 = fiat_p384_addcarryx_u32(x935, x950, x968)
  var x971 uint32
  var x972 fiat_p384_uint1
  x971, x972 = fiat_p384_addcarryx_u32(x937, x947, x970)
  var x973 uint32
  var x974 fiat_p384_uint1
  x973, x974 = fiat_p384_addcarryx_u32(x939, x955, x972)
  var x975 uint32
  var x976 fiat_p384_uint1
  x975, x976 = fiat_p384_addcarryx_u32(x941, uint32(x956), x974)
  var x977 uint32
  var x978 fiat_p384_uint1
  x977, x978 = fiat_p384_addcarryx_u32(x943, uint32(0x0), x976)
  var x979 uint32
  var x980 fiat_p384_uint1
  x979, x980 = fiat_p384_addcarryx_u32(x945, uint32(0x0), x978)
  var x981 uint32
  var x982 uint32
  x982, x981 = bits.Mul32(x957, 0xffffffff)
  var x983 uint32
  var x984 uint32
  x984, x983 = bits.Mul32(x957, 0xffffffff)
  var x985 uint32
  var x986 uint32
  x986, x985 = bits.Mul32(x957, 0xffffffff)
  var x987 uint32
  var x988 uint32
  x988, x987 = bits.Mul32(x957, 0xffffffff)
  var x989 uint32
  var x990 uint32
  x990, x989 = bits.Mul32(x957, 0xffffffff)
  var x991 uint32
  var x992 uint32
  x992, x991 = bits.Mul32(x957, 0xffffffff)
  var x993 uint32
  var x994 uint32
  x994, x993 = bits.Mul32(x957, 0xffffffff)
  var x995 uint32
  var x996 uint32
  x996, x995 = bits.Mul32(x957, 0xfffffffe)
  var x997 uint32
  var x998 uint32
  x998, x997 = bits.Mul32(x957, 0xffffffff)
  var x999 uint32
  var x1000 uint32
  x1000, x999 = bits.Mul32(x957, 0xffffffff)
  var x1001 uint32
  var x1002 fiat_p384_uint1
  x1001, x1002 = fiat_p384_addcarryx_u32(x998, x995, 0x0)
  var x1003 uint32
  var x1004 fiat_p384_uint1
  x1003, x1004 = fiat_p384_addcarryx_u32(x996, x993, x1002)
  var x1005 uint32
  var x1006 fiat_p384_uint1
  x1005, x1006 = fiat_p384_addcarryx_u32(x994, x991, x1004)
  var x1007 uint32
  var x1008 fiat_p384_uint1
  x1007, x1008 = fiat_p384_addcarryx_u32(x992, x989, x1006)
  var x1009 uint32
  var x1010 fiat_p384_uint1
  x1009, x1010 = fiat_p384_addcarryx_u32(x990, x987, x1008)
  var x1011 uint32
  var x1012 fiat_p384_uint1
  x1011, x1012 = fiat_p384_addcarryx_u32(x988, x985, x1010)
  var x1013 uint32
  var x1014 fiat_p384_uint1
  x1013, x1014 = fiat_p384_addcarryx_u32(x986, x983, x1012)
  var x1015 uint32
  var x1016 fiat_p384_uint1
  x1015, x1016 = fiat_p384_addcarryx_u32(x984, x981, x1014)
  var x1018 fiat_p384_uint1
  _, x1018 = fiat_p384_addcarryx_u32(x957, x999, 0x0)
  var x1019 uint32
  var x1020 fiat_p384_uint1
  x1019, x1020 = fiat_p384_addcarryx_u32(x959, x1000, x1018)
  var x1021 uint32
  var x1022 fiat_p384_uint1
  x1021, x1022 = fiat_p384_addcarryx_u32(x961, uint32(0x0), x1020)
  var x1023 uint32
  var x1024 fiat_p384_uint1
  x1023, x1024 = fiat_p384_addcarryx_u32(x963, x997, x1022)
  var x1025 uint32
  var x1026 fiat_p384_uint1
  x1025, x1026 = fiat_p384_addcarryx_u32(x965, x1001, x1024)
  var x1027 uint32
  var x1028 fiat_p384_uint1
  x1027, x1028 = fiat_p384_addcarryx_u32(x967, x1003, x1026)
  var x1029 uint32
  var x1030 fiat_p384_uint1
  x1029, x1030 = fiat_p384_addcarryx_u32(x969, x1005, x1028)
  var x1031 uint32
  var x1032 fiat_p384_uint1
  x1031, x1032 = fiat_p384_addcarryx_u32(x971, x1007, x1030)
  var x1033 uint32
  var x1034 fiat_p384_uint1
  x1033, x1034 = fiat_p384_addcarryx_u32(x973, x1009, x1032)
  var x1035 uint32
  var x1036 fiat_p384_uint1
  x1035, x1036 = fiat_p384_addcarryx_u32(x975, x1011, x1034)
  var x1037 uint32
  var x1038 fiat_p384_uint1
  x1037, x1038 = fiat_p384_addcarryx_u32(x977, x1013, x1036)
  var x1039 uint32
  var x1040 fiat_p384_uint1
  x1039, x1040 = fiat_p384_addcarryx_u32(x979, x1015, x1038)
  var x1041 uint32
  var x1042 fiat_p384_uint1
  x1041, x1042 = fiat_p384_addcarryx_u32((uint32(x980) + uint32(x946)), (uint32(x1016) + x982), x1040)
  var x1043 uint32
  var x1044 uint32
  x1044, x1043 = bits.Mul32(x11, 0x2)
  var x1045 uint32
  var x1046 uint32
  x1046, x1045 = bits.Mul32(x11, 0xfffffffe)
  var x1047 uint32
  var x1048 uint32
  x1048, x1047 = bits.Mul32(x11, 0x2)
  var x1049 uint32
  var x1050 uint32
  x1050, x1049 = bits.Mul32(x11, 0xfffffffe)
  var x1051 uint32
  var x1052 fiat_p384_uint1
  x1051, x1052 = fiat_p384_addcarryx_u32(uint32(fiat_p384_uint1(x1044)), x11, 0x0)
  var x1053 uint32
  var x1054 fiat_p384_uint1
  x1053, x1054 = fiat_p384_addcarryx_u32(x1019, x11, 0x0)
  var x1055 uint32
  var x1056 fiat_p384_uint1
  x1055, x1056 = fiat_p384_addcarryx_u32(x1021, x1049, x1054)
  var x1057 uint32
  var x1058 fiat_p384_uint1
  x1057, x1058 = fiat_p384_addcarryx_u32(x1023, x1050, x1056)
  var x1059 uint32
  var x1060 fiat_p384_uint1
  x1059, x1060 = fiat_p384_addcarryx_u32(x1025, x1047, x1058)
  var x1061 uint32
  var x1062 fiat_p384_uint1
  x1061, x1062 = fiat_p384_addcarryx_u32(x1027, uint32(fiat_p384_uint1(x1048)), x1060)
  var x1063 uint32
  var x1064 fiat_p384_uint1
  x1063, x1064 = fiat_p384_addcarryx_u32(x1029, x1045, x1062)
  var x1065 uint32
  var x1066 fiat_p384_uint1
  x1065, x1066 = fiat_p384_addcarryx_u32(x1031, x1046, x1064)
  var x1067 uint32
  var x1068 fiat_p384_uint1
  x1067, x1068 = fiat_p384_addcarryx_u32(x1033, x1043, x1066)
  var x1069 uint32
  var x1070 fiat_p384_uint1
  x1069, x1070 = fiat_p384_addcarryx_u32(x1035, x1051, x1068)
  var x1071 uint32
  var x1072 fiat_p384_uint1
  x1071, x1072 = fiat_p384_addcarryx_u32(x1037, uint32(x1052), x1070)
  var x1073 uint32
  var x1074 fiat_p384_uint1
  x1073, x1074 = fiat_p384_addcarryx_u32(x1039, uint32(0x0), x1072)
  var x1075 uint32
  var x1076 fiat_p384_uint1
  x1075, x1076 = fiat_p384_addcarryx_u32(x1041, uint32(0x0), x1074)
  var x1077 uint32
  var x1078 uint32
  x1078, x1077 = bits.Mul32(x1053, 0xffffffff)
  var x1079 uint32
  var x1080 uint32
  x1080, x1079 = bits.Mul32(x1053, 0xffffffff)
  var x1081 uint32
  var x1082 uint32
  x1082, x1081 = bits.Mul32(x1053, 0xffffffff)
  var x1083 uint32
  var x1084 uint32
  x1084, x1083 = bits.Mul32(x1053, 0xffffffff)
  var x1085 uint32
  var x1086 uint32
  x1086, x1085 = bits.Mul32(x1053, 0xffffffff)
  var x1087 uint32
  var x1088 uint32
  x1088, x1087 = bits.Mul32(x1053, 0xffffffff)
  var x1089 uint32
  var x1090 uint32
  x1090, x1089 = bits.Mul32(x1053, 0xffffffff)
  var x1091 uint32
  var x1092 uint32
  x1092, x1091 = bits.Mul32(x1053, 0xfffffffe)
  var x1093 uint32
  var x1094 uint32
  x1094, x1093 = bits.Mul32(x1053, 0xffffffff)
  var x1095 uint32
  var x1096 uint32
  x1096, x1095 = bits.Mul32(x1053, 0xffffffff)
  var x1097 uint32
  var x1098 fiat_p384_uint1
  x1097, x1098 = fiat_p384_addcarryx_u32(x1094, x1091, 0x0)
  var x1099 uint32
  var x1100 fiat_p384_uint1
  x1099, x1100 = fiat_p384_addcarryx_u32(x1092, x1089, x1098)
  var x1101 uint32
  var x1102 fiat_p384_uint1
  x1101, x1102 = fiat_p384_addcarryx_u32(x1090, x1087, x1100)
  var x1103 uint32
  var x1104 fiat_p384_uint1
  x1103, x1104 = fiat_p384_addcarryx_u32(x1088, x1085, x1102)
  var x1105 uint32
  var x1106 fiat_p384_uint1
  x1105, x1106 = fiat_p384_addcarryx_u32(x1086, x1083, x1104)
  var x1107 uint32
  var x1108 fiat_p384_uint1
  x1107, x1108 = fiat_p384_addcarryx_u32(x1084, x1081, x1106)
  var x1109 uint32
  var x1110 fiat_p384_uint1
  x1109, x1110 = fiat_p384_addcarryx_u32(x1082, x1079, x1108)
  var x1111 uint32
  var x1112 fiat_p384_uint1
  x1111, x1112 = fiat_p384_addcarryx_u32(x1080, x1077, x1110)
  var x1114 fiat_p384_uint1
  _, x1114 = fiat_p384_addcarryx_u32(x1053, x1095, 0x0)
  var x1115 uint32
  var x1116 fiat_p384_uint1
  x1115, x1116 = fiat_p384_addcarryx_u32(x1055, x1096, x1114)
  var x1117 uint32
  var x1118 fiat_p384_uint1
  x1117, x1118 = fiat_p384_addcarryx_u32(x1057, uint32(0x0), x1116)
  var x1119 uint32
  var x1120 fiat_p384_uint1
  x1119, x1120 = fiat_p384_addcarryx_u32(x1059, x1093, x1118)
  var x1121 uint32
  var x1122 fiat_p384_uint1
  x1121, x1122 = fiat_p384_addcarryx_u32(x1061, x1097, x1120)
  var x1123 uint32
  var x1124 fiat_p384_uint1
  x1123, x1124 = fiat_p384_addcarryx_u32(x1063, x1099, x1122)
  var x1125 uint32
  var x1126 fiat_p384_uint1
  x1125, x1126 = fiat_p384_addcarryx_u32(x1065, x1101, x1124)
  var x1127 uint32
  var x1128 fiat_p384_uint1
  x1127, x1128 = fiat_p384_addcarryx_u32(x1067, x1103, x1126)
  var x1129 uint32
  var x1130 fiat_p384_uint1
  x1129, x1130 = fiat_p384_addcarryx_u32(x1069, x1105, x1128)
  var x1131 uint32
  var x1132 fiat_p384_uint1
  x1131, x1132 = fiat_p384_addcarryx_u32(x1071, x1107, x1130)
  var x1133 uint32
  var x1134 fiat_p384_uint1
  x1133, x1134 = fiat_p384_addcarryx_u32(x1073, x1109, x1132)
  var x1135 uint32
  var x1136 fiat_p384_uint1
  x1135, x1136 = fiat_p384_addcarryx_u32(x1075, x1111, x1134)
  var x1137 uint32
  var x1138 fiat_p384_uint1
  x1137, x1138 = fiat_p384_addcarryx_u32((uint32(x1076) + uint32(x1042)), (uint32(x1112) + x1078), x1136)
  var x1139 uint32
  var x1140 fiat_p384_uint1
  x1139, x1140 = fiat_p384_subborrowx_u32(x1115, 0xffffffff, 0x0)
  var x1141 uint32
  var x1142 fiat_p384_uint1
  x1141, x1142 = fiat_p384_subborrowx_u32(x1117, uint32(0x0), x1140)
  var x1143 uint32
  var x1144 fiat_p384_uint1
  x1143, x1144 = fiat_p384_subborrowx_u32(x1119, uint32(0x0), x1142)
  var x1145 uint32
  var x1146 fiat_p384_uint1
  x1145, x1146 = fiat_p384_subborrowx_u32(x1121, 0xffffffff, x1144)
  var x1147 uint32
  var x1148 fiat_p384_uint1
  x1147, x1148 = fiat_p384_subborrowx_u32(x1123, 0xfffffffe, x1146)
  var x1149 uint32
  var x1150 fiat_p384_uint1
  x1149, x1150 = fiat_p384_subborrowx_u32(x1125, 0xffffffff, x1148)
  var x1151 uint32
  var x1152 fiat_p384_uint1
  x1151, x1152 = fiat_p384_subborrowx_u32(x1127, 0xffffffff, x1150)
  var x1153 uint32
  var x1154 fiat_p384_uint1
  x1153, x1154 = fiat_p384_subborrowx_u32(x1129, 0xffffffff, x1152)
  var x1155 uint32
  var x1156 fiat_p384_uint1
  x1155, x1156 = fiat_p384_subborrowx_u32(x1131, 0xffffffff, x1154)
  var x1157 uint32
  var x1158 fiat_p384_uint1
  x1157, x1158 = fiat_p384_subborrowx_u32(x1133, 0xffffffff, x1156)
  var x1159 uint32
  var x1160 fiat_p384_uint1
  x1159, x1160 = fiat_p384_subborrowx_u32(x1135, 0xffffffff, x1158)
  var x1161 uint32
  var x1162 fiat_p384_uint1
  x1161, x1162 = fiat_p384_subborrowx_u32(x1137, 0xffffffff, x1160)
  var x1164 fiat_p384_uint1
  _, x1164 = fiat_p384_subborrowx_u32(uint32(x1138), uint32(0x0), x1162)
  var x1165 uint32
  fiat_p384_cmovznz_u32(&x1165, x1164, x1139, x1115)
  var x1166 uint32
  fiat_p384_cmovznz_u32(&x1166, x1164, x1141, x1117)
  var x1167 uint32
  fiat_p384_cmovznz_u32(&x1167, x1164, x1143, x1119)
  var x1168 uint32
  fiat_p384_cmovznz_u32(&x1168, x1164, x1145, x1121)
  var x1169 uint32
  fiat_p384_cmovznz_u32(&x1169, x1164, x1147, x1123)
  var x1170 uint32
  fiat_p384_cmovznz_u32(&x1170, x1164, x1149, x1125)
  var x1171 uint32
  fiat_p384_cmovznz_u32(&x1171, x1164, x1151, x1127)
  var x1172 uint32
  fiat_p384_cmovznz_u32(&x1172, x1164, x1153, x1129)
  var x1173 uint32
  fiat_p384_cmovznz_u32(&x1173, x1164, x1155, x1131)
  var x1174 uint32
  fiat_p384_cmovznz_u32(&x1174, x1164, x1157, x1133)
  var x1175 uint32
  fiat_p384_cmovznz_u32(&x1175, x1164, x1159, x1135)
  var x1176 uint32
  fiat_p384_cmovznz_u32(&x1176, x1164, x1161, x1137)
  out1[0] = x1165
  out1[1] = x1166
  out1[2] = x1167
  out1[3] = x1168
  out1[4] = x1169
  out1[5] = x1170
  out1[6] = x1171
  out1[7] = x1172
  out1[8] = x1173
  out1[9] = x1174
  out1[10] = x1175
  out1[11] = x1176
}

/*
 * The function fiat_p384_nonzero outputs a single non-zero word if the input is non-zero and zero otherwise.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   out1 = 0 ↔ eval (from_montgomery arg1) mod m = 0
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffff]
 */
/*inline*/
func fiat_p384_nonzero(out1 *uint32, arg1 *[12]uint32) {
  var x1 uint32 = ((arg1[0]) | ((arg1[1]) | ((arg1[2]) | ((arg1[3]) | ((arg1[4]) | ((arg1[5]) | ((arg1[6]) | ((arg1[7]) | ((arg1[8]) | ((arg1[9]) | ((arg1[10]) | (arg1[11]))))))))))))
  *out1 = x1
}

/*
 * The function fiat_p384_selectznz is a multi-limb conditional select.
 * Postconditions:
 *   eval out1 = (if arg1 = 0 then eval arg2 else eval arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   arg3: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
/*inline*/
func fiat_p384_selectznz(out1 *[12]uint32, arg1 fiat_p384_uint1, arg2 *[12]uint32, arg3 *[12]uint32) {
  var x1 uint32
  fiat_p384_cmovznz_u32(&x1, arg1, (arg2[0]), (arg3[0]))
  var x2 uint32
  fiat_p384_cmovznz_u32(&x2, arg1, (arg2[1]), (arg3[1]))
  var x3 uint32
  fiat_p384_cmovznz_u32(&x3, arg1, (arg2[2]), (arg3[2]))
  var x4 uint32
  fiat_p384_cmovznz_u32(&x4, arg1, (arg2[3]), (arg3[3]))
  var x5 uint32
  fiat_p384_cmovznz_u32(&x5, arg1, (arg2[4]), (arg3[4]))
  var x6 uint32
  fiat_p384_cmovznz_u32(&x6, arg1, (arg2[5]), (arg3[5]))
  var x7 uint32
  fiat_p384_cmovznz_u32(&x7, arg1, (arg2[6]), (arg3[6]))
  var x8 uint32
  fiat_p384_cmovznz_u32(&x8, arg1, (arg2[7]), (arg3[7]))
  var x9 uint32
  fiat_p384_cmovznz_u32(&x9, arg1, (arg2[8]), (arg3[8]))
  var x10 uint32
  fiat_p384_cmovznz_u32(&x10, arg1, (arg2[9]), (arg3[9]))
  var x11 uint32
  fiat_p384_cmovznz_u32(&x11, arg1, (arg2[10]), (arg3[10]))
  var x12 uint32
  fiat_p384_cmovznz_u32(&x12, arg1, (arg2[11]), (arg3[11]))
  out1[0] = x1
  out1[1] = x2
  out1[2] = x3
  out1[3] = x4
  out1[4] = x5
  out1[5] = x6
  out1[6] = x7
  out1[7] = x8
  out1[8] = x9
  out1[9] = x10
  out1[10] = x11
  out1[11] = x12
}

/*
 * The function fiat_p384_to_bytes serializes a field element NOT in the Montgomery domain to bytes in little-endian order.
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   out1 = map (λ x, ⌊((eval arg1 mod m) mod 2^(8 * (x + 1))) / 2^(8 * x)⌋) [0..47]
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]
 */
/*inline*/
func fiat_p384_to_bytes(out1 *[48]uint8, arg1 *[12]uint32) {
  var x1 uint32 = (arg1[11])
  var x2 uint32 = (arg1[10])
  var x3 uint32 = (arg1[9])
  var x4 uint32 = (arg1[8])
  var x5 uint32 = (arg1[7])
  var x6 uint32 = (arg1[6])
  var x7 uint32 = (arg1[5])
  var x8 uint32 = (arg1[4])
  var x9 uint32 = (arg1[3])
  var x10 uint32 = (arg1[2])
  var x11 uint32 = (arg1[1])
  var x12 uint32 = (arg1[0])
  var x13 uint8 = (uint8(x12) & 0xff)
  var x14 uint32 = (x12 >> 8)
  var x15 uint8 = (uint8(x14) & 0xff)
  var x16 uint32 = (x14 >> 8)
  var x17 uint8 = (uint8(x16) & 0xff)
  var x18 uint8 = uint8((x16 >> 8))
  var x19 uint8 = (uint8(x11) & 0xff)
  var x20 uint32 = (x11 >> 8)
  var x21 uint8 = (uint8(x20) & 0xff)
  var x22 uint32 = (x20 >> 8)
  var x23 uint8 = (uint8(x22) & 0xff)
  var x24 uint8 = uint8((x22 >> 8))
  var x25 uint8 = (uint8(x10) & 0xff)
  var x26 uint32 = (x10 >> 8)
  var x27 uint8 = (uint8(x26) & 0xff)
  var x28 uint32 = (x26 >> 8)
  var x29 uint8 = (uint8(x28) & 0xff)
  var x30 uint8 = uint8((x28 >> 8))
  var x31 uint8 = (uint8(x9) & 0xff)
  var x32 uint32 = (x9 >> 8)
  var x33 uint8 = (uint8(x32) & 0xff)
  var x34 uint32 = (x32 >> 8)
  var x35 uint8 = (uint8(x34) & 0xff)
  var x36 uint8 = uint8((x34 >> 8))
  var x37 uint8 = (uint8(x8) & 0xff)
  var x38 uint32 = (x8 >> 8)
  var x39 uint8 = (uint8(x38) & 0xff)
  var x40 uint32 = (x38 >> 8)
  var x41 uint8 = (uint8(x40) & 0xff)
  var x42 uint8 = uint8((x40 >> 8))
  var x43 uint8 = (uint8(x7) & 0xff)
  var x44 uint32 = (x7 >> 8)
  var x45 uint8 = (uint8(x44) & 0xff)
  var x46 uint32 = (x44 >> 8)
  var x47 uint8 = (uint8(x46) & 0xff)
  var x48 uint8 = uint8((x46 >> 8))
  var x49 uint8 = (uint8(x6) & 0xff)
  var x50 uint32 = (x6 >> 8)
  var x51 uint8 = (uint8(x50) & 0xff)
  var x52 uint32 = (x50 >> 8)
  var x53 uint8 = (uint8(x52) & 0xff)
  var x54 uint8 = uint8((x52 >> 8))
  var x55 uint8 = (uint8(x5) & 0xff)
  var x56 uint32 = (x5 >> 8)
  var x57 uint8 = (uint8(x56) & 0xff)
  var x58 uint32 = (x56 >> 8)
  var x59 uint8 = (uint8(x58) & 0xff)
  var x60 uint8 = uint8((x58 >> 8))
  var x61 uint8 = (uint8(x4) & 0xff)
  var x62 uint32 = (x4 >> 8)
  var x63 uint8 = (uint8(x62) & 0xff)
  var x64 uint32 = (x62 >> 8)
  var x65 uint8 = (uint8(x64) & 0xff)
  var x66 uint8 = uint8((x64 >> 8))
  var x67 uint8 = (uint8(x3) & 0xff)
  var x68 uint32 = (x3 >> 8)
  var x69 uint8 = (uint8(x68) & 0xff)
  var x70 uint32 = (x68 >> 8)
  var x71 uint8 = (uint8(x70) & 0xff)
  var x72 uint8 = uint8((x70 >> 8))
  var x73 uint8 = (uint8(x2) & 0xff)
  var x74 uint32 = (x2 >> 8)
  var x75 uint8 = (uint8(x74) & 0xff)
  var x76 uint32 = (x74 >> 8)
  var x77 uint8 = (uint8(x76) & 0xff)
  var x78 uint8 = uint8((x76 >> 8))
  var x79 uint8 = (uint8(x1) & 0xff)
  var x80 uint32 = (x1 >> 8)
  var x81 uint8 = (uint8(x80) & 0xff)
  var x82 uint32 = (x80 >> 8)
  var x83 uint8 = (uint8(x82) & 0xff)
  var x84 uint8 = uint8((x82 >> 8))
  out1[0] = x13
  out1[1] = x15
  out1[2] = x17
  out1[3] = x18
  out1[4] = x19
  out1[5] = x21
  out1[6] = x23
  out1[7] = x24
  out1[8] = x25
  out1[9] = x27
  out1[10] = x29
  out1[11] = x30
  out1[12] = x31
  out1[13] = x33
  out1[14] = x35
  out1[15] = x36
  out1[16] = x37
  out1[17] = x39
  out1[18] = x41
  out1[19] = x42
  out1[20] = x43
  out1[21] = x45
  out1[22] = x47
  out1[23] = x48
  out1[24] = x49
  out1[25] = x51
  out1[26] = x53
  out1[27] = x54
  out1[28] = x55
  out1[29] = x57
  out1[30] = x59
  out1[31] = x60
  out1[32] = x61
  out1[33] = x63
  out1[34] = x65
  out1[35] = x66
  out1[36] = x67
  out1[37] = x69
  out1[38] = x71
  out1[39] = x72
  out1[40] = x73
  out1[41] = x75
  out1[42] = x77
  out1[43] = x78
  out1[44] = x79
  out1[45] = x81
  out1[46] = x83
  out1[47] = x84
}

/*
 * The function fiat_p384_from_bytes deserializes a field element NOT in the Montgomery domain from bytes in little-endian order.
 * Preconditions:
 *   0 ≤ bytes_eval arg1 < m
 * Postconditions:
 *   eval out1 mod m = bytes_eval arg1 mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff]]
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
/*inline*/
func fiat_p384_from_bytes(out1 *[12]uint32, arg1 *[48]uint8) {
  var x1 uint32 = (uint32((arg1[47])) << 24)
  var x2 uint32 = (uint32((arg1[46])) << 16)
  var x3 uint32 = (uint32((arg1[45])) << 8)
  var x4 uint8 = (arg1[44])
  var x5 uint32 = (uint32((arg1[43])) << 24)
  var x6 uint32 = (uint32((arg1[42])) << 16)
  var x7 uint32 = (uint32((arg1[41])) << 8)
  var x8 uint8 = (arg1[40])
  var x9 uint32 = (uint32((arg1[39])) << 24)
  var x10 uint32 = (uint32((arg1[38])) << 16)
  var x11 uint32 = (uint32((arg1[37])) << 8)
  var x12 uint8 = (arg1[36])
  var x13 uint32 = (uint32((arg1[35])) << 24)
  var x14 uint32 = (uint32((arg1[34])) << 16)
  var x15 uint32 = (uint32((arg1[33])) << 8)
  var x16 uint8 = (arg1[32])
  var x17 uint32 = (uint32((arg1[31])) << 24)
  var x18 uint32 = (uint32((arg1[30])) << 16)
  var x19 uint32 = (uint32((arg1[29])) << 8)
  var x20 uint8 = (arg1[28])
  var x21 uint32 = (uint32((arg1[27])) << 24)
  var x22 uint32 = (uint32((arg1[26])) << 16)
  var x23 uint32 = (uint32((arg1[25])) << 8)
  var x24 uint8 = (arg1[24])
  var x25 uint32 = (uint32((arg1[23])) << 24)
  var x26 uint32 = (uint32((arg1[22])) << 16)
  var x27 uint32 = (uint32((arg1[21])) << 8)
  var x28 uint8 = (arg1[20])
  var x29 uint32 = (uint32((arg1[19])) << 24)
  var x30 uint32 = (uint32((arg1[18])) << 16)
  var x31 uint32 = (uint32((arg1[17])) << 8)
  var x32 uint8 = (arg1[16])
  var x33 uint32 = (uint32((arg1[15])) << 24)
  var x34 uint32 = (uint32((arg1[14])) << 16)
  var x35 uint32 = (uint32((arg1[13])) << 8)
  var x36 uint8 = (arg1[12])
  var x37 uint32 = (uint32((arg1[11])) << 24)
  var x38 uint32 = (uint32((arg1[10])) << 16)
  var x39 uint32 = (uint32((arg1[9])) << 8)
  var x40 uint8 = (arg1[8])
  var x41 uint32 = (uint32((arg1[7])) << 24)
  var x42 uint32 = (uint32((arg1[6])) << 16)
  var x43 uint32 = (uint32((arg1[5])) << 8)
  var x44 uint8 = (arg1[4])
  var x45 uint32 = (uint32((arg1[3])) << 24)
  var x46 uint32 = (uint32((arg1[2])) << 16)
  var x47 uint32 = (uint32((arg1[1])) << 8)
  var x48 uint8 = (arg1[0])
  var x49 uint32 = (x47 + uint32(x48))
  var x50 uint32 = (x46 + x49)
  var x51 uint32 = (x45 + x50)
  var x52 uint32 = (x43 + uint32(x44))
  var x53 uint32 = (x42 + x52)
  var x54 uint32 = (x41 + x53)
  var x55 uint32 = (x39 + uint32(x40))
  var x56 uint32 = (x38 + x55)
  var x57 uint32 = (x37 + x56)
  var x58 uint32 = (x35 + uint32(x36))
  var x59 uint32 = (x34 + x58)
  var x60 uint32 = (x33 + x59)
  var x61 uint32 = (x31 + uint32(x32))
  var x62 uint32 = (x30 + x61)
  var x63 uint32 = (x29 + x62)
  var x64 uint32 = (x27 + uint32(x28))
  var x65 uint32 = (x26 + x64)
  var x66 uint32 = (x25 + x65)
  var x67 uint32 = (x23 + uint32(x24))
  var x68 uint32 = (x22 + x67)
  var x69 uint32 = (x21 + x68)
  var x70 uint32 = (x19 + uint32(x20))
  var x71 uint32 = (x18 + x70)
  var x72 uint32 = (x17 + x71)
  var x73 uint32 = (x15 + uint32(x16))
  var x74 uint32 = (x14 + x73)
  var x75 uint32 = (x13 + x74)
  var x76 uint32 = (x11 + uint32(x12))
  var x77 uint32 = (x10 + x76)
  var x78 uint32 = (x9 + x77)
  var x79 uint32 = (x7 + uint32(x8))
  var x80 uint32 = (x6 + x79)
  var x81 uint32 = (x5 + x80)
  var x82 uint32 = (x3 + uint32(x4))
  var x83 uint32 = (x2 + x82)
  var x84 uint32 = (x1 + x83)
  out1[0] = x51
  out1[1] = x54
  out1[2] = x57
  out1[3] = x60
  out1[4] = x63
  out1[5] = x66
  out1[6] = x69
  out1[7] = x72
  out1[8] = x75
  out1[9] = x78
  out1[10] = x81
  out1[11] = x84
}

/*
 * The function fiat_p384_set_one returns the field element one in the Montgomery domain.
 * Postconditions:
 *   eval (from_montgomery out1) mod m = 1 mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
/*inline*/
func fiat_p384_set_one(out1 *[12]uint32) {
  out1[0] = uint32(0x1)
  out1[1] = 0xffffffff
  out1[2] = 0xffffffff
  out1[3] = uint32(0x0)
  out1[4] = uint32(0x1)
  out1[5] = uint32(0x0)
  out1[6] = uint32(0x0)
  out1[7] = uint32(0x0)
  out1[8] = uint32(0x0)
  out1[9] = uint32(0x0)
  out1[10] = uint32(0x0)
  out1[11] = uint32(0x0)
}

/*
 * The function fiat_p384_msat returns the saturated represtation of the prime modulus.
 * Postconditions:
 *   twos_complement_eval out1 = m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
/*inline*/
func fiat_p384_msat(out1 *[13]uint32) {
  out1[0] = 0xffffffff
  out1[1] = uint32(0x0)
  out1[2] = uint32(0x0)
  out1[3] = 0xffffffff
  out1[4] = 0xfffffffe
  out1[5] = 0xffffffff
  out1[6] = 0xffffffff
  out1[7] = 0xffffffff
  out1[8] = 0xffffffff
  out1[9] = 0xffffffff
  out1[10] = 0xffffffff
  out1[11] = 0xffffffff
  out1[12] = uint32(0x0)
}

/*
 * The function fiat_p384_divstep computes a divstep.
 * Preconditions:
 *   0 ≤ eval arg4 < m
 *   0 ≤ eval arg5 < m
 * Postconditions:
 *   out1 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then 1 - arg1 else 1 + arg1)
 *   twos_complement_eval out2 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then twos_complement_eval arg3 else twos_complement_eval arg2)
 *   twos_complement_eval out3 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then ⌊(twos_complement_eval arg3 - twos_complement_eval arg2) / 2⌋ else ⌊(twos_complement_eval arg3 + (twos_complement_eval arg3 mod 2) * twos_complement_eval arg2) / 2⌋)
 *   eval (from_montgomery out4) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (2 * eval (from_montgomery arg5)) mod m else (2 * eval (from_montgomery arg4)) mod m)
 *   eval (from_montgomery out5) mod m = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then (eval (from_montgomery arg4) - eval (from_montgomery arg4)) mod m else (eval (from_montgomery arg5) + (twos_complement_eval arg3 mod 2) * eval (from_montgomery arg4)) mod m)
 *   0 ≤ eval out5 < m
 *   0 ≤ eval out5 < m
 *   0 ≤ eval out2 < m
 *   0 ≤ eval out3 < m
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0xffffffff]
 *   arg2: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   arg3: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   arg4: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   arg5: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffff]
 *   out2: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   out3: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   out4: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 *   out5: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
/*inline*/
func fiat_p384_divstep(out1 *uint32, out2 *[13]uint32, out3 *[13]uint32, out4 *[12]uint32, out5 *[12]uint32, arg1 uint32, arg2 *[13]uint32, arg3 *[13]uint32, arg4 *[12]uint32, arg5 *[12]uint32) {
  var x1 uint32
  x1, _ = fiat_p384_addcarryx_u32((^arg1), uint32(0x1), 0x0)
  var x3 fiat_p384_uint1 = (fiat_p384_uint1((x1 >> 31)) & (fiat_p384_uint1((arg3[0])) & 0x1))
  var x4 uint32
  x4, _ = fiat_p384_addcarryx_u32((^arg1), uint32(0x1), 0x0)
  var x6 uint32
  fiat_p384_cmovznz_u32(&x6, x3, arg1, x4)
  var x7 uint32
  fiat_p384_cmovznz_u32(&x7, x3, (arg2[0]), (arg3[0]))
  var x8 uint32
  fiat_p384_cmovznz_u32(&x8, x3, (arg2[1]), (arg3[1]))
  var x9 uint32
  fiat_p384_cmovznz_u32(&x9, x3, (arg2[2]), (arg3[2]))
  var x10 uint32
  fiat_p384_cmovznz_u32(&x10, x3, (arg2[3]), (arg3[3]))
  var x11 uint32
  fiat_p384_cmovznz_u32(&x11, x3, (arg2[4]), (arg3[4]))
  var x12 uint32
  fiat_p384_cmovznz_u32(&x12, x3, (arg2[5]), (arg3[5]))
  var x13 uint32
  fiat_p384_cmovznz_u32(&x13, x3, (arg2[6]), (arg3[6]))
  var x14 uint32
  fiat_p384_cmovznz_u32(&x14, x3, (arg2[7]), (arg3[7]))
  var x15 uint32
  fiat_p384_cmovznz_u32(&x15, x3, (arg2[8]), (arg3[8]))
  var x16 uint32
  fiat_p384_cmovznz_u32(&x16, x3, (arg2[9]), (arg3[9]))
  var x17 uint32
  fiat_p384_cmovznz_u32(&x17, x3, (arg2[10]), (arg3[10]))
  var x18 uint32
  fiat_p384_cmovznz_u32(&x18, x3, (arg2[11]), (arg3[11]))
  var x19 uint32
  fiat_p384_cmovznz_u32(&x19, x3, (arg2[12]), (arg3[12]))
  var x20 uint32
  var x21 fiat_p384_uint1
  x20, x21 = fiat_p384_addcarryx_u32(uint32(0x1), (^(arg2[0])), 0x0)
  var x22 uint32
  var x23 fiat_p384_uint1
  x22, x23 = fiat_p384_addcarryx_u32(uint32(0x0), (^(arg2[1])), x21)
  var x24 uint32
  var x25 fiat_p384_uint1
  x24, x25 = fiat_p384_addcarryx_u32(uint32(0x0), (^(arg2[2])), x23)
  var x26 uint32
  var x27 fiat_p384_uint1
  x26, x27 = fiat_p384_addcarryx_u32(uint32(0x0), (^(arg2[3])), x25)
  var x28 uint32
  var x29 fiat_p384_uint1
  x28, x29 = fiat_p384_addcarryx_u32(uint32(0x0), (^(arg2[4])), x27)
  var x30 uint32
  var x31 fiat_p384_uint1
  x30, x31 = fiat_p384_addcarryx_u32(uint32(0x0), (^(arg2[5])), x29)
  var x32 uint32
  var x33 fiat_p384_uint1
  x32, x33 = fiat_p384_addcarryx_u32(uint32(0x0), (^(arg2[6])), x31)
  var x34 uint32
  var x35 fiat_p384_uint1
  x34, x35 = fiat_p384_addcarryx_u32(uint32(0x0), (^(arg2[7])), x33)
  var x36 uint32
  var x37 fiat_p384_uint1
  x36, x37 = fiat_p384_addcarryx_u32(uint32(0x0), (^(arg2[8])), x35)
  var x38 uint32
  var x39 fiat_p384_uint1
  x38, x39 = fiat_p384_addcarryx_u32(uint32(0x0), (^(arg2[9])), x37)
  var x40 uint32
  var x41 fiat_p384_uint1
  x40, x41 = fiat_p384_addcarryx_u32(uint32(0x0), (^(arg2[10])), x39)
  var x42 uint32
  var x43 fiat_p384_uint1
  x42, x43 = fiat_p384_addcarryx_u32(uint32(0x0), (^(arg2[11])), x41)
  var x44 uint32
  x44, _ = fiat_p384_addcarryx_u32(uint32(0x0), (^(arg2[12])), x43)
  var x46 uint32
  fiat_p384_cmovznz_u32(&x46, x3, (arg3[0]), x20)
  var x47 uint32
  fiat_p384_cmovznz_u32(&x47, x3, (arg3[1]), x22)
  var x48 uint32
  fiat_p384_cmovznz_u32(&x48, x3, (arg3[2]), x24)
  var x49 uint32
  fiat_p384_cmovznz_u32(&x49, x3, (arg3[3]), x26)
  var x50 uint32
  fiat_p384_cmovznz_u32(&x50, x3, (arg3[4]), x28)
  var x51 uint32
  fiat_p384_cmovznz_u32(&x51, x3, (arg3[5]), x30)
  var x52 uint32
  fiat_p384_cmovznz_u32(&x52, x3, (arg3[6]), x32)
  var x53 uint32
  fiat_p384_cmovznz_u32(&x53, x3, (arg3[7]), x34)
  var x54 uint32
  fiat_p384_cmovznz_u32(&x54, x3, (arg3[8]), x36)
  var x55 uint32
  fiat_p384_cmovznz_u32(&x55, x3, (arg3[9]), x38)
  var x56 uint32
  fiat_p384_cmovznz_u32(&x56, x3, (arg3[10]), x40)
  var x57 uint32
  fiat_p384_cmovznz_u32(&x57, x3, (arg3[11]), x42)
  var x58 uint32
  fiat_p384_cmovznz_u32(&x58, x3, (arg3[12]), x44)
  var x59 uint32
  fiat_p384_cmovznz_u32(&x59, x3, (arg4[0]), (arg5[0]))
  var x60 uint32
  fiat_p384_cmovznz_u32(&x60, x3, (arg4[1]), (arg5[1]))
  var x61 uint32
  fiat_p384_cmovznz_u32(&x61, x3, (arg4[2]), (arg5[2]))
  var x62 uint32
  fiat_p384_cmovznz_u32(&x62, x3, (arg4[3]), (arg5[3]))
  var x63 uint32
  fiat_p384_cmovznz_u32(&x63, x3, (arg4[4]), (arg5[4]))
  var x64 uint32
  fiat_p384_cmovznz_u32(&x64, x3, (arg4[5]), (arg5[5]))
  var x65 uint32
  fiat_p384_cmovznz_u32(&x65, x3, (arg4[6]), (arg5[6]))
  var x66 uint32
  fiat_p384_cmovznz_u32(&x66, x3, (arg4[7]), (arg5[7]))
  var x67 uint32
  fiat_p384_cmovznz_u32(&x67, x3, (arg4[8]), (arg5[8]))
  var x68 uint32
  fiat_p384_cmovznz_u32(&x68, x3, (arg4[9]), (arg5[9]))
  var x69 uint32
  fiat_p384_cmovznz_u32(&x69, x3, (arg4[10]), (arg5[10]))
  var x70 uint32
  fiat_p384_cmovznz_u32(&x70, x3, (arg4[11]), (arg5[11]))
  var x71 uint32
  var x72 fiat_p384_uint1
  x71, x72 = fiat_p384_addcarryx_u32(x59, x59, 0x0)
  var x73 uint32
  var x74 fiat_p384_uint1
  x73, x74 = fiat_p384_addcarryx_u32(x60, x60, x72)
  var x75 uint32
  var x76 fiat_p384_uint1
  x75, x76 = fiat_p384_addcarryx_u32(x61, x61, x74)
  var x77 uint32
  var x78 fiat_p384_uint1
  x77, x78 = fiat_p384_addcarryx_u32(x62, x62, x76)
  var x79 uint32
  var x80 fiat_p384_uint1
  x79, x80 = fiat_p384_addcarryx_u32(x63, x63, x78)
  var x81 uint32
  var x82 fiat_p384_uint1
  x81, x82 = fiat_p384_addcarryx_u32(x64, x64, x80)
  var x83 uint32
  var x84 fiat_p384_uint1
  x83, x84 = fiat_p384_addcarryx_u32(x65, x65, x82)
  var x85 uint32
  var x86 fiat_p384_uint1
  x85, x86 = fiat_p384_addcarryx_u32(x66, x66, x84)
  var x87 uint32
  var x88 fiat_p384_uint1
  x87, x88 = fiat_p384_addcarryx_u32(x67, x67, x86)
  var x89 uint32
  var x90 fiat_p384_uint1
  x89, x90 = fiat_p384_addcarryx_u32(x68, x68, x88)
  var x91 uint32
  var x92 fiat_p384_uint1
  x91, x92 = fiat_p384_addcarryx_u32(x69, x69, x90)
  var x93 uint32
  var x94 fiat_p384_uint1
  x93, x94 = fiat_p384_addcarryx_u32(x70, x70, x92)
  var x95 uint32
  var x96 fiat_p384_uint1
  x95, x96 = fiat_p384_subborrowx_u32(x71, 0xffffffff, 0x0)
  var x97 uint32
  var x98 fiat_p384_uint1
  x97, x98 = fiat_p384_subborrowx_u32(x73, uint32(0x0), x96)
  var x99 uint32
  var x100 fiat_p384_uint1
  x99, x100 = fiat_p384_subborrowx_u32(x75, uint32(0x0), x98)
  var x101 uint32
  var x102 fiat_p384_uint1
  x101, x102 = fiat_p384_subborrowx_u32(x77, 0xffffffff, x100)
  var x103 uint32
  var x104 fiat_p384_uint1
  x103, x104 = fiat_p384_subborrowx_u32(x79, 0xfffffffe, x102)
  var x105 uint32
  var x106 fiat_p384_uint1
  x105, x106 = fiat_p384_subborrowx_u32(x81, 0xffffffff, x104)
  var x107 uint32
  var x108 fiat_p384_uint1
  x107, x108 = fiat_p384_subborrowx_u32(x83, 0xffffffff, x106)
  var x109 uint32
  var x110 fiat_p384_uint1
  x109, x110 = fiat_p384_subborrowx_u32(x85, 0xffffffff, x108)
  var x111 uint32
  var x112 fiat_p384_uint1
  x111, x112 = fiat_p384_subborrowx_u32(x87, 0xffffffff, x110)
  var x113 uint32
  var x114 fiat_p384_uint1
  x113, x114 = fiat_p384_subborrowx_u32(x89, 0xffffffff, x112)
  var x115 uint32
  var x116 fiat_p384_uint1
  x115, x116 = fiat_p384_subborrowx_u32(x91, 0xffffffff, x114)
  var x117 uint32
  var x118 fiat_p384_uint1
  x117, x118 = fiat_p384_subborrowx_u32(x93, 0xffffffff, x116)
  var x120 fiat_p384_uint1
  _, x120 = fiat_p384_subborrowx_u32(uint32(x94), uint32(0x0), x118)
  var x121 uint32 = (arg4[11])
  var x122 uint32 = (arg4[10])
  var x123 uint32 = (arg4[9])
  var x124 uint32 = (arg4[8])
  var x125 uint32 = (arg4[7])
  var x126 uint32 = (arg4[6])
  var x127 uint32 = (arg4[5])
  var x128 uint32 = (arg4[4])
  var x129 uint32 = (arg4[3])
  var x130 uint32 = (arg4[2])
  var x131 uint32 = (arg4[1])
  var x132 uint32 = (arg4[0])
  var x133 uint32
  var x134 fiat_p384_uint1
  x133, x134 = fiat_p384_subborrowx_u32(uint32(0x0), x132, 0x0)
  var x135 uint32
  var x136 fiat_p384_uint1
  x135, x136 = fiat_p384_subborrowx_u32(uint32(0x0), x131, x134)
  var x137 uint32
  var x138 fiat_p384_uint1
  x137, x138 = fiat_p384_subborrowx_u32(uint32(0x0), x130, x136)
  var x139 uint32
  var x140 fiat_p384_uint1
  x139, x140 = fiat_p384_subborrowx_u32(uint32(0x0), x129, x138)
  var x141 uint32
  var x142 fiat_p384_uint1
  x141, x142 = fiat_p384_subborrowx_u32(uint32(0x0), x128, x140)
  var x143 uint32
  var x144 fiat_p384_uint1
  x143, x144 = fiat_p384_subborrowx_u32(uint32(0x0), x127, x142)
  var x145 uint32
  var x146 fiat_p384_uint1
  x145, x146 = fiat_p384_subborrowx_u32(uint32(0x0), x126, x144)
  var x147 uint32
  var x148 fiat_p384_uint1
  x147, x148 = fiat_p384_subborrowx_u32(uint32(0x0), x125, x146)
  var x149 uint32
  var x150 fiat_p384_uint1
  x149, x150 = fiat_p384_subborrowx_u32(uint32(0x0), x124, x148)
  var x151 uint32
  var x152 fiat_p384_uint1
  x151, x152 = fiat_p384_subborrowx_u32(uint32(0x0), x123, x150)
  var x153 uint32
  var x154 fiat_p384_uint1
  x153, x154 = fiat_p384_subborrowx_u32(uint32(0x0), x122, x152)
  var x155 uint32
  var x156 fiat_p384_uint1
  x155, x156 = fiat_p384_subborrowx_u32(uint32(0x0), x121, x154)
  var x157 uint32
  fiat_p384_cmovznz_u32(&x157, x156, uint32(0x0), 0xffffffff)
  var x158 uint32
  var x159 fiat_p384_uint1
  x158, x159 = fiat_p384_addcarryx_u32(x133, x157, 0x0)
  var x160 uint32
  var x161 fiat_p384_uint1
  x160, x161 = fiat_p384_addcarryx_u32(x135, uint32(0x0), x159)
  var x162 uint32
  var x163 fiat_p384_uint1
  x162, x163 = fiat_p384_addcarryx_u32(x137, uint32(0x0), x161)
  var x164 uint32
  var x165 fiat_p384_uint1
  x164, x165 = fiat_p384_addcarryx_u32(x139, x157, x163)
  var x166 uint32
  var x167 fiat_p384_uint1
  x166, x167 = fiat_p384_addcarryx_u32(x141, (x157 & 0xfffffffe), x165)
  var x168 uint32
  var x169 fiat_p384_uint1
  x168, x169 = fiat_p384_addcarryx_u32(x143, x157, x167)
  var x170 uint32
  var x171 fiat_p384_uint1
  x170, x171 = fiat_p384_addcarryx_u32(x145, x157, x169)
  var x172 uint32
  var x173 fiat_p384_uint1
  x172, x173 = fiat_p384_addcarryx_u32(x147, x157, x171)
  var x174 uint32
  var x175 fiat_p384_uint1
  x174, x175 = fiat_p384_addcarryx_u32(x149, x157, x173)
  var x176 uint32
  var x177 fiat_p384_uint1
  x176, x177 = fiat_p384_addcarryx_u32(x151, x157, x175)
  var x178 uint32
  var x179 fiat_p384_uint1
  x178, x179 = fiat_p384_addcarryx_u32(x153, x157, x177)
  var x180 uint32
  x180, _ = fiat_p384_addcarryx_u32(x155, x157, x179)
  var x182 uint32
  fiat_p384_cmovznz_u32(&x182, x3, (arg5[0]), x158)
  var x183 uint32
  fiat_p384_cmovznz_u32(&x183, x3, (arg5[1]), x160)
  var x184 uint32
  fiat_p384_cmovznz_u32(&x184, x3, (arg5[2]), x162)
  var x185 uint32
  fiat_p384_cmovznz_u32(&x185, x3, (arg5[3]), x164)
  var x186 uint32
  fiat_p384_cmovznz_u32(&x186, x3, (arg5[4]), x166)
  var x187 uint32
  fiat_p384_cmovznz_u32(&x187, x3, (arg5[5]), x168)
  var x188 uint32
  fiat_p384_cmovznz_u32(&x188, x3, (arg5[6]), x170)
  var x189 uint32
  fiat_p384_cmovznz_u32(&x189, x3, (arg5[7]), x172)
  var x190 uint32
  fiat_p384_cmovznz_u32(&x190, x3, (arg5[8]), x174)
  var x191 uint32
  fiat_p384_cmovznz_u32(&x191, x3, (arg5[9]), x176)
  var x192 uint32
  fiat_p384_cmovznz_u32(&x192, x3, (arg5[10]), x178)
  var x193 uint32
  fiat_p384_cmovznz_u32(&x193, x3, (arg5[11]), x180)
  var x194 fiat_p384_uint1 = (fiat_p384_uint1(x46) & 0x1)
  var x195 uint32
  fiat_p384_cmovznz_u32(&x195, x194, uint32(0x0), x7)
  var x196 uint32
  fiat_p384_cmovznz_u32(&x196, x194, uint32(0x0), x8)
  var x197 uint32
  fiat_p384_cmovznz_u32(&x197, x194, uint32(0x0), x9)
  var x198 uint32
  fiat_p384_cmovznz_u32(&x198, x194, uint32(0x0), x10)
  var x199 uint32
  fiat_p384_cmovznz_u32(&x199, x194, uint32(0x0), x11)
  var x200 uint32
  fiat_p384_cmovznz_u32(&x200, x194, uint32(0x0), x12)
  var x201 uint32
  fiat_p384_cmovznz_u32(&x201, x194, uint32(0x0), x13)
  var x202 uint32
  fiat_p384_cmovznz_u32(&x202, x194, uint32(0x0), x14)
  var x203 uint32
  fiat_p384_cmovznz_u32(&x203, x194, uint32(0x0), x15)
  var x204 uint32
  fiat_p384_cmovznz_u32(&x204, x194, uint32(0x0), x16)
  var x205 uint32
  fiat_p384_cmovznz_u32(&x205, x194, uint32(0x0), x17)
  var x206 uint32
  fiat_p384_cmovznz_u32(&x206, x194, uint32(0x0), x18)
  var x207 uint32
  fiat_p384_cmovznz_u32(&x207, x194, uint32(0x0), x19)
  var x208 uint32
  var x209 fiat_p384_uint1
  x208, x209 = fiat_p384_addcarryx_u32(x46, x195, 0x0)
  var x210 uint32
  var x211 fiat_p384_uint1
  x210, x211 = fiat_p384_addcarryx_u32(x47, x196, x209)
  var x212 uint32
  var x213 fiat_p384_uint1
  x212, x213 = fiat_p384_addcarryx_u32(x48, x197, x211)
  var x214 uint32
  var x215 fiat_p384_uint1
  x214, x215 = fiat_p384_addcarryx_u32(x49, x198, x213)
  var x216 uint32
  var x217 fiat_p384_uint1
  x216, x217 = fiat_p384_addcarryx_u32(x50, x199, x215)
  var x218 uint32
  var x219 fiat_p384_uint1
  x218, x219 = fiat_p384_addcarryx_u32(x51, x200, x217)
  var x220 uint32
  var x221 fiat_p384_uint1
  x220, x221 = fiat_p384_addcarryx_u32(x52, x201, x219)
  var x222 uint32
  var x223 fiat_p384_uint1
  x222, x223 = fiat_p384_addcarryx_u32(x53, x202, x221)
  var x224 uint32
  var x225 fiat_p384_uint1
  x224, x225 = fiat_p384_addcarryx_u32(x54, x203, x223)
  var x226 uint32
  var x227 fiat_p384_uint1
  x226, x227 = fiat_p384_addcarryx_u32(x55, x204, x225)
  var x228 uint32
  var x229 fiat_p384_uint1
  x228, x229 = fiat_p384_addcarryx_u32(x56, x205, x227)
  var x230 uint32
  var x231 fiat_p384_uint1
  x230, x231 = fiat_p384_addcarryx_u32(x57, x206, x229)
  var x232 uint32
  x232, _ = fiat_p384_addcarryx_u32(x58, x207, x231)
  var x234 uint32
  fiat_p384_cmovznz_u32(&x234, x194, uint32(0x0), x59)
  var x235 uint32
  fiat_p384_cmovznz_u32(&x235, x194, uint32(0x0), x60)
  var x236 uint32
  fiat_p384_cmovznz_u32(&x236, x194, uint32(0x0), x61)
  var x237 uint32
  fiat_p384_cmovznz_u32(&x237, x194, uint32(0x0), x62)
  var x238 uint32
  fiat_p384_cmovznz_u32(&x238, x194, uint32(0x0), x63)
  var x239 uint32
  fiat_p384_cmovznz_u32(&x239, x194, uint32(0x0), x64)
  var x240 uint32
  fiat_p384_cmovznz_u32(&x240, x194, uint32(0x0), x65)
  var x241 uint32
  fiat_p384_cmovznz_u32(&x241, x194, uint32(0x0), x66)
  var x242 uint32
  fiat_p384_cmovznz_u32(&x242, x194, uint32(0x0), x67)
  var x243 uint32
  fiat_p384_cmovznz_u32(&x243, x194, uint32(0x0), x68)
  var x244 uint32
  fiat_p384_cmovznz_u32(&x244, x194, uint32(0x0), x69)
  var x245 uint32
  fiat_p384_cmovznz_u32(&x245, x194, uint32(0x0), x70)
  var x246 uint32
  var x247 fiat_p384_uint1
  x246, x247 = fiat_p384_addcarryx_u32(x182, x234, 0x0)
  var x248 uint32
  var x249 fiat_p384_uint1
  x248, x249 = fiat_p384_addcarryx_u32(x183, x235, x247)
  var x250 uint32
  var x251 fiat_p384_uint1
  x250, x251 = fiat_p384_addcarryx_u32(x184, x236, x249)
  var x252 uint32
  var x253 fiat_p384_uint1
  x252, x253 = fiat_p384_addcarryx_u32(x185, x237, x251)
  var x254 uint32
  var x255 fiat_p384_uint1
  x254, x255 = fiat_p384_addcarryx_u32(x186, x238, x253)
  var x256 uint32
  var x257 fiat_p384_uint1
  x256, x257 = fiat_p384_addcarryx_u32(x187, x239, x255)
  var x258 uint32
  var x259 fiat_p384_uint1
  x258, x259 = fiat_p384_addcarryx_u32(x188, x240, x257)
  var x260 uint32
  var x261 fiat_p384_uint1
  x260, x261 = fiat_p384_addcarryx_u32(x189, x241, x259)
  var x262 uint32
  var x263 fiat_p384_uint1
  x262, x263 = fiat_p384_addcarryx_u32(x190, x242, x261)
  var x264 uint32
  var x265 fiat_p384_uint1
  x264, x265 = fiat_p384_addcarryx_u32(x191, x243, x263)
  var x266 uint32
  var x267 fiat_p384_uint1
  x266, x267 = fiat_p384_addcarryx_u32(x192, x244, x265)
  var x268 uint32
  var x269 fiat_p384_uint1
  x268, x269 = fiat_p384_addcarryx_u32(x193, x245, x267)
  var x270 uint32
  var x271 fiat_p384_uint1
  x270, x271 = fiat_p384_subborrowx_u32(x246, 0xffffffff, 0x0)
  var x272 uint32
  var x273 fiat_p384_uint1
  x272, x273 = fiat_p384_subborrowx_u32(x248, uint32(0x0), x271)
  var x274 uint32
  var x275 fiat_p384_uint1
  x274, x275 = fiat_p384_subborrowx_u32(x250, uint32(0x0), x273)
  var x276 uint32
  var x277 fiat_p384_uint1
  x276, x277 = fiat_p384_subborrowx_u32(x252, 0xffffffff, x275)
  var x278 uint32
  var x279 fiat_p384_uint1
  x278, x279 = fiat_p384_subborrowx_u32(x254, 0xfffffffe, x277)
  var x280 uint32
  var x281 fiat_p384_uint1
  x280, x281 = fiat_p384_subborrowx_u32(x256, 0xffffffff, x279)
  var x282 uint32
  var x283 fiat_p384_uint1
  x282, x283 = fiat_p384_subborrowx_u32(x258, 0xffffffff, x281)
  var x284 uint32
  var x285 fiat_p384_uint1
  x284, x285 = fiat_p384_subborrowx_u32(x260, 0xffffffff, x283)
  var x286 uint32
  var x287 fiat_p384_uint1
  x286, x287 = fiat_p384_subborrowx_u32(x262, 0xffffffff, x285)
  var x288 uint32
  var x289 fiat_p384_uint1
  x288, x289 = fiat_p384_subborrowx_u32(x264, 0xffffffff, x287)
  var x290 uint32
  var x291 fiat_p384_uint1
  x290, x291 = fiat_p384_subborrowx_u32(x266, 0xffffffff, x289)
  var x292 uint32
  var x293 fiat_p384_uint1
  x292, x293 = fiat_p384_subborrowx_u32(x268, 0xffffffff, x291)
  var x295 fiat_p384_uint1
  _, x295 = fiat_p384_subborrowx_u32(uint32(x269), uint32(0x0), x293)
  var x296 uint32
  x296, _ = fiat_p384_addcarryx_u32(x6, uint32(0x1), 0x0)
  var x298 uint32 = ((x208 >> 1) | ((x210 << 31) & 0xffffffff))
  var x299 uint32 = ((x210 >> 1) | ((x212 << 31) & 0xffffffff))
  var x300 uint32 = ((x212 >> 1) | ((x214 << 31) & 0xffffffff))
  var x301 uint32 = ((x214 >> 1) | ((x216 << 31) & 0xffffffff))
  var x302 uint32 = ((x216 >> 1) | ((x218 << 31) & 0xffffffff))
  var x303 uint32 = ((x218 >> 1) | ((x220 << 31) & 0xffffffff))
  var x304 uint32 = ((x220 >> 1) | ((x222 << 31) & 0xffffffff))
  var x305 uint32 = ((x222 >> 1) | ((x224 << 31) & 0xffffffff))
  var x306 uint32 = ((x224 >> 1) | ((x226 << 31) & 0xffffffff))
  var x307 uint32 = ((x226 >> 1) | ((x228 << 31) & 0xffffffff))
  var x308 uint32 = ((x228 >> 1) | ((x230 << 31) & 0xffffffff))
  var x309 uint32 = ((x230 >> 1) | ((x232 << 31) & 0xffffffff))
  var x310 uint32 = ((x232 & 0x80000000) | (x232 >> 1))
  var x311 uint32
  fiat_p384_cmovznz_u32(&x311, x120, x95, x71)
  var x312 uint32
  fiat_p384_cmovznz_u32(&x312, x120, x97, x73)
  var x313 uint32
  fiat_p384_cmovznz_u32(&x313, x120, x99, x75)
  var x314 uint32
  fiat_p384_cmovznz_u32(&x314, x120, x101, x77)
  var x315 uint32
  fiat_p384_cmovznz_u32(&x315, x120, x103, x79)
  var x316 uint32
  fiat_p384_cmovznz_u32(&x316, x120, x105, x81)
  var x317 uint32
  fiat_p384_cmovznz_u32(&x317, x120, x107, x83)
  var x318 uint32
  fiat_p384_cmovznz_u32(&x318, x120, x109, x85)
  var x319 uint32
  fiat_p384_cmovznz_u32(&x319, x120, x111, x87)
  var x320 uint32
  fiat_p384_cmovznz_u32(&x320, x120, x113, x89)
  var x321 uint32
  fiat_p384_cmovznz_u32(&x321, x120, x115, x91)
  var x322 uint32
  fiat_p384_cmovznz_u32(&x322, x120, x117, x93)
  var x323 uint32
  fiat_p384_cmovznz_u32(&x323, x295, x270, x246)
  var x324 uint32
  fiat_p384_cmovznz_u32(&x324, x295, x272, x248)
  var x325 uint32
  fiat_p384_cmovznz_u32(&x325, x295, x274, x250)
  var x326 uint32
  fiat_p384_cmovznz_u32(&x326, x295, x276, x252)
  var x327 uint32
  fiat_p384_cmovznz_u32(&x327, x295, x278, x254)
  var x328 uint32
  fiat_p384_cmovznz_u32(&x328, x295, x280, x256)
  var x329 uint32
  fiat_p384_cmovznz_u32(&x329, x295, x282, x258)
  var x330 uint32
  fiat_p384_cmovznz_u32(&x330, x295, x284, x260)
  var x331 uint32
  fiat_p384_cmovznz_u32(&x331, x295, x286, x262)
  var x332 uint32
  fiat_p384_cmovznz_u32(&x332, x295, x288, x264)
  var x333 uint32
  fiat_p384_cmovznz_u32(&x333, x295, x290, x266)
  var x334 uint32
  fiat_p384_cmovznz_u32(&x334, x295, x292, x268)
  *out1 = x296
  out2[0] = x7
  out2[1] = x8
  out2[2] = x9
  out2[3] = x10
  out2[4] = x11
  out2[5] = x12
  out2[6] = x13
  out2[7] = x14
  out2[8] = x15
  out2[9] = x16
  out2[10] = x17
  out2[11] = x18
  out2[12] = x19
  out3[0] = x298
  out3[1] = x299
  out3[2] = x300
  out3[3] = x301
  out3[4] = x302
  out3[5] = x303
  out3[6] = x304
  out3[7] = x305
  out3[8] = x306
  out3[9] = x307
  out3[10] = x308
  out3[11] = x309
  out3[12] = x310
  out4[0] = x311
  out4[1] = x312
  out4[2] = x313
  out4[3] = x314
  out4[4] = x315
  out4[5] = x316
  out4[6] = x317
  out4[7] = x318
  out4[8] = x319
  out4[9] = x320
  out4[10] = x321
  out4[11] = x322
  out5[0] = x323
  out5[1] = x324
  out5[2] = x325
  out5[3] = x326
  out5[4] = x327
  out5[5] = x328
  out5[6] = x329
  out5[7] = x330
  out5[8] = x331
  out5[9] = x332
  out5[10] = x333
  out5[11] = x334
}

/*
 * The function fiat_p384_divstep_precomp returns the precomputed value for Bernstein-Yang-inversion (in montgomery form).
 * Postconditions:
 *   eval (from_montgomery out1) = ⌊(m - 1) / 2⌋^(if (log2 m) + 1 < 46 then ⌊(49 * ((log2 m) + 1) + 80) / 17⌋ else ⌊(49 * ((log2 m) + 1) + 57) / 17⌋)
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff], [0x0 ~> 0xffffffff]]
 */
/*inline*/
func fiat_p384_divstep_precomp(out1 *[12]uint32) {
  out1[0] = 0xfff18fff
  out1[1] = 0xfff69400
  out1[2] = 0xffffd3ff
  out1[3] = 0x2b7fe
  out1[4] = 0xfffe97ff
  out1[5] = 0xfffedbff
  out1[6] = 0x2fff
  out1[7] = 0x28400
  out1[8] = 0x50400
  out1[9] = 0x60400
  out1[10] = 0x38000
  out1[11] = 0xfffc4800
}

